package com.jeeplus.modules.cg.infrastructure.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.infrastructure.entity.ConstructionBatch;

import java.util.List;

/**
 * 基建 - 施工计划批次信息 - mapper
 * @author: 王强
 * @create: 2023-05-08 15:03
 **/
@MyBatisMapper
public interface ConstructionBatchMapper extends BaseMapper<ConstructionBatch> {

    /**
     * 根据条件查询所有数据
     * @param param
     * @return
     */
    int getAllInfo(ConstructionBatch param);

    /**
     * 根据批次编号获取项目信息
     * @param rm
     * @return
     */
    ConstructionBatch queryByProjectCode(ConstructionBatch rm);

    /**
     * 批量添加 施工计划批次信息
     * @param reserveManagementList
     */
    void insertList(List<ConstructionBatch> reserveManagementList);

    /**
     * 导出数据查询
     * @param basicInfo
     * @return
     */
    List<ConstructionBatch> exportFindList(ConstructionBatch basicInfo);

    /**
     * 获取所有的施工图纸收集截止时间和拟定开标时间
     * @return
     */
    List<ConstructionBatch> getAllDeadLine();
}
