package com.jeeplus.modules.cg.infrastructure.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.infrastructure.entity.InfrastructureBasicInfo;

import java.util.List;

/**
 * 基建基础信息 - mapper
 * @author: 王强
 * @create: 2023-05-08 14:20
 **/
@MyBatisMapper
public interface InfrastructureBasicInfoMapper extends BaseMapper<InfrastructureBasicInfo> {

    /**
     * 根据条件查询所有数据
     * @param param
     * @return
     */
    int getAllInfo(InfrastructureBasicInfo param);

    /**
     * 导出数据查询
     * @param basicInfo
     * @return
     */
    List<InfrastructureBasicInfo> exportFindList(InfrastructureBasicInfo basicInfo);

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId();

    /**
     * 根据项目编码获取项目信息
     * @param rm
     * @return
     */
    InfrastructureBasicInfo queryByProjectCode(InfrastructureBasicInfo rm);

    /**
     * 批量添加 基建基础信息
     * @param reserveManagementList
     */
    void insertList(List<InfrastructureBasicInfo> reserveManagementList);
}
