package com.jeeplus.modules.cg.infrastructure.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.infrastructure.entity.ReviewPlanArrangement;

/**
 * 基建 - 评审计划安排表 - mapper
 * @author: 王强
 * @create: 2023-05-08 15:12
 **/
@MyBatisMapper
public interface ReviewPlanArrangementMapper extends BaseMapper<ReviewPlanArrangement> {
    /**
     * 根据项目编码去查看是否有对应这条项目的 评审计划安排信息
     * @param projectCode
     */
    ReviewPlanArrangement getByCode(String projectCode);

    /**
     * 根据项目编码删除评审计划安排信息
     * @param projectCode
     */
    void deleteByCode(String projectCode);
}
