package com.jeeplus.modules.cg.infrastructure.service;

import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.cg.infrastructure.entity.ReviewPlanArrangement;
import com.jeeplus.modules.cg.infrastructure.mapper.ReviewPlanArrangementMapper;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * 基建 - 评审计划安排表 - service
 * @author: 王强
 * @create: 2023-05-08 15:14
 **/
@Service
@Transactional(readOnly = true)
public class ReviewPlanArrangementService extends CrudService<ReviewPlanArrangementMapper, ReviewPlanArrangement> {

    /**
     * 新增方法
     * @param entity
     */
    @Transactional(readOnly = false)
    public void save(ReviewPlanArrangement entity) {
        //根据项目编码去查看是否有对应这条项目的 评审计划安排信息
        ReviewPlanArrangement arrangement = mapper.getByCode(entity.getProjectCode());
        if (null == arrangement) {
            entity.preInsert();
            mapper.insert(entity);
        } else {
            entity.preUpdate();
            mapper.update(entity);
        }
    }

    /**
     * 根据项目编码删除评审计划安排信息
     * @param projectCode
     */
    @Transactional(readOnly = false)
    public void deleteByCode(String projectCode){
        mapper.deleteByCode(projectCode);
    }

    public ReviewPlanArrangement getByCode(String code){
        return mapper.getByCode(code);
    }
}
