package com.jeeplus.modules.cg.reservemanagementcenter.distribution.entity;

import com.jeeplus.core.persistence.ActEntity;

/**
 * 配网项目设计变更记录表
 * @author 王强
 * @version 1.0
 * @date 2023-09-07 9:26
 */
public class DistributionDesignChange extends ActEntity<DistributionDesignChange> {

    //储备项目基本信息
    private String projectYear;             //项目年份
    private String projectNature;           //项目性质
    private String demandUnit;              //需求单位
    private String district;                //区域
    private String projectGroup;            //项目分组
    private String reserveBatches;          //储备批次
    private String blockSupply;             //供电区域
    private String gridNumber;              //网格编号
    private String cellNumber;              //单元格编号
    private String projectReserveId;        //项目储备编号
    private String projectName;             //项目名称
    private String stateGridProjectCode;             //国网项目编码
    private String stateGridProjectName;             //国网项目名称
    private String constructionNecessityAndContent;           //建设必要性及内容
    private String substationName;           //变电站名称
    private String circuitName;              //线路名称
    private String netRackProjectDivide;     //网架项目划分
    private String requirementType;          //需求类型
    private String projectType;              //项目类型
    private String costEstimate;             //费用估算
    private String basicRemarks;                  //备注
    //项目参建（单位）人员信息
    private String projectReleaseBatch;     //项目下达批次
    private String ownerManager;            //业主项目经理
    private String constructionManagementUnit;          //现场施工管理单位
    private String dqProjectManager;          //施工项目经理(电气)
    private String tjProjectManager;          //施工项目经理(土建)
    private String cjRemarks;                 //备注
    //项目总体进度
    private String projectApproval;             //是否立项
    private String completionStatus;            //竣工情况
    private String completionDate;              //竣工日期
    private String settlementStatus;            //结算状态
    private String closeStatus;                 //关闭状态
    private String projectDesignChangeStatus;   //设计变更状态
    private String stockReturnStatus;           //拆旧物资退库状态
    //设计变更进度
    private String designChangeStatus;          //设计变更状态
    private String designChangeType;            //设计变更类型 - 经理
    private String designChangeTypeLeader;      //设计变更类型 - 领导
    private String proposer;                    //提出人
    private String proposeReasons;              //提出原因
    private String designChangeContent;         //设计变更内容
    private String changeType;                  //变更类型 - 经理
    private String changeTypeLeader;            //变更类型 - 领导
    private String designChangeProposeTime;     //设计变更提出时间
    private String completeDesignChangeType;    //是否完成设计变更
    private String projectManagerApproved;      //项目经理是否审核通过
    private String electronDiagramCompleteTime; //电子图变更完成时间
    private String completeBudgetAdjust;        //是否完成概预算调整
    private String jjApproved;                  //设计是否审核通过
    private String budgetCompleteTime;          //概预算变更完成时间
    private String beforeChangeBudget;          //变更前预算
    private String afterChangeBudget;           //变更后预算
    private String afterChangeConstructionCost; //变更后施工费
    private String drawingTransfer;             //变更纸质图纸是否移交
    private String drawingTransferTime;         //变更纸质图纸移交时间
    private String designChangeTime;            //设计变更时长
    private String dataIntegrity;               //设计变更签字资料是否完整
    private String scanningCopy;                //扫描件
    private String remarks;                     //备注

    public String getDesignChangeTypeLeader() {
        return designChangeTypeLeader;
    }

    public void setDesignChangeTypeLeader(String designChangeTypeLeader) {
        this.designChangeTypeLeader = designChangeTypeLeader;
    }

    public String getChangeTypeLeader() {
        return changeTypeLeader;
    }

    public void setChangeTypeLeader(String changeTypeLeader) {
        this.changeTypeLeader = changeTypeLeader;
    }

    public String getProjectYear() {
        return projectYear;
    }

    public void setProjectYear(String projectYear) {
        this.projectYear = projectYear;
    }

    public String getProjectNature() {
        return projectNature;
    }

    public void setProjectNature(String projectNature) {
        this.projectNature = projectNature;
    }

    public String getDemandUnit() {
        return demandUnit;
    }

    public void setDemandUnit(String demandUnit) {
        this.demandUnit = demandUnit;
    }

    public String getDistrict() {
        return district;
    }

    public void setDistrict(String district) {
        this.district = district;
    }

    public String getProjectGroup() {
        return projectGroup;
    }

    public void setProjectGroup(String projectGroup) {
        this.projectGroup = projectGroup;
    }

    public String getReserveBatches() {
        return reserveBatches;
    }

    public void setReserveBatches(String reserveBatches) {
        this.reserveBatches = reserveBatches;
    }

    public String getBlockSupply() {
        return blockSupply;
    }

    public void setBlockSupply(String blockSupply) {
        this.blockSupply = blockSupply;
    }

    public String getGridNumber() {
        return gridNumber;
    }

    public void setGridNumber(String gridNumber) {
        this.gridNumber = gridNumber;
    }

    public String getCellNumber() {
        return cellNumber;
    }

    public void setCellNumber(String cellNumber) {
        this.cellNumber = cellNumber;
    }

    public String getProjectReserveId() {
        return projectReserveId;
    }

    public void setProjectReserveId(String projectReserveId) {
        this.projectReserveId = projectReserveId;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getStateGridProjectCode() {
        return stateGridProjectCode;
    }

    public void setStateGridProjectCode(String stateGridProjectCode) {
        this.stateGridProjectCode = stateGridProjectCode;
    }

    public String getStateGridProjectName() {
        return stateGridProjectName;
    }

    public void setStateGridProjectName(String stateGridProjectName) {
        this.stateGridProjectName = stateGridProjectName;
    }

    public String getConstructionNecessityAndContent() {
        return constructionNecessityAndContent;
    }

    public void setConstructionNecessityAndContent(String constructionNecessityAndContent) {
        this.constructionNecessityAndContent = constructionNecessityAndContent;
    }

    public String getSubstationName() {
        return substationName;
    }

    public void setSubstationName(String substationName) {
        this.substationName = substationName;
    }

    public String getCircuitName() {
        return circuitName;
    }

    public void setCircuitName(String circuitName) {
        this.circuitName = circuitName;
    }

    public String getNetRackProjectDivide() {
        return netRackProjectDivide;
    }

    public void setNetRackProjectDivide(String netRackProjectDivide) {
        this.netRackProjectDivide = netRackProjectDivide;
    }

    public String getRequirementType() {
        return requirementType;
    }

    public void setRequirementType(String requirementType) {
        this.requirementType = requirementType;
    }

    public String getProjectType() {
        return projectType;
    }

    public void setProjectType(String projectType) {
        this.projectType = projectType;
    }

    public String getCostEstimate() {
        return costEstimate;
    }

    public void setCostEstimate(String costEstimate) {
        this.costEstimate = costEstimate;
    }

    public String getBasicRemarks() {
        return basicRemarks;
    }

    public void setBasicRemarks(String basicRemarks) {
        this.basicRemarks = basicRemarks;
    }

    public String getProjectReleaseBatch() {
        return projectReleaseBatch;
    }

    public void setProjectReleaseBatch(String projectReleaseBatch) {
        this.projectReleaseBatch = projectReleaseBatch;
    }

    public String getOwnerManager() {
        return ownerManager;
    }

    public void setOwnerManager(String ownerManager) {
        this.ownerManager = ownerManager;
    }

    public String getConstructionManagementUnit() {
        return constructionManagementUnit;
    }

    public void setConstructionManagementUnit(String constructionManagementUnit) {
        constructionManagementUnit = constructionManagementUnit;
    }

    public String getDqProjectManager() {
        return dqProjectManager;
    }

    public void setDqProjectManager(String dqProjectManager) {
        this.dqProjectManager = dqProjectManager;
    }

    public String getTjProjectManager() {
        return tjProjectManager;
    }

    public void setTjProjectManager(String tjProjectManager) {
        this.tjProjectManager = tjProjectManager;
    }

    public String getCjRemarks() {
        return cjRemarks;
    }

    public void setCjRemarks(String cjRemarks) {
        this.cjRemarks = cjRemarks;
    }

    public String getProjectApproval() {
        return projectApproval;
    }

    public void setProjectApproval(String projectApproval) {
        this.projectApproval = projectApproval;
    }

    public String getCompletionStatus() {
        return completionStatus;
    }

    public void setCompletionStatus(String completionStatus) {
        this.completionStatus = completionStatus;
    }

    public String getCompletionDate() {
        return completionDate;
    }

    public void setCompletionDate(String completionDate) {
        this.completionDate = completionDate;
    }

    public String getSettlementStatus() {
        return settlementStatus;
    }

    public void setSettlementStatus(String settlementStatus) {
        this.settlementStatus = settlementStatus;
    }

    public String getCloseStatus() {
        return closeStatus;
    }

    public void setCloseStatus(String closeStatus) {
        this.closeStatus = closeStatus;
    }

    public String getProjectDesignChangeStatus() {
        return projectDesignChangeStatus;
    }

    public void setProjectDesignChangeStatus(String projectDesignChangeStatus) {
        this.projectDesignChangeStatus = projectDesignChangeStatus;
    }

    public String getStockReturnStatus() {
        return stockReturnStatus;
    }

    public void setStockReturnStatus(String stockReturnStatus) {
        this.stockReturnStatus = stockReturnStatus;
    }

    public String getDesignChangeStatus() {
        return designChangeStatus;
    }

    public void setDesignChangeStatus(String designChangeStatus) {
        this.designChangeStatus = designChangeStatus;
    }

    public String getDesignChangeType() {
        return designChangeType;
    }

    public void setDesignChangeType(String designChangeType) {
        this.designChangeType = designChangeType;
    }

    public String getProposer() {
        return proposer;
    }

    public void setProposer(String proposer) {
        this.proposer = proposer;
    }

    public String getProposeReasons() {
        return proposeReasons;
    }

    public void setProposeReasons(String proposeReasons) {
        this.proposeReasons = proposeReasons;
    }

    public String getDesignChangeContent() {
        return designChangeContent;
    }

    public void setDesignChangeContent(String designChangeContent) {
        this.designChangeContent = designChangeContent;
    }

    public String getChangeType() {
        return changeType;
    }

    public void setChangeType(String changeType) {
        this.changeType = changeType;
    }

    public String getDesignChangeProposeTime() {
        return designChangeProposeTime;
    }

    public void setDesignChangeProposeTime(String designChangeProposeTime) {
        this.designChangeProposeTime = designChangeProposeTime;
    }

    public String getCompleteDesignChangeType() {
        return completeDesignChangeType;
    }

    public void setCompleteDesignChangeType(String completeDesignChangeType) {
        this.completeDesignChangeType = completeDesignChangeType;
    }

    public String getProjectManagerApproved() {
        return projectManagerApproved;
    }

    public void setProjectManagerApproved(String projectManagerApproved) {
        this.projectManagerApproved = projectManagerApproved;
    }

    public String getElectronDiagramCompleteTime() {
        return electronDiagramCompleteTime;
    }

    public void setElectronDiagramCompleteTime(String electronDiagramCompleteTime) {
        this.electronDiagramCompleteTime = electronDiagramCompleteTime;
    }

    public String getCompleteBudgetAdjust() {
        return completeBudgetAdjust;
    }

    public void setCompleteBudgetAdjust(String completeBudgetAdjust) {
        this.completeBudgetAdjust = completeBudgetAdjust;
    }

    public String getJjApproved() {
        return jjApproved;
    }

    public void setJjApproved(String jjApproved) {
        this.jjApproved = jjApproved;
    }

    public String getBudgetCompleteTime() {
        return budgetCompleteTime;
    }

    public void setBudgetCompleteTime(String budgetCompleteTime) {
        this.budgetCompleteTime = budgetCompleteTime;
    }

    public String getBeforeChangeBudget() {
        return beforeChangeBudget;
    }

    public void setBeforeChangeBudget(String beforeChangeBudget) {
        this.beforeChangeBudget = beforeChangeBudget;
    }

    public String getAfterChangeBudget() {
        return afterChangeBudget;
    }

    public void setAfterChangeBudget(String afterChangeBudget) {
        this.afterChangeBudget = afterChangeBudget;
    }

    public String getAfterChangeConstructionCost() {
        return afterChangeConstructionCost;
    }

    public void setAfterChangeConstructionCost(String afterChangeConstructionCost) {
        this.afterChangeConstructionCost = afterChangeConstructionCost;
    }

    public String getDrawingTransfer() {
        return drawingTransfer;
    }

    public void setDrawingTransfer(String drawingTransfer) {
        this.drawingTransfer = drawingTransfer;
    }

    public String getDrawingTransferTime() {
        return drawingTransferTime;
    }

    public void setDrawingTransferTime(String drawingTransferTime) {
        this.drawingTransferTime = drawingTransferTime;
    }

    public String getDesignChangeTime() {
        return designChangeTime;
    }

    public void setDesignChangeTime(String designChangeTime) {
        this.designChangeTime = designChangeTime;
    }

    public String getDataIntegrity() {
        return dataIntegrity;
    }

    public void setDataIntegrity(String dataIntegrity) {
        this.dataIntegrity = dataIntegrity;
    }

    public String getScanningCopy() {
        return scanningCopy;
    }

    public void setScanningCopy(String scanningCopy) {
        this.scanningCopy = scanningCopy;
    }

    @Override
    public String getRemarks() {
        return remarks;
    }

    @Override
    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }
}
