package com.jeeplus.modules.cg.reservemanagementcenter.distribution.entity;

import com.jeeplus.core.persistence.ActEntity;

/**
 * 配网项目问题表
 * @author 王强
 * @version 1.0
 * @date 2023-09-07 9:26
 */
public class DistributionNetwork extends ActEntity<DistributionNetwork> {

    //储备项目基本信息
    private String projectYear;             //项目年份
    private String projectNature;           //项目性质
    private String demandUnit;              //需求单位
    private String district;                //区域
    private String projectGroup;            //项目分组
    private String reserveBatches;          //储备批次
    private String blockSupply;             //供电区域
    private String gridNumber;              //网格编号
    private String cellNumber;              //单元格编号
    private String projectReserveId;        //项目储备编号
    private String projectName;             //项目名称
    private String stateGridProjectCode;             //国网项目编码
    private String stateGridProjectName;             //国网项目名称
    private String constructionNecessityAndContent;           //建设必要性及内容
    private String substationName;           //变电站名称
    private String circuitName;              //线路名称
    private String netRackProjectDivide;     //网架项目划分
    private String requirementType;          //需求类型
    private String projectType;              //项目类型
    private String costEstimate;             //费用估算
    private String remarks;                  //备注
    private String reserStatus;                 //储备流程状态
    //问题发起
    private String promoter;                  //问题发起人
    private String problemStage;              //问题所处阶段
    private String problemType;               //问题类型
    private String problemDescript;           //问题描述
    //业主项目经理
    private String problemSolver;             //问题解决人-经理
    private String problemResolved;           //问题是否解决-经理
    private String problemResolvedDescript;   //问题解决描述-经理
    private String designChange;              //是否需要设计变更-经理
    private String changeType;                //变更类型-经理
    private String designChangeType;          //设计变更类型-经理
    private String reportToLeader;            //是否需要上报业主领导
    //业主单位领导
    private String problemSolverLeader;       //问题解决人-领导
    private String problemResolvedLeader;         //问题是否解决-领导
    private String problemResolvedDescriptLeader; //问题解决描述-领导
    private String designChangeLeader;            //是否需要设计变更-领导
    private String changeTypeLeader;              //变更类型-领导
    private String designChangeTypeLeader;        //设计变更类型-领导
    private String processStatus;                 //流程状态

    public String getReserStatus() {
        return reserStatus;
    }

    public void setReserStatus(String reserStatus) {
        this.reserStatus = reserStatus;
    }

    public String getProjectYear() {
        return projectYear;
    }

    public void setProjectYear(String projectYear) {
        this.projectYear = projectYear;
    }

    public String getProjectNature() {
        return projectNature;
    }

    public void setProjectNature(String projectNature) {
        this.projectNature = projectNature;
    }

    public String getDemandUnit() {
        return demandUnit;
    }

    public void setDemandUnit(String demandUnit) {
        this.demandUnit = demandUnit;
    }

    public String getDistrict() {
        return district;
    }

    public void setDistrict(String district) {
        this.district = district;
    }

    public String getProjectGroup() {
        return projectGroup;
    }

    public void setProjectGroup(String projectGroup) {
        this.projectGroup = projectGroup;
    }

    public String getReserveBatches() {
        return reserveBatches;
    }

    public void setReserveBatches(String reserveBatches) {
        this.reserveBatches = reserveBatches;
    }

    public String getBlockSupply() {
        return blockSupply;
    }

    public void setBlockSupply(String blockSupply) {
        this.blockSupply = blockSupply;
    }

    public String getGridNumber() {
        return gridNumber;
    }

    public void setGridNumber(String gridNumber) {
        this.gridNumber = gridNumber;
    }

    public String getCellNumber() {
        return cellNumber;
    }

    public void setCellNumber(String cellNumber) {
        this.cellNumber = cellNumber;
    }

    public String getProjectReserveId() {
        return projectReserveId;
    }

    public void setProjectReserveId(String projectReserveId) {
        this.projectReserveId = projectReserveId;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getStateGridProjectCode() {
        return stateGridProjectCode;
    }

    public void setStateGridProjectCode(String stateGridProjectCode) {
        this.stateGridProjectCode = stateGridProjectCode;
    }

    public String getStateGridProjectName() {
        return stateGridProjectName;
    }

    public void setStateGridProjectName(String stateGridProjectName) {
        this.stateGridProjectName = stateGridProjectName;
    }

    public String getConstructionNecessityAndContent() {
        return constructionNecessityAndContent;
    }

    public void setConstructionNecessityAndContent(String constructionNecessityAndContent) {
        this.constructionNecessityAndContent = constructionNecessityAndContent;
    }

    public String getSubstationName() {
        return substationName;
    }

    public void setSubstationName(String substationName) {
        this.substationName = substationName;
    }

    public String getCircuitName() {
        return circuitName;
    }

    public void setCircuitName(String circuitName) {
        this.circuitName = circuitName;
    }

    public String getNetRackProjectDivide() {
        return netRackProjectDivide;
    }

    public void setNetRackProjectDivide(String netRackProjectDivide) {
        this.netRackProjectDivide = netRackProjectDivide;
    }

    public String getRequirementType() {
        return requirementType;
    }

    public void setRequirementType(String requirementType) {
        this.requirementType = requirementType;
    }

    public String getProjectType() {
        return projectType;
    }

    public void setProjectType(String projectType) {
        this.projectType = projectType;
    }

    public String getCostEstimate() {
        return costEstimate;
    }

    public void setCostEstimate(String costEstimate) {
        this.costEstimate = costEstimate;
    }

    @Override
    public String getRemarks() {
        return remarks;
    }

    @Override
    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    public String getPromoter() {
        return promoter;
    }

    public void setPromoter(String promoter) {
        this.promoter = promoter;
    }

    public String getProblemStage() {
        return problemStage;
    }

    public void setProblemStage(String problemStage) {
        this.problemStage = problemStage;
    }

    public String getProblemType() {
        return problemType;
    }

    public void setProblemType(String problemType) {
        this.problemType = problemType;
    }

    public String getProblemDescript() {
        return problemDescript;
    }

    public void setProblemDescript(String problemDescript) {
        this.problemDescript = problemDescript;
    }

    public String getProblemSolver() {
        return problemSolver;
    }

    public void setProblemSolver(String problemSolver) {
        this.problemSolver = problemSolver;
    }

    public String getProblemResolved() {
        return problemResolved;
    }

    public void setProblemResolved(String problemResolved) {
        this.problemResolved = problemResolved;
    }

    public String getProblemResolvedDescript() {
        return problemResolvedDescript;
    }

    public void setProblemResolvedDescript(String problemResolvedDescript) {
        this.problemResolvedDescript = problemResolvedDescript;
    }

    public String getDesignChange() {
        return designChange;
    }

    public void setDesignChange(String designChange) {
        this.designChange = designChange;
    }

    public String getChangeType() {
        return changeType;
    }

    public void setChangeType(String changeType) {
        this.changeType = changeType;
    }

    public String getDesignChangeType() {
        return designChangeType;
    }

    public void setDesignChangeType(String designChangeType) {
        this.designChangeType = designChangeType;
    }

    public String getReportToLeader() {
        return reportToLeader;
    }

    public void setReportToLeader(String reportToLeader) {
        this.reportToLeader = reportToLeader;
    }

    public String getProblemSolverLeader() {
        return problemSolverLeader;
    }

    public void setProblemSolverLeader(String problemSolverLeader) {
        this.problemSolverLeader = problemSolverLeader;
    }

    public String getProblemResolvedLeader() {
        return problemResolvedLeader;
    }

    public void setProblemResolvedLeader(String problemResolvedLeader) {
        this.problemResolvedLeader = problemResolvedLeader;
    }

    public String getProblemResolvedDescriptLeader() {
        return problemResolvedDescriptLeader;
    }

    public void setProblemResolvedDescriptLeader(String problemResolvedDescriptLeader) {
        this.problemResolvedDescriptLeader = problemResolvedDescriptLeader;
    }

    public String getDesignChangeLeader() {
        return designChangeLeader;
    }

    public void setDesignChangeLeader(String designChangeLeader) {
        this.designChangeLeader = designChangeLeader;
    }

    public String getChangeTypeLeader() {
        return changeTypeLeader;
    }

    public void setChangeTypeLeader(String changeTypeLeader) {
        this.changeTypeLeader = changeTypeLeader;
    }

    public String getDesignChangeTypeLeader() {
        return designChangeTypeLeader;
    }

    public void setDesignChangeTypeLeader(String designChangeTypeLeader) {
        this.designChangeTypeLeader = designChangeTypeLeader;
    }

    public String getProcessStatus() {
        return processStatus;
    }

    public void setProcessStatus(String processStatus) {
        this.processStatus = processStatus;
    }
}
