package com.jeeplus.modules.cg.reservemanagementcenter.distribution.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.distribution.entity.DistributionDesignChange;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-09-07 10:04
 */
@MyBatisMapper
public interface DistributionDesignChangeMapper extends BaseMapper<DistributionDesignChange> {

    /**
     * 通过流程定义号删除流程对应信息
     * */
    void deleteAct(String projectReserveId);

    /**
     * 根据项目储备编号查数据
     * @param reserveId
     * @return
     */
    DistributionDesignChange getByReserveId(String reserveId);

    /**
     * 批量添加政策处理基本信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<DistributionDesignChange> list);

    /**
     * 根据项目储备编号删除政策处理基本信息
     * @param projectReserveId
     */
    void deleteByProjectReserveId(String projectReserveId);

    /**
     * 根据项目储备id查询政策处理基本信息
     * @param reserveManagement
     * @return
     */
    DistributionDesignChange queryByProjectReserveId(DistributionDesignChange reserveManagement);

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId();

    /**
     * 从基本数据表中获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId2();

    /**
     * 导出数据查询
     * @param reserveManagement
     * @return
     */
    List<DistributionDesignChange> exportFindList(DistributionDesignChange reserveManagement);

    /**
     * 根据projectReserveId查出proc_ins_id
     * @param projectReserveId
     * @return
     */
    String getByProjectReserveId(String projectReserveId);

    /**
     * 根据executeId查出历史节点信息
     * @param executeId
     * @return
     */
    List<History> getHistoryByExecuteId(String executeId);

    /**
     * 根据executeId查出当前节点的名称
     * @param executeId
     * @return
     */
    String getByExecuteId(String executeId);

    String getByUserName(String name);
}
