package com.jeeplus.modules.cg.reservemanagementcenter.distribution.service;

import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.cg.reservemanagementcenter.distribution.entity.DistributionNetworkProcess;
import com.jeeplus.modules.cg.reservemanagementcenter.distribution.mapper.DistributionNetworkProcessMapper;
import com.jeeplus.modules.sys.entity.User;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-09-07 16:04
 */
@Service
@Transactional(readOnly = true)
public class DistributionNetworkProcessService extends CrudService<DistributionNetworkProcessMapper, DistributionNetworkProcess> {

    @Override
    public DistributionNetworkProcess get(String id) {
        DistributionNetworkProcess entity = new DistributionNetworkProcess();
        entity.setId(id);
        String projectId = mapper.findProjectId(entity);
        DistributionNetworkProcess reserveProcess = mapper.get(projectId);
        return reserveProcess;
    }

    @Transactional(readOnly = false)
    public void insert(DistributionNetworkProcess entity) {
        mapper.insert(entity);
    }

    public List<String> getUserInfo(){
        return mapper.getUserInfo();
    }
}
