package com.jeeplus.modules.cg.reservemanagementcenter.distribution.util;

import com.jeeplus.modules.cg.reservemanagementcenter.distribution.entity.DistributionDesignChange;
import com.jeeplus.modules.cg.reservemanagementcenter.distribution.entity.DistributionNetwork;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLEncoder;
import java.util.List;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-09-07 9:37
 */
public class DistributionExportUtil {

    private XSSFCellStyle style = null;

    public static DistributionExportUtil getOne(){

        return new DistributionExportUtil();
    }

    /**
     * 导出政配网项目问题表信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportDistributionNetwork(HttpServletResponse response, XSSFWorkbook workbook, List<DistributionNetwork> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 2;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //国网项目编码
                Cell cell13 = crateCell(workbook,row,13); //国网项目名称
                Cell cell14 = crateCell(workbook,row,14); //建设必要性及内容
                Cell cell15 = crateCell(workbook,row,15); //变电站名称
                Cell cell16 = crateCell(workbook,row,16); //线路名称
                Cell cell17 = crateCell(workbook,row,17); //网架项目划分
                Cell cell18 = crateCell(workbook,row,18); //需求类型
                Cell cell19 = crateCell(workbook,row,19); //项目类型
                Cell cell20 = crateCell(workbook,row,20); //费用估算
                Cell cell21 = crateCell(workbook,row,21); //备注

                Cell cell22 = crateCell(workbook,row,22); //问题发起人
                Cell cell23 = crateCell(workbook,row,23); //问题所处阶段
                Cell cell24 = crateCell(workbook,row,24); //问题类型
                Cell cell25 = crateCell(workbook,row,25); //问题描述
                Cell cell26 = crateCell(workbook,row,26); //问题解决人
                Cell cell27 = crateCell(workbook,row,27); //问题是否解决
                Cell cell28 = crateCell(workbook,row,28); //问题解决描述

                Cell cell29 = crateCell(workbook,row,29); //是否需要设计变更
                Cell cell30 = crateCell(workbook,row,30); //变更类型
                Cell cell31 = crateCell(workbook,row,31); //设计变更类型
                Cell cell32 = crateCell(workbook,row,32); //是否需要上报业主领导

                Cell cell33 = crateCell(workbook,row,33); //问题解决人
                Cell cell34 = crateCell(workbook,row,34); //问题是否解决
                Cell cell35 = crateCell(workbook,row,35); //问题解决描述
                Cell cell36 = crateCell(workbook,row,36); //是否需要设计变更
                Cell cell37 = crateCell(workbook,row,37); //变更类型
                Cell cell38 = crateCell(workbook,row,38); //设计变更类型

                DistributionNetwork reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getReserveBatches());
                cell7.setCellValue(reserveManagement.getBlockSupply());
                cell8.setCellValue(reserveManagement.getGridNumber());
                cell9.setCellValue(reserveManagement.getCellNumber());
                cell10.setCellValue(reserveManagement.getProjectReserveId());
                cell11.setCellValue(reserveManagement.getProjectName());
                cell12.setCellValue(reserveManagement.getStateGridProjectCode());
                cell13.setCellValue(reserveManagement.getStateGridProjectName());
                cell14.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell15.setCellValue(reserveManagement.getSubstationName());
                cell16.setCellValue(reserveManagement.getCircuitName());
                cell17.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell18.setCellValue(reserveManagement.getRequirementType());
                cell19.setCellValue(reserveManagement.getProjectType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell20.setCellValue(Double.parseDouble(costEstimateStr));
                }

                cell21.setCellValue(reserveManagement.getRemarks());

                cell22.setCellValue(reserveManagement.getPromoter());
                cell23.setCellValue(reserveManagement.getProblemStage());
                cell24.setCellValue(reserveManagement.getProblemType());
                cell25.setCellValue(reserveManagement.getProblemDescript());
                cell26.setCellValue(reserveManagement.getProblemSolver());
                cell27.setCellValue(reserveManagement.getProblemResolved());
                cell28.setCellValue(reserveManagement.getProblemResolvedDescript());
                cell29.setCellValue(reserveManagement.getDesignChange());
                cell30.setCellValue(reserveManagement.getChangeType());
                cell31.setCellValue(reserveManagement.getDesignChangeType());
                cell32.setCellValue(reserveManagement.getReportToLeader());
                cell33.setCellValue(reserveManagement.getProblemSolverLeader());
                cell34.setCellValue(reserveManagement.getProblemResolvedLeader());
                cell35.setCellValue(reserveManagement.getProblemResolvedDescriptLeader());
                cell36.setCellValue(reserveManagement.getDesignChangeLeader());
                cell37.setCellValue(reserveManagement.getChangeTypeLeader());
                cell38.setCellValue(reserveManagement.getDesignChangeTypeLeader());

            }

            String str = URLEncoder.encode("配网项目问题表信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出配网项目设计变更记录表信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportDistributionDesignChange(HttpServletResponse response, XSSFWorkbook workbook, List<DistributionDesignChange> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 2;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //国网项目编码
                Cell cell13 = crateCell(workbook,row,13); //国网项目名称
                Cell cell14 = crateCell(workbook,row,14); //建设必要性及内容
                Cell cell15 = crateCell(workbook,row,15); //变电站名称
                Cell cell16 = crateCell(workbook,row,16); //线路名称
                Cell cell17 = crateCell(workbook,row,17); //网架项目划分
                Cell cell18 = crateCell(workbook,row,18); //需求类型
                Cell cell19 = crateCell(workbook,row,19); //项目类型
                Cell cell20 = crateCell(workbook,row,20); //费用估算
                Cell cell21 = crateCell(workbook,row,21); //备注

                Cell cell22 = crateCell(workbook,row,22); //项目下达批次
                Cell cell23 = crateCell(workbook,row,23); //业主项目经理
                Cell cell24 = crateCell(workbook,row,24); //现场施工管理单位
                Cell cell25 = crateCell(workbook,row,25); //施工项目经理(电气)
                Cell cell26 = crateCell(workbook,row,26); //施工项目经理(土建)
                Cell cell27 = crateCell(workbook,row,27); //备注

                Cell cell28 = crateCell(workbook,row,28); //是否立项
                Cell cell29 = crateCell(workbook,row,29); //竣工情况
                Cell cell30 = crateCell(workbook,row,30); //竣工日期
                Cell cell31 = crateCell(workbook,row,31); //结算状态
                Cell cell32 = crateCell(workbook,row,32); //关闭状态
                Cell cell33 = crateCell(workbook,row,33); //设计变更状态
                Cell cell34 = crateCell(workbook,row,34); //拆旧物资退库状态

                Cell cell35 = crateCell(workbook,row,35); //设计变更状态
                Cell cell36 = crateCell(workbook,row,36); //设计变更类型
                Cell cell37 = crateCell(workbook,row,37); //提出人
                Cell cell38 = crateCell(workbook,row,38); //提出原因
                Cell cell39 = crateCell(workbook,row,39); //设计变更内容
                Cell cell40 = crateCell(workbook,row,40); //变更类型
                Cell cell41 = crateCell(workbook,row,41); //设计变更提出时间
                Cell cell42 = crateCell(workbook,row,42); //是否完成设计变更
                Cell cell43 = crateCell(workbook,row,43); //项目经理是否审核通过
                Cell cell44 = crateCell(workbook,row,44); //电子图变更完成时间
                Cell cell45 = crateCell(workbook,row,45); //是否完成概预算调整
                Cell cell46 = crateCell(workbook,row,46); //设计是否审核通过
                Cell cell47 = crateCell(workbook,row,47); //概预算变更完成时间
                Cell cell48 = crateCell(workbook,row,48); //变更前预算
                Cell cell49 = crateCell(workbook,row,49); //变更后预算
                Cell cell50 = crateCell(workbook,row,50); //变更后施工费
                Cell cell51 = crateCell(workbook,row,51); //变更纸质图纸是否移交
                Cell cell52 = crateCell(workbook,row,52); //变更纸质图纸移交时间
                Cell cell53 = crateCell(workbook,row,53); //设计变更时长
                Cell cell54 = crateCell(workbook,row,54); //设计变更签字资料是否完整
                Cell cell55 = crateCell(workbook,row,55); //扫描件
                Cell cell56 = crateCell(workbook,row,56); //备注

                DistributionDesignChange reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getReserveBatches());
                cell7.setCellValue(reserveManagement.getBlockSupply());
                cell8.setCellValue(reserveManagement.getGridNumber());
                cell9.setCellValue(reserveManagement.getCellNumber());
                cell10.setCellValue(reserveManagement.getProjectReserveId());
                cell11.setCellValue(reserveManagement.getProjectName());
                cell12.setCellValue(reserveManagement.getStateGridProjectCode());
                cell13.setCellValue(reserveManagement.getStateGridProjectName());
                cell14.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell15.setCellValue(reserveManagement.getSubstationName());
                cell16.setCellValue(reserveManagement.getCircuitName());
                cell17.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell18.setCellValue(reserveManagement.getRequirementType());
                cell19.setCellValue(reserveManagement.getProjectType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell20.setCellValue(Double.parseDouble(costEstimateStr));
                }

                cell21.setCellValue(reserveManagement.getBasicRemarks());
                cell22.setCellValue(reserveManagement.getProjectReleaseBatch());
                cell23.setCellValue(reserveManagement.getOwnerManager());
                cell24.setCellValue(reserveManagement.getConstructionManagementUnit());
                cell25.setCellValue(reserveManagement.getDqProjectManager());
                cell26.setCellValue(reserveManagement.getTjProjectManager());
                cell27.setCellValue(reserveManagement.getCjRemarks());
                cell28.setCellValue(reserveManagement.getProjectApproval());
                cell29.setCellValue(reserveManagement.getCompletionStatus());
                cell30.setCellValue(reserveManagement.getCompletionDate());
                cell31.setCellValue(reserveManagement.getSettlementStatus());
                cell32.setCellValue(reserveManagement.getCloseStatus());
                cell33.setCellValue(reserveManagement.getProjectDesignChangeStatus());
                cell34.setCellValue(reserveManagement.getStockReturnStatus());
                cell35.setCellValue(reserveManagement.getDesignChangeStatus());
                cell36.setCellValue(reserveManagement.getDesignChangeType());
                cell37.setCellValue(reserveManagement.getProposer());
                cell38.setCellValue(reserveManagement.getProposeReasons());
                cell39.setCellValue(reserveManagement.getDesignChangeContent());
                cell40.setCellValue(reserveManagement.getChangeType());
                cell41.setCellValue(reserveManagement.getDesignChangeProposeTime());
                cell42.setCellValue(reserveManagement.getCompleteDesignChangeType());
                cell43.setCellValue(reserveManagement.getProjectManagerApproved());
                cell44.setCellValue(reserveManagement.getElectronDiagramCompleteTime());
                cell45.setCellValue(reserveManagement.getCompleteBudgetAdjust());
                cell46.setCellValue(reserveManagement.getJjApproved());
                cell47.setCellValue(reserveManagement.getBudgetCompleteTime());
                cell48.setCellValue(reserveManagement.getBeforeChangeBudget());
                cell49.setCellValue(reserveManagement.getAfterChangeBudget());
                cell50.setCellValue(reserveManagement.getAfterChangeConstructionCost());
                cell51.setCellValue(reserveManagement.getDrawingTransfer());
                cell52.setCellValue(reserveManagement.getDrawingTransferTime());
                cell53.setCellValue(reserveManagement.getDesignChangeTime());
                cell54.setCellValue(reserveManagement.getDataIntegrity());
                cell55.setCellValue(reserveManagement.getScanningCopy());
                cell56.setCellValue(reserveManagement.getRemarks());

            }

            String str = URLEncoder.encode("配网项目设计变更记录表信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    /**
     * 传入excel模板名称 获取workbook对象
     * @param fileName excel模板名称
     * @return
     */
    public XSSFWorkbook getWorkbook(String fileName){
        InputStream inputStream = null;
        XSSFWorkbook workbook = null;
        try {
            File file = new File(this.getClass().getResource("/").getPath() + "/freemarker/excelmodel/"+fileName+".xlsx");
            inputStream = new FileInputStream(file);// 将excel文件转为输入流
            workbook = new XSSFWorkbook(inputStream);// 创建个workbook，
        } catch (Exception e) {
            e.printStackTrace();
        }
        return workbook;
    }

    /**
     * 创建Cell对象 同时设置style
     * @param workbook
     * @param row
     * @param num
     * @return
     */
    Cell crateCell(XSSFWorkbook workbook, Row row, int num){
        Cell cell = row.createCell(num);
        if(style == null){
            style =workbook.createCellStyle();
            style.setWrapText(true);
            style.setVerticalAlignment(XSSFCellStyle.VERTICAL_CENTER);
        }
        cell.setCellStyle(style);
        return cell;
    }
}
