package com.jeeplus.modules.cg.reservemanagementcenter.distribution.util;

import com.jeeplus.modules.cg.reservemanagementcenter.distribution.entity.DistributionDesignChange;
import com.jeeplus.modules.cg.reservemanagementcenter.distribution.entity.DistributionNetwork;
import com.jeeplus.modules.sg.managementcenter.materialproject.util.ImportUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Row;

import java.util.ArrayList;
import java.util.List;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-09-07 9:37
 */
public class DistributionImportUtil {

    /**
     * 获取配网项目问题表数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<DistributionNetwork> getDistributionNetworkUtil(ImportUtil importUtil, List<String> proIdList, List<String> proIdList2) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<DistributionNetwork> list = new ArrayList<DistributionNetwork>();

        //项目储备编号唯一性判断
        List<String> cbbhList = new ArrayList<>();

        //建设必要性及内容
        List<String> jsList = new ArrayList<>();
        DistributionNetwork reserveManagement = null;
        for(int i=2; i<=lastRow;i++){
            reserveManagement = new DistributionNetwork();
            Row row = importUtil.getRow(i);
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 10);
            if(StringUtils.isNotBlank(projectReserveId)){

                reserveManagement.setProjectReserveId((String) importUtil.getCellValue(row,10));

                //和基本信息表比对，是否有对应的数据
                getBmList2(proIdList2,reserveManagement.getProjectReserveId());

                reserveManagement.setPromoter((String) importUtil.getCellValue(row,22));
                reserveManagement.setProblemStage((String) importUtil.getCellValue(row,23));
                reserveManagement.setProblemType((String) importUtil.getCellValue(row,24));
                reserveManagement.setProblemDescript((String) importUtil.getCellValue(row,25));
                reserveManagement.setProblemSolver((String) importUtil.getCellValue(row,26));
                reserveManagement.setProblemResolved((String) importUtil.getCellValue(row,27));
                reserveManagement.setProblemResolvedDescript((String) importUtil.getCellValue(row,28));
                reserveManagement.setDesignChange((String) importUtil.getCellValue(row,29));
                reserveManagement.setChangeType((String) importUtil.getCellValue(row,30));
                reserveManagement.setDesignChangeType((String) importUtil.getCellValue(row,31));
                reserveManagement.setReportToLeader((String) importUtil.getCellValue(row,32));
                reserveManagement.setProblemSolverLeader((String) importUtil.getCellValue(row,33));
                reserveManagement.setProblemResolvedLeader((String) importUtil.getCellValue(row,34));
                reserveManagement.setProblemResolvedDescriptLeader((String) importUtil.getCellValue(row,35));
                reserveManagement.setDesignChangeLeader((String) importUtil.getCellValue(row,36));
                reserveManagement.setChangeTypeLeader((String) importUtil.getCellValue(row,37));
                reserveManagement.setDesignChangeTypeLeader((String) importUtil.getCellValue(row,38));
                reserveManagement.setProcessStatus("0");


                if (list.size() == 0){
                    list.add(reserveManagement);
                    cbbhList.add(reserveManagement.getProjectReserveId());
                }else {
                    if (!cbbhList.contains(reserveManagement.getProjectReserveId())){
                        list.add(reserveManagement);
                        cbbhList.add(reserveManagement.getProjectReserveId());
                        jsList.add(reserveManagement.getConstructionNecessityAndContent());
                    }
                }

            }
        }
        return list;
    }

    /**
     * 获取配网项目设计变更记录表数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<DistributionDesignChange> getDistributionDesignChangeUtil(ImportUtil importUtil, List<String> proIdList, List<String> proIdList2) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<DistributionDesignChange> list = new ArrayList<DistributionDesignChange>();

        //项目储备编号唯一性判断
        List<String> cbbhList = new ArrayList<>();

        //建设必要性及内容
        List<String> jsList = new ArrayList<>();
        DistributionDesignChange reserveManagement = null;
        for(int i=2; i<=lastRow;i++){
            reserveManagement = new DistributionDesignChange();
            Row row = importUtil.getRow(i);
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 10);
            if(StringUtils.isNotBlank(projectReserveId)){

                reserveManagement.setProjectReserveId((String) importUtil.getCellValue(row,10));

                //和基本信息表比对，是否有对应的数据
                getBmList2(proIdList2,reserveManagement.getProjectReserveId());

                reserveManagement.setDesignChangeContent((String) importUtil.getCellValue(row,39));
                reserveManagement.setDrawingTransfer((String) importUtil.getCellValue(row,51));
                reserveManagement.setDrawingTransferTime((String) importUtil.getCellValue(row,52));
                reserveManagement.setDataIntegrity((String) importUtil.getCellValue(row,54));
                reserveManagement.setRemarks((String) importUtil.getCellValue(row,56));


                if (list.size() == 0){
                    list.add(reserveManagement);
                    cbbhList.add(reserveManagement.getProjectReserveId());
                }else {
                    if (!cbbhList.contains(reserveManagement.getProjectReserveId())){
                        list.add(reserveManagement);
                        cbbhList.add(reserveManagement.getProjectReserveId());
                        jsList.add(reserveManagement.getConstructionNecessityAndContent());
                    }
                }

            }
        }
        return list;
    }

    public static void getBmList2(List<String> sjkList, String proId) throws Exception {
        if (!sjkList.contains(proId)){
            throw new Exception( "项目储备编号为" + proId + "等项目在基础信息表中不存在相关数据！");
        }
    }
}
