package com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.entity;

import com.jeeplus.core.persistence.ActEntity;

/**
 * 政策处理基本信息表
 * @author 王强
 * @version 1.0
 * @date 2023-09-01 10:53
 */
public class PoliceProcessBase extends ActEntity<PoliceProcessBase> {
    //储备项目基本信息
    private String projectManager;          //项目储备经理
    private String projectYear;             //项目年份
    private String projectNature;           //项目性质
    private String demandUnit;              //需求单位
    private String district;                //区域
    private String projectGroup;            //项目分组
    private String reserveBatches;          //储备批次
    private String blockSupply;             //供电区域
    private String gridNumber;              //网格编号
    private String cellNumber;              //单元格编号
    private String projectReserveId;        //项目储备编号
    private String projectName;             //项目名称
    private String stateGridProjectCode;             //国网项目编码
    private String stateGridProjectName;             //国网项目名称
    private String constructionNecessityAndContent;           //建设必要性及内容
    private String substationName;           //变电站名称
    private String circuitName;              //线路名称
    private String netRackProjectDivide;     //网架项目划分
    private String requirementType;          //需求类型
    private String projectType;              //项目类型
    private String costEstimate;             //费用估算
    private String remarks;                  //备注

    //储备进度
    private String reserveProgress;          //储备进度
    private String implementPlan;            //是否纳入实施计划
    private String implementBatch;           //初定实施批次

    //工作量统计
    private String civilEngineeringWorkload; //是否含土建工作量
    private String engineeringWorkloadStatistic; //土建工作量统计
    private String poleWorkload;             //是否含立杆工作量
    private String poleWorkloadStatistic;    //立杆工作量统计
    private String workRemark;               //工作量统计-备注

    //政策处理基本信息
    private String powerStationJurisdiction;        //供电所辖区
    private String constructionLocation;            //施工地点
    private String whetherExitPolitical;            //是否存在政处
    private String politicalType;                   //政处类型
    private String politicalDescribe;               //政处描述
    private String politicalDifficulty;             //政处难度
    private String whetherReport;                   //是否需规划报批
    private String safetyProcedures;                //是否需办理安评手续
    private String aviationReviewProcedures;        //是否需办理航评手续
    private String startPolitical;                  //是否启动政处
    private String startTime;                       //启动时间
    private String politicalRemarks;                //政处备注


    public String getProjectManager() {
        return projectManager;
    }

    public void setProjectManager(String projectManager) {
        this.projectManager = projectManager;
    }

    public String getProjectYear() {
        return projectYear;
    }

    public void setProjectYear(String projectYear) {
        this.projectYear = projectYear;
    }

    public String getProjectNature() {
        return projectNature;
    }

    public void setProjectNature(String projectNature) {
        this.projectNature = projectNature;
    }

    public String getDemandUnit() {
        return demandUnit;
    }

    public void setDemandUnit(String demandUnit) {
        this.demandUnit = demandUnit;
    }

    public String getDistrict() {
        return district;
    }

    public void setDistrict(String district) {
        this.district = district;
    }

    public String getProjectGroup() {
        return projectGroup;
    }

    public void setProjectGroup(String projectGroup) {
        this.projectGroup = projectGroup;
    }

    public String getReserveBatches() {
        return reserveBatches;
    }

    public void setReserveBatches(String reserveBatches) {
        this.reserveBatches = reserveBatches;
    }

    public String getBlockSupply() {
        return blockSupply;
    }

    public void setBlockSupply(String blockSupply) {
        this.blockSupply = blockSupply;
    }

    public String getGridNumber() {
        return gridNumber;
    }

    public void setGridNumber(String gridNumber) {
        this.gridNumber = gridNumber;
    }

    public String getCellNumber() {
        return cellNumber;
    }

    public void setCellNumber(String cellNumber) {
        this.cellNumber = cellNumber;
    }

    public String getProjectReserveId() {
        return projectReserveId;
    }

    public void setProjectReserveId(String projectReserveId) {
        this.projectReserveId = projectReserveId;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getStateGridProjectCode() {
        return stateGridProjectCode;
    }

    public void setStateGridProjectCode(String stateGridProjectCode) {
        this.stateGridProjectCode = stateGridProjectCode;
    }

    public String getStateGridProjectName() {
        return stateGridProjectName;
    }

    public void setStateGridProjectName(String stateGridProjectName) {
        this.stateGridProjectName = stateGridProjectName;
    }

    public String getConstructionNecessityAndContent() {
        return constructionNecessityAndContent;
    }

    public void setConstructionNecessityAndContent(String constructionNecessityAndContent) {
        this.constructionNecessityAndContent = constructionNecessityAndContent;
    }

    public String getSubstationName() {
        return substationName;
    }

    public void setSubstationName(String substationName) {
        this.substationName = substationName;
    }

    public String getCircuitName() {
        return circuitName;
    }

    public void setCircuitName(String circuitName) {
        this.circuitName = circuitName;
    }

    public String getNetRackProjectDivide() {
        return netRackProjectDivide;
    }

    public void setNetRackProjectDivide(String netRackProjectDivide) {
        this.netRackProjectDivide = netRackProjectDivide;
    }

    public String getRequirementType() {
        return requirementType;
    }

    public void setRequirementType(String requirementType) {
        this.requirementType = requirementType;
    }

    public String getProjectType() {
        return projectType;
    }

    public void setProjectType(String projectType) {
        this.projectType = projectType;
    }

    public String getCostEstimate() {
        return costEstimate;
    }

    public void setCostEstimate(String costEstimate) {
        this.costEstimate = costEstimate;
    }

    @Override
    public String getRemarks() {
        return remarks;
    }

    @Override
    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    public String getReserveProgress() {
        return reserveProgress;
    }

    public void setReserveProgress(String reserveProgress) {
        this.reserveProgress = reserveProgress;
    }

    public String getImplementPlan() {
        return implementPlan;
    }

    public void setImplementPlan(String implementPlan) {
        this.implementPlan = implementPlan;
    }

    public String getImplementBatch() {
        return implementBatch;
    }

    public void setImplementBatch(String implementBatch) {
        this.implementBatch = implementBatch;
    }

    public String getCivilEngineeringWorkload() {
        return civilEngineeringWorkload;
    }

    public void setCivilEngineeringWorkload(String civilEngineeringWorkload) {
        this.civilEngineeringWorkload = civilEngineeringWorkload;
    }

    public String getEngineeringWorkloadStatistic() {
        return engineeringWorkloadStatistic;
    }

    public void setEngineeringWorkloadStatistic(String engineeringWorkloadStatistic) {
        this.engineeringWorkloadStatistic = engineeringWorkloadStatistic;
    }

    public String getPoleWorkload() {
        return poleWorkload;
    }

    public void setPoleWorkload(String poleWorkload) {
        this.poleWorkload = poleWorkload;
    }

    public String getPoleWorkloadStatistic() {
        return poleWorkloadStatistic;
    }

    public void setPoleWorkloadStatistic(String poleWorkloadStatistic) {
        this.poleWorkloadStatistic = poleWorkloadStatistic;
    }

    public String getWorkRemark() {
        return workRemark;
    }

    public void setWorkRemark(String workRemark) {
        this.workRemark = workRemark;
    }

    public String getPowerStationJurisdiction() {
        return powerStationJurisdiction;
    }

    public void setPowerStationJurisdiction(String powerStationJurisdiction) {
        this.powerStationJurisdiction = powerStationJurisdiction;
    }

    public String getConstructionLocation() {
        return constructionLocation;
    }

    public void setConstructionLocation(String constructionLocation) {
        this.constructionLocation = constructionLocation;
    }

    public String getWhetherExitPolitical() {
        return whetherExitPolitical;
    }

    public void setWhetherExitPolitical(String whetherExitPolitical) {
        this.whetherExitPolitical = whetherExitPolitical;
    }

    public String getPoliticalType() {
        return politicalType;
    }

    public void setPoliticalType(String politicalType) {
        this.politicalType = politicalType;
    }

    public String getPoliticalDescribe() {
        return politicalDescribe;
    }

    public void setPoliticalDescribe(String politicalDescribe) {
        this.politicalDescribe = politicalDescribe;
    }

    public String getPoliticalDifficulty() {
        return politicalDifficulty;
    }

    public void setPoliticalDifficulty(String politicalDifficulty) {
        this.politicalDifficulty = politicalDifficulty;
    }

    public String getWhetherReport() {
        return whetherReport;
    }

    public void setWhetherReport(String whetherReport) {
        this.whetherReport = whetherReport;
    }

    public String getSafetyProcedures() {
        return safetyProcedures;
    }

    public void setSafetyProcedures(String safetyProcedures) {
        this.safetyProcedures = safetyProcedures;
    }

    public String getAviationReviewProcedures() {
        return aviationReviewProcedures;
    }

    public void setAviationReviewProcedures(String aviationReviewProcedures) {
        this.aviationReviewProcedures = aviationReviewProcedures;
    }

    public String getStartPolitical() {
        return startPolitical;
    }

    public void setStartPolitical(String startPolitical) {
        this.startPolitical = startPolitical;
    }

    public String getStartTime() {
        return startTime;
    }

    public void setStartTime(String startTime) {
        this.startTime = startTime;
    }

    public String getPoliticalRemarks() {
        return politicalRemarks;
    }

    public void setPoliticalRemarks(String politicalRemarks) {
        this.politicalRemarks = politicalRemarks;
    }
}
