package com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.entity;

import com.jeeplus.core.persistence.ActEntity;

/**
 * 政策处理记录表
 * @author 王强
 * @version 1.0
 * @date 2023-09-01 14:03
 */
public class PoliceProcessRecord extends ActEntity<PoliceProcessRecord> {
    //储备项目基本信息
    private String projectYear;             //项目年份
    private String projectNature;           //项目性质
    private String demandUnit;              //需求单位
    private String district;                //区域
    private String projectGroup;            //项目分组
    private String reserveBatches;          //储备批次
    private String blockSupply;             //供电区域
    private String gridNumber;              //网格编号
    private String cellNumber;              //单元格编号
    private String projectReserveId;        //项目储备编号
    private String projectName;             //项目名称
    private String stateGridProjectCode;             //国网项目编码
    private String stateGridProjectName;             //国网项目名称
    private String constructionNecessityAndContent;           //建设必要性及内容
    private String substationName;           //变电站名称
    private String circuitName;              //线路名称
    private String netRackProjectDivide;     //网架项目划分
    private String requirementType;          //需求类型
    private String projectType;              //项目类型
    private String costEstimate;             //费用估算
    private String remarks;                  //备注
    //项目参建（单位）人员信息
    private String implementBatch;           //初定实施批次
    private String constructionUnit;        //初定施工单位
    private String projectReleaseBatch;     //项目下达批次
    private String ownerManager;            //业主项目经理
    private String constructionManagementUnit;          //现场施工管理单位
    private String dqProjectManager;          //施工项目经理(电气)
    private String tjProjectManager;          //施工项目经理(土建)
    //分包队伍
    private String dqSubcontractingUnit;      //电气分包单位
    private String dqContacts;                //电气联系人
    private String tjSubcontractingUnit;      //土建分包单位
    private String tjContacts;                //土建联系人
    private String subpackageRemarks;         //分包队伍-备注
    //项目工程量统计
    private String civilEngineer;               //是否含土建
    private String civilEngineerStatistic;      //土建工作量统计
    private String poleWorkload;                //是否含立杆工作量
    private String poleWorkloadStatistic;       //立杆工作量统计
    private String statisticRemarks;            //立杆工作量统计-备注
    //政处记录
    private String serialNumber;                //序号
    private String startPoliticalWork;          //是否启动政处工作
    private String startPoliticalWork2;          //是否启动政处工作
    private String startTime;                   //启动时间
    private String startTime2;                   //启动时间
    private String administrativeObject;        //政处对象
    private String needCompensation;            //是否需赔付
    private String compensationContent;         //赔付内容
    private String compensationMoney;           //赔付金额
    private String documentCommitTime;           //签字政处单据提交时间
    private String financialPayment;            //是否财政付款
    private String needSignContract;            //是否需签订合同
    private String signContractTime;            //政处合同完成签订时间
    private String weatherLoan;                 //是否借款
    private String loanTime;                    //借款支付时间
    private String completeFinancialReimbursement;    //是否完成财务报销
    private String completeFinancialReimbursementTime;    //财务报销完成时间
    private String possibleToEnterSite;         //是否可进场
    private String possibleToEnterSiteTime;     //可进场日期
    private String completeProcess;             //政处是否完成
    private String negotiatingUnit;             //政处洽谈单位
    private String coordinateUnit;             //政处配合单位
    private String recordRemarks;               //政处记录-备注

    public String getStartPoliticalWork2() {
        return startPoliticalWork2;
    }

    public void setStartPoliticalWork2(String startPoliticalWork2) {
        this.startPoliticalWork2 = startPoliticalWork2;
    }

    public String getStartTime2() {
        return startTime2;
    }

    public void setStartTime2(String startTime2) {
        this.startTime2 = startTime2;
    }

    public String getProjectYear() {
        return projectYear;
    }

    public void setProjectYear(String projectYear) {
        this.projectYear = projectYear;
    }

    public String getProjectNature() {
        return projectNature;
    }

    public void setProjectNature(String projectNature) {
        this.projectNature = projectNature;
    }

    public String getDemandUnit() {
        return demandUnit;
    }

    public void setDemandUnit(String demandUnit) {
        this.demandUnit = demandUnit;
    }

    public String getDistrict() {
        return district;
    }

    public void setDistrict(String district) {
        this.district = district;
    }

    public String getProjectGroup() {
        return projectGroup;
    }

    public void setProjectGroup(String projectGroup) {
        this.projectGroup = projectGroup;
    }

    public String getReserveBatches() {
        return reserveBatches;
    }

    public void setReserveBatches(String reserveBatches) {
        this.reserveBatches = reserveBatches;
    }

    public String getBlockSupply() {
        return blockSupply;
    }

    public void setBlockSupply(String blockSupply) {
        this.blockSupply = blockSupply;
    }

    public String getGridNumber() {
        return gridNumber;
    }

    public void setGridNumber(String gridNumber) {
        this.gridNumber = gridNumber;
    }

    public String getCellNumber() {
        return cellNumber;
    }

    public void setCellNumber(String cellNumber) {
        this.cellNumber = cellNumber;
    }

    public String getProjectReserveId() {
        return projectReserveId;
    }

    public void setProjectReserveId(String projectReserveId) {
        this.projectReserveId = projectReserveId;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getStateGridProjectCode() {
        return stateGridProjectCode;
    }

    public void setStateGridProjectCode(String stateGridProjectCode) {
        this.stateGridProjectCode = stateGridProjectCode;
    }

    public String getStateGridProjectName() {
        return stateGridProjectName;
    }

    public void setStateGridProjectName(String stateGridProjectName) {
        this.stateGridProjectName = stateGridProjectName;
    }

    public String getConstructionNecessityAndContent() {
        return constructionNecessityAndContent;
    }

    public void setConstructionNecessityAndContent(String constructionNecessityAndContent) {
        this.constructionNecessityAndContent = constructionNecessityAndContent;
    }

    public String getSubstationName() {
        return substationName;
    }

    public void setSubstationName(String substationName) {
        this.substationName = substationName;
    }

    public String getCircuitName() {
        return circuitName;
    }

    public void setCircuitName(String circuitName) {
        this.circuitName = circuitName;
    }

    public String getNetRackProjectDivide() {
        return netRackProjectDivide;
    }

    public void setNetRackProjectDivide(String netRackProjectDivide) {
        this.netRackProjectDivide = netRackProjectDivide;
    }

    public String getRequirementType() {
        return requirementType;
    }

    public void setRequirementType(String requirementType) {
        this.requirementType = requirementType;
    }

    public String getProjectType() {
        return projectType;
    }

    public void setProjectType(String projectType) {
        this.projectType = projectType;
    }

    public String getCostEstimate() {
        return costEstimate;
    }

    public void setCostEstimate(String costEstimate) {
        this.costEstimate = costEstimate;
    }

    @Override
    public String getRemarks() {
        return remarks;
    }

    @Override
    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    public String getImplementBatch() {
        return implementBatch;
    }

    public void setImplementBatch(String implementBatch) {
        this.implementBatch = implementBatch;
    }

    public String getConstructionUnit() {
        return constructionUnit;
    }

    public void setConstructionUnit(String constructionUnit) {
        this.constructionUnit = constructionUnit;
    }

    public String getProjectReleaseBatch() {
        return projectReleaseBatch;
    }

    public void setProjectReleaseBatch(String projectReleaseBatch) {
        this.projectReleaseBatch = projectReleaseBatch;
    }

    public String getOwnerManager() {
        return ownerManager;
    }

    public void setOwnerManager(String ownerManager) {
        this.ownerManager = ownerManager;
    }

    public String getConstructionManagementUnit() {
        return constructionManagementUnit;
    }

    public void setConstructionManagementUnit(String constructionManagementUnit) {
        this.constructionManagementUnit = constructionManagementUnit;
    }

    public String getDqProjectManager() {
        return dqProjectManager;
    }

    public void setDqProjectManager(String dqProjectManager) {
        this.dqProjectManager = dqProjectManager;
    }

    public String getTjProjectManager() {
        return tjProjectManager;
    }

    public void setTjProjectManager(String tjProjectManager) {
        this.tjProjectManager = tjProjectManager;
    }

    public String getDqSubcontractingUnit() {
        return dqSubcontractingUnit;
    }

    public void setDqSubcontractingUnit(String dqSubcontractingUnit) {
        this.dqSubcontractingUnit = dqSubcontractingUnit;
    }

    public String getDqContacts() {
        return dqContacts;
    }

    public void setDqContacts(String dqContacts) {
        this.dqContacts = dqContacts;
    }

    public String getTjSubcontractingUnit() {
        return tjSubcontractingUnit;
    }

    public void setTjSubcontractingUnit(String tjSubcontractingUnit) {
        this.tjSubcontractingUnit = tjSubcontractingUnit;
    }

    public String getTjContacts() {
        return tjContacts;
    }

    public void setTjContacts(String tjContacts) {
        this.tjContacts = tjContacts;
    }

    public String getSubpackageRemarks() {
        return subpackageRemarks;
    }

    public void setSubpackageRemarks(String subpackageRemarks) {
        this.subpackageRemarks = subpackageRemarks;
    }

    public String getCivilEngineer() {
        return civilEngineer;
    }

    public void setCivilEngineer(String civilEngineer) {
        this.civilEngineer = civilEngineer;
    }

    public String getCivilEngineerStatistic() {
        return civilEngineerStatistic;
    }

    public void setCivilEngineerStatistic(String civilEngineerStatistic) {
        this.civilEngineerStatistic = civilEngineerStatistic;
    }

    public String getPoleWorkload() {
        return poleWorkload;
    }

    public void setPoleWorkload(String poleWorkload) {
        this.poleWorkload = poleWorkload;
    }

    public String getPoleWorkloadStatistic() {
        return poleWorkloadStatistic;
    }

    public void setPoleWorkloadStatistic(String poleWorkloadStatistic) {
        this.poleWorkloadStatistic = poleWorkloadStatistic;
    }

    public String getStatisticRemarks() {
        return statisticRemarks;
    }

    public void setStatisticRemarks(String statisticRemarks) {
        this.statisticRemarks = statisticRemarks;
    }

    public String getSerialNumber() {
        return serialNumber;
    }

    public void setSerialNumber(String serialNumber) {
        this.serialNumber = serialNumber;
    }

    public String getStartPoliticalWork() {
        return startPoliticalWork;
    }

    public void setStartPoliticalWork(String startPoliticalWork) {
        this.startPoliticalWork = startPoliticalWork;
    }

    public String getStartTime() {
        return startTime;
    }

    public void setStartTime(String startTime) {
        this.startTime = startTime;
    }

    public String getAdministrativeObject() {
        return administrativeObject;
    }

    public void setAdministrativeObject(String administrativeObject) {
        this.administrativeObject = administrativeObject;
    }

    public String getNeedCompensation() {
        return needCompensation;
    }

    public void setNeedCompensation(String needCompensation) {
        this.needCompensation = needCompensation;
    }

    public String getCompensationContent() {
        return compensationContent;
    }

    public void setCompensationContent(String compensationContent) {
        this.compensationContent = compensationContent;
    }

    public String getCompensationMoney() {
        return compensationMoney;
    }

    public void setCompensationMoney(String compensationMoney) {
        this.compensationMoney = compensationMoney;
    }

    public String getDocumentCommitTime() {
        return documentCommitTime;
    }

    public void setDocumentCommitTime(String documentCommitTime) {
        this.documentCommitTime = documentCommitTime;
    }

    public String getFinancialPayment() {
        return financialPayment;
    }

    public void setFinancialPayment(String financialPayment) {
        this.financialPayment = financialPayment;
    }

    public String getNeedSignContract() {
        return needSignContract;
    }

    public void setNeedSignContract(String needSignContract) {
        this.needSignContract = needSignContract;
    }

    public String getSignContractTime() {
        return signContractTime;
    }

    public void setSignContractTime(String signContractTime) {
        this.signContractTime = signContractTime;
    }

    public String getWeatherLoan() {
        return weatherLoan;
    }

    public void setWeatherLoan(String weatherLoan) {
        this.weatherLoan = weatherLoan;
    }

    public String getLoanTime() {
        return loanTime;
    }

    public void setLoanTime(String loanTime) {
        this.loanTime = loanTime;
    }

    public String getCompleteFinancialReimbursement() {
        return completeFinancialReimbursement;
    }

    public void setCompleteFinancialReimbursement(String completeFinancialReimbursement) {
        this.completeFinancialReimbursement = completeFinancialReimbursement;
    }

    public String getCompleteFinancialReimbursementTime() {
        return completeFinancialReimbursementTime;
    }

    public void setCompleteFinancialReimbursementTime(String completeFinancialReimbursementTime) {
        this.completeFinancialReimbursementTime = completeFinancialReimbursementTime;
    }

    public String getPossibleToEnterSite() {
        return possibleToEnterSite;
    }

    public void setPossibleToEnterSite(String possibleToEnterSite) {
        this.possibleToEnterSite = possibleToEnterSite;
    }

    public String getPossibleToEnterSiteTime() {
        return possibleToEnterSiteTime;
    }

    public void setPossibleToEnterSiteTime(String possibleToEnterSiteTime) {
        this.possibleToEnterSiteTime = possibleToEnterSiteTime;
    }

    public String getCompleteProcess() {
        return completeProcess;
    }

    public void setCompleteProcess(String completeProcess) {
        this.completeProcess = completeProcess;
    }

    public String getNegotiatingUnit() {
        return negotiatingUnit;
    }

    public void setNegotiatingUnit(String negotiatingUnit) {
        this.negotiatingUnit = negotiatingUnit;
    }

    public String getCoordinateUnit() {
        return coordinateUnit;
    }

    public void setCoordinateUnit(String coordinateUnit) {
        this.coordinateUnit = coordinateUnit;
    }

    public String getRecordRemarks() {
        return recordRemarks;
    }

    public void setRecordRemarks(String recordRemarks) {
        this.recordRemarks = recordRemarks;
    }
}
