package com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.entity;

import com.jeeplus.core.persistence.ActEntity;

/**
 * 政策处理进度表
 * @author 王强
 * @version 1.0
 * @date 2023-09-01 13:33
 */
public class PoliceProcessSchedule extends ActEntity<PoliceProcessSchedule> {

    private String projectYear;             //项目年份
    private String projectNature;           //项目性质
    private String demandUnit;              //需求单位
    private String district;                //区域
    private String projectGroup;            //项目分组
    private String reserveBatches;          //储备批次
    private String blockSupply;             //供电区域
    private String gridNumber;              //网格编号
    private String cellNumber;              //单元格编号
    private String projectReserveId;        //项目储备编号
    private String projectName;             //项目名称
    private String stateGridProjectCode;             //国网项目编码
    private String stateGridProjectName;             //国网项目名称
    private String constructionNecessityAndContent;           //建设必要性及内容
    private String substationName;           //变电站名称
    private String circuitName;              //线路名称
    private String netRackProjectDivide;     //网架项目划分
    private String requirementType;          //需求类型
    private String projectType;              //项目类型
    private String costEstimate;             //费用估算
    private String remarks;                  //备注
    //项目参建（单位）人员信息
    private String implementBatch;           //初定实施批次
    private String constructionUnit;        //初定施工单位
    private String projectReleaseBatch;     //项目下达批次
    private String ownerManager;            //业主项目经理
    private String ConstructionManagementUnit;          //现场施工管理单位
    private String dqProjectManager;          //施工项目经理(电气)
    private String tjProjectManager;          //施工项目经理(土建)
    //分包队伍
    private String dqSubcontractingUnit;      //电气分包单位
    private String dqContacts;                //电气联系人
    private String tjSubcontractingUnit;      //土建分包单位
    private String tjContacts;                //土建联系人
    private String subpackageRemarks;         //分包队伍-备注
    //项目工程量统计
    private String civilEngineer;              //是否含土建
    private String civilEngineerStatistic;     //土建工作量统计
    private String poleWorkload;           //是否含立杆工作量
    private String poleWorkloadStatistic;    //立杆工作量统计
    private String statisticRemarks;         //立杆工作量统计-备注
    //政处基本信息
    private String powerStationJurisdiction;        //供电所辖区
    private String constructionLocation;            //施工地点
    private String whetherExitPolitical;            //是否存在政处
    private String politicalType;                   //政处类型
    private String politicalDescribe;               //政处描述
    private String politicalDifficulty;             //政处难度
    private String whetherReport;                   //是否需规划报批
    private String safetyProcedures;                //是否需办理安评手续
    private String aviationReviewProcedures;        //是否需办理航评手续
    private String startPolitical;                  //是否启动政处
    private String startTime;                       //启动时间
    private String politicalRemarks;                //政处备注
    //政处进度表
    private String projectScheduleNum;              //该项目政处数量
    private String scheduleNumDescription;          //政处对象描述
    private String planApprovalCompletion;          //规划报批完成情况
    private String safetyCompletion;                //安评完成情况
    private String hongpingCompletion;              //洪评完成情况
    private String administrativeProgress;          //政处进度
    private String entryAllowed;                    //是否允许进场
    private String entryAllowedTime;                //允许进场日期
    private String designChangeRequired;            //是否需设计变更
    private String designChangeState;               //设计变更状态
    private String scheduleRemarks;                 //政处进度表-备注


    public String getProjectYear() {
        return projectYear;
    }

    public void setProjectYear(String projectYear) {
        this.projectYear = projectYear;
    }

    public String getProjectNature() {
        return projectNature;
    }

    public void setProjectNature(String projectNature) {
        this.projectNature = projectNature;
    }

    public String getDemandUnit() {
        return demandUnit;
    }

    public void setDemandUnit(String demandUnit) {
        this.demandUnit = demandUnit;
    }

    public String getDistrict() {
        return district;
    }

    public void setDistrict(String district) {
        this.district = district;
    }

    public String getProjectGroup() {
        return projectGroup;
    }

    public void setProjectGroup(String projectGroup) {
        this.projectGroup = projectGroup;
    }

    public String getReserveBatches() {
        return reserveBatches;
    }

    public void setReserveBatches(String reserveBatches) {
        this.reserveBatches = reserveBatches;
    }

    public String getBlockSupply() {
        return blockSupply;
    }

    public void setBlockSupply(String blockSupply) {
        this.blockSupply = blockSupply;
    }

    public String getGridNumber() {
        return gridNumber;
    }

    public void setGridNumber(String gridNumber) {
        this.gridNumber = gridNumber;
    }

    public String getCellNumber() {
        return cellNumber;
    }

    public void setCellNumber(String cellNumber) {
        this.cellNumber = cellNumber;
    }

    public String getProjectReserveId() {
        return projectReserveId;
    }

    public void setProjectReserveId(String projectReserveId) {
        this.projectReserveId = projectReserveId;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getStateGridProjectCode() {
        return stateGridProjectCode;
    }

    public void setStateGridProjectCode(String stateGridProjectCode) {
        this.stateGridProjectCode = stateGridProjectCode;
    }

    public String getStateGridProjectName() {
        return stateGridProjectName;
    }

    public void setStateGridProjectName(String stateGridProjectName) {
        this.stateGridProjectName = stateGridProjectName;
    }

    public String getConstructionNecessityAndContent() {
        return constructionNecessityAndContent;
    }

    public void setConstructionNecessityAndContent(String constructionNecessityAndContent) {
        this.constructionNecessityAndContent = constructionNecessityAndContent;
    }

    public String getSubstationName() {
        return substationName;
    }

    public void setSubstationName(String substationName) {
        this.substationName = substationName;
    }

    public String getCircuitName() {
        return circuitName;
    }

    public void setCircuitName(String circuitName) {
        this.circuitName = circuitName;
    }

    public String getNetRackProjectDivide() {
        return netRackProjectDivide;
    }

    public void setNetRackProjectDivide(String netRackProjectDivide) {
        this.netRackProjectDivide = netRackProjectDivide;
    }

    public String getRequirementType() {
        return requirementType;
    }

    public void setRequirementType(String requirementType) {
        this.requirementType = requirementType;
    }

    public String getProjectType() {
        return projectType;
    }

    public void setProjectType(String projectType) {
        this.projectType = projectType;
    }

    public String getCostEstimate() {
        return costEstimate;
    }

    public void setCostEstimate(String costEstimate) {
        this.costEstimate = costEstimate;
    }

    public String getRemarks() {
        return remarks;
    }

    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    public String getImplementBatch() {
        return implementBatch;
    }

    public void setImplementBatch(String implementBatch) {
        this.implementBatch = implementBatch;
    }

    public String getConstructionUnit() {
        return constructionUnit;
    }

    public void setConstructionUnit(String constructionUnit) {
        this.constructionUnit = constructionUnit;
    }

    public String getProjectReleaseBatch() {
        return projectReleaseBatch;
    }

    public void setProjectReleaseBatch(String projectReleaseBatch) {
        this.projectReleaseBatch = projectReleaseBatch;
    }

    public String getOwnerManager() {
        return ownerManager;
    }

    public void setOwnerManager(String ownerManager) {
        this.ownerManager = ownerManager;
    }

    public String getConstructionManagementUnit() {
        return ConstructionManagementUnit;
    }

    public void setConstructionManagementUnit(String constructionManagementUnit) {
        ConstructionManagementUnit = constructionManagementUnit;
    }

    public String getDqProjectManager() {
        return dqProjectManager;
    }

    public void setDqProjectManager(String dqProjectManager) {
        this.dqProjectManager = dqProjectManager;
    }

    public String getTjProjectManager() {
        return tjProjectManager;
    }

    public void setTjProjectManager(String tjProjectManager) {
        this.tjProjectManager = tjProjectManager;
    }

    public String getDqSubcontractingUnit() {
        return dqSubcontractingUnit;
    }

    public void setDqSubcontractingUnit(String dqSubcontractingUnit) {
        this.dqSubcontractingUnit = dqSubcontractingUnit;
    }

    public String getDqContacts() {
        return dqContacts;
    }

    public void setDqContacts(String dqContacts) {
        this.dqContacts = dqContacts;
    }

    public String getTjSubcontractingUnit() {
        return tjSubcontractingUnit;
    }

    public void setTjSubcontractingUnit(String tjSubcontractingUnit) {
        this.tjSubcontractingUnit = tjSubcontractingUnit;
    }

    public String getTjContacts() {
        return tjContacts;
    }

    public void setTjContacts(String tjContacts) {
        this.tjContacts = tjContacts;
    }

    public String getSubpackageRemarks() {
        return subpackageRemarks;
    }

    public void setSubpackageRemarks(String subpackageRemarks) {
        this.subpackageRemarks = subpackageRemarks;
    }

    public String getCivilEngineer() {
        return civilEngineer;
    }

    public void setCivilEngineer(String civilEngineer) {
        this.civilEngineer = civilEngineer;
    }

    public String getCivilEngineerStatistic() {
        return civilEngineerStatistic;
    }

    public void setCivilEngineerStatistic(String civilEngineerStatistic) {
        this.civilEngineerStatistic = civilEngineerStatistic;
    }

    public String getPoleWorkload() {
        return poleWorkload;
    }

    public void setPoleWorkload(String poleWorkload) {
        this.poleWorkload = poleWorkload;
    }

    public String getPoleWorkloadStatistic() {
        return poleWorkloadStatistic;
    }

    public void setPoleWorkloadStatistic(String poleWorkloadStatistic) {
        this.poleWorkloadStatistic = poleWorkloadStatistic;
    }

    public String getStatisticRemarks() {
        return statisticRemarks;
    }

    public void setStatisticRemarks(String statisticRemarks) {
        this.statisticRemarks = statisticRemarks;
    }

    public String getPowerStationJurisdiction() {
        return powerStationJurisdiction;
    }

    public void setPowerStationJurisdiction(String powerStationJurisdiction) {
        this.powerStationJurisdiction = powerStationJurisdiction;
    }

    public String getConstructionLocation() {
        return constructionLocation;
    }

    public void setConstructionLocation(String constructionLocation) {
        this.constructionLocation = constructionLocation;
    }

    public String getWhetherExitPolitical() {
        return whetherExitPolitical;
    }

    public void setWhetherExitPolitical(String whetherExitPolitical) {
        this.whetherExitPolitical = whetherExitPolitical;
    }

    public String getPoliticalType() {
        return politicalType;
    }

    public void setPoliticalType(String politicalType) {
        this.politicalType = politicalType;
    }

    public String getPoliticalDescribe() {
        return politicalDescribe;
    }

    public void setPoliticalDescribe(String politicalDescribe) {
        this.politicalDescribe = politicalDescribe;
    }

    public String getPoliticalDifficulty() {
        return politicalDifficulty;
    }

    public void setPoliticalDifficulty(String politicalDifficulty) {
        this.politicalDifficulty = politicalDifficulty;
    }

    public String getWhetherReport() {
        return whetherReport;
    }

    public void setWhetherReport(String whetherReport) {
        this.whetherReport = whetherReport;
    }

    public String getSafetyProcedures() {
        return safetyProcedures;
    }

    public void setSafetyProcedures(String safetyProcedures) {
        this.safetyProcedures = safetyProcedures;
    }

    public String getAviationReviewProcedures() {
        return aviationReviewProcedures;
    }

    public void setAviationReviewProcedures(String aviationReviewProcedures) {
        this.aviationReviewProcedures = aviationReviewProcedures;
    }

    public String getStartPolitical() {
        return startPolitical;
    }

    public void setStartPolitical(String startPolitical) {
        this.startPolitical = startPolitical;
    }

    public String getStartTime() {
        return startTime;
    }

    public void setStartTime(String startTime) {
        this.startTime = startTime;
    }

    public String getPoliticalRemarks() {
        return politicalRemarks;
    }

    public void setPoliticalRemarks(String politicalRemarks) {
        this.politicalRemarks = politicalRemarks;
    }

    public String getProjectScheduleNum() {
        return projectScheduleNum;
    }

    public void setProjectScheduleNum(String projectScheduleNum) {
        this.projectScheduleNum = projectScheduleNum;
    }

    public String getScheduleNumDescription() {
        return scheduleNumDescription;
    }

    public void setScheduleNumDescription(String scheduleNumDescription) {
        this.scheduleNumDescription = scheduleNumDescription;
    }

    public String getPlanApprovalCompletion() {
        return planApprovalCompletion;
    }

    public void setPlanApprovalCompletion(String planApprovalCompletion) {
        this.planApprovalCompletion = planApprovalCompletion;
    }

    public String getSafetyCompletion() {
        return safetyCompletion;
    }

    public void setSafetyCompletion(String safetyCompletion) {
        this.safetyCompletion = safetyCompletion;
    }

    public String getHongpingCompletion() {
        return hongpingCompletion;
    }

    public void setHongpingCompletion(String hongpingCompletion) {
        this.hongpingCompletion = hongpingCompletion;
    }

    public String getAdministrativeProgress() {
        return administrativeProgress;
    }

    public void setAdministrativeProgress(String administrativeProgress) {
        this.administrativeProgress = administrativeProgress;
    }

    public String getEntryAllowed() {
        return entryAllowed;
    }

    public void setEntryAllowed(String entryAllowed) {
        this.entryAllowed = entryAllowed;
    }

    public String getEntryAllowedTime() {
        return entryAllowedTime;
    }

    public void setEntryAllowedTime(String entryAllowedTime) {
        this.entryAllowedTime = entryAllowedTime;
    }

    public String getDesignChangeRequired() {
        return designChangeRequired;
    }

    public void setDesignChangeRequired(String designChangeRequired) {
        this.designChangeRequired = designChangeRequired;
    }

    public String getDesignChangeState() {
        return designChangeState;
    }

    public void setDesignChangeState(String designChangeState) {
        this.designChangeState = designChangeState;
    }

    public String getScheduleRemarks() {
        return scheduleRemarks;
    }

    public void setScheduleRemarks(String scheduleRemarks) {
        this.scheduleRemarks = scheduleRemarks;
    }
}
