package com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.entity.PoliceProcessRecord;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-09-01 15:45
 */
@MyBatisMapper
public interface PoliceProcessRecordMapper extends BaseMapper<PoliceProcessRecord> {

    /**
     * 根据项目储备编号查数据
     * @param reserveId
     * @return
     */
    PoliceProcessRecord getByReserveId(String reserveId);

    /**
     * 批量添加政策处理基本信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<PoliceProcessRecord> list);

    /**
     * 根据项目储备编号删除政策处理基本信息
     * @param projectReserveId
     */
    void deleteByProjectReserveId(String projectReserveId);

    /**
     * 根据项目储备id查询政策处理基本信息
     * @param reserveManagement
     * @return
     */
    PoliceProcessRecord queryByProjectReserveId(PoliceProcessRecord reserveManagement);

    PoliceProcessRecord get(@Param("id")String id, @Param("serialNumber") String serialNumber);

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId();

    /**
     * 从基本数据表中获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId2();

    /**
     * 导出数据查询
     * @param reserveManagement
     * @return
     */
    List<PoliceProcessRecord> exportFindList(PoliceProcessRecord reserveManagement);

    /**
     * 根据projectReserveId查出proc_ins_id
     * @param projectReserveId
     * @return
     */
    String getByProjectReserveId(String projectReserveId);

    /**
     * 根据executeId查出历史节点信息
     * @param executeId
     * @return
     */
    List<History> getHistoryByExecuteId(String executeId);

    /**
     * 根据executeId查出当前节点的名称
     * @param executeId
     * @return
     */
    String getByExecuteId(String executeId);

    /**
     * 根据项目储备编号与序号查相关数据
     * @param projectReserveId
     * @param serialNumber
     * @return
     */
    PoliceProcessRecord getInfoByReserveIdAndNum(@Param("projectReserveId")String projectReserveId, @Param("serialNumber") String serialNumber);


    List<String> getSerialNumByReserveId(@Param("projectReserveId")String projectReserveId);
}
