package com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.entity.PoliceProcessSchedule;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 政策处理进度表 mapper
 * @author 王强
 * @version 1.0
 * @date 2023-09-01 15:37
 */
@MyBatisMapper
public interface PoliceProcessScheduleMapper extends BaseMapper<PoliceProcessSchedule> {

    /**
     * 根据项目储备编号查数据
     * @param reserveId
     * @return
     */
    PoliceProcessSchedule getByReserveId(String reserveId);

    /**
     * 批量添加政策处理基本信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<PoliceProcessSchedule> list);

    /**
     * 根据项目储备编号删除政策处理基本信息
     * @param projectReserveId
     */
    void deleteByProjectReserveId(String projectReserveId);

    /**
     * 根据项目储备id查询政策处理基本信息
     * @param reserveManagement
     * @return
     */
    PoliceProcessSchedule queryByProjectReserveId(PoliceProcessSchedule reserveManagement);

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId();

    /**
     * 从基本数据表中获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId2();

    /**
     * 导出数据查询
     * @param reserveManagement
     * @return
     */
    List<PoliceProcessSchedule> exportFindList(PoliceProcessSchedule reserveManagement);

    /**
     * 根据projectReserveId查出proc_ins_id
     * @param projectReserveId
     * @return
     */
    String getByProjectReserveId(String projectReserveId);

    /**
     * 根据executeId查出历史节点信息
     * @param executeId
     * @return
     */
    List<History> getHistoryByExecuteId(String executeId);

    /**
     * 根据executeId查出当前节点的名称
     * @param executeId
     * @return
     */
    String getByExecuteId(String executeId);

    List<String> getInfoByProReserveId(String projectReserveId);

    List<String> getJcInfoByProReserveId(String projectReserveId);

    String getDateValByProReserveId(String projectReserveId);
}
