package com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.util;

import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.entity.PoliceProcessBase;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.entity.PoliceProcessRecord;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.entity.PoliceProcessSchedule;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils.ReserveProcessProjectExportUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLEncoder;
import java.util.List;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-09-04 9:16
 */
public class PolicyProcessExportUtil {

    private  XSSFCellStyle style = null;

    public static PolicyProcessExportUtil getOne(){

        return new PolicyProcessExportUtil();
    }

    /**
     * 传入excel模板名称 获取workbook对象
     * @param fileName excel模板名称
     * @return
     */
    public  XSSFWorkbook getWorkbook(String fileName){
        InputStream inputStream = null;
        XSSFWorkbook workbook = null;
        try {
            File file = new File(this.getClass().getResource("/").getPath() + "/freemarker/excelmodel/"+fileName+".xlsx");
            inputStream = new FileInputStream(file);// 将excel文件转为输入流
            workbook = new XSSFWorkbook(inputStream);// 创建个workbook，
        } catch (Exception e) {
            e.printStackTrace();
        }
        return workbook;
    }


    /**
     * 导出储备项目安全交底信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportSafety(HttpServletResponse response, XSSFWorkbook workbook, List<PoliceProcessBase> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 2;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //储备项目经理
                Cell cell2 = crateCell(workbook,row,2); //项目年份
                Cell cell3 = crateCell(workbook,row,3); //项目性质
                Cell cell4 = crateCell(workbook,row,4); //需求单位
                Cell cell5 = crateCell(workbook,row,5); //区域
                Cell cell6 = crateCell(workbook,row,6); //项目分组
                Cell cell7 = crateCell(workbook,row,7); //储备批次

                Cell cell8 = crateCell(workbook,row,8); //供电区域
                Cell cell9 = crateCell(workbook,row,9); //网格编号
                Cell cell10 = crateCell(workbook,row,10); //单元格编号
                Cell cell11 = crateCell(workbook,row,11); //项目储备编号
                Cell cell12 = crateCell(workbook,row,12); //项目名称
                Cell cell13 = crateCell(workbook,row,13); //国网项目编码
                Cell cell14 = crateCell(workbook,row,14); //国网项目名称
                Cell cell15 = crateCell(workbook,row,15); //建设必要性及内容
                Cell cell16 = crateCell(workbook,row,16); //变电站名称
                Cell cell17 = crateCell(workbook,row,17); //线路名称
                Cell cell18 = crateCell(workbook,row,18); //网架项目划分
                Cell cell19 = crateCell(workbook,row,19); //需求类型
                Cell cell20 = crateCell(workbook,row,20); //项目类型
                Cell cell21 = crateCell(workbook,row,21); //费用估算
                Cell cell22 = crateCell(workbook,row,22); //备注
                Cell cell23 = crateCell(workbook,row,23); //储备进度
                Cell cell24 = crateCell(workbook,row,24); //是否纳入实施计划
                Cell cell25 = crateCell(workbook,row,25); //初定实施批次
                Cell cell26 = crateCell(workbook,row,26); //是否含土建工作量
                Cell cell27 = crateCell(workbook,row,27); //土建工作量统计
                Cell cell28 = crateCell(workbook,row,28); //是否含立杆工作量
                Cell cell29 = crateCell(workbook,row,29); //立杆工作量统计
                Cell cell30 = crateCell(workbook,row,30); //工作量统计-备注
                Cell cell31 = crateCell(workbook,row,31); //供电所辖区
                Cell cell32 = crateCell(workbook,row,32); //施工地点
                Cell cell33 = crateCell(workbook,row,33); //是否存在政处
                Cell cell34 = crateCell(workbook,row,34); //政处类型
                Cell cell35 = crateCell(workbook,row,35); //政处描述
                Cell cell36 = crateCell(workbook,row,36); //政处难度
                Cell cell37 = crateCell(workbook,row,37); //是否需规划报批
                Cell cell38 = crateCell(workbook,row,38); //是否需办理安评手续
                Cell cell39 = crateCell(workbook,row,39); //是否需办理航评手续
                Cell cell40 = crateCell(workbook,row,40); //是否启动政处
                Cell cell41 = crateCell(workbook,row,41); //政处备注


                PoliceProcessBase reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectManager());
                cell2.setCellValue(reserveManagement.getProjectYear());
                cell3.setCellValue(reserveManagement.getProjectNature());
                cell4.setCellValue(reserveManagement.getDemandUnit());
                cell5.setCellValue(reserveManagement.getDistrict());
                cell6.setCellValue(reserveManagement.getProjectGroup());
                cell7.setCellValue(reserveManagement.getReserveBatches());
                cell8.setCellValue(reserveManagement.getBlockSupply());
                cell9.setCellValue(reserveManagement.getGridNumber());
                cell10.setCellValue(reserveManagement.getCellNumber());
                cell11.setCellValue(reserveManagement.getProjectReserveId());
                cell12.setCellValue(reserveManagement.getProjectName());
                cell13.setCellValue(reserveManagement.getStateGridProjectCode());
                cell14.setCellValue(reserveManagement.getStateGridProjectName());
                cell15.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell16.setCellValue(reserveManagement.getSubstationName());
                cell17.setCellValue(reserveManagement.getCircuitName());
                cell18.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell19.setCellValue(reserveManagement.getRequirementType());
                cell20.setCellValue(reserveManagement.getProjectType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell21.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell22.setCellValue(reserveManagement.getRemarks());
                cell23.setCellValue(reserveManagement.getReserveProgress());
                cell24.setCellValue(reserveManagement.getImplementPlan());
                cell25.setCellValue(reserveManagement.getImplementBatch());
                cell26.setCellValue(reserveManagement.getCivilEngineeringWorkload());
                cell27.setCellValue(reserveManagement.getEngineeringWorkloadStatistic());
                cell28.setCellValue(reserveManagement.getPoleWorkload());
                cell29.setCellValue(reserveManagement.getPoleWorkloadStatistic());
                cell30.setCellValue(reserveManagement.getWorkRemark());
                cell31.setCellValue(reserveManagement.getPowerStationJurisdiction());
                cell32.setCellValue(reserveManagement.getConstructionLocation());
                cell33.setCellValue(reserveManagement.getWhetherExitPolitical());
                cell34.setCellValue(reserveManagement.getPoliticalType());
                cell35.setCellValue(reserveManagement.getPoliticalDescribe());
                cell36.setCellValue(reserveManagement.getPoliticalDifficulty());
                cell37.setCellValue(reserveManagement.getWhetherReport());
                cell38.setCellValue(reserveManagement.getSafetyProcedures());
                cell39.setCellValue(reserveManagement.getAviationReviewProcedures());
                cell40.setCellValue(reserveManagement.getStartPolitical());
                cell41.setCellValue(reserveManagement.getPoliticalRemarks());


            }

            String str = URLEncoder.encode("储备项目政策处理基本信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出政策处理记录信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportRecord(HttpServletResponse response, XSSFWorkbook workbook, List<PoliceProcessRecord> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 2;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //国网项目编码
                Cell cell13 = crateCell(workbook,row,13); //国网项目名称
                Cell cell14 = crateCell(workbook,row,14); //建设必要性及内容
                Cell cell15 = crateCell(workbook,row,15); //变电站名称
                Cell cell16 = crateCell(workbook,row,16); //线路名称
                Cell cell17 = crateCell(workbook,row,17); //网架项目划分
                Cell cell18 = crateCell(workbook,row,18); //需求类型
                Cell cell19 = crateCell(workbook,row,19); //项目类型
                Cell cell20 = crateCell(workbook,row,20); //费用估算
                Cell cell21 = crateCell(workbook,row,21); //备注

                Cell cell22 = crateCell(workbook,row,22); //初定实施批次
                Cell cell23 = crateCell(workbook,row,23); //初定施工单位
                Cell cell24 = crateCell(workbook,row,24); //项目下达批次
                Cell cell25 = crateCell(workbook,row,25); //业主项目经理
                Cell cell26 = crateCell(workbook,row,26); //现场施工管理单位
                Cell cell27 = crateCell(workbook,row,27); //施工项目经理(电气)
                Cell cell28 = crateCell(workbook,row,28); //施工项目经理(土建)

                Cell cell29 = crateCell(workbook,row,29); //电气分包单位
                Cell cell30 = crateCell(workbook,row,30); //电气联系人
                Cell cell31 = crateCell(workbook,row,31); //土建分包单位
                Cell cell32 = crateCell(workbook,row,32); //土建联系人
                Cell cell33 = crateCell(workbook,row,33); //分包队伍-备注

                Cell cell34 = crateCell(workbook,row,34); //是否含土建
                Cell cell35 = crateCell(workbook,row,35); //土建工作量统计
                Cell cell36 = crateCell(workbook,row,36); //是否含立杆工作量
                Cell cell37 = crateCell(workbook,row,37); //立杆工作量统计
                Cell cell38 = crateCell(workbook,row,38); //立杆工作量统计-备注

                Cell cell39 = crateCell(workbook,row,39); //序号
                Cell cell40 = crateCell(workbook,row,40); //是否启动政处工作
                Cell cell41 = crateCell(workbook,row,41); //启动时间
                Cell cell42 = crateCell(workbook,row,42); //政处对象
                Cell cell43 = crateCell(workbook,row,43); //是否需赔付
                Cell cell44 = crateCell(workbook,row,44); //赔付内容
                Cell cell45 = crateCell(workbook,row,45); //赔付金额
                Cell cell46 = crateCell(workbook,row,46); //签字政处单据提交时间
                Cell cell47 = crateCell(workbook,row,47); //是否财政付款
                Cell cell48 = crateCell(workbook,row,48); //是否需签订合同
                Cell cell49 = crateCell(workbook,row,49); //政处合同完成签订时间
                Cell cell50 = crateCell(workbook,row,50); //是否借款
                Cell cell51 = crateCell(workbook,row,51); //借款支付时间
                Cell cell52 = crateCell(workbook,row,52); //是否完成财务报销
                Cell cell53 = crateCell(workbook,row,53); //财务报销完成时间
                Cell cell54 = crateCell(workbook,row,54); //是否可进场
                Cell cell55 = crateCell(workbook,row,55); //可进场日期
                Cell cell56 = crateCell(workbook,row,56); //政处是否完成
                Cell cell57 = crateCell(workbook,row,57); //政处洽谈单位
                Cell cell58 = crateCell(workbook,row,58); //政处配合单位
                Cell cell59 = crateCell(workbook,row,59); //政处记录-备注


                PoliceProcessRecord reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getReserveBatches());
                cell7.setCellValue(reserveManagement.getBlockSupply());
                cell8.setCellValue(reserveManagement.getGridNumber());
                cell9.setCellValue(reserveManagement.getCellNumber());
                cell10.setCellValue(reserveManagement.getProjectReserveId());
                cell11.setCellValue(reserveManagement.getProjectName());
                cell12.setCellValue(reserveManagement.getStateGridProjectCode());
                cell13.setCellValue(reserveManagement.getStateGridProjectName());
                cell14.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell15.setCellValue(reserveManagement.getSubstationName());
                cell16.setCellValue(reserveManagement.getCircuitName());
                cell17.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell18.setCellValue(reserveManagement.getRequirementType());
                cell19.setCellValue(reserveManagement.getProjectType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell20.setCellValue(Double.parseDouble(costEstimateStr));
                }

                cell21.setCellValue(reserveManagement.getRemarks());
                cell22.setCellValue(reserveManagement.getImplementBatch());
                cell23.setCellValue(reserveManagement.getConstructionUnit());
                cell24.setCellValue(reserveManagement.getProjectReleaseBatch());
                cell25.setCellValue(reserveManagement.getOwnerManager());
                cell26.setCellValue(reserveManagement.getConstructionManagementUnit());
                cell27.setCellValue(reserveManagement.getDqProjectManager());
                cell28.setCellValue(reserveManagement.getTjProjectManager());
                cell29.setCellValue(reserveManagement.getDqSubcontractingUnit());
                cell30.setCellValue(reserveManagement.getDqContacts());
                cell31.setCellValue(reserveManagement.getTjSubcontractingUnit());
                cell32.setCellValue(reserveManagement.getTjContacts());
                cell33.setCellValue(reserveManagement.getSubpackageRemarks());
                cell34.setCellValue(reserveManagement.getCivilEngineer());
                cell35.setCellValue(reserveManagement.getCivilEngineerStatistic());
                cell36.setCellValue(reserveManagement.getPoleWorkload());
                cell37.setCellValue(reserveManagement.getPoleWorkloadStatistic());
                cell38.setCellValue(reserveManagement.getStatisticRemarks());
                cell39.setCellValue(reserveManagement.getSerialNumber());
                cell40.setCellValue(reserveManagement.getStartPoliticalWork());
                cell41.setCellValue(reserveManagement.getStartTime());
                cell42.setCellValue(reserveManagement.getAdministrativeObject());
                cell43.setCellValue(reserveManagement.getNeedCompensation());
                cell44.setCellValue(reserveManagement.getCompensationContent());
                cell45.setCellValue(reserveManagement.getCompensationMoney());
                cell46.setCellValue(reserveManagement.getDocumentCommitTime());
                cell47.setCellValue(reserveManagement.getFinancialPayment());
                cell48.setCellValue(reserveManagement.getNeedSignContract());
                cell49.setCellValue(reserveManagement.getSignContractTime());
                cell50.setCellValue(reserveManagement.getWeatherLoan());
                cell51.setCellValue(reserveManagement.getLoanTime());
                cell52.setCellValue(reserveManagement.getCompleteFinancialReimbursement());
                cell53.setCellValue(reserveManagement.getCompleteFinancialReimbursementTime());
                cell54.setCellValue(reserveManagement.getPossibleToEnterSite());
                cell55.setCellValue(reserveManagement.getPossibleToEnterSiteTime());
                cell56.setCellValue(reserveManagement.getCompleteProcess());
                cell57.setCellValue(reserveManagement.getNegotiatingUnit());
                cell58.setCellValue(reserveManagement.getCoordinateUnit());
                cell59.setCellValue(reserveManagement.getRecordRemarks());

            }

            String str = URLEncoder.encode("储备项目政策记录表信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出政策处理进度信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportSchedule(HttpServletResponse response, XSSFWorkbook workbook, List<PoliceProcessSchedule> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 2;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //国网项目编码
                Cell cell13 = crateCell(workbook,row,13); //国网项目名称
                Cell cell14 = crateCell(workbook,row,14); //建设必要性及内容
                Cell cell15 = crateCell(workbook,row,15); //变电站名称
                Cell cell16 = crateCell(workbook,row,16); //线路名称
                Cell cell17 = crateCell(workbook,row,17); //网架项目划分
                Cell cell18 = crateCell(workbook,row,18); //需求类型
                Cell cell19 = crateCell(workbook,row,19); //项目类型
                Cell cell20 = crateCell(workbook,row,20); //费用估算
                Cell cell21 = crateCell(workbook,row,21); //备注

                Cell cell22 = crateCell(workbook,row,22); //初定实施批次
                Cell cell23 = crateCell(workbook,row,23); //初定施工单位
                Cell cell24 = crateCell(workbook,row,24); //项目下达批次
                Cell cell25 = crateCell(workbook,row,25); //业主项目经理
                Cell cell26 = crateCell(workbook,row,26); //现场施工管理单位
                Cell cell27 = crateCell(workbook,row,27); //施工项目经理(电气)
                Cell cell28 = crateCell(workbook,row,28); //施工项目经理(土建)

                Cell cell29 = crateCell(workbook,row,29); //电气分包单位
                Cell cell30 = crateCell(workbook,row,30); //电气联系人
                Cell cell31 = crateCell(workbook,row,31); //土建分包单位
                Cell cell32 = crateCell(workbook,row,32); //土建联系人
                Cell cell33 = crateCell(workbook,row,33); //分包队伍-备注

                Cell cell34 = crateCell(workbook,row,34); //是否含土建
                Cell cell35 = crateCell(workbook,row,35); //土建工作量统计
                Cell cell36 = crateCell(workbook,row,36); //是否含立杆工作量
                Cell cell37 = crateCell(workbook,row,37); //立杆工作量统计
                Cell cell38 = crateCell(workbook,row,38); //立杆工作量统计-备注

                Cell cell39 = crateCell(workbook,row,39); //供电所辖区
                Cell cell40 = crateCell(workbook,row,40); //施工地点
                Cell cell41 = crateCell(workbook,row,41); //是否存在政处
                Cell cell42 = crateCell(workbook,row,42); //政处类型
                Cell cell43 = crateCell(workbook,row,43); //政处描述
                Cell cell44 = crateCell(workbook,row,44); //政处难度
                Cell cell45 = crateCell(workbook,row,45); //是否需规划报批
                Cell cell46 = crateCell(workbook,row,46); //是否需办理安评手续
                Cell cell47 = crateCell(workbook,row,47); //是否需办理航评手续
                Cell cell48 = crateCell(workbook,row,48); //是否启动政处
                Cell cell49 = crateCell(workbook,row,49); //启动时间
                Cell cell50 = crateCell(workbook,row,50); //政处备注

                Cell cell51 = crateCell(workbook,row,51); //该项目政处数量
                Cell cell52 = crateCell(workbook,row,52); //政处对象描述
                Cell cell53 = crateCell(workbook,row,53); //规划报批完成情况
                Cell cell54 = crateCell(workbook,row,54); //安评完成情况
                Cell cell55 = crateCell(workbook,row,55); //洪评完成情况
                Cell cell56 = crateCell(workbook,row,56); //政处进度
                Cell cell57 = crateCell(workbook,row,57); //是否允许进场
                Cell cell58 = crateCell(workbook,row,58); //允许进场日期
                Cell cell59 = crateCell(workbook,row,59); //是否需设计变更
                Cell cell60 = crateCell(workbook,row,60); //设计变更状态
                Cell cell61 = crateCell(workbook,row,61); //政处进度表-备注

                PoliceProcessSchedule reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getReserveBatches());
                cell7.setCellValue(reserveManagement.getBlockSupply());
                cell8.setCellValue(reserveManagement.getGridNumber());
                cell9.setCellValue(reserveManagement.getCellNumber());
                cell10.setCellValue(reserveManagement.getProjectReserveId());
                cell11.setCellValue(reserveManagement.getProjectName());
                cell12.setCellValue(reserveManagement.getStateGridProjectCode());
                cell13.setCellValue(reserveManagement.getStateGridProjectName());
                cell14.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell15.setCellValue(reserveManagement.getSubstationName());
                cell16.setCellValue(reserveManagement.getCircuitName());
                cell17.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell18.setCellValue(reserveManagement.getRequirementType());
                cell19.setCellValue(reserveManagement.getProjectType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell20.setCellValue(Double.parseDouble(costEstimateStr));
                }

                cell21.setCellValue(reserveManagement.getRemarks());
                cell22.setCellValue(reserveManagement.getImplementBatch());
                cell23.setCellValue(reserveManagement.getConstructionUnit());
                cell24.setCellValue(reserveManagement.getProjectReleaseBatch());
                cell25.setCellValue(reserveManagement.getOwnerManager());
                cell26.setCellValue(reserveManagement.getConstructionManagementUnit());
                cell27.setCellValue(reserveManagement.getDqProjectManager());
                cell28.setCellValue(reserveManagement.getTjProjectManager());
                cell29.setCellValue(reserveManagement.getDqSubcontractingUnit());
                cell30.setCellValue(reserveManagement.getDqContacts());
                cell31.setCellValue(reserveManagement.getTjSubcontractingUnit());
                cell32.setCellValue(reserveManagement.getTjContacts());
                cell33.setCellValue(reserveManagement.getSubpackageRemarks());
                cell34.setCellValue(reserveManagement.getCivilEngineer());
                cell35.setCellValue(reserveManagement.getCivilEngineerStatistic());
                cell36.setCellValue(reserveManagement.getPoleWorkload());
                cell37.setCellValue(reserveManagement.getPoleWorkloadStatistic());
                cell38.setCellValue(reserveManagement.getStatisticRemarks());
                cell39.setCellValue(reserveManagement.getPowerStationJurisdiction());
                cell40.setCellValue(reserveManagement.getConstructionLocation());
                cell41.setCellValue(reserveManagement.getWhetherExitPolitical());
                cell42.setCellValue(reserveManagement.getPoliticalType());
                cell43.setCellValue(reserveManagement.getPoliticalDescribe());
                cell44.setCellValue(reserveManagement.getPoliticalDifficulty());
                cell45.setCellValue(reserveManagement.getWhetherReport());
                cell46.setCellValue(reserveManagement.getSafetyProcedures());
                cell47.setCellValue(reserveManagement.getAviationReviewProcedures());
                cell48.setCellValue(reserveManagement.getStartPolitical());
                cell49.setCellValue(reserveManagement.getStartTime());
                cell50.setCellValue(reserveManagement.getPoliticalRemarks());
                cell51.setCellValue(reserveManagement.getProjectScheduleNum());
                cell52.setCellValue(reserveManagement.getScheduleNumDescription());
                cell53.setCellValue(reserveManagement.getPlanApprovalCompletion());
                cell54.setCellValue(reserveManagement.getSafetyCompletion());
                cell55.setCellValue(reserveManagement.getHongpingCompletion());
                cell56.setCellValue(reserveManagement.getAdministrativeProgress());
                cell57.setCellValue(reserveManagement.getEntryAllowed());
                cell58.setCellValue(reserveManagement.getEntryAllowedTime());
                cell59.setCellValue(reserveManagement.getDesignChangeRequired());
                cell60.setCellValue(reserveManagement.getDesignChangeState());
                cell61.setCellValue(reserveManagement.getScheduleRemarks());

            }

            String str = URLEncoder.encode("储备项目政策记录表信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 创建Cell对象 同时设置style
     * @param workbook
     * @param row
     * @param num
     * @return
     */
    Cell crateCell(XSSFWorkbook workbook,Row row, int num){
        Cell cell = row.createCell(num);
        if(style == null){
            style =workbook.createCellStyle();
            style.setWrapText(true);
            style.setVerticalAlignment(XSSFCellStyle.VERTICAL_CENTER);
        }
        cell.setCellStyle(style);
        return cell;
    }
}
