package com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.web;

import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.entity.PoliceProcessBase;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.entity.PoliceProcessRecord;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.service.PoliceProcessBaseService;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.service.PoliceProcessRecordService;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.util.PolicyProcessExportUtil;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.util.PolicyProcessImportUtil;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.service.ProjectTypeVerificateService;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.service.ReserveElectricityWorkService;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.DemoliteList;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import com.jeeplus.modules.sg.managementcenter.materialproject.util.ImportUtil;
import com.jeeplus.modules.sg.picking.activiti.entity.PickList;
import com.jeeplus.modules.sg.raiseCapital.service.RaiseCapitalService;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.apache.shiro.authz.annotation.Logical;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-09-01 15:53
 */
@Controller
@RequestMapping(value = "${adminPath}/cg/policeProcess/base")
public class PoliceProcessBaseController extends BaseController {

    @Autowired
    private PoliceProcessBaseService baseService;

    @Autowired
    private ReserveElectricityWorkService workService;

    @Autowired
    private PoliceProcessRecordService recordService;

    @Autowired
    private ProjectTypeVerificateService verificateService;

    @Autowired
    private RaiseCapitalService raiseCapitalService;

    @ModelAttribute
    public PoliceProcessBase get(@RequestParam(required = false) String id) {
        PoliceProcessBase entity = null;
        if (StringUtils.isNotBlank(id)) {
            entity = baseService.get(id);
        }
        if (entity == null) {
            entity = new PoliceProcessBase();
        }
        return entity;
    }

    /**
     * 项目储备信息列表页面
     * @param reserveManagement
     * @param model
     * @return
     */
    @RequiresPermissions("cg:policeProcess:base:list")
    @RequestMapping(value = "skipList")
    public String skipList(PoliceProcessBase reserveManagement, Model model) {
        model.addAttribute("reserveManagement", reserveManagement);
        return "modules/cg/reservemanagementcenter/policyProcess/policyProcessBase/reserveManagementInformation";
    }

    /**
     * 查看表单页面
     */
    @RequiresPermissions(value={"cg:policeProcess:base:view"},logical= Logical.OR)
    @RequestMapping(value = "view")
    public String view(PoliceProcessBase reserveManagement, Model model) {
        model.addAttribute("reserveManagement", reserveManagement);
        return "modules/cg/reservemanagementcenter/policyProcess/policyProcessBase/reserveManagementView";
    }

    /**
     * 项目储备信息数据列表
     * @param reserveManagement
     * @param request
     * @param response
     * @param model
     * @return
     */
    @ResponseBody
    @RequiresPermissions("cg:policeProcess:base:list")
    @RequestMapping(value = "list")
    public Map<String, Object> basicData(PoliceProcessBase reserveManagement, HttpServletRequest request, HttpServletResponse response, Model model) {

        Page<PoliceProcessBase> page = baseService.findPage(new Page<PoliceProcessBase>(request, response), reserveManagement);
        List<PoliceProcessBase> list = page.getList();

        List<PoliceProcessBase> safetyList = new ArrayList<>();

        List<String> nameList = new ArrayList<>();
        //获取所有小类的名称
        List<PickList> pickListList = raiseCapitalService.newAllList();
        if (null != pickListList) {
            pickListList.forEach(k->{
                if (k.getName().equals("三、设备")){
                    k.getMdTheClassList().forEach(v->{
                        v.getMdSmallClassList().forEach(na->{
                            nameList.add(na.getName());
                        });
                    });
                }
            });
        }

        List<DemoliteList> info = verificateService.getByProjectName();


        for (PoliceProcessBase safety : list){

            info.forEach(in->{
                if (in.getProjectName().equals(safety.getProjectName())){
                    if (StringUtils.isBlank(safety.getProjectNature())){
                        if (nameList.contains(in.getMaterialName())){
                            safety.setProjectNature("资本");
                        } else {
                            safety.setProjectNature("成本");
                        }
                    }
                }
            });
//            //根据项目储备id去在线开甲供材表中查询物理信息
//            List<String> materialNameList = verificateService.getMaterialName(safety.getProjectName());
//            if (null != nameList & null != materialNameList){
//                nameList.forEach(n->{
//                    if (StringUtils.isBlank(safety.getProjectNature())){
//                        if (materialNameList.contains(n)){
//                            safety.setProjectNature("资本");
//                        } else {
//                            safety.setProjectNature("成本");
//                        }
//                    }
//                });
//            }

            //根据projectReserveId查出流程表的proc_ins_id
            String procInsId = baseService.getByProjectReserveId(safety.getProjectReserveId());
            //根据procInsId查出历史流程名称和时间
            List<History> histories = baseService.getHistoryByExecuteId(procInsId);
            String historyName = workService.getHistoryName(procInsId);
            //当size>0时待办有历史流程，
            if (histories.size()>0){
                //根据proc_ins_id去运行时任务节点表（act_ru_task）中查出当前流程名称
                String name = baseService.getByExecuteId(procInsId);
                //设置项目进度
                if (StringUtils.isNotEmpty(name)){
                    safety.setReserveProgress(name);
                }else {
                    if (StringUtils.isNotBlank(historyName) && historyName.equals("技经人员审预算")){
                        safety.setReserveProgress("储备完成");
                    } else {
                        safety.setReserveProgress("");
                    }
                }
            }else {
                safety.setReserveProgress("");
            }
            safety.setWorkRemark("");
            safety.setStateGridProjectName("");
            safety.setStateGridProjectCode("");
            safetyList.add(safety);
        }
        page.setList(safetyList);
        return getBootstrapData(page);
    }

    /**
     * 专职人员增加，编辑表单页面
     * @param reserveManagement
     * @param model
     * @return
     */
    @RequiresPermissions(value={"cg:policeProcess:base:add","cg:policeProcess:base:edit"},logical= Logical.OR)
    @RequestMapping(value = "form")
    public String form(PoliceProcessBase reserveManagement, Model model) {
        //根据projectReserveId查出流程表的proc_ins_id
        String procInsId = baseService.getByProjectReserveId(reserveManagement.getProjectReserveId());
        //根据procInsId查出历史流程名称和时间
        List<History> histories = baseService.getHistoryByExecuteId(procInsId);
        //当size>0时待办有历史流程，
        if (histories.size()>0){
            //根据proc_ins_id去运行时任务节点表（act_ru_task）中查出当前流程名称
            String name = baseService.getByExecuteId(procInsId);
            //设置项目进度
            reserveManagement.setReserveProgress(name);
        }else {
            reserveManagement.setReserveProgress("");
        }
        model.addAttribute("reserveManagement", reserveManagement);
        //判断id是否为空 如果未空则为新增 否则为修改
        if(StringUtils.isBlank(reserveManagement.getId())){
            return "modules/cg/reservemanagementcenter/policyProcess/policyProcessBase/reserveManagementForm";
        }
        return "modules/cg/reservemanagementcenter/policyProcess/policyProcessBase/reserveManagementModifyByzz";
    }

    /**
     * 专职人员保存表单
     * @param reserveManagement
     * @return
     */
    @ResponseBody
    @RequiresPermissions(value={"cg:policeProcess:base:add"},logical=Logical.OR)
    @RequestMapping(value = "save")
    public AjaxJson save(PoliceProcessBase reserveManagement){
        AjaxJson j = new AjaxJson();
        /**
         * 后台hibernate-validation插件校验
         */
        String errMsg = beanValidator(reserveManagement);
        if (StringUtils.isNotBlank(errMsg)){
            j.setSuccess(false);
            j.setMsg(errMsg);
            return j;
        }
        //新增或编辑表单保存
        baseService.save(reserveManagement);//保存
        j.setSuccess(true);
        j.setMsg("保存储备项目基本信息成功");
        return j;
    }

    /**
     * 专职人员修改表单
     * @param reserveManagement
     * @return
     */
    @ResponseBody
    @RequiresPermissions(value={"cg:policeProcess:base:edit"},logical=Logical.OR)
    @RequestMapping(value = "update")
    public AjaxJson update(PoliceProcessBase reserveManagement){
        AjaxJson j = new AjaxJson();
        /**
         * 后台hibernate-validation插件校验
         */
        String errMsg = beanValidator(reserveManagement);
        if (StringUtils.isNotBlank(errMsg)){
            j.setSuccess(false);
            j.setMsg(errMsg);
            return j;
        }
        //根据项目储备编号查是否有改数据
        PoliceProcessBase safety = baseService.getByReserveId(reserveManagement.getProjectReserveId());
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        if (null == safety){
            safety = new PoliceProcessBase();
            safety.setProjectReserveId(reserveManagement.getProjectReserveId());
            safety.setPowerStationJurisdiction(reserveManagement.getPowerStationJurisdiction());
            safety.setConstructionLocation(reserveManagement.getConstructionLocation());
            safety.setWhetherExitPolitical(reserveManagement.getWhetherExitPolitical());
            safety.setPoliticalType(reserveManagement.getPoliticalType());
            safety.setPoliticalDescribe(reserveManagement.getPoliticalDescribe());
            safety.setPoliticalDifficulty(reserveManagement.getPoliticalDifficulty());
            safety.setWhetherReport(reserveManagement.getWhetherReport());
            safety.setSafetyProcedures(reserveManagement.getSafetyProcedures());
            safety.setAviationReviewProcedures(reserveManagement.getAviationReviewProcedures());
            safety.setStartPolitical(reserveManagement.getStartPolitical());
            safety.setStartTime(format.format(new Date()));
            safety.setPoliticalRemarks(reserveManagement.getPoliticalRemarks());
            //对需要对政策处理记录表进行处理
            mainTenanceRecord(safety);
            baseService.save(safety);
        }else {
            safety.setPowerStationJurisdiction(reserveManagement.getPowerStationJurisdiction());
            safety.setConstructionLocation(reserveManagement.getConstructionLocation());
            safety.setWhetherExitPolitical(reserveManagement.getWhetherExitPolitical());
            safety.setPoliticalType(reserveManagement.getPoliticalType());
            safety.setPoliticalDescribe(reserveManagement.getPoliticalDescribe());
            safety.setPoliticalDifficulty(reserveManagement.getPoliticalDifficulty());
            safety.setWhetherReport(reserveManagement.getWhetherReport());
            safety.setSafetyProcedures(reserveManagement.getSafetyProcedures());
            safety.setAviationReviewProcedures(reserveManagement.getAviationReviewProcedures());
            safety.setStartPolitical(reserveManagement.getStartPolitical());
            safety.setStartTime(reserveManagement.getStartTime());
            safety.setPoliticalRemarks(reserveManagement.getPoliticalRemarks());
            mainTenanceRecord(safety);
            //新增或编辑表单保存
            baseService.update(safety);
        }

        j.setSuccess(true);
        j.setMsg("修改储备项目基本信息成功");
        return j;
    }

    /**
     * 导入Excel数据
     */
    @ResponseBody
    @RequiresPermissions("cg:policeProcess:base:import")
    @RequestMapping(value = "import")
    public AjaxJson importBasic(@RequestParam("file") MultipartFile file, HttpServletResponse response, HttpServletRequest request) {
        AjaxJson j = new AjaxJson();
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        try {
            ImportUtil importUtil = new ImportUtil(file, 0, 0);

            //从数据库中查出所有的 项目储备编号
            List<String> proIdList = baseService.getAllProId();

            //从基本数据表中查出所有的 项目储备编号
            List<String> proIdList2 = baseService.getAllProId2();

            //获取导入表格所有数据
            List<PoliceProcessBase> reserveManagementList = PolicyProcessImportUtil.getPoliceProcessBaseUtil(importUtil,proIdList,proIdList2);
            //查询已有的参数数据 并分类返回已存在数据和未存在数据
            Map map = baseService.getExistProjectList(reserveManagementList);
            //未存在数据
            List<PoliceProcessBase> withoutList = (List<PoliceProcessBase>) map.get("without");
            //已存在数据
            List<PoliceProcessBase> existList = (List<PoliceProcessBase>) map.get("exist");

            //对未存在的数据进行批量导入
            if(withoutList.size()>0){

                for (PoliceProcessBase reserveManagement : withoutList) {
                    if (StringUtils.isNotBlank(reserveManagement.getStartPolitical())
                            &&reserveManagement.getStartPolitical().equals("是")){
                        reserveManagement.setStartTime(format.format(new Date()));
                    }
                    mainTenanceRecord(reserveManagement);
                }
                baseService.insertList(withoutList);

            }

            //对已存在的数据进行修改
            if(existList.size()>0){
                for (PoliceProcessBase reserveManagement : existList) {
                    if (StringUtils.isNotBlank(reserveManagement.getStartPolitical())
                            &&reserveManagement.getStartPolitical().equals("是")){
                        reserveManagement.setStartTime(format.format(new Date()));
                    }
                    mainTenanceRecord(reserveManagement);
                    baseService.update(reserveManagement);
                }
            }
            int i = withoutList.size() + existList.size();
            j.setMsg("已成功导入" + i + "条政策处理基本信息记录");

        } catch (Exception e) {
            j.setSuccess(false);
            j.setMsg("导入政策处理信息失败！失败信息：" + e.getMessage());
        }
        return j;
    }

    public void mainTenanceRecord(PoliceProcessBase reserveManagement){
        //需要对政策处理记录表进行处理
        if (StringUtils.isNotBlank(reserveManagement.getWhetherReport())
                &&reserveManagement.getWhetherReport().equals("是")){
            PoliceProcessRecord record = recordService.getInfoByReserveIdAndNum(reserveManagement.getProjectReserveId(),"1");
            if (null == record){
                record = new PoliceProcessRecord();
                record.setProjectReserveId(reserveManagement.getProjectReserveId());
                record.setSerialNumber("1");
                record.setAdministrativeObject("规划报批");
            } else {
                record.setAdministrativeObject("规划报批");
            }
            recordService.save(record);
        }
        if (StringUtils.isNotBlank(reserveManagement.getSafetyProcedures())
                &&reserveManagement.getSafetyProcedures().equals("是")){
            PoliceProcessRecord record = recordService.getInfoByReserveIdAndNum(reserveManagement.getProjectReserveId(),"2");
            if (null == record){
                record = new PoliceProcessRecord();
                record.setProjectReserveId(reserveManagement.getProjectReserveId());
                record.setSerialNumber("2");
                record.setAdministrativeObject("安评");
            } else {
                record.setAdministrativeObject("安评");
            }
            recordService.save(record);
        }
        if (StringUtils.isNotBlank(reserveManagement.getAviationReviewProcedures())
                &&reserveManagement.getAviationReviewProcedures().equals("是")){
            PoliceProcessRecord record = recordService.getInfoByReserveIdAndNum(reserveManagement.getProjectReserveId(),"3");
            if (null == record){
                record = new PoliceProcessRecord();
                record.setProjectReserveId(reserveManagement.getProjectReserveId());
                record.setSerialNumber("3");
                record.setAdministrativeObject("航评");
            } else {
                record.setAdministrativeObject("航评");
            }
            recordService.save(record);
        }
        if (StringUtils.isBlank(reserveManagement.getWhetherReport())
            && StringUtils.isBlank(reserveManagement.getSafetyProcedures())
                && StringUtils.isBlank(reserveManagement.getAviationReviewProcedures())){
            //当都为空的时候删除原有数据
            recordService.deleteByReserveId(reserveManagement.getProjectReserveId());
        }
    }

    //导出excel
    @ResponseBody
    @RequiresPermissions("cg:policeProcess:base:export")
    @RequestMapping(value = "export")
    public void exportExcel(PoliceProcessBase reserveManagement, HttpServletRequest request, HttpServletResponse response) {
        List<PoliceProcessBase> list = baseService.exportFindList(reserveManagement);

        List<PoliceProcessBase> safetyList = new ArrayList<>();

        for (PoliceProcessBase safety : list){
            //根据projectReserveId查出流程表的proc_ins_id
            String procInsId = baseService.getByProjectReserveId(safety.getProjectReserveId());
            //根据procInsId查出历史流程名称和时间
            List<History> histories = baseService.getHistoryByExecuteId(procInsId);
            String historyName = workService.getHistoryName(procInsId);
            //当size>0时待办有历史流程，
            if (histories.size()>0){
                //根据proc_ins_id去运行时任务节点表（act_ru_task）中查出当前流程名称
                String name = baseService.getByExecuteId(procInsId);
                //设置项目进度
                if (StringUtils.isNotEmpty(name)){
                    safety.setReserveProgress(name);
                }else {
                    if (StringUtils.isNotBlank(historyName) && historyName.equals("技经人员审预算")){
                        safety.setReserveProgress("储备完成");
                    } else {
                        safety.setReserveProgress("");
                    }
                }
            }else {
                safety.setReserveProgress("");
            }
            safety.setWorkRemark("");
            safety.setStateGridProjectCode("");
            safety.setStateGridProjectName("");
            safetyList.add(safety);
        }

        //生成序列号
        int i = 1;
        for (PoliceProcessBase s : safetyList) {
            s.setId(String.valueOf(i));
            i++;
        }

        PolicyProcessExportUtil util = PolicyProcessExportUtil.getOne();
        XSSFWorkbook workbook = util.getWorkbook("policeProcessBase");
        util.exportSafety(response,workbook,safetyList);
    }
}
