package com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.web;

import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.entity.PoliceProcessBase;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.entity.PoliceProcessRecord;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.service.PoliceProcessBaseService;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.service.PoliceProcessRecordService;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.util.PolicyProcessExportUtil;
import com.jeeplus.modules.cg.reservemanagementcenter.policyProcess.util.PolicyProcessImportUtil;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.service.ProjectTypeVerificateService;
import com.jeeplus.modules.sg.managementcenter.materialproject.util.ImportUtil;
import com.jeeplus.modules.sg.picking.activiti.entity.PickList;
import com.jeeplus.modules.sg.raiseCapital.service.RaiseCapitalService;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.apache.shiro.authz.annotation.Logical;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.UUID;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-09-01 15:49
 */
@Controller
@RequestMapping(value = "${adminPath}/cg/policeProcess/record")
public class PoliceProcessRecordController extends BaseController {

    @Autowired
    private PoliceProcessRecordService recordService;

    @Autowired
    private PoliceProcessBaseService baseService;

    @Autowired
    private ProjectTypeVerificateService verificateService;

    @Autowired
    private RaiseCapitalService raiseCapitalService;

    @ModelAttribute
    public PoliceProcessRecord get(@RequestParam(required = false) String id,@RequestParam(required = false) String serialNumber) {
        PoliceProcessRecord entity = null;
        if (StringUtils.isNotBlank(id)) {
            entity = recordService.get(id,serialNumber);
        }
        if (entity == null) {
            entity = new PoliceProcessRecord();
        }
        return entity;
    }

    /**
     * 项目储备信息列表页面
     * @param reserveManagement
     * @param model
     * @return
     */
    @RequiresPermissions("cg:policeProcess:record:list")
    @RequestMapping(value = "skipList")
    public String skipList(PoliceProcessRecord reserveManagement, Model model) {
        model.addAttribute("reserveManagement", reserveManagement);
        return "modules/cg/reservemanagementcenter/policyProcess/policyProcessRecord/reserveManagementInformation";
    }

    /**
     * 查看表单页面
     */
    @RequiresPermissions(value={"cg:policeProcess:record:view"},logical= Logical.OR)
    @RequestMapping(value = "view")
    public String view(PoliceProcessRecord reserveManagement, Model model) {
        model.addAttribute("reserveManagement", reserveManagement);
        return "modules/cg/reservemanagementcenter/policyProcess/policyProcessRecord/reserveManagementView";
    }

    /**
     * 项目储备信息数据列表
     * @param reserveManagement
     * @param request
     * @param response
     * @param model
     * @return
     */
    @ResponseBody
    @RequiresPermissions("cg:policeProcess:record:list")
    @RequestMapping(value = "list")
    public Map<String, Object> basicData(PoliceProcessRecord reserveManagement, HttpServletRequest request, HttpServletResponse response, Model model) {

        Page<PoliceProcessRecord> page = recordService.findPage(new Page<PoliceProcessRecord>(request, response), reserveManagement);
        List<PoliceProcessRecord> list = page.getList();

        List<String> nameList = new ArrayList<>();
        //获取所有小类的名称
        List<PickList> pickListList = raiseCapitalService.newAllList();
        if (null != pickListList) {
            pickListList.forEach(k->{
                if (k.getName().equals("三、设备")){
                    k.getMdTheClassList().forEach(v->{
                        v.getMdSmallClassList().forEach(na->{
                            nameList.add(na.getName());
                        });
                    });
                }
            });
        }

        for (int i=0;i<list.size();i++){

            //根据项目储备id去在线开甲供材表中查询物理信息
            List<String> materialNameList = verificateService.getMaterialName(list.get(i).getProjectName());
            if (null != nameList & null != materialNameList){
                int finalI = i;
                nameList.forEach(n->{
                    if (StringUtils.isBlank(list.get(finalI).getProjectNature())){
                        if (materialNameList.contains(n)){
                            list.get(finalI).setProjectNature("资本");
                        } else {
                            list.get(finalI).setProjectNature("成本");
                        }
                    }
                });
            }

            if (StringUtils.isNotBlank(list.get(i).getCompleteFinancialReimbursement())
                    &&list.get(i).getCompleteFinancialReimbursement().equals("是")
                    &&StringUtils.isNotBlank(list.get(i).getPossibleToEnterSite())&&list.get(i).getPossibleToEnterSite().equals("是")){
                list.get(i).setCompleteProcess("是");
            }else {
                list.get(i).setCompleteProcess("否");
            }
            if (StringUtils.isBlank(list.get(i).getStartPoliticalWork())&&StringUtils.isNotBlank(list.get(i).getStartPoliticalWork2())){
                list.get(i).setStartPoliticalWork(list.get(i).getStartPoliticalWork2());
            }
            if (StringUtils.isBlank(list.get(i).getStartTime())&&StringUtils.isNotBlank(list.get(i).getStartTime2())){
                list.get(i).setStartTime(list.get(i).getStartTime2());
            }
        }
        return getBootstrapData(page);
    }

    /**
     * 专职人员增加，编辑表单页面
     * @param reserveManagement
     * @param model
     * @return
     */
    @RequiresPermissions(value={"cg:policeProcess:record:add","cg:policeProcess:record:edit"},logical= Logical.OR)
    @RequestMapping(value = "form")
    public String form(PoliceProcessRecord reserveManagement, Model model) {
        model.addAttribute("reserveManagement", reserveManagement);
        //判断id是否为空 如果未空则为新增 否则为修改
        if(StringUtils.isBlank(reserveManagement.getId())){
            return "modules/cg/reservemanagementcenter/policyProcess/policyProcessRecord/reserveManagementForm";
        }
        return "modules/cg/reservemanagementcenter/policyProcess/policyProcessRecord/reserveManagementModifyByzz";
    }

    /**
     * 专职人员保存表单
     * @param reserveManagement
     * @return
     */
    @ResponseBody
    @RequiresPermissions(value={"cg:policeProcess:record:add"},logical=Logical.OR)
    @RequestMapping(value = "save")
    public AjaxJson save(PoliceProcessRecord reserveManagement){
        AjaxJson j = new AjaxJson();
        /**
         * 后台hibernate-validation插件校验
         */
        String errMsg = beanValidator(reserveManagement);
        if (StringUtils.isNotBlank(errMsg)){
            j.setSuccess(false);
            j.setMsg(errMsg);
            return j;
        }
        //新增或编辑表单保存
        recordService.save(reserveManagement);//保存
        j.setSuccess(true);
        j.setMsg("保存储备项目基本信息成功");
        return j;
    }

    /**
     * 导入Excel数据
     */
    @ResponseBody
    @RequiresPermissions("cg:policeProcess:record:import")
    @RequestMapping(value = "import")
    public AjaxJson importBasic(@RequestParam("file") MultipartFile file, HttpServletResponse response, HttpServletRequest request) {
        AjaxJson j = new AjaxJson();
        try {
            ImportUtil importUtil = new ImportUtil(file, 0, 0);

            //从数据库中查出所有的 项目储备编号
            List<String> proIdList = recordService.getAllProId();

            //从基本数据表中查出所有的 项目储备编号
            List<String> proIdList2 = recordService.getAllProId2();

            //获取导入表格所有数据
            List<PoliceProcessRecord> reserveManagementList = PolicyProcessImportUtil.getPoliceProcessRecordUtil(importUtil,proIdList,proIdList2);
            //查询已有的参数数据 并分类返回已存在数据和未存在数据
            Map map = recordService.getExistProjectList(reserveManagementList);
            //未存在数据
            List<PoliceProcessRecord> withoutList = (List<PoliceProcessRecord>) map.get("without");
            //已存在数据
            List<PoliceProcessRecord> existList = (List<PoliceProcessRecord>) map.get("exist");

            //对未存在的数据进行批量导入
            if(withoutList.size()>0){
                recordService.insertList(withoutList);
            }

            //对已存在的数据进行修改
            if(existList.size()>0){
                for (PoliceProcessRecord reserveManagement : existList) {
                    recordService.update(reserveManagement);
                }
            }
            int i = withoutList.size() + existList.size();
            j.setMsg("已成功导入" + i + "条政策处理记录信息记录");

        } catch (Exception e) {
            j.setSuccess(false);
            j.setMsg("导入政策处理信息失败！失败信息：" + e.getMessage());
        }
        return j;
    }

    /**
     * 保存 评政策处理记录页面数据
     * @param arrangement
     * @return
     */
    @ResponseBody
    @RequiresPermissions(value={"cg:policeProcess:record:add"},logical=Logical.OR)
    @RequestMapping(value = "reviewSave")
    public AjaxJson reviewSave(@RequestBody PoliceProcessRecord arrangement){
        AjaxJson j = new AjaxJson();
        /**
         * 后台hibernate-validation插件校验
         */
        String errMsg = beanValidator(arrangement);
        if (StringUtils.isNotBlank(errMsg)){
            j.setSuccess(false);
            j.setMsg(errMsg);
            return j;
        }

        //新增或编辑表单保存
        //根据projectReserveId与序号查相关数据
        PoliceProcessRecord record = recordService.getInfoByReserveIdAndNum(arrangement.getProjectReserveId(),arrangement.getSerialNumber());
        if (null == record) {
            record = new PoliceProcessRecord();
            record.setProjectReserveId(arrangement.getProjectReserveId());
            record.setSerialNumber(arrangement.getSerialNumber());
            record.setStartPoliticalWork(arrangement.getStartPoliticalWork());
            record.setStartTime(arrangement.getStartTime());
            record.setAdministrativeObject(arrangement.getAdministrativeObject());
            record.setNeedCompensation(arrangement.getNeedCompensation());
            record.setCompensationMoney(arrangement.getCompensationMoney());
            record.setDocumentCommitTime(arrangement.getDocumentCommitTime());
            record.setFinancialPayment(arrangement.getFinancialPayment());
            record.setNeedSignContract(arrangement.getNeedSignContract());
            record.setSignContractTime(arrangement.getSignContractTime());
            record.setWeatherLoan(arrangement.getWeatherLoan());
            record.setLoanTime(arrangement.getLoanTime());
            record.setCompleteFinancialReimbursement(arrangement.getCompleteFinancialReimbursement());
            record.setCompleteFinancialReimbursementTime(arrangement.getCompleteFinancialReimbursementTime());
            record.setPossibleToEnterSite(arrangement.getPossibleToEnterSite());
            record.setPossibleToEnterSiteTime(arrangement.getPossibleToEnterSiteTime());
            record.setNegotiatingUnit(arrangement.getNegotiatingUnit());
            record.setCoordinateUnit(arrangement.getCoordinateUnit());
            record.setRecordRemarks(arrangement.getRecordRemarks());
            recordService.save(record);//保存
        } else {
            record.setProjectReserveId(arrangement.getProjectReserveId());
            record.setSerialNumber(arrangement.getSerialNumber());
            record.setStartPoliticalWork(arrangement.getStartPoliticalWork());
            record.setStartTime(arrangement.getStartTime());
            record.setAdministrativeObject(arrangement.getAdministrativeObject());
            record.setNeedCompensation(arrangement.getNeedCompensation());
            record.setCompensationMoney(arrangement.getCompensationMoney());
            record.setDocumentCommitTime(arrangement.getDocumentCommitTime());
            record.setFinancialPayment(arrangement.getFinancialPayment());
            record.setNeedSignContract(arrangement.getNeedSignContract());
            record.setSignContractTime(arrangement.getSignContractTime());
            record.setWeatherLoan(arrangement.getWeatherLoan());
            record.setLoanTime(arrangement.getLoanTime());
            record.setCompleteFinancialReimbursement(arrangement.getCompleteFinancialReimbursement());
            record.setCompleteFinancialReimbursementTime(arrangement.getCompleteFinancialReimbursementTime());
            record.setPossibleToEnterSite(arrangement.getPossibleToEnterSite());
            record.setPossibleToEnterSiteTime(arrangement.getPossibleToEnterSiteTime());
            record.setNegotiatingUnit(arrangement.getNegotiatingUnit());
            record.setCoordinateUnit(arrangement.getCoordinateUnit());
            record.setRecordRemarks(arrangement.getRecordRemarks());
            recordService.update(record);//保存
        }
        j.setSuccess(true);
        j.setMsg("保存政策处理记录信息成功");
        return j;
    }

    //导出excel
    @ResponseBody
    @RequiresPermissions("cg:policeProcess:record:export")
    @RequestMapping(value = "export")
    public void exportExcel(PoliceProcessRecord reserveManagement, HttpServletRequest request, HttpServletResponse response) {
        List<PoliceProcessRecord> list = recordService.exportFindList(reserveManagement);

        //生成序列号
        int j = 1;
        for (PoliceProcessRecord s : list) {
            s.setId(String.valueOf(j));
            j++;
        }

        for (int i=0;i<list.size();i++){
            if (StringUtils.isNotBlank(list.get(i).getCompleteFinancialReimbursement())
                    &&list.get(i).getCompleteFinancialReimbursement().equals("是")
                    &&StringUtils.isNotBlank(list.get(i).getPossibleToEnterSite())&&list.get(i).getPossibleToEnterSite().equals("是")){
                list.get(i).setCompleteProcess("是");
            }else {
                list.get(i).setCompleteProcess("否");
            }
            if (StringUtils.isBlank(list.get(i).getStartPoliticalWork())&&StringUtils.isNotBlank(list.get(i).getStartPoliticalWork2())){
                list.get(i).setStartPoliticalWork(list.get(i).getStartPoliticalWork2());
            }
            if (StringUtils.isBlank(list.get(i).getStartTime())&&StringUtils.isNotBlank(list.get(i).getStartTime2())){
                list.get(i).setStartTime(list.get(i).getStartTime2());
            }
        }
        PolicyProcessExportUtil util = PolicyProcessExportUtil.getOne();
        XSSFWorkbook workbook = util.getWorkbook("policeProcessRecord");
        util.exportRecord(response,workbook,list);
    }
}
