package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity;

import com.jeeplus.core.persistence.DataEntity;

/**
 * 储备项目前期准备工作
 * @author: 王强
 * @create: 2023-03-27 16:31
 **/
public class PreliminaryPrepartion extends DataEntity<PreliminaryPrepartion> {

    private String projectYear;             //项目年份
    private String projectNature;           //项目性质
    private String demandUnit;              //需求单位
    private String district;                //区域
    private String projectGroup;            //项目分组
    private String projectManager;          //项目经理
    private String reserveBatches;          //储备批次
    private String blockSupply;             //供电区域
    private String gridNumber;              //网格编号
    private String cellNumber;              //单元格编号
    private String projectReserveId;        //项目储备编号
    private String projectName;             //项目名称
    private String constructionNecessityAndContent;           //建设必要性及内容
    private String substationName;           //变电站名称
    private String circuitName;              //线路名称
    private String netRackProjectDivide;     //网架项目划分
    private String requirementType;          //需求类型
    private String projectType;              //项目类型
    private String costEstimate;             //费用估算
    private String basicRemarks;             //备注


    private String comprehensiveProject;     //项目综合可实施性
    private String officeDifficulty;         //政处难度
    private String officeProgress;           //政处描述
    private String powerFailureDifficulty;   //停电难度
    private String powerFailureDescribe;     //停电描述
    private String otherProblemDifficulty;   //其他问题难度
    private String otherProblemDescribe;     //其他问题描述
    private String runPlanRequire;           //是否需重跑方案
    private String programChangeDescription; //方案变更说明
    private String discloseRemarks;          //储备项目交底信息-备注


    private String reserveProgress;          //储备进度
    private String civilEngineeringWorkload; //是否含土建工作量
    private String engineeringWorkloadStatistic; //土建工作量统计
    private String poleWorkload;             //是否含立杆工作量
    private String poleWorkloadStatistic;    //立杆工作量统计
    private String budgetIncludesTax;        //预算含税
    private String budgetNotIncludesTax;     //预算不含税
    private String constructCostExcludeTax;  //施工费（不含税）
    private String quantityRemarks;  //储备项目工程量统计备注

    private String reserveProjectPromotyPlan;  //储备项目推进计划（项目管理中心）
    private String unitCompleteProgress;  //项目管理单位完成进度
    private String demandUnitReserveProjectPromotyPlan;  //储备项目推进计划（需求单位）
    private String demandUnitCompleteProgress;  //需求单位完成进度
    private String fireAdministrativeDepartment;  //是否启动政处
    private String administrativeProgress;           //政处进度
    private String preliminaryPreparationRemarks;  //前期准备工作备注

    private String demandUnitPriority;  //需求单位优先级
    private String implementPlan;  //是否纳入实施计划
    private String implementBatch;  //初定实施批次
    private String constructionUnit;  //初定施工单位
    private String planAndApprovalDraw;  //是否出规划报批图
    private String drawOfficeDrawn;  //是否出正式图
    private String projectApprovalRemarks;  //立项安排备注

    public String getProjectYear() {
        return projectYear;
    }

    public void setProjectYear(String projectYear) {
        this.projectYear = projectYear;
    }

    public String getProjectNature() {
        return projectNature;
    }

    public void setProjectNature(String projectNature) {
        this.projectNature = projectNature;
    }

    public String getDemandUnit() {
        return demandUnit;
    }

    public void setDemandUnit(String demandUnit) {
        this.demandUnit = demandUnit;
    }

    public String getDistrict() {
        return district;
    }

    public void setDistrict(String district) {
        this.district = district;
    }

    public String getProjectGroup() {
        return projectGroup;
    }

    public void setProjectGroup(String projectGroup) {
        this.projectGroup = projectGroup;
    }

    public String getProjectManager() {
        return projectManager;
    }

    public void setProjectManager(String projectManager) {
        this.projectManager = projectManager;
    }

    public String getReserveBatches() {
        return reserveBatches;
    }

    public void setReserveBatches(String reserveBatches) {
        this.reserveBatches = reserveBatches;
    }

    public String getBlockSupply() {
        return blockSupply;
    }

    public void setBlockSupply(String blockSupply) {
        this.blockSupply = blockSupply;
    }

    public String getGridNumber() {
        return gridNumber;
    }

    public void setGridNumber(String gridNumber) {
        this.gridNumber = gridNumber;
    }

    public String getCellNumber() {
        return cellNumber;
    }

    public void setCellNumber(String cellNumber) {
        this.cellNumber = cellNumber;
    }

    public String getProjectReserveId() {
        return projectReserveId;
    }

    public void setProjectReserveId(String projectReserveId) {
        this.projectReserveId = projectReserveId;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getConstructionNecessityAndContent() {
        return constructionNecessityAndContent;
    }

    public void setConstructionNecessityAndContent(String constructionNecessityAndContent) {
        this.constructionNecessityAndContent = constructionNecessityAndContent;
    }

    public String getSubstationName() {
        return substationName;
    }

    public void setSubstationName(String substationName) {
        this.substationName = substationName;
    }

    public String getCircuitName() {
        return circuitName;
    }

    public void setCircuitName(String circuitName) {
        this.circuitName = circuitName;
    }

    public String getNetRackProjectDivide() {
        return netRackProjectDivide;
    }

    public void setNetRackProjectDivide(String netRackProjectDivide) {
        this.netRackProjectDivide = netRackProjectDivide;
    }

    public String getRequirementType() {
        return requirementType;
    }

    public void setRequirementType(String requirementType) {
        this.requirementType = requirementType;
    }

    public String getProjectType() {
        return projectType;
    }

    public void setProjectType(String projectType) {
        this.projectType = projectType;
    }

    public String getCostEstimate() {
        return costEstimate;
    }

    public void setCostEstimate(String costEstimate) {
        this.costEstimate = costEstimate;
    }

    public String getBasicRemarks() {
        return basicRemarks;
    }

    public void setBasicRemarks(String basicRemarks) {
        this.basicRemarks = basicRemarks;
    }

    public String getComprehensiveProject() {
        return comprehensiveProject;
    }

    public void setComprehensiveProject(String comprehensiveProject) {
        this.comprehensiveProject = comprehensiveProject;
    }

    public String getOfficeDifficulty() {
        return officeDifficulty;
    }

    public void setOfficeDifficulty(String officeDifficulty) {
        this.officeDifficulty = officeDifficulty;
    }

    public String getOfficeProgress() {
        return officeProgress;
    }

    public void setOfficeProgress(String officeProgress) {
        this.officeProgress = officeProgress;
    }

    public String getPowerFailureDifficulty() {
        return powerFailureDifficulty;
    }

    public void setPowerFailureDifficulty(String powerFailureDifficulty) {
        this.powerFailureDifficulty = powerFailureDifficulty;
    }

    public String getPowerFailureDescribe() {
        return powerFailureDescribe;
    }

    public void setPowerFailureDescribe(String powerFailureDescribe) {
        this.powerFailureDescribe = powerFailureDescribe;
    }

    public String getOtherProblemDifficulty() {
        return otherProblemDifficulty;
    }

    public void setOtherProblemDifficulty(String otherProblemDifficulty) {
        this.otherProblemDifficulty = otherProblemDifficulty;
    }

    public String getOtherProblemDescribe() {
        return otherProblemDescribe;
    }

    public void setOtherProblemDescribe(String otherProblemDescribe) {
        this.otherProblemDescribe = otherProblemDescribe;
    }

    public String getRunPlanRequire() {
        return runPlanRequire;
    }

    public void setRunPlanRequire(String runPlanRequire) {
        this.runPlanRequire = runPlanRequire;
    }

    public String getProgramChangeDescription() {
        return programChangeDescription;
    }

    public void setProgramChangeDescription(String programChangeDescription) {
        this.programChangeDescription = programChangeDescription;
    }

    public String getDiscloseRemarks() {
        return discloseRemarks;
    }

    public void setDiscloseRemarks(String discloseRemarks) {
        this.discloseRemarks = discloseRemarks;
    }

    public String getReserveProgress() {
        return reserveProgress;
    }

    public void setReserveProgress(String reserveProgress) {
        this.reserveProgress = reserveProgress;
    }

    public String getCivilEngineeringWorkload() {
        return civilEngineeringWorkload;
    }

    public void setCivilEngineeringWorkload(String civilEngineeringWorkload) {
        this.civilEngineeringWorkload = civilEngineeringWorkload;
    }

    public String getEngineeringWorkloadStatistic() {
        return engineeringWorkloadStatistic;
    }

    public void setEngineeringWorkloadStatistic(String engineeringWorkloadStatistic) {
        this.engineeringWorkloadStatistic = engineeringWorkloadStatistic;
    }

    public String getPoleWorkload() {
        return poleWorkload;
    }

    public void setPoleWorkload(String poleWorkload) {
        this.poleWorkload = poleWorkload;
    }

    public String getPoleWorkloadStatistic() {
        return poleWorkloadStatistic;
    }

    public void setPoleWorkloadStatistic(String poleWorkloadStatistic) {
        this.poleWorkloadStatistic = poleWorkloadStatistic;
    }

    public String getBudgetIncludesTax() {
        return budgetIncludesTax;
    }

    public void setBudgetIncludesTax(String budgetIncludesTax) {
        this.budgetIncludesTax = budgetIncludesTax;
    }

    public String getBudgetNotIncludesTax() {
        return budgetNotIncludesTax;
    }

    public void setBudgetNotIncludesTax(String budgetNotIncludesTax) {
        this.budgetNotIncludesTax = budgetNotIncludesTax;
    }

    public String getConstructCostExcludeTax() {
        return constructCostExcludeTax;
    }

    public void setConstructCostExcludeTax(String constructCostExcludeTax) {
        this.constructCostExcludeTax = constructCostExcludeTax;
    }

    public String getQuantityRemarks() {
        return quantityRemarks;
    }

    public void setQuantityRemarks(String quantityRemarks) {
        this.quantityRemarks = quantityRemarks;
    }

    public String getReserveProjectPromotyPlan() {
        return reserveProjectPromotyPlan;
    }

    public void setReserveProjectPromotyPlan(String reserveProjectPromotyPlan) {
        this.reserveProjectPromotyPlan = reserveProjectPromotyPlan;
    }

    public String getUnitCompleteProgress() {
        return unitCompleteProgress;
    }

    public void setUnitCompleteProgress(String unitCompleteProgress) {
        this.unitCompleteProgress = unitCompleteProgress;
    }

    public String getDemandUnitReserveProjectPromotyPlan() {
        return demandUnitReserveProjectPromotyPlan;
    }

    public void setDemandUnitReserveProjectPromotyPlan(String demandUnitReserveProjectPromotyPlan) {
        this.demandUnitReserveProjectPromotyPlan = demandUnitReserveProjectPromotyPlan;
    }

    public String getDemandUnitCompleteProgress() {
        return demandUnitCompleteProgress;
    }

    public void setDemandUnitCompleteProgress(String demandUnitCompleteProgress) {
        this.demandUnitCompleteProgress = demandUnitCompleteProgress;
    }

    public String getFireAdministrativeDepartment() {
        return fireAdministrativeDepartment;
    }

    public void setFireAdministrativeDepartment(String fireAdministrativeDepartment) {
        this.fireAdministrativeDepartment = fireAdministrativeDepartment;
    }

    public String getAdministrativeProgress() {
        return administrativeProgress;
    }

    public void setAdministrativeProgress(String administrativeProgress) {
        this.administrativeProgress = administrativeProgress;
    }

    public String getPreliminaryPreparationRemarks() {
        return preliminaryPreparationRemarks;
    }

    public void setPreliminaryPreparationRemarks(String preliminaryPreparationRemarks) {
        this.preliminaryPreparationRemarks = preliminaryPreparationRemarks;
    }

    public String getDemandUnitPriority() {
        return demandUnitPriority;
    }

    public void setDemandUnitPriority(String demandUnitPriority) {
        this.demandUnitPriority = demandUnitPriority;
    }

    public String getImplementPlan() {
        return implementPlan;
    }

    public void setImplementPlan(String implementPlan) {
        this.implementPlan = implementPlan;
    }

    public String getImplementBatch() {
        return implementBatch;
    }

    public void setImplementBatch(String implementBatch) {
        this.implementBatch = implementBatch;
    }

    public String getConstructionUnit() {
        return constructionUnit;
    }

    public void setConstructionUnit(String constructionUnit) {
        this.constructionUnit = constructionUnit;
    }

    public String getPlanAndApprovalDraw() {
        return planAndApprovalDraw;
    }

    public void setPlanAndApprovalDraw(String planAndApprovalDraw) {
        this.planAndApprovalDraw = planAndApprovalDraw;
    }

    public String getDrawOfficeDrawn() {
        return drawOfficeDrawn;
    }

    public void setDrawOfficeDrawn(String drawOfficeDrawn) {
        this.drawOfficeDrawn = drawOfficeDrawn;
    }

    public String getProjectApprovalRemarks() {
        return projectApprovalRemarks;
    }

    public void setProjectApprovalRemarks(String projectApprovalRemarks) {
        this.projectApprovalRemarks = projectApprovalRemarks;
    }
}
