package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity;

import com.jeeplus.core.persistence.DataEntity;

/**
 * 储备项目立项筛选统计表
 * @author: 王强
 * @create: 2023-06-28 08:54
 **/
public class ProjectScreen extends DataEntity<ProjectScreen> {

    private String projectManager;          //项目储备经理
    private String projectYear;             //项目年份
    private String projectNature;           //项目性质
    private String demandUnit;              //需求单位
    private String district;                //区域
    private String projectGroup;            //项目分组
    private String reserveBatches;          //储备批次
    private String blockSupply;             //供电区域
    private String gridNumber;              //网格编号
    private String cellNumber;              //单元格编号
    private String projectReserveId;        //项目储备编号
    private String projectName;             //项目名称
    private String stateGridProjectCode;             //国网项目编码
    private String stateGridProjectName;             //国网项目名称
    private String constructionNecessityAndContent;           //建设必要性及内容
    private String substationName;           //变电站名称
    private String circuitName;              //线路名称
    private String netRackProjectDivide;     //网架项目划分
    private String requirementType;          //需求类型
    private String projectType;          //项目类型
    private String costEstimate;             //费用估算
    private String basicRemarks;             //储备项目基本信息-备注

    private String reserveProgress;          //储备进度
    private String implementReserve;         //是否纳入储备
    private String implementBatch;           //初定实施批次

    private String civilWorkload;             //是否含土建工作量
    private String civilWorkloadStatistics;   //土建工作量统计
    private String uprightPoleWorkload;             //是否含立杆工作量
    private String uprightPoleWorkloadStatistics;   //立杆工作量统计
    private String budgetIncludesTax;        //预算含税
    private String budgetNotIncludesTax;     //预算不含税
    private String constructCostExcludeTax;  //施工费（不含税）
    private String projectQuantityRemarks;         //储备项目工程量统计-备注

    private String comprehensiveProject;      //项目综合可实施性
    private String officeDifficulty;         //政处难度
    private String officeProgress;           //政处描述
    private String powerFailureDifficulty;   //停电难度
    private String powerFailureDescribe;     //停电描述
    private String otherProblemDifficulty;   //其他问题难度
    private String otherProblemDescribe;     //其他问题描述
    private String runPlanRequire;           //是否需重跑方案
    private String programChangeDescription; //方案变更说明
    private String discloseRemarks;          //储备项目交底信息-备注

    private String projectPromotion;        //储备项目推进任务。
    private String completeProgress;        //完成进度。
    private String fireAdministrativeDepartment;  //是否启动政处
    private String administrativeProgress;           //政处进度
    private String preliminaryWorkPreparationRemarks;           //储备项目前期准备工作-备注。

    private String requirementUnitPriority;     //需求单位优先级
    private String implementPlan;            //是否纳入实施计划
    private String implementBatchScreen;           //立项筛选-初定实施批次
    private String constructionUnit;           //初定施工单位
    private String projectApprovalBatch;           //实际立项批次
    private String realityConstructionUnit;           //实际施工单位
    private String approvalDiagram;           //是否需出规划报批图
    private String approvalDiagramTime;           //要求移交规划报批图时间
    private String paperDrawing;           //是否需出纸质图
    private String paperDrawingTime;           //要求移交纸质图纸时间
    private String screenRemarks;           //立项筛选-备注


    public String getProjectManager() {
        return projectManager;
    }

    public void setProjectManager(String projectManager) {
        this.projectManager = projectManager;
    }

    public String getProjectYear() {
        return projectYear;
    }

    public void setProjectYear(String projectYear) {
        this.projectYear = projectYear;
    }

    public String getProjectNature() {
        return projectNature;
    }

    public void setProjectNature(String projectNature) {
        this.projectNature = projectNature;
    }

    public String getDemandUnit() {
        return demandUnit;
    }

    public void setDemandUnit(String demandUnit) {
        this.demandUnit = demandUnit;
    }

    public String getDistrict() {
        return district;
    }

    public void setDistrict(String district) {
        this.district = district;
    }

    public String getProjectGroup() {
        return projectGroup;
    }

    public void setProjectGroup(String projectGroup) {
        this.projectGroup = projectGroup;
    }

    public String getReserveBatches() {
        return reserveBatches;
    }

    public void setReserveBatches(String reserveBatches) {
        this.reserveBatches = reserveBatches;
    }

    public String getBlockSupply() {
        return blockSupply;
    }

    public void setBlockSupply(String blockSupply) {
        this.blockSupply = blockSupply;
    }

    public String getGridNumber() {
        return gridNumber;
    }

    public void setGridNumber(String gridNumber) {
        this.gridNumber = gridNumber;
    }

    public String getCellNumber() {
        return cellNumber;
    }

    public void setCellNumber(String cellNumber) {
        this.cellNumber = cellNumber;
    }

    public String getProjectReserveId() {
        return projectReserveId;
    }

    public void setProjectReserveId(String projectReserveId) {
        this.projectReserveId = projectReserveId;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getStateGridProjectCode() {
        return stateGridProjectCode;
    }

    public void setStateGridProjectCode(String stateGridProjectCode) {
        this.stateGridProjectCode = stateGridProjectCode;
    }

    public String getStateGridProjectName() {
        return stateGridProjectName;
    }

    public void setStateGridProjectName(String stateGridProjectName) {
        this.stateGridProjectName = stateGridProjectName;
    }

    public String getConstructionNecessityAndContent() {
        return constructionNecessityAndContent;
    }

    public void setConstructionNecessityAndContent(String constructionNecessityAndContent) {
        this.constructionNecessityAndContent = constructionNecessityAndContent;
    }

    public String getSubstationName() {
        return substationName;
    }

    public void setSubstationName(String substationName) {
        this.substationName = substationName;
    }

    public String getCircuitName() {
        return circuitName;
    }

    public void setCircuitName(String circuitName) {
        this.circuitName = circuitName;
    }

    public String getNetRackProjectDivide() {
        return netRackProjectDivide;
    }

    public void setNetRackProjectDivide(String netRackProjectDivide) {
        this.netRackProjectDivide = netRackProjectDivide;
    }

    public String getRequirementType() {
        return requirementType;
    }

    public void setRequirementType(String requirementType) {
        this.requirementType = requirementType;
    }

    public String getProjectType() {
        return projectType;
    }

    public void setProjectType(String projectType) {
        this.projectType = projectType;
    }

    public String getCostEstimate() {
        return costEstimate;
    }

    public void setCostEstimate(String costEstimate) {
        this.costEstimate = costEstimate;
    }

    public String getBasicRemarks() {
        return basicRemarks;
    }

    public void setBasicRemarks(String basicRemarks) {
        this.basicRemarks = basicRemarks;
    }

    public String getReserveProgress() {
        return reserveProgress;
    }

    public void setReserveProgress(String reserveProgress) {
        this.reserveProgress = reserveProgress;
    }

    public String getImplementReserve() {
        return implementReserve;
    }

    public void setImplementReserve(String implementReserve) {
        this.implementReserve = implementReserve;
    }

    public String getImplementBatch() {
        return implementBatch;
    }

    public void setImplementBatch(String implementBatch) {
        this.implementBatch = implementBatch;
    }

    public String getCivilWorkload() {
        return civilWorkload;
    }

    public void setCivilWorkload(String civilWorkload) {
        this.civilWorkload = civilWorkload;
    }

    public String getCivilWorkloadStatistics() {
        return civilWorkloadStatistics;
    }

    public void setCivilWorkloadStatistics(String civilWorkloadStatistics) {
        this.civilWorkloadStatistics = civilWorkloadStatistics;
    }

    public String getUprightPoleWorkload() {
        return uprightPoleWorkload;
    }

    public void setUprightPoleWorkload(String uprightPoleWorkload) {
        this.uprightPoleWorkload = uprightPoleWorkload;
    }

    public String getUprightPoleWorkloadStatistics() {
        return uprightPoleWorkloadStatistics;
    }

    public void setUprightPoleWorkloadStatistics(String uprightPoleWorkloadStatistics) {
        this.uprightPoleWorkloadStatistics = uprightPoleWorkloadStatistics;
    }

    public String getBudgetIncludesTax() {
        return budgetIncludesTax;
    }

    public void setBudgetIncludesTax(String budgetIncludesTax) {
        this.budgetIncludesTax = budgetIncludesTax;
    }

    public String getBudgetNotIncludesTax() {
        return budgetNotIncludesTax;
    }

    public void setBudgetNotIncludesTax(String budgetNotIncludesTax) {
        this.budgetNotIncludesTax = budgetNotIncludesTax;
    }

    public String getConstructCostExcludeTax() {
        return constructCostExcludeTax;
    }

    public void setConstructCostExcludeTax(String constructCostExcludeTax) {
        this.constructCostExcludeTax = constructCostExcludeTax;
    }

    public String getProjectQuantityRemarks() {
        return projectQuantityRemarks;
    }

    public void setProjectQuantityRemarks(String projectQuantityRemarks) {
        this.projectQuantityRemarks = projectQuantityRemarks;
    }

    public String getComprehensiveProject() {
        return comprehensiveProject;
    }

    public void setComprehensiveProject(String comprehensiveProject) {
        this.comprehensiveProject = comprehensiveProject;
    }

    public String getOfficeDifficulty() {
        return officeDifficulty;
    }

    public void setOfficeDifficulty(String officeDifficulty) {
        this.officeDifficulty = officeDifficulty;
    }

    public String getOfficeProgress() {
        return officeProgress;
    }

    public void setOfficeProgress(String officeProgress) {
        this.officeProgress = officeProgress;
    }

    public String getPowerFailureDifficulty() {
        return powerFailureDifficulty;
    }

    public void setPowerFailureDifficulty(String powerFailureDifficulty) {
        this.powerFailureDifficulty = powerFailureDifficulty;
    }

    public String getPowerFailureDescribe() {
        return powerFailureDescribe;
    }

    public void setPowerFailureDescribe(String powerFailureDescribe) {
        this.powerFailureDescribe = powerFailureDescribe;
    }

    public String getOtherProblemDifficulty() {
        return otherProblemDifficulty;
    }

    public void setOtherProblemDifficulty(String otherProblemDifficulty) {
        this.otherProblemDifficulty = otherProblemDifficulty;
    }

    public String getOtherProblemDescribe() {
        return otherProblemDescribe;
    }

    public void setOtherProblemDescribe(String otherProblemDescribe) {
        this.otherProblemDescribe = otherProblemDescribe;
    }

    public String getRunPlanRequire() {
        return runPlanRequire;
    }

    public void setRunPlanRequire(String runPlanRequire) {
        this.runPlanRequire = runPlanRequire;
    }

    public String getProgramChangeDescription() {
        return programChangeDescription;
    }

    public void setProgramChangeDescription(String programChangeDescription) {
        this.programChangeDescription = programChangeDescription;
    }

    public String getDiscloseRemarks() {
        return discloseRemarks;
    }

    public void setDiscloseRemarks(String discloseRemarks) {
        this.discloseRemarks = discloseRemarks;
    }

    public String getProjectPromotion() {
        return projectPromotion;
    }

    public void setProjectPromotion(String projectPromotion) {
        this.projectPromotion = projectPromotion;
    }

    public String getCompleteProgress() {
        return completeProgress;
    }

    public void setCompleteProgress(String completeProgress) {
        this.completeProgress = completeProgress;
    }

    public String getFireAdministrativeDepartment() {
        return fireAdministrativeDepartment;
    }

    public void setFireAdministrativeDepartment(String fireAdministrativeDepartment) {
        this.fireAdministrativeDepartment = fireAdministrativeDepartment;
    }

    public String getAdministrativeProgress() {
        return administrativeProgress;
    }

    public void setAdministrativeProgress(String administrativeProgress) {
        this.administrativeProgress = administrativeProgress;
    }

    public String getPreliminaryWorkPreparationRemarks() {
        return preliminaryWorkPreparationRemarks;
    }

    public void setPreliminaryWorkPreparationRemarks(String preliminaryWorkPreparationRemarks) {
        this.preliminaryWorkPreparationRemarks = preliminaryWorkPreparationRemarks;
    }

    public String getRequirementUnitPriority() {
        return requirementUnitPriority;
    }

    public void setRequirementUnitPriority(String requirementUnitPriority) {
        this.requirementUnitPriority = requirementUnitPriority;
    }

    public String getImplementPlan() {
        return implementPlan;
    }

    public void setImplementPlan(String implementPlan) {
        this.implementPlan = implementPlan;
    }

    public String getImplementBatchScreen() {
        return implementBatchScreen;
    }

    public void setImplementBatchScreen(String implementBatchScreen) {
        this.implementBatchScreen = implementBatchScreen;
    }

    public String getConstructionUnit() {
        return constructionUnit;
    }

    public void setConstructionUnit(String constructionUnit) {
        this.constructionUnit = constructionUnit;
    }

    public String getProjectApprovalBatch() {
        return projectApprovalBatch;
    }

    public void setProjectApprovalBatch(String projectApprovalBatch) {
        this.projectApprovalBatch = projectApprovalBatch;
    }

    public String getRealityConstructionUnit() {
        return realityConstructionUnit;
    }

    public void setRealityConstructionUnit(String realityConstructionUnit) {
        this.realityConstructionUnit = realityConstructionUnit;
    }

    public String getApprovalDiagram() {
        return approvalDiagram;
    }

    public void setApprovalDiagram(String approvalDiagram) {
        this.approvalDiagram = approvalDiagram;
    }

    public String getApprovalDiagramTime() {
        return approvalDiagramTime;
    }

    public void setApprovalDiagramTime(String approvalDiagramTime) {
        this.approvalDiagramTime = approvalDiagramTime;
    }

    public String getPaperDrawing() {
        return paperDrawing;
    }

    public void setPaperDrawing(String paperDrawing) {
        this.paperDrawing = paperDrawing;
    }

    public String getPaperDrawingTime() {
        return paperDrawingTime;
    }

    public void setPaperDrawingTime(String paperDrawingTime) {
        this.paperDrawingTime = paperDrawingTime;
    }

    public String getScreenRemarks() {
        return screenRemarks;
    }

    public void setScreenRemarks(String screenRemarks) {
        this.screenRemarks = screenRemarks;
    }
}
