package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.CompanyReview;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 省公司评审
 * @author: 王强
 * @create: 2022-10-24 15:58
 **/
@MyBatisMapper
public interface CompanyReviewMapper extends BaseMapper<CompanyReview> {

    /**
     * 根据项目储备编号删除省公司评审信息
     * @param projectReserveId
     */
    void deleteByProjectReserveId(String projectReserveId);

    /**
     * 根据 项目储备编号删除对应的流程信息
     * @param proId
     */
    void deleteActivityByProId(String proId);

    /**
     * 获取所有的projectReserveId
     * @return
     */
    List<String> getAllProId();

    /**
     * 去汇总表中获取所有的projectReserveId
     * @return
     */
    List<String> getAllProId2();

    /**
     * 根据项目储备id查询项目信息
     * @param companyReview
     * @return
     */
    CompanyReview queryByProjectReserveId(CompanyReview companyReview);

    /**
     * 批量添加省公司评审信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<CompanyReview> list);

    /**
     * 导出数据查询
     * @param companyReview
     * @return
     */
    List<CompanyReview> exportFindList(CompanyReview companyReview);

    /**
     * 估计项目储备编号查数据
     * @param proId
     * @return
     */
    CompanyReview getByProId(String proId);
}
