package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.PreliminaryPrepartion;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 储备项目前期准备工作 mapper
 * @author: 王强
 * @create: 2023-03-27 16:30
 **/
@MyBatisMapper
public interface PreliminaryPrepartionMapper extends BaseMapper<PreliminaryPrepartion> {

    /**
     * 批量添加储备项目前期准备工作信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<PreliminaryPrepartion> list);

    /**
     * 根据项目储备编号删除储备项目前期准备工作信息
     * @param projectReserveId
     */
    void deleteByProjectReserveId(String projectReserveId);

    /**
     * 根据项目储备id查数据
     * @param proId
     * @return
     */
    PreliminaryPrepartion getByProId(String proId);

    /**
     * 导出数据查询
     * @param reserveManagement
     * @return
     */
    List<PreliminaryPrepartion> exportFindList(PreliminaryPrepartion reserveManagement);

    /**
     * 根据projectReserveId查出proc_ins_id
     * @param projectReserveId
     * @return
     */
    String getByProjectReserveId(String projectReserveId);

    /**
     * 根据executeId查出历史节点信息
     * @param executeId
     * @return
     */
    List<History> getHistoryByExecuteId(String executeId);

    /**
     * 根据executeId查出当前节点的名称
     * @param executeId
     * @return
     */
    String getByExecuteId(String executeId);

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId();

    /**
     * 从基本数据表中获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId2();

    /**
     * 根据项目储备id查询项目信息
     * @param reserveManagement
     * @return
     */
    PreliminaryPrepartion queryByProjectReserveId(PreliminaryPrepartion reserveManagement);
}
