package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ProjectScreen;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author: 王强
 * @create: 2023-06-28 09:33
 **/
@MyBatisMapper
public interface ProjectScreenMapper extends BaseMapper<ProjectScreen> {

    /**
     * 批量添加项目储备信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<ProjectScreen> list);

    /**
     * 根据项目储备id查询项目信息
     * @param reserveManagement
     * @return
     */
    ProjectScreen queryByProjectReserveId(ProjectScreen reserveManagement);

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId();

    /**
     * 从基本数据表中获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId2();

    /**
     * 根据项目储备编号查看是否有该数据
     * @param proId
     * @return
     */
    ProjectScreen getByProId(String proId);

    /**
     * 导出数据查询
     * @param verificate
     * @return
     */
    List<ProjectScreen> exportFindList(ProjectScreen verificate);

    /**
     * 根据projectReserveId查出proc_ins_id
     * @param projectReserveId
     * @return
     */
    String getByProjectReserveId(String projectReserveId);


    /**
     * 根据executeId查出历史节点信息
     * @param executeId
     * @return
     */
    List<History> getHistoryByExecuteId(String executeId);

    /**
     * 根据executeId查出当前节点的名称
     * @param executeId
     * @return
     */
    String getByExecuteId(String executeId);

}
