package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ProjectTypeVerificate;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.DemoliteList;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author: 王强
 * @create: 2023-06-26 14:00
 **/
@MyBatisMapper
public interface ProjectTypeVerificateMapper extends BaseMapper<ProjectTypeVerificate> {

    /**
     * 根据项目名称去在线开甲供材表中查询物料名称
     * @param projectName
     * @return
     */
    List<String> getMaterialName(String projectName);

    List<DemoliteList> getByProjectName();

    /**
     * 根据项目名称去在线开甲供材表中查询物料名称
     * @param projectName
     * @return
     */
    List<String> getMaterialName2(String projectName);

    /**
     * 导出数据查询
     * @param verificate
     * @return
     */
    List<ProjectTypeVerificate> exportFindList(ProjectTypeVerificate verificate);

    /**
     * 批量添加项目储备信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<ProjectTypeVerificate> list);

    /**
     * 根据项目储备id查询项目信息
     * @param reserveManagement
     * @return
     */
    ProjectTypeVerificate queryByProjectReserveId(ProjectTypeVerificate reserveManagement);

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId();

    /**
     * 从基本数据表中获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId2();

    /**
     * 根据项目储备编号查看是否有该数据
     * @param proId
     * @return
     */
    ProjectTypeVerificate getByProId(String proId);

    /**
     * 根据projectReserveId查出proc_ins_id
     * @param projectReserveId
     * @return
     */
    String getByProjectReserveId(String projectReserveId);

    /**
     * 根据executeId查出历史节点信息
     * @param executeId
     * @return
     */
    List<History> getHistoryByExecuteId(String executeId);

    /**
     * 根据executeId查出当前节点的名称
     * @param executeId
     * @return
     */
    String getByExecuteId(String executeId);
}
