package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ActRunTaskTest;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ReserveSummaryProcess;
import com.jeeplus.modules.sg.managementcenter.materialinfo.entity.MaterialInfo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author: 王强
 * @create: 2022-08-03 10:13
 **/
@MyBatisMapper
public interface ReserveSummaryProcessMapper extends BaseMapper<ReserveSummaryProcess> {

    /**
     * 根据结束时间查下一个节点信息
     * @param instId
     * @param time
     * @return
     */
    String selectNameByTime(@Param("instId") String instId,@Param("time") String time);

    /**
     * 根据查出来的endTime来查下一个节点
     * @param instId
     * @param name
     * @return
     */
    String selectTimeByName(@Param("instId") String instId,@Param("name") String name);

    /**
     * 根据   proc_def_id,和节点名称找到 taskKey
     * @param procId
     * @param name
     * @return
     */
    String selectTaskKey(@Param("procId") String procId,@Param("name") String name);

    /**
     * 根据项目储备id删除对应的流程信息
     * @param priId
     */
    void deleteActivityByProId(String priId);

    /**
     * 获取act_hi_comment表中的原因
     * @return
     */
    String getMessage();

    /**
     * 将  设计单位的数据  插入到  act_ru_task 表中
     * @param taskTest
     */
//    void insertIntoTask(ActRunTaskTest taskTest);

    /**
     * 根据   proc_def_id,和节点名称 删除 表 act_ru_task 的  项目经理审图 和 联合审图 相关数据
     * @param procId
     */
    void deleteByProcId(@Param("procId") String procId,@Param("name") String name);

    /**
     * 根据 proc_def_id 和 task_def_key_来删除表act_ru_execution的相关数据
     * @param procId
     * @param taskKey
     */
    void deleteExecution(@Param("procId") String procId,@Param("taskKey") String taskKey);

    /**
     * 根据 项目储备编号  查出设计单位节点信息
     * @param proId
     * @return
     */
    ActRunTaskTest getByProId(@Param("proId")String proId);

    /**
     * 根据 项目储备编号  查出设计单位节点信息
     * @param proId
     * @return
     */
    String getInfoByProId(@Param("proId")String proId);

    /**
     * 将ActRunTaskTest  设计单位的节点信息 做持久化操作
     * @param taskTest
     */
    void insertIntoActRunTask(ActRunTaskTest taskTest);

    /**
     * 估计 项目储备编号  删除信息
     * @param proId
     */
    void deleteIntoActRunTaskByProId(String proId);

    /**
     * 获取act_run_task的设计单位节点数据
     * @return
     */
    ActRunTaskTest getInfo();

    /**
     * 根据 项目名称 查看甲供材信息
     * @param projectName
     * @return
     */
    int getCountByName(String projectName);

    /**
     * 通过procInsId查询项目定义号
     * */
    String findProjectId(ReserveSummaryProcess reserveProcess);

    /**
     * 通过项目名称删除对应甲供材信息数据
     * */
    void deleteMaterial(String projectName);

    /**
     * 通过项目名称删除配网对应甲供材信息数据
     * */
    void deleteDistributionMaterial(String projectName);
    /**
     * 根据物料编码查出所有的 总数之和
     * @param materialCode
     * @return
     */
    Double getAllNum(String materialCode);

    /**
     * 插入对应的项目甲供材信息
     * */
    void insertList(@Param("list") List<MaterialInfo> list);

    /**
     * 插入配网对应的项目甲供材信息
     * */
    void insertDistributionList(@Param("list") List<MaterialInfo> list);

    /**
     * 通过储备项目编号查询项目是否有甲供材清册
     */
    Integer findMaterialData(String procInsId);

    /**
     * 修改项目设计单位信息
     * */
    void updateDesign(ReserveSummaryProcess reserveProcess);

    /**
     * 通过流程定义号删除流程对应信息
     * */
    void deleteAct(String projectReserveId);

    /**
     * 储备文件管理，
     */
    List<ReserveSummaryProcess> findAllUpload(ReserveSummaryProcess reserveProcess);

    /**
     * 储备文件管理，
     */
    List<ReserveSummaryProcess> findAllUpload2(ReserveSummaryProcess reserveProcess);

    /**
     * 储备流程当前流程所有的甲供材数据
     */
    List<MaterialInfo> findMaterialList(MaterialInfo entity);

    /**
     * 配网流程当前流程所有的甲供材数据
     */
    List<MaterialInfo> findMaterialList2(MaterialInfo entity);

    /**
     * 通过项目名称导出符合条件的数据
     * */
    List<MaterialInfo> findMaterialActiviti(String projectName);

    /**
     * 通过项目名称导出符合条件的数据
     * */
    List<MaterialInfo> findMaterialActiviti2(String projectName);

    /**
     * 根据用户名查出登录名
     * @param name
     * @return
     */
    String getLoginNameByName(String name);


}
