package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.service;

import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.DocumentInfo;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.mapper.DocumentInfoMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * 流程文件信息表 service
 * @author: 王强
 * @create: 2022-10-26 14:37
 **/
@Service
@Transactional(readOnly = true)
public class DocumentInfoService extends CrudService<DocumentInfoMapper, DocumentInfo> {

    @Autowired
    private DocumentInfoMapper dao;

    /**
     * 根据项目储备id 查询数据
     * @param proId
     * @return
     */
    public DocumentInfo getInfoByProId(String proId){
        return dao.getInfoByProId(proId);
    }

    /**
     * 根据  项目储备id 删除数据
     * @param proId
     */
//    @Transactional(readOnly = false)
//    public void deleteInfoByProId(String proId){
//        dao.deleteInfoByProId(proId);
//    }

    @Transactional(readOnly = false)
    public void save(DocumentInfo info){
        if (info.getIsNewRecord()){
            info.preInsert();
            dao.deleteInfoByProId(info.getProjectReserveId());
            dao.insert(info);
        }
    }

    @Transactional(readOnly = false)
    public void distributionFileSave(DocumentInfo info){
        if (info.getIsNewRecord()){
            info.preInsert();
            dao.deleteDistributionFileInfoByProId(info.getProjectReserveId());
            dao.insertDistributionFileInfo(info);
        }
    }
}
