package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.service;

import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.FeedBackBudget;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.mapper.FeedBackBudgetMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * 预算问题反馈记录 service
 * @author: 王强
 * @create: 2022-08-10 16:11
 **/
@Service
@Transactional(readOnly = true)
public class FeedBackBudgetService extends CrudService<FeedBackBudgetMapper, FeedBackBudget> {

    @Autowired
    private FeedBackBudgetMapper dao;

    /**
     * 根据项目储备id获取  问题反馈信息
     * @param proId
     * @return
     */
    public FeedBackBudget getInfoByProId(String proId){
        return dao.getInfoByProId(proId);
    }

    /**
     * 根据项目储备编号  修改预算问题反馈记录
     * @param backBudget
     */
    public void updateInFoByProId(FeedBackBudget backBudget){
        dao.updateInFoByProId(backBudget);
    }

    /**
     * 新增方法
     * @param entity
     */
    @Transactional(readOnly = false)
    public void save(FeedBackBudget entity) {
        entity.preInsert();
        mapper.insert(entity);
    }

    @Transactional(readOnly = false)
    public void deleteByProjectReserveId(String projectReserveId){
        dao.deleteByProjectReserveId(projectReserveId);
    }

    public FeedBackBudget findByProjectReserveId(String projectReserveId){
        return dao.findByProjectReserveId(projectReserveId);
    }
}
