package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils;

import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.*;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.xssf.usermodel.XSSFCellStyle;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLEncoder;
import java.util.List;

public class ReserveProcessProjectExportUtil {

    private  XSSFCellStyle style = null;

    public static ReserveProcessProjectExportUtil getOne(){

        return new ReserveProcessProjectExportUtil();
    }

    /**
     * 传入excel模板名称 获取workbook对象
     * @param fileName excel模板名称
     * @return
     */
    public  XSSFWorkbook getWorkbook(String fileName){
        InputStream inputStream = null;
        XSSFWorkbook workbook = null;
        try {
            File file = new File(this.getClass().getResource("/").getPath() + "/freemarker/excelmodel/"+fileName+".xlsx");
            inputStream = new FileInputStream(file);// 将excel文件转为输入流
            workbook = new XSSFWorkbook(inputStream);// 创建个workbook，
        } catch (Exception e) {
            e.printStackTrace();
        }
        return workbook;
    }

    /**
     * 导出储备项目带电作业基本信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportElectricityWork(HttpServletResponse response, XSSFWorkbook workbook, List<ReserveElectricityWork> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 2;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备项目经理
                Cell cell7 = crateCell(workbook,row,7); //储备批次
                Cell cell8 = crateCell(workbook,row,8); //供电区域
                Cell cell9 = crateCell(workbook,row,9); //网格编号
                Cell cell10 = crateCell(workbook,row,10); //单元格编号
                Cell cell11 = crateCell(workbook,row,11); //项目储备编号
                Cell cell12 = crateCell(workbook,row,12); //项目名称
                Cell cell13 = crateCell(workbook,row,13); //国网项目编码
                Cell cell14 = crateCell(workbook,row,14); //国网项目名称
                Cell cell15 = crateCell(workbook,row,15); //建设必要性及内容
                Cell cell16 = crateCell(workbook,row,16); //变电站名称
                Cell cell17 = crateCell(workbook,row,17); //线路名称
                Cell cell18 = crateCell(workbook,row,18); //网架项目划分
                Cell cell19 = crateCell(workbook,row,19); //需求类型
                Cell cell20 = crateCell(workbook,row,20); //项目类型
                Cell cell21 = crateCell(workbook,row,21); //费用估算
                Cell cell22 = crateCell(workbook,row,22); //储备进度
                Cell cell23 = crateCell(workbook,row,23); //是否纳入实施计划
                Cell cell24 = crateCell(workbook,row,24); //初定实施批次
                Cell cell25 = crateCell(workbook,row,25); //项目类型
                Cell cell26 = crateCell(workbook,row,26); //是否含带电作业
                Cell cell27 = crateCell(workbook,row,27); //用户分界开关数量
                Cell cell28 = crateCell(workbook,row,28); //带电作业类型编号/次数
                Cell cell29 = crateCell(workbook,row,29); //不停电作业方案
                Cell cell30 = crateCell(workbook,row,30); //节约停电时户数
                Cell cell31 = crateCell(workbook,row,31); //无法不停电作业原因
                Cell cell32 = crateCell(workbook,row,32); //停电作业方案
                Cell cell33 = crateCell(workbook,row,33); //方案编制人
                Cell cell34 = crateCell(workbook,row,34); //现场查勘人


                ReserveElectricityWork reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getProjectManager());
                cell7.setCellValue(reserveManagement.getReserveBatches());
                cell8.setCellValue(reserveManagement.getBlockSupply());
                cell9.setCellValue(reserveManagement.getGridNumber());
                cell10.setCellValue(reserveManagement.getCellNumber());
                cell11.setCellValue(reserveManagement.getProjectReserveId());
                cell12.setCellValue(reserveManagement.getProjectName());
                cell13.setCellValue(reserveManagement.getStateGridProjectCode());
                cell14.setCellValue(reserveManagement.getStateGridProjectName());
                cell15.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell16.setCellValue(reserveManagement.getSubstationName());
                cell17.setCellValue(reserveManagement.getCircuitName());
                cell18.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell19.setCellValue(reserveManagement.getRequirementType());
                cell20.setCellValue(reserveManagement.getProjectType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell21.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell22.setCellValue(reserveManagement.getReserveProgress());
                cell23.setCellValue(reserveManagement.getImplementPlan());
                cell24.setCellValue(reserveManagement.getImplementBatch());
                cell25.setCellValue(reserveManagement.getProjectType());
                cell26.setCellValue(reserveManagement.getHotLineWork());
                cell27.setCellValue(reserveManagement.getBoundarySwitchNum());
                cell28.setCellValue(reserveManagement.getHotLineWorkTypeNo());
                cell29.setCellValue(reserveManagement.getNoStopWorkPlan());
                cell30.setCellValue(reserveManagement.getPowerFailureNum());
                cell31.setCellValue(reserveManagement.getReasonsForNotWorkInterruption());
                cell32.setCellValue(reserveManagement.getPowerOutagePlan());
                cell33.setCellValue(reserveManagement.getPlanner());
                cell34.setCellValue(reserveManagement.getSiteSurveyor());


            }

            String str = URLEncoder.encode("储备项目带电作业统计表.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出储备项目基本信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportBasic(HttpServletResponse response, XSSFWorkbook workbook, List<ReserveProcessProject> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 3;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //国网项目编码
                Cell cell13 = crateCell(workbook,row,13); //国网项目名称
                Cell cell14 = crateCell(workbook,row,14); //建设必要性及内容
                Cell cell15 = crateCell(workbook,row,15); //变电站名称
                Cell cell16 = crateCell(workbook,row,16); //线路名称
                Cell cell17 = crateCell(workbook,row,17); //网架项目划分
                Cell cell18 = crateCell(workbook,row,18); //需求类型

                Cell cell19 = crateCell(workbook,row,19); //项目类型
                Cell cell20 = crateCell(workbook,row,20); //费用估算
                Cell cell21 = crateCell(workbook,row,21); //备注
                Cell cell22 = crateCell(workbook,row,22); //需求提报人
                Cell cell23 = crateCell(workbook,row,23); //业主储备专职
                Cell cell24 = crateCell(workbook,row,24); //业主配网专职
                Cell cell25 = crateCell(workbook,row,25); //业主储备项目经理
                Cell cell26 = crateCell(workbook,row,26); //业主物资专职

                Cell cell27 = crateCell(workbook,row,27); //业主技经人员
                Cell cell28 = crateCell(workbook,row,28); //运维人员
                Cell cell29 = crateCell(workbook,row,29); //设计人员
                Cell cell30 = crateCell(workbook,row,30); //概算编制人员
                Cell cell31 = crateCell(workbook,row,31); //不停电作业查勘人员

                ReserveProcessProject reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getReserveBatches());
                cell7.setCellValue(reserveManagement.getBlockSupply());
                cell8.setCellValue(reserveManagement.getGridNumber());
                cell9.setCellValue(reserveManagement.getCellNumber());
                cell10.setCellValue(reserveManagement.getProjectReserveId());
                cell11.setCellValue(reserveManagement.getProjectName());
                cell12.setCellValue(reserveManagement.getStateGridProjectCode());
                cell13.setCellValue(reserveManagement.getStateGridProjectName());
                cell14.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell15.setCellValue(reserveManagement.getSubstationName());
                cell16.setCellValue(reserveManagement.getCircuitName());

                cell17.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell18.setCellValue(reserveManagement.getRequirementType());

                cell19.setCellValue(reserveManagement.getProjectType());
                String costEstimateStr= reserveManagement.getCostEstimate() + "";
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell20.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell21.setCellValue(reserveManagement.getBasicRemarks());
                cell22.setCellValue(reserveManagement.getRequester());
                cell23.setCellValue(reserveManagement.getOwnerReserveFullTime());
                cell24.setCellValue(reserveManagement.getOwnerDistributionNerworkFullTime());
                cell25.setCellValue(reserveManagement.getOwnerReserveProjectManagre());
                cell26.setCellValue(reserveManagement.getMaterialSoleDuty());
                cell27.setCellValue(reserveManagement.getTechnicalStaff());
                cell28.setCellValue(reserveManagement.getOperationAndMaintenancePersonnel());
                cell29.setCellValue(reserveManagement.getDesigner());
                cell30.setCellValue(reserveManagement.getBudgetPreparer());
                cell31.setCellValue(reserveManagement.getUninterruptedWorkSurveyPersonnel());
            }

            String str = URLEncoder.encode("储备项目基本信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出储  作业查勘单
     * @param response
     * @param workbook
     * @param reserveManagement
     */
    public void exportSurveySheet(HttpServletResponse response, XSSFWorkbook workbook, ReserveElectricityWork reserveManagement){
        try {
            Sheet sheet = workbook.getSheetAt(0);

            String excelName = "";
            if (reserveManagement.getHotLineWork().equals("否")){
                Row nameRow = sheet.createRow(3);
                Row gcRow = sheet.createRow(5);
                Row btdyyRow = sheet.createRow(7);
                Row btdfaRow = sheet.createRow(11);
                Row ckrRow = sheet.createRow(19);

                Cell nameCell = crateCellNew(workbook,nameRow,0); //项目名称
                Cell gcCell = crateCellNew(workbook,gcRow,0); //工程内容
                Cell btdyyCell = crateCellNew(workbook,btdyyRow,0); //无法不停电作业原因
                Cell btdfaCell = crateCellNew(workbook,btdfaRow,0); //不停电作业方案
                Cell ckrCell = crateCellNew(workbook,ckrRow,0); //现场查勘人
                Cell bzrCell = crateCellNew(workbook,ckrRow,2); //方案编制人


                nameCell.setCellValue("项目名称");
                gcCell.setCellValue("工程内容");
                btdyyCell.setCellValue("无法不停电作业原因");
                btdfaCell.setCellValue("停电作业方案");
                ckrCell.setCellValue("现场查勘人");
                bzrCell.setCellValue("方案编制人");

                Cell nameCell2 = crateCellNew(workbook,nameRow,1); //项目名称
                Cell gcCell2 = crateCellNew(workbook,gcRow,1); //工程内容
                Cell btdyyCell2 = crateCellNew(workbook,btdyyRow,1); //无法不停电作业原因
                Cell btdfaCell2 = crateCellNew(workbook,btdfaRow,1); //停电作业方案
                Cell ckrCell2 = crateCellNew(workbook,ckrRow,1); //现场查勘人
                Cell bzrCell2 = crateCellNew(workbook,ckrRow,3); //方案编制人

                nameCell2.setCellValue(reserveManagement.getProjectName());
                gcCell2.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                btdyyCell2.setCellValue(reserveManagement.getReasonsForNotWorkInterruption());
                btdfaCell2.setCellValue(reserveManagement.getPowerOutagePlan());
                ckrCell2.setCellValue(reserveManagement.getSiteSurveyor());
                bzrCell2.setCellValue(reserveManagement.getPlanner());
                excelName = "镇江公司设计阶段停电作业查勘单.xlsx";

                // 指定要添加边框的行和列范围
                int startRow = 3; // 起始行
                int endRow = 12;   // 结束行
                int endColumn = 3;   // 结束列

                setCellStyle(workbook,startRow,endRow,sheet,endColumn);
            }else {
                Row nameRow = sheet.createRow(2);
                Row gcRow = sheet.createRow(4);
                Row faRow = sheet.createRow(6);
                Row hsRow = sheet.createRow(12);
                Row ckrRow = sheet.createRow(16);

                Cell nameCell = crateCellNew(workbook,nameRow,0); //项目名称
                Cell gcCell = crateCellNew(workbook,gcRow,0); //工程内容
                Cell faCell = crateCellNew(workbook,faRow,0); //不停电作业方案
                Cell hsCell = crateCellNew(workbook,hsRow,0); //预估节约停电时户数
                Cell ckrCell = crateCellNew(workbook,ckrRow,0); //现场查勘人
                Cell bzrCell = crateCellNew(workbook,ckrRow,2); //方案编制人
                nameCell.setCellValue("项目名称");
                gcCell.setCellValue("工程内容");
                faCell.setCellValue("不停电作业方案");
                hsCell.setCellValue("预估节约停电时户数");
                ckrCell.setCellValue("现场查勘人");
                bzrCell.setCellValue("方案编制人");


                Cell nameCell2 = crateCellNew(workbook,nameRow,1); //项目名称
                Cell gcCell2 = crateCellNew(workbook,gcRow,1); //工程内容
                Cell faCell2 = crateCellNew(workbook,faRow,1); //不停电作业方案
                Cell hsCell2 = crateCellNew(workbook,hsRow,1); //预估节约停电时户数
                Cell ckrCell2 = crateCellNew(workbook,ckrRow,1); //现场查勘人
                Cell bzrCell2 = crateCellNew(workbook,ckrRow,3); //方案编制人

                nameCell2.setCellValue(reserveManagement.getProjectName());
                gcCell2.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                faCell2.setCellValue(reserveManagement.getNoStopWorkPlan());
                hsCell2.setCellValue(reserveManagement.getPowerFailureNum());
                ckrCell2.setCellValue(reserveManagement.getSiteSurveyor());
                bzrCell2.setCellValue(reserveManagement.getPlanner());

                excelName = "镇江公司设计阶段不停电作业查勘单.xlsx";

                // 指定要添加边框的行和列范围
                int startRow = 2; // 起始行
                int endRow = 13;   // 结束行
                int endColumn = 3;   // 结束列

                setCellStyle(workbook,startRow,endRow,sheet,endColumn);
            }


            String str = URLEncoder.encode(excelName, "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出储备项目安全交底信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportSafety(HttpServletResponse response, XSSFWorkbook workbook, List<ReserveSafety> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 3;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //业主储备项目经理
                Cell cell7 = crateCell(workbook,row,7); //储备批次
                Cell cell8 = crateCell(workbook,row,8); //供电区域
                Cell cell9 = crateCell(workbook,row,9); //网格编号
                Cell cell10 = crateCell(workbook,row,10); //单元格编号
                Cell cell11 = crateCell(workbook,row,11); //项目储备编号
                Cell cell12 = crateCell(workbook,row,12); //项目名称
                Cell cell13 = crateCell(workbook,row,13); //国网项目编码
                Cell cell14 = crateCell(workbook,row,14); //国网项目名称
                Cell cell15 = crateCell(workbook,row,15); //建设必要性及内容
                Cell cell16 = crateCell(workbook,row,16); //变电站名称
                Cell cell17 = crateCell(workbook,row,17); //线路名称
                Cell cell18 = crateCell(workbook,row,18); //网架项目划分
                Cell cell19 = crateCell(workbook,row,19); //需求类型
                Cell cell20 = crateCell(workbook,row,20); //项目类型
                Cell cell21 = crateCell(workbook,row,21); //费用估算
                Cell cell22 = crateCell(workbook,row,22); //储备进度
                Cell cell23 = crateCell(workbook,row,23); //是否纳入实施计划
                Cell cell24 = crateCell(workbook,row,24); //初定实施批次
                Cell cell25 = crateCell(workbook,row,25); //是否临近（交叉）输电线路作业（含土建）
                Cell cell26 = crateCell(workbook,row,26); //是否临近（交叉）输电线路作业（含土建）-描述
                Cell cell27 = crateCell(workbook,row,27); //是否与输电线路同杆架设
                Cell cell28 = crateCell(workbook,row,28); //是否与输电线路同杆架设-描述
                Cell cell29 = crateCell(workbook,row,29); //是否与输电线路共沟
                Cell cell30 = crateCell(workbook,row,30); //是否与输电线路共沟-描述
                Cell cell31 = crateCell(workbook,row,31); //是否临近带电中压线路作业
                Cell cell32 = crateCell(workbook,row,32); //是否临近带电中压线路作业-描述
                Cell cell33 = crateCell(workbook,row,33); //是否有限空间作业
                Cell cell34 = crateCell(workbook,row,34); //是否有限空间作业-描述
                Cell cell35 = crateCell(workbook,row,35); //是否存在变电站出线电缆搭接-是
                Cell cell36 = crateCell(workbook,row,36); //是否存在变电站出线电缆搭接-是-描述
                Cell cell37 = crateCell(workbook,row,37); //是否存在跨越公路、铁路、航道作业
                Cell cell38 = crateCell(workbook,row,38); //是否存在跨越公路、铁路、航道作业-描述
                Cell cell39 = crateCell(workbook,row,39); //是否存在动火作业
                Cell cell40 = crateCell(workbook,row,40); //是否存在动火作业-描述
                Cell cell41 = crateCell(workbook,row,41); //是否需停电四条以上线路
                Cell cell42 = crateCell(workbook,row,42); //是否需停电四条以上线路-描述
                Cell cell43 = crateCell(workbook,row,43); //是否三条以上线路负荷改接
                Cell cell44 = crateCell(workbook,row,44); //是否三条以上线路负荷改接-描述
                Cell cell45 = crateCell(workbook,row,45); //是否多专业、多班组大型作业
                Cell cell46 = crateCell(workbook,row,46); //是否多专业、多班组大型作业-描述
                Cell cell47 = crateCell(workbook,row,47); //是否需编制三措
                Cell cell48 = crateCell(workbook,row,48); //是否需编制三措-描述
                Cell cell49 = crateCell(workbook,row,49); //作业风险等级预判


                ReserveSafety reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getProjectManager());
                cell7.setCellValue(reserveManagement.getReserveBatches());
                cell8.setCellValue(reserveManagement.getBlockSupply());
                cell9.setCellValue(reserveManagement.getGridNumber());
                cell10.setCellValue(reserveManagement.getCellNumber());
                cell11.setCellValue(reserveManagement.getProjectReserveId());
                cell12.setCellValue(reserveManagement.getProjectName());
                cell13.setCellValue(reserveManagement.getStateGridProjectCode());
                cell14.setCellValue(reserveManagement.getStateGridProjectName());
                cell15.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell16.setCellValue(reserveManagement.getSubstationName());
                cell17.setCellValue(reserveManagement.getCircuitName());
                cell18.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell19.setCellValue(reserveManagement.getRequirementType());
                cell20.setCellValue(reserveManagement.getProjectType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell21.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell22.setCellValue(reserveManagement.getReserveProgress());
                cell23.setCellValue(reserveManagement.getImplementPlan());
                cell24.setCellValue(reserveManagement.getImplementBatch());
                cell25.setCellValue(reserveManagement.getTransmissionWork());

                cell26.setCellValue(reserveManagement.getWorkDescribe());
                cell27.setCellValue(reserveManagement.getTransmissionErection());
                cell28.setCellValue(reserveManagement.getErecteDescribe());
                cell29.setCellValue(reserveManagement.getTransmissionCommonTrench());
                cell30.setCellValue(reserveManagement.getTrenchDescribe());
                cell31.setCellValue(reserveManagement.getMediumVoltageWork());
                cell32.setCellValue(reserveManagement.getVoltageWorkDescribe());
                cell33.setCellValue(reserveManagement.getConfineSpaceWork());
                cell34.setCellValue(reserveManagement.getSpaceDescribe());
                cell35.setCellValue(reserveManagement.getSubStationCableBonding());
                cell36.setCellValue(reserveManagement.getCableDescribe());
                cell37.setCellValue(reserveManagement.getRoadRailwaysAndWaterwaysWork());
                cell38.setCellValue(reserveManagement.getWaterDescribe());
                cell39.setCellValue(reserveManagement.getHotWork());
                cell40.setCellValue(reserveManagement.getHotWorkDescribe());
                cell41.setCellValue(reserveManagement.getBlackoutLineFour());
                cell42.setCellValue(reserveManagement.getLineFourDescribe());
                cell43.setCellValue(reserveManagement.getLineLoadRedirectionThree());
                cell44.setCellValue(reserveManagement.getThreeRedirectDescribe());
                cell45.setCellValue(reserveManagement.getLargeScaleMultiTeamWork());
                cell46.setCellValue(reserveManagement.getTeamWorkDescribe());
                cell47.setCellValue(reserveManagement.getPrepareThreeMeasures());
                cell48.setCellValue(reserveManagement.getMeasureDescribe());
                cell49.setCellValue(reserveManagement.getJobRiskLevelPrediction());

            }

            String str = URLEncoder.encode("储备项目安全交底信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    /**
     * 导出储备项目预土建制化信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportPrecons(HttpServletResponse response, XSSFWorkbook workbook, List<ReservePreconstruction> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 3;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //建设必要性及内容
                Cell cell13 = crateCell(workbook,row,13); //变电站名称
                Cell cell14 = crateCell(workbook,row,14); //线路名称
                Cell cell15 = crateCell(workbook,row,15); //网架项目划分
                Cell cell16 = crateCell(workbook,row,16); //需求类型
                Cell cell17 = crateCell(workbook,row,17); //费用估算
                Cell cell18 = crateCell(workbook,row,18); //备注
                Cell cell19 = crateCell(workbook,row,19); //储备进度
                Cell cell20 = crateCell(workbook,row,20); //是否纳入实施计划
                Cell cell21 = crateCell(workbook,row,21); //初定实施批次
                Cell cell22 = crateCell(workbook,row,22); //交底预制化信息-是否含新建土建基础/包封
                Cell cell23 = crateCell(workbook,row,23); //交底预制化信息-是否预制化
                Cell cell24 = crateCell(workbook,row,24); //交底预制化信息-预制化描述
                Cell cell25 = crateCell(workbook,row,25); //设计预制化信息-是否含新建土建基础/包封
                Cell cell26 = crateCell(workbook,row,26); //设计预制化信息-是否预制化
                Cell cell27 = crateCell(workbook,row,27); //设计预制化信息-预制化描述


                ReservePreconstruction reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getReserveBatches());
                cell7.setCellValue(reserveManagement.getBlockSupply());
                cell8.setCellValue(reserveManagement.getGridNumber());
                cell9.setCellValue(reserveManagement.getCellNumber());
                cell10.setCellValue(reserveManagement.getProjectReserveId());
                cell11.setCellValue(reserveManagement.getProjectName());
                cell12.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell13.setCellValue(reserveManagement.getSubstationName());
                cell14.setCellValue(reserveManagement.getCircuitName());
                cell15.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell16.setCellValue(reserveManagement.getRequirementType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell17.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell18.setCellValue(reserveManagement.getBasicRemarks());
                cell19.setCellValue(reserveManagement.getReserveProgress());
                cell20.setCellValue(reserveManagement.getImplementPlan());
                cell21.setCellValue(reserveManagement.getImplementBatch());
                cell22.setCellValue(reserveManagement.getConfessCivilFoundation());
                cell23.setCellValue(reserveManagement.getConfessPrefab());
                cell24.setCellValue(reserveManagement.getConfessPrefabDescription());
                cell25.setCellValue(reserveManagement.getDesignCivilFoundation());
                cell26.setCellValue(reserveManagement.getCastInPlaceList());
                cell27.setCellValue(reserveManagement.getDesignList());

            }

            String str = URLEncoder.encode("储备项目土建预置化信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出储备项目政策处理信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportPolicy(HttpServletResponse response, XSSFWorkbook workbook, List<ReservePolicyHand> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 3;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //建设必要性及内容
                Cell cell13 = crateCell(workbook,row,13); //变电站名称
                Cell cell14 = crateCell(workbook,row,14); //线路名称
                Cell cell15 = crateCell(workbook,row,15); //网架项目划分
                Cell cell16 = crateCell(workbook,row,16); //需求类型
                Cell cell17 = crateCell(workbook,row,17); //费用估算
                Cell cell18 = crateCell(workbook,row,18); //备注
                Cell cell19 = crateCell(workbook,row,19); //储备进度
                Cell cell20 = crateCell(workbook,row,20); //是否纳入实施计划
                Cell cell21 = crateCell(workbook,row,21); //拟实施批次
                Cell cell22 = crateCell(workbook,row,22); //供电所辖区
                Cell cell23 = crateCell(workbook,row,23); //施工地点
                Cell cell24 = crateCell(workbook,row,24); //是否含土建工作量
                Cell cell25 = crateCell(workbook,row,25); //是否含立杆工作量
                Cell cell26 = crateCell(workbook,row,26); //项目经理
                Cell cell27 = crateCell(workbook,row,27); //拟定施工单位
                Cell cell28 = crateCell(workbook,row,28); //是否移交政处单位图纸
                Cell cell29 = crateCell(workbook,row,29); //是否存在政处
                Cell cell30 = crateCell(workbook,row,30); //政处描述
                Cell cell31 = crateCell(workbook,row,31); //政处难度
                Cell cell32 = crateCell(workbook,row,32); //政处对象数量
                Cell cell33 = crateCell(workbook,row,33); //政处对象描述（产权单位）
                Cell cell34 = crateCell(workbook,row,34); //政处类型
                Cell cell35 = crateCell(workbook,row,35); //启动政处时间
                Cell cell36 = crateCell(workbook,row,36); //是否需规划报批
                Cell cell37 = crateCell(workbook,row,37); //规划报批完成情况
                Cell cell38 = crateCell(workbook,row,38); //是否需办理安评航评手续
                Cell cell39 = crateCell(workbook,row,39); //安评完成情况
                Cell cell40 = crateCell(workbook,row,40); //政处对象金额
                Cell cell41 = crateCell(workbook,row,41); //是否完成付款
                Cell cell42 = crateCell(workbook,row,42); //政处进度
                Cell cell43 = crateCell(workbook,row,43); //是否允许土建进场
                Cell cell44 = crateCell(workbook,row,43); //是否允许电气进场
                Cell cell45 = crateCell(workbook,row,44); //是否允许开土建领料单
                Cell cell46 = crateCell(workbook,row,45); //是否允许开电气领料单
                Cell cell47 = crateCell(workbook,row,46); //政处进度-备注


                ReservePolicyHand reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getReserveBatches());
                cell7.setCellValue(reserveManagement.getBlockSupply());
                cell8.setCellValue(reserveManagement.getGridNumber());
                cell9.setCellValue(reserveManagement.getCellNumber());
                cell10.setCellValue(reserveManagement.getProjectReserveId());
                cell11.setCellValue(reserveManagement.getProjectName());
                cell12.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell13.setCellValue(reserveManagement.getSubstationName());
                cell14.setCellValue(reserveManagement.getCircuitName());
                cell15.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell16.setCellValue(reserveManagement.getRequirementType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell17.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell18.setCellValue(reserveManagement.getBasicRemarks());
                cell19.setCellValue(reserveManagement.getReserveProgress());
                cell20.setCellValue(reserveManagement.getImplementPlan());
                cell21.setCellValue(reserveManagement.getIntendBatch());
                cell22.setCellValue(reserveManagement.getPowerSupplyArea());
                cell23.setCellValue(reserveManagement.getConstructionSpot());
                cell24.setCellValue(reserveManagement.getIncludeCivilWork());
                cell25.setCellValue(reserveManagement.getPoleWorkload());
                cell26.setCellValue(reserveManagement.getProjectManager());
                cell27.setCellValue(reserveManagement.getProposedConstructionUnit());
                cell28.setCellValue(reserveManagement.getOverToGovernment());
                cell29.setCellValue(reserveManagement.getGovernmentOffice());
                cell30.setCellValue(reserveManagement.getOfficeDescription());
                cell31.setCellValue(reserveManagement.getAdministrativeDifficulty());
                cell32.setCellValue(reserveManagement.getAdministrativeObjectNumber());
                cell33.setCellValue(reserveManagement.getPropertyUnitOfficeDescription());
                cell34.setCellValue(reserveManagement.getOfficeType());
                cell35.setCellValue(reserveManagement.getStartOfficeTime());
                cell36.setCellValue(reserveManagement.getPlanApprovalRequire());
                cell37.setCellValue(reserveManagement.getPlanApprovalCompletion());
                cell38.setCellValue(reserveManagement.getSafetyReview());
                cell39.setCellValue(reserveManagement.getSafetyReviewCompletion());
                cell40.setCellValue(reserveManagement.getOfficeAmount());
                cell41.setCellValue(reserveManagement.getPaymentCompleted());
                cell42.setCellValue(reserveManagement.getOfficeProgress());
                cell43.setCellValue(reserveManagement.getCivilEngineeringApproach());
                cell44.setCellValue(reserveManagement.getElectricApproach());
                cell45.setCellValue(reserveManagement.getCivilConstructionMaterialOpen());
                cell46.setCellValue(reserveManagement.getElectricalPickListOpen());
                cell47.setCellValue(reserveManagement.getAdministrativeOfficeRemark());


            }

            String str = URLEncoder.encode("储备项目政策处理信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出储备项目交底信息汇总统计
     * @param response
     * @param workbook
     * @param list
     */
    public void exportSummary(HttpServletResponse response, XSSFWorkbook workbook, List<ReserveSummary> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 2;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //项目储备经理
                Cell cell7 = crateCell(workbook,row,7); //储备批次
                Cell cell8 = crateCell(workbook,row,8); //供电区域
                Cell cell9 = crateCell(workbook,row,9); //网格编号
                Cell cell10 = crateCell(workbook,row,10); //单元格编号
                Cell cell11 = crateCell(workbook,row,11); //项目储备编号
                Cell cell12 = crateCell(workbook,row,12); //项目名称
                Cell cell13 = crateCell(workbook,row,13); //国网项目编码
                Cell cell14 = crateCell(workbook,row,14); //国网项目名称
                Cell cell15 = crateCell(workbook,row,15); //建设必要性及内容
                Cell cell16 = crateCell(workbook,row,16); //变电站名称
                Cell cell17 = crateCell(workbook,row,17); //线路名称
                Cell cell18 = crateCell(workbook,row,18); //网架项目划分
                Cell cell19 = crateCell(workbook,row,19); //需求类型
                Cell cell20 = crateCell(workbook,row,20); //项目类型
                Cell cell21 = crateCell(workbook,row,21); //费用估算

                Cell cell22 = crateCell(workbook,row,22); //储备进度
                Cell cell23 = crateCell(workbook,row,23); //是否纳入储备
                Cell cell24 = crateCell(workbook,row,24); //取消原因说明
                Cell cell25 = crateCell(workbook,row,25); //是否启动设计

                Cell cell26 = crateCell(workbook,row,26); //是否完成交底
                Cell cell27 = crateCell(workbook,row,27); //交底完成时间
                Cell cell28 = crateCell(workbook,row,28); //项目综合可实施性
                Cell cell29 = crateCell(workbook,row,29); //政处难度
                Cell cell30 = crateCell(workbook,row,30); //政处描述
                Cell cell31 = crateCell(workbook,row,31); //停电难度
                Cell cell32 = crateCell(workbook,row,32); //停电描述
                Cell cell33 = crateCell(workbook,row,33); //其他问题难度
                Cell cell34 = crateCell(workbook,row,34); //其他问题描述
                Cell cell35 = crateCell(workbook,row,35); //是否需重跑方案
                Cell cell36 = crateCell(workbook,row,36); //方案变更说明
                Cell cell37 = crateCell(workbook,row,37); //储备项目交底信息-备注

                ReserveSummary reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getProjectManager());
                cell7.setCellValue(reserveManagement.getReserveBatches());
                cell8.setCellValue(reserveManagement.getBlockSupply());
                cell9.setCellValue(reserveManagement.getGridNumber());
                cell10.setCellValue(reserveManagement.getCellNumber());
                cell11.setCellValue(reserveManagement.getProjectReserveId());
                cell12.setCellValue(reserveManagement.getProjectName());
                cell13.setCellValue(reserveManagement.getStateGridProjectCode());
                cell14.setCellValue(reserveManagement.getStateGridProjectName());
                cell15.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell16.setCellValue(reserveManagement.getSubstationName());
                cell17.setCellValue(reserveManagement.getCircuitName());
                cell18.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell19.setCellValue(reserveManagement.getRequirementType());
                cell20.setCellValue(reserveManagement.getProjectType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell21.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell22.setCellValue(reserveManagement.getReserveProgress());
                cell23.setCellValue(reserveManagement.getIncludeReserve());
                cell24.setCellValue(reserveManagement.getReasonForCancel());
                cell25.setCellValue(reserveManagement.getStartDesignOrNot());
                cell26.setCellValue(reserveManagement.getCompleteDisclose());
                cell27.setCellValue(reserveManagement.getCompleteDiscloseTime());
                cell28.setCellValue(reserveManagement.getComprehensiveProject());
                cell29.setCellValue(reserveManagement.getOfficeDifficulty());
                cell30.setCellValue(reserveManagement.getOfficeProgress());
                cell31.setCellValue(reserveManagement.getPowerFailureDifficulty());
                cell32.setCellValue(reserveManagement.getPowerFailureDescribe());
                cell33.setCellValue(reserveManagement.getOtherProblemDifficulty());
                cell34.setCellValue(reserveManagement.getOtherProblemDescribe());
                cell35.setCellValue(reserveManagement.getRunPlanRequire());
                cell36.setCellValue(reserveManagement.getProgramChangeDescription());
                cell37.setCellValue(reserveManagement.getDiscloseRemarks());
            }

            String str = URLEncoder.encode("储备项目交底信息统计表.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出省公司评审信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportCompany(HttpServletResponse response, XSSFWorkbook workbook, List<CompanyReview> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 3;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //项目经理
                Cell cell7 = crateCell(workbook,row,7); //储备批次
                Cell cell8 = crateCell(workbook,row,8); //供电区域
                Cell cell9 = crateCell(workbook,row,9); //网格编号
                Cell cell10 = crateCell(workbook,row,10); //单元格编号
                Cell cell11 = crateCell(workbook,row,11); //项目储备编号
                Cell cell12 = crateCell(workbook,row,12); //项目名称
                Cell cell13 = crateCell(workbook,row,13); //建设必要性及内容
                Cell cell14 = crateCell(workbook,row,14); //变电站名称
                Cell cell15 = crateCell(workbook,row,15); //线路名称
                Cell cell16 = crateCell(workbook,row,16); //网架项目划分
                Cell cell17 = crateCell(workbook,row,17); //需求类型
                Cell cell18 = crateCell(workbook,row,18); //项目类型
                Cell cell19 = crateCell(workbook,row,19); //费用估算
                Cell cell20 = crateCell(workbook,row,20); //是否参加省公司评审
                Cell cell21 = crateCell(workbook,row,21); //省公司评审批次/日期
                Cell cell22 = crateCell(workbook,row,22); //是否通过省公司评审
                Cell cell23 = crateCell(workbook,row,23); //评审意见
                Cell cell24 = crateCell(workbook,row,24); //是否需设计变更
                Cell cell25 = crateCell(workbook,row,25); //备注


                CompanyReview companyReview = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(companyReview.getProjectYear());
                cell2.setCellValue(companyReview.getProjectNature());
                cell3.setCellValue(companyReview.getDemandUnit());
                cell4.setCellValue(companyReview.getDistrict());
                cell5.setCellValue(companyReview.getProjectGroup());
                cell6.setCellValue(companyReview.getProjectManager());
                cell7.setCellValue(companyReview.getReserveBatches());
                cell8.setCellValue(companyReview.getBlockSupply());
                cell9.setCellValue(companyReview.getGridNumber());
                cell10.setCellValue(companyReview.getCellNumber());
                cell11.setCellValue(companyReview.getProjectReserveId());
                cell12.setCellValue(companyReview.getProjectName());
                cell13.setCellValue(companyReview.getConstructionNecessityAndContent());
                cell14.setCellValue(companyReview.getSubstationName());
                cell15.setCellValue(companyReview.getCircuitName());
                cell16.setCellValue(companyReview.getNetRackProjectDivide());
                cell17.setCellValue(companyReview.getRequirementType());
                cell18.setCellValue(companyReview.getProjectType());

                String costEstimateStr= companyReview.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell19.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell20.setCellValue(companyReview.getJoinProvincialCompanyReview());
                cell21.setCellValue(companyReview.getBatchOfProvincialCompany());
                cell22.setCellValue(companyReview.getPassProvincialCompanyReview());
                cell23.setCellValue(companyReview.getReviewComments());
                cell24.setCellValue(companyReview.getDesignChangeRequired());
                cell25.setCellValue(companyReview.getCompanyRemarks());
            }

            String str = URLEncoder.encode("省公司评审.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出项目类型校核表信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportVerificate(HttpServletResponse response, XSSFWorkbook workbook, List<ProjectTypeVerificate> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 3;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目储备经理
                Cell cell2 = crateCell(workbook,row,2); //项目年份
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //储备批次
                Cell cell7 = crateCell(workbook,row,7); //供电区域
                Cell cell8 = crateCell(workbook,row,8); //网格编号
                Cell cell9 = crateCell(workbook,row,9); //单元格编号
                Cell cell10 = crateCell(workbook,row,10); //项目储备编号
                Cell cell11 = crateCell(workbook,row,11); //项目名称
                Cell cell12 = crateCell(workbook,row,12); //国网项目编码
                Cell cell13 = crateCell(workbook,row,13); //国网项目名称
                Cell cell14 = crateCell(workbook,row,14); //建设必要性及内容
                Cell cell15 = crateCell(workbook,row,15); //变电站名称
                Cell cell16 = crateCell(workbook,row,16); //线路名称
                Cell cell17 = crateCell(workbook,row,17); //网架项目划分
                Cell cell18 = crateCell(workbook,row,18); //需求类型
                Cell cell19 = crateCell(workbook,row,19); //费用估算
                Cell cell20 = crateCell(workbook,row,20); //备注

                Cell cell21 = crateCell(workbook,row,21); //储备进度
                Cell cell22 = crateCell(workbook,row,22); //是否纳入实施计划
                Cell cell23 = crateCell(workbook,row,23); //初定实施批次
                Cell cell24 = crateCell(workbook,row,24); //项目性质（初定）
                Cell cell25 = crateCell(workbook,row,25); //是否含变电站新出线
                Cell cell26 = crateCell(workbook,row,26); //是否含资本设备
                Cell cell27 = crateCell(workbook,row,27); //项目属性（系统判断）
                Cell cell28 = crateCell(workbook,row,28); //项目性质（人工判断）
                Cell cell29 = crateCell(workbook,row,29); //项目类型（初定）
                Cell cell30 = crateCell(workbook,row,30); //是否含土建
                Cell cell31 = crateCell(workbook,row,31); //是否含电缆
                Cell cell32 = crateCell(workbook,row,32); //是否含立杆工作量
                Cell cell33 = crateCell(workbook,row,33); //是否含架空线
                Cell cell34 = crateCell(workbook,row,34); //是否含环网柜
                Cell cell35 = crateCell(workbook,row,35); //是否含拆旧环网柜
                Cell cell36 = crateCell(workbook,row,36); //是否含箱变
                Cell cell37 = crateCell(workbook,row,37); //是否含拆旧箱变
                Cell cell38 = crateCell(workbook,row,38); //是否含配变
                Cell cell39 = crateCell(workbook,row,39); //是否含拆旧配变
                Cell cell40 = crateCell(workbook,row,40); //项目类型（人工判断）


                ProjectTypeVerificate companyReview = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(companyReview.getProjectManager());
                cell2.setCellValue(companyReview.getProjectYear());

                cell3.setCellValue(companyReview.getDemandUnit());
                cell4.setCellValue(companyReview.getDistrict());
                cell5.setCellValue(companyReview.getProjectGroup());
                cell6.setCellValue(companyReview.getReserveBatches());
                cell7.setCellValue(companyReview.getBlockSupply());
                cell8.setCellValue(companyReview.getGridNumber());
                cell9.setCellValue(companyReview.getCellNumber());
                cell10.setCellValue(companyReview.getProjectReserveId());
                cell11.setCellValue(companyReview.getProjectName());

                cell12.setCellValue(companyReview.getStateGridProjectCode());
                cell13.setCellValue(companyReview.getStateGridProjectName());
                cell14.setCellValue(companyReview.getConstructionNecessityAndContent());

                cell15.setCellValue(companyReview.getSubstationName());
                cell16.setCellValue(companyReview.getCircuitName());
                cell17.setCellValue(companyReview.getNetRackProjectDivide());
                cell18.setCellValue(companyReview.getRequirementType());

                String costEstimateStr= companyReview.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell19.setCellValue(Double.parseDouble(costEstimateStr));
                }

                cell20.setCellValue(companyReview.getBasicRemarks());
                cell21.setCellValue(companyReview.getReserveProgress());
                cell22.setCellValue(companyReview.getImplementPlan());
                cell23.setCellValue(companyReview.getImplementBatch());
                cell24.setCellValue(companyReview.getProjectNature());
                cell25.setCellValue(companyReview.getNewSubstation());
                cell26.setCellValue(companyReview.getIncludeCapitalEquipment());
                cell27.setCellValue(companyReview.getProjectProperties());
                cell28.setCellValue(companyReview.getProjectNatureArtificial());


                cell29.setCellValue(companyReview.getProjectType());
                cell30.setCellValue(companyReview.getCivilEngineer());
                cell31.setCellValue(companyReview.getIncludeCables());
                cell32.setCellValue(companyReview.getPoleWorkload());
                cell33.setCellValue(companyReview.getOldPoleWorkload());
                cell34.setCellValue(companyReview.getRingNetworkCabinet());
                cell35.setCellValue(companyReview.getOldRingNetworkCabinet());
                cell36.setCellValue(companyReview.getBoxTransformer());
                cell37.setCellValue(companyReview.getOldBoxTransformer());
                cell38.setCellValue(companyReview.getDistributionTransformer());
                cell39.setCellValue(companyReview.getOldDistributionTransformer());
                cell40.setCellValue(companyReview.getIncludeCablesArtificial());

            }

            String str = URLEncoder.encode("储备项目项目类型校核表.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出项目类型校核表信息
     * @param response
     * @param workbook
     * @param list
     */
    public void exportProjectScreen(HttpServletResponse response, XSSFWorkbook workbook, List<ProjectScreen> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 2;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目储备经理
                Cell cell2 = crateCell(workbook,row,2); //项目年份
                Cell cell3 = crateCell(workbook,row,3); //项目性质
                Cell cell4 = crateCell(workbook,row,4); //需求单位
                Cell cell5 = crateCell(workbook,row,5); //区域
                Cell cell6 = crateCell(workbook,row,6); //项目分组
                Cell cell7 = crateCell(workbook,row,7); //储备批次
                Cell cell8 = crateCell(workbook,row,8); //供电区域
                Cell cell9 = crateCell(workbook,row,9); //网格编号
                Cell cell10 = crateCell(workbook,row,10); //单元格编号
                Cell cell11 = crateCell(workbook,row,11); //项目储备编号
                Cell cell12 = crateCell(workbook,row,12); //项目名称
                Cell cell13 = crateCell(workbook,row,13); //国网项目编码
                Cell cell14 = crateCell(workbook,row,14); //国网项目名称
                Cell cell15 = crateCell(workbook,row,15); //建设必要性及内容
                Cell cell16 = crateCell(workbook,row,16); //变电站名称
                Cell cell17 = crateCell(workbook,row,17); //线路名称
                Cell cell18 = crateCell(workbook,row,18); //网架项目划分
                Cell cell19 = crateCell(workbook,row,19); //需求类型
                Cell cell20 = crateCell(workbook,row,20); //项目类型
                Cell cell21 = crateCell(workbook,row,21); //费用估算
                Cell cell22 = crateCell(workbook,row,22); //备注

                Cell cell23 = crateCell(workbook,row,23); //储备进度
                Cell cell24 = crateCell(workbook,row,24); //是否纳入储备
                Cell cell25 = crateCell(workbook,row,25); //初定实施批次
                Cell cell26 = crateCell(workbook,row,26); //是否含土建工作量
                Cell cell27 = crateCell(workbook,row,27); //土建工作量统计
                Cell cell28 = crateCell(workbook,row,28); //是否含立杆工作量
                Cell cell29 = crateCell(workbook,row,29); //立杆工作量统计
                Cell cell30 = crateCell(workbook,row,30); //预算含税
                Cell cell31 = crateCell(workbook,row,31); //预算不含税
                Cell cell32 = crateCell(workbook,row,32); //施工费（不含税）
                Cell cell33 = crateCell(workbook,row,33); //储备项目工程量统计-备注
                Cell cell34 = crateCell(workbook,row,34); //项目综合可实施性
                Cell cell35 = crateCell(workbook,row,35); //政处难度
                Cell cell36 = crateCell(workbook,row,36); //政处描述
                Cell cell37 = crateCell(workbook,row,37); //停电难度
                Cell cell38 = crateCell(workbook,row,38); //停电描述
                Cell cell39 = crateCell(workbook,row,39); //其他问题难度
                Cell cell40 = crateCell(workbook,row,40); //其他问题描述
                Cell cell41 = crateCell(workbook,row,41); //是否需重跑方案
                Cell cell42 = crateCell(workbook,row,42); //方案变更说明
                Cell cell43 = crateCell(workbook,row,43); //储备项目交底信息-备注
                Cell cell44 = crateCell(workbook,row,44); //储备项目推进任务
                Cell cell45 = crateCell(workbook,row,45); //完成进度
                Cell cell46 = crateCell(workbook,row,46); //是否启动政处
                Cell cell47 = crateCell(workbook,row,47); //政处进度
                Cell cell48 = crateCell(workbook,row,48); //储备项目前期准备工作-备注。
                Cell cell49 = crateCell(workbook,row,49); //需求单位优先级
                Cell cell50 = crateCell(workbook,row,50); //是否纳入实施计划
                Cell cell51 = crateCell(workbook,row,51); //立项筛选-初定实施批次
                Cell cell52 = crateCell(workbook,row,52); //初定施工单位
                Cell cell53 = crateCell(workbook,row,53); //实际立项批次
                Cell cell54 = crateCell(workbook,row,54); //实际施工单位
                Cell cell55 = crateCell(workbook,row,55); //是否需出规划报批图
                Cell cell56 = crateCell(workbook,row,56); //要求移交规划报批图时间
                Cell cell57 = crateCell(workbook,row,57); //是否需出纸质图
                Cell cell58 = crateCell(workbook,row,58); //要求移交纸质图纸时间
                Cell cell59 = crateCell(workbook,row,59); //立项筛选-备注


                ProjectScreen companyReview = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(companyReview.getProjectManager());
                cell2.setCellValue(companyReview.getProjectYear());
                cell3.setCellValue(companyReview.getProjectNature());
                cell4.setCellValue(companyReview.getDemandUnit());
                cell5.setCellValue(companyReview.getDistrict());
                cell6.setCellValue(companyReview.getProjectGroup());
                cell7.setCellValue(companyReview.getReserveBatches());
                cell8.setCellValue(companyReview.getBlockSupply());
                cell9.setCellValue(companyReview.getGridNumber());
                cell10.setCellValue(companyReview.getCellNumber());
                cell11.setCellValue(companyReview.getProjectReserveId());
                cell12.setCellValue(companyReview.getProjectName());
                cell13.setCellValue(companyReview.getStateGridProjectCode());
                cell14.setCellValue(companyReview.getStateGridProjectName());
                cell15.setCellValue(companyReview.getConstructionNecessityAndContent());
                cell16.setCellValue(companyReview.getSubstationName());
                cell17.setCellValue(companyReview.getCircuitName());
                cell18.setCellValue(companyReview.getNetRackProjectDivide());
                cell19.setCellValue(companyReview.getRequirementType());
                cell20.setCellValue(companyReview.getProjectType());
                String costEstimateStr= companyReview.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell21.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell22.setCellValue(companyReview.getBasicRemarks());
                cell23.setCellValue(companyReview.getReserveProgress());
                cell24.setCellValue(companyReview.getImplementReserve());
                cell25.setCellValue(companyReview.getImplementBatch());
                cell26.setCellValue(companyReview.getCivilWorkload());
                cell27.setCellValue(companyReview.getCivilWorkloadStatistics());
                cell28.setCellValue(companyReview.getUprightPoleWorkload());
                cell29.setCellValue(companyReview.getUprightPoleWorkloadStatistics());
                cell30.setCellValue(companyReview.getBudgetIncludesTax());
                cell31.setCellValue(companyReview.getBudgetNotIncludesTax());
                cell32.setCellValue(companyReview.getConstructCostExcludeTax());
                cell33.setCellValue(companyReview.getProjectQuantityRemarks());
                cell34.setCellValue(companyReview.getComprehensiveProject());
                cell35.setCellValue(companyReview.getOfficeDifficulty());
                cell36.setCellValue(companyReview.getOfficeProgress());
                cell37.setCellValue(companyReview.getPowerFailureDifficulty());
                cell38.setCellValue(companyReview.getPowerFailureDescribe());
                cell39.setCellValue(companyReview.getOtherProblemDifficulty());
                cell40.setCellValue(companyReview.getOtherProblemDescribe());
                cell41.setCellValue(companyReview.getRunPlanRequire());
                cell42.setCellValue(companyReview.getProgramChangeDescription());
                cell43.setCellValue(companyReview.getDiscloseRemarks());
                cell44.setCellValue(companyReview.getProjectPromotion());
                cell45.setCellValue(companyReview.getCompleteProgress());
                cell46.setCellValue(companyReview.getFireAdministrativeDepartment());
                cell47.setCellValue(companyReview.getAdministrativeProgress());
                cell48.setCellValue(companyReview.getPreliminaryWorkPreparationRemarks());
                cell49.setCellValue(companyReview.getRequirementUnitPriority());
                cell50.setCellValue(companyReview.getImplementPlan());
                cell51.setCellValue(companyReview.getImplementBatchScreen());
                cell52.setCellValue(companyReview.getConstructionUnit());
                cell53.setCellValue(companyReview.getProjectApprovalBatch());
                cell54.setCellValue(companyReview.getRealityConstructionUnit());
                cell55.setCellValue(companyReview.getApprovalDiagram());
                cell56.setCellValue(companyReview.getApprovalDiagramTime());
                cell57.setCellValue(companyReview.getPaperDrawing());
                cell58.setCellValue(companyReview.getPaperDrawingTime());
                cell59.setCellValue(companyReview.getScreenRemarks());

            }

            String str = URLEncoder.encode("储备项目立项筛选统计表.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 导出前期工作准备
     * @param response
     * @param workbook
     * @param list
     */
    public void exportProcess(HttpServletResponse response, XSSFWorkbook workbook, List<PreliminaryPrepartion> list){
        try {
            int index = 1;//第一列序号
            int rowNum = 2;//数据起始列
            Sheet sheet = workbook.getSheetAt(0);
            for(int i=0;i<list.size();i++){
                Row row = sheet.createRow(rowNum+i);
                Cell cell0 = crateCell(workbook,row,0); //序号
                Cell cell1 = crateCell(workbook,row,1); //项目年份
                Cell cell2 = crateCell(workbook,row,2); //项目性质
                Cell cell3 = crateCell(workbook,row,3); //需求单位
                Cell cell4 = crateCell(workbook,row,4); //区域
                Cell cell5 = crateCell(workbook,row,5); //项目分组
                Cell cell6 = crateCell(workbook,row,6); //项目经理
                Cell cell7 = crateCell(workbook,row,7); //储备批次
                Cell cell8 = crateCell(workbook,row,8); //供电区域
                Cell cell9 = crateCell(workbook,row,9); //网格编号
                Cell cell10 = crateCell(workbook,row,10); //单元格编号
                Cell cell11 = crateCell(workbook,row,11); //项目储备编号
                Cell cell12 = crateCell(workbook,row,12); //项目名称
                Cell cell13 = crateCell(workbook,row,13); //建设必要性及内容
                Cell cell14 = crateCell(workbook,row,14); //变电站名称
                Cell cell15 = crateCell(workbook,row,15); //线路名称
                Cell cell16 = crateCell(workbook,row,16); //网架项目划分
                Cell cell17 = crateCell(workbook,row,17); //需求类型
                Cell cell18 = crateCell(workbook,row,18); //项目类型
                Cell cell19 = crateCell(workbook,row,19); //费用估算
                Cell cell20 = crateCell(workbook,row,20); //备注
                Cell cell21 = crateCell(workbook,row,21); //项目综合可实施性
                Cell cell22 = crateCell(workbook,row,22); //政处难度
                Cell cell23 = crateCell(workbook,row,23); //政处描述
                Cell cell24 = crateCell(workbook,row,24); //停电难度
                Cell cell25 = crateCell(workbook,row,25); //停电描述
                Cell cell26 = crateCell(workbook,row,26); //其他问题难度
                Cell cell27 = crateCell(workbook,row,27); //其他问题描述
                Cell cell28 = crateCell(workbook,row,28); //是否需重跑方案
                Cell cell29 = crateCell(workbook,row,29); //方案变更说明
                Cell cell30 = crateCell(workbook,row,30); //储备项目交底信息-备注
                Cell cell31 = crateCell(workbook,row,31); //储备进度
                Cell cell32 = crateCell(workbook,row,32); //是否含土建工作量
                Cell cell33 = crateCell(workbook,row,33); //土建工作量统计
                Cell cell34 = crateCell(workbook,row,34); //是否含立杆工作量
                Cell cell35 = crateCell(workbook,row,35); //立杆工作量统计
                Cell cell36 = crateCell(workbook,row,36); //预算（含税）
                Cell cell37 = crateCell(workbook,row,37); //预算（不含税）
                Cell cell38 = crateCell(workbook,row,38); //施工费（不含税）
                Cell cell39 = crateCell(workbook,row,39); //备注
                Cell cell40 = crateCell(workbook,row,40); //储备项目推进计划（项目管理中心）
                Cell cell41 = crateCell(workbook,row,41); //项目管理单位完成进度
                Cell cell42 = crateCell(workbook,row,42); //储备项目推进计划（需求单位）
                Cell cell43 = crateCell(workbook,row,43); //需求单位完成进度
                Cell cell44 = crateCell(workbook,row,44); //是否启动政处
                Cell cell45 = crateCell(workbook,row,45); //政处进度
                Cell cell46 = crateCell(workbook,row,46); //备注
                Cell cell47 = crateCell(workbook,row,47); //需求单位优先级
                Cell cell48 = crateCell(workbook,row,48); //是否纳入实施计划
                Cell cell49 = crateCell(workbook,row,49); //初定实施批次
                Cell cell50 = crateCell(workbook,row,50); //初定施工单位
                Cell cell51 = crateCell(workbook,row,51); //是否出规划报批图
                Cell cell52 = crateCell(workbook,row,52); //是否出正式图
                Cell cell53 = crateCell(workbook,row,53); //备注

                PreliminaryPrepartion reserveManagement = list.get(i);

                cell0.setCellValue(String.valueOf(index++));
                cell1.setCellValue(reserveManagement.getProjectYear());
                cell2.setCellValue(reserveManagement.getProjectNature());
                cell3.setCellValue(reserveManagement.getDemandUnit());
                cell4.setCellValue(reserveManagement.getDistrict());
                cell5.setCellValue(reserveManagement.getProjectGroup());
                cell6.setCellValue(reserveManagement.getProjectManager());
                cell7.setCellValue(reserveManagement.getReserveBatches());
                cell8.setCellValue(reserveManagement.getBlockSupply());
                cell9.setCellValue(reserveManagement.getGridNumber());
                cell10.setCellValue(reserveManagement.getCellNumber());
                cell11.setCellValue(reserveManagement.getProjectReserveId());
                cell12.setCellValue(reserveManagement.getProjectName());
                cell13.setCellValue(reserveManagement.getConstructionNecessityAndContent());
                cell14.setCellValue(reserveManagement.getSubstationName());
                cell15.setCellValue(reserveManagement.getCircuitName());
                cell16.setCellValue(reserveManagement.getNetRackProjectDivide());
                cell17.setCellValue(reserveManagement.getRequirementType());
                cell18.setCellValue(reserveManagement.getProjectType());

                String costEstimateStr= reserveManagement.getCostEstimate().toString();
                if(StringUtils.isNotBlank(costEstimateStr)){
                    cell19.setCellValue(Double.parseDouble(costEstimateStr));
                }
                cell20.setCellValue(reserveManagement.getBasicRemarks());
                cell21.setCellValue(reserveManagement.getComprehensiveProject());
                cell22.setCellValue(reserveManagement.getOfficeDifficulty());
                cell23.setCellValue(reserveManagement.getOfficeProgress());
                cell24.setCellValue(reserveManagement.getPowerFailureDifficulty());
                cell25.setCellValue(reserveManagement.getPowerFailureDescribe());
                cell26.setCellValue(reserveManagement.getOtherProblemDifficulty());
                cell27.setCellValue(reserveManagement.getOtherProblemDescribe());
                cell28.setCellValue(reserveManagement.getRunPlanRequire());
                cell29.setCellValue(reserveManagement.getProgramChangeDescription());
                cell30.setCellValue(reserveManagement.getDiscloseRemarks());
                cell31.setCellValue(reserveManagement.getReserveProgress());
                cell32.setCellValue(reserveManagement.getCivilEngineeringWorkload());
                cell33.setCellValue(reserveManagement.getEngineeringWorkloadStatistic());
                cell34.setCellValue(reserveManagement.getPoleWorkload());
                cell35.setCellValue(reserveManagement.getPoleWorkloadStatistic());
                cell36.setCellValue(reserveManagement.getBudgetIncludesTax());
                cell37.setCellValue(reserveManagement.getBudgetNotIncludesTax());
                cell38.setCellValue(reserveManagement.getConstructCostExcludeTax());
                cell39.setCellValue(reserveManagement.getQuantityRemarks());
                cell40.setCellValue(reserveManagement.getReserveProjectPromotyPlan());
                cell41.setCellValue(reserveManagement.getUnitCompleteProgress());
                cell42.setCellValue(reserveManagement.getDemandUnitReserveProjectPromotyPlan());
                cell43.setCellValue(reserveManagement.getDemandUnitCompleteProgress());
                cell44.setCellValue(reserveManagement.getFireAdministrativeDepartment());
                cell45.setCellValue(reserveManagement.getAdministrativeProgress());
                cell46.setCellValue(reserveManagement.getPreliminaryPreparationRemarks());
                cell47.setCellValue(reserveManagement.getDemandUnitPriority());
                cell48.setCellValue(reserveManagement.getImplementPlan());
                cell49.setCellValue(reserveManagement.getImplementBatch());
                cell50.setCellValue(reserveManagement.getConstructionUnit());
                cell51.setCellValue(reserveManagement.getPlanAndApprovalDraw());
                cell52.setCellValue(reserveManagement.getDrawOfficeDrawn());
                cell53.setCellValue(reserveManagement.getProjectApprovalRemarks());
            }

            String str = URLEncoder.encode("前期工作准备信息.xlsx", "UTF8");
            response.setHeader("Content-Disposition", "attachment;filename="+str);
            response.setContentType("application/vnd.ms-excel;charset=UTF-8");
            OutputStream outputStream = response.getOutputStream();
            workbook.write(outputStream);
            outputStream.flush();
            outputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 创建Cell对象 同时设置style
     * @param workbook
     * @param row
     * @param num
     * @return
     */
    Cell crateCell(XSSFWorkbook workbook,Row row, int num){
        Cell cell = row.createCell(num);
        if(style == null){
            style =workbook.createCellStyle();
            style.setWrapText(true);
            style.setVerticalAlignment(XSSFCellStyle.VERTICAL_CENTER);
        }
        cell.setCellStyle(style);
        return cell;
    }

    /**
     * 创建Cell对象 同时设置style
     * @param workbook
     * @param row
     * @param num
     * @return
     */
    Cell crateCellNew(XSSFWorkbook workbook,Row row, int num){
        Cell cell = row.createCell(num);
        //设置样式
        XSSFCellStyle style = workbook.createCellStyle();
        style.setAlignment(XSSFCellStyle.ALIGN_CENTER); //水平居中
        style.setVerticalAlignment(XSSFCellStyle.VERTICAL_CENTER);  //垂直居中
        style.setWrapText(true);//自动换行
        style.setBorderLeft(XSSFCellStyle.BORDER_THIN); // 左边框细线
        style.setBorderRight(XSSFCellStyle.BORDER_THIN); // 右边框细线
        style.setBorderBottom(XSSFCellStyle.BORDER_THIN); // 下边框细线
        cell.setCellStyle(style);
        return cell;
    }

    public void setCellStyle(XSSFWorkbook workbook,int startRow,int endRow,Sheet sheet,int endColumn ){
        XSSFCellStyle newStyle = workbook.createCellStyle();
        newStyle.setBorderRight(XSSFCellStyle.BORDER_THIN); // 右边框细线
        newStyle.setBorderBottom(XSSFCellStyle.BORDER_THIN); // 下边框细线
        // 循环遍历指定的行和列范围，为每个单元格应用边框样式
        for (int rowIndex = startRow; rowIndex <= endRow; rowIndex++) {
            Row row = sheet.getRow(rowIndex);
            if (row == null) {
                row = sheet.createRow(rowIndex);
            }

            Cell cell = row.createCell(endColumn);
            cell.setCellValue(""); // 如果需要在单元格中填充数据

            // 将样式应用到指定的单元格
            cell.setCellStyle(newStyle);
        }
    }
}
