package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils;

import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.*;
import com.jeeplus.modules.sg.managementcenter.materialproject.util.ImportUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Row;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;

public class ReserveProcessProjectProUtil {


    /**
     * 获取储备项目基本信息表格数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<ReserveProcessProject> getProjectUtil(ImportUtil importUtil,List<String> proIdList,List<String> projectNameList,List<String> contentList) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<ReserveProcessProject> list = new ArrayList<ReserveProcessProject>();

        //项目储备编号唯一性判断
        List<String> cbbhList = new ArrayList<>();
        //项目名称唯一性判断
        List<String> nameList = new ArrayList<>();
        //建设必要性及内容
        List<String> jsList = new ArrayList<>();
        ReserveProcessProject reserveManagement = null;
        for(int i=3; i<=lastRow;i++){
            reserveManagement = new ReserveProcessProject();
            Row row = importUtil.getRow(i);
            //储备人员流转信息
            Row cbRow = importUtil.getRow(3);
            String reserveProjectName = (String) importUtil.getCellValue(row,11);
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 10);

            if(StringUtils.isNotBlank(reserveProjectName) ) {
                if(StringUtils.isNotBlank(projectReserveId)){

                    reserveManagement.setProjectYear((String) importUtil.getCellValue(row,1));
//                    reserveManagement.setProjectNature((String) importUtil.getCellValue(row,2));
                    reserveManagement.setDemandUnit((String) importUtil.getCellValue(row,3));
                    reserveManagement.setDistrict((String) importUtil.getCellValue(row,4));
                    reserveManagement.setProjectGroup((String) importUtil.getCellValue(row,5));
                    reserveManagement.setReserveBatches((String) importUtil.getCellValue(row,6));
                    reserveManagement.setBlockSupply((String) importUtil.getCellValue(row,7));
                    reserveManagement.setGridNumber((String) importUtil.getCellValue(row,8));

                    reserveManagement.setCellNumber((String) importUtil.getCellValue(row,9));

                    reserveManagement.setProjectReserveId((String) importUtil.getCellValue(row,10));

                    //判断库中是否有重复数据
                    getBmList(proIdList,reserveManagement.getProjectReserveId());

                    reserveManagement.setProjectName((String) importUtil.getCellValue(row,11));
                    reserveManagement.setStateGridProjectCode((String) importUtil.getCellValue(row,12));
                    reserveManagement.setStateGridProjectName((String) importUtil.getCellValue(row,13));
                    //判断库钟是否有重复的项目名称、建设必要性及内容
                    getNaList(projectNameList,reserveManagement.getProjectName());

                    reserveManagement.setConstructionNecessityAndContent((String) importUtil.getCellValue(row,14));
                    //建设必要性及内容
                    getCoList(contentList,reserveManagement.getConstructionNecessityAndContent());

                    reserveManagement.setSubstationName((String) importUtil.getCellValue(row,15));
                    reserveManagement.setCircuitName((String) importUtil.getCellValue(row,16));
                    reserveManagement.setNetRackProjectDivide((String) importUtil.getCellValue(row,17));
                    reserveManagement.setRequirementType((String) importUtil.getCellValue(row,18));
                    reserveManagement.setProjectType((String) importUtil.getCellValue(row,19));

                    String costEstimateStr = importUtil.getCellValue(row,20).toString();
                    if(StringUtils.isNotBlank(costEstimateStr)){
                        reserveManagement.setCostEstimate(Double.parseDouble(costEstimateStr));
                    }
                    reserveManagement.setBasicRemarks((String) importUtil.getCellValue(row,21));
                    reserveManagement.setRequester((String) importUtil.getCellValue(row,22));
                    reserveManagement.setOwnerReserveFullTime((String) importUtil.getCellValue(row,23));
                    reserveManagement.setOwnerDistributionNerworkFullTime((String) importUtil.getCellValue(row,24));
                    reserveManagement.setOwnerReserveProjectManagre((String) importUtil.getCellValue(row,25));
                    reserveManagement.setMaterialSoleDuty((String) importUtil.getCellValue(row,26));
                    reserveManagement.setTechnicalStaff((String) importUtil.getCellValue(row,27));
                    reserveManagement.setOperationAndMaintenancePersonnel((String) importUtil.getCellValue(row,28));
                    reserveManagement.setDesigner((String) importUtil.getCellValue(row,29));
                    reserveManagement.setBudgetPreparer((String) importUtil.getCellValue(row,30));
//                    reserveManagement.setUninterruptedWorkSurveyPersonnel((String) importUtil.getCellValue(row,28));
                    reserveManagement.setProcessStatus(0);
//                    reserveManagement.setUninterruptedWorkSurveyPersonnel((String) importUtil.getCellValue(row,27));


                    if (list.size() == 0){
                        list.add(reserveManagement);
                        /*wgList.add(reserveManagement.getGridNumber());
                        dygList.add(reserveManagement.getCellNumber());*/
                        cbbhList.add(reserveManagement.getProjectReserveId());
                        nameList.add(reserveManagement.getProjectName());
                        jsList.add(reserveManagement.getConstructionNecessityAndContent());
                    }else {
                        if (!cbbhList.contains(reserveManagement.getProjectReserveId())
                            & !nameList.contains(reserveManagement.getProjectName())
                            & ! jsList.contains(reserveManagement.getConstructionNecessityAndContent())){
                            list.add(reserveManagement);
                            cbbhList.add(reserveManagement.getProjectReserveId());
                            nameList.add(reserveManagement.getProjectName());
                            jsList.add(reserveManagement.getConstructionNecessityAndContent());
                        } else if (cbbhList.contains(reserveManagement.getProjectReserveId())) {
                            throw new Exception( "项目编号为" + reserveManagement.getProjectReserveId() + "的项目在导入的excel表中重复，不对数据进行保存操作！");
                        } else if (nameList.contains(reserveManagement.getProjectName())) {
                            throw new Exception( "项目名称为" + reserveManagement.getProjectName() + "的项目在导入的excel表中重复，不对数据进行保存操作！");
                        } else if (jsList.contains(reserveManagement.getConstructionNecessityAndContent())) {
                            throw new Exception( "建设及必要性内容为" + reserveManagement.getConstructionNecessityAndContent() + "的项目在导入的excel表中重复，不对数据进行保存操作！");
                        }
                    }

                }
            }
        }
        return list;
    }

    /**
     * 获取储备项目带电作业表格数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<ReserveElectricityWork> getChargeProjectUtil(ImportUtil importUtil,List<String> proIdList,List<String> proIdList2) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<ReserveElectricityWork> list = new ArrayList<ReserveElectricityWork>();
        //项目储备编号唯一性判断
        List<String> cbbhList = new ArrayList<>();
        //项目名称唯一性判断
        List<String> nameList = new ArrayList<>();
        //建设必要性及内容
        List<String> jsList = new ArrayList<>();
        ReserveElectricityWork reserveManagement = null;
        for(int i=2; i<=lastRow;i++){
            reserveManagement = new ReserveElectricityWork();
            Row row = importUtil.getRow(i);
            //储备人员流转信息
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 11);
            if(StringUtils.isNotBlank(projectReserveId)){

                reserveManagement.setProjectReserveId((String) importUtil.getCellValue(row,11));

                //和基本信息表比对，是否有对应的数据
                getBmList2(proIdList2,reserveManagement.getProjectReserveId());

                reserveManagement.setHotLineWork((String) importUtil.getCellValue(row,26));

                reserveManagement.setHotLineWorkTypeNo((String) importUtil.getCellValue(row,28));
                reserveManagement.setNoStopWorkPlan((String) importUtil.getCellValue(row,29));
                reserveManagement.setPowerFailureNum((String) importUtil.getCellValue(row,30));

                if (reserveManagement.getHotLineWork().equals("是") & (reserveManagement.getHotLineWorkTypeNo().equals("")
                    || reserveManagement.getNoStopWorkPlan().equals("") || reserveManagement.getPowerFailureNum().equals(""))){

                    throw new Exception(reserveManagement.getProjectReserveId() + "项目，带电作业信息填写不完整！");
                }

                reserveManagement.setReasonsForNotWorkInterruption((String) importUtil.getCellValue(row,31));
                reserveManagement.setPowerOutagePlan((String) importUtil.getCellValue(row,32));
                reserveManagement.setPlanner((String) importUtil.getCellValue(row,33));
                reserveManagement.setSiteSurveyor((String) importUtil.getCellValue(row,34));

                if (list.size() == 0){
                    list.add(reserveManagement);

                    cbbhList.add(reserveManagement.getProjectReserveId());
                }else {
                    if (!cbbhList.contains(reserveManagement.getProjectReserveId())){
                        list.add(reserveManagement);
                        cbbhList.add(reserveManagement.getProjectReserveId());
                    }
                }

            }
        }
        return list;
    }

    /**
     * 获取前期工作准备表格数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<PreliminaryPrepartion> getPreLiminUtil(ImportUtil importUtil,List<String> proIdList,List<String> proIdList2) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<PreliminaryPrepartion> list = new ArrayList<PreliminaryPrepartion>();
        //项目储备编号唯一性判断
        List<String> cbbhList = new ArrayList<>();
        //项目名称唯一性判断
        List<String> nameList = new ArrayList<>();
        //建设必要性及内容
        List<String> jsList = new ArrayList<>();
        PreliminaryPrepartion reserveManagement = null;
        for(int i=2; i<=lastRow;i++){
            reserveManagement = new PreliminaryPrepartion();
            Row row = importUtil.getRow(i);
            //储备人员流转信息
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 11);
            if(StringUtils.isNotBlank(projectReserveId)){

                reserveManagement.setProjectReserveId((String) importUtil.getCellValue(row,11));

                //和基本信息表比对，是否有对应的数据
                getBmList2(proIdList2,reserveManagement.getProjectReserveId());

                reserveManagement.setCivilEngineeringWorkload((String) importUtil.getCellValue(row,32));
                reserveManagement.setQuantityRemarks((String) importUtil.getCellValue(row,39));
                reserveManagement.setReserveProjectPromotyPlan((String) importUtil.getCellValue(row,40));
                reserveManagement.setUnitCompleteProgress((String) importUtil.getCellValue(row,41));
                reserveManagement.setDemandUnitReserveProjectPromotyPlan((String) importUtil.getCellValue(row,42));
                reserveManagement.setDemandUnitCompleteProgress((String) importUtil.getCellValue(row,43));
                reserveManagement.setPreliminaryPreparationRemarks((String) importUtil.getCellValue(row,46));
                reserveManagement.setDemandUnitPriority((String) importUtil.getCellValue(row,47));
                reserveManagement.setImplementPlan((String) importUtil.getCellValue(row,48));
                reserveManagement.setImplementBatch((String) importUtil.getCellValue(row,49));
                reserveManagement.setConstructionUnit((String) importUtil.getCellValue(row,50));
                reserveManagement.setPlanAndApprovalDraw((String) importUtil.getCellValue(row,51));
                reserveManagement.setDrawOfficeDrawn((String) importUtil.getCellValue(row,52));
                reserveManagement.setProjectApprovalRemarks((String) importUtil.getCellValue(row,53));

                if (list.size() == 0){
                    list.add(reserveManagement);

                    cbbhList.add(reserveManagement.getProjectReserveId());
                }else {
                    if (!cbbhList.contains(reserveManagement.getProjectReserveId())){
                        list.add(reserveManagement);
                        cbbhList.add(reserveManagement.getProjectReserveId());
                    }
                }

            }
        }
        return list;
    }

    /**
     * 获取项目类型校核表格数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<ProjectTypeVerificate> getVerificateUtil(ImportUtil importUtil,List<String> proIdList,List<String> proIdList2) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<ProjectTypeVerificate> list = new ArrayList<ProjectTypeVerificate>();
        //项目储备编号唯一性判断
        List<String> cbbhList = new ArrayList<>();
        //项目名称唯一性判断
        List<String> nameList = new ArrayList<>();
        //建设必要性及内容
        List<String> jsList = new ArrayList<>();
        ProjectTypeVerificate reserveManagement = null;
        for(int i=2; i<=lastRow;i++){
            reserveManagement = new ProjectTypeVerificate();
            Row row = importUtil.getRow(i);
            //储备人员流转信息
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 10);
            if(StringUtils.isNotBlank(projectReserveId)){

                reserveManagement.setProjectReserveId((String) importUtil.getCellValue(row,10));

                //和基本信息表比对，是否有对应的数据
                getBmList2(proIdList2,reserveManagement.getProjectReserveId());

                reserveManagement.setProjectNature((String) importUtil.getCellValue(row,24));
                reserveManagement.setNewSubstation((String) importUtil.getCellValue(row,25));
                reserveManagement.setProjectNatureArtificial((String) importUtil.getCellValue(row,28));
                reserveManagement.setProjectType((String) importUtil.getCellValue(row,29));
                reserveManagement.setIncludeCablesArtificial((String) importUtil.getCellValue(row,40));

                if (list.size() == 0){
                    list.add(reserveManagement);

                    cbbhList.add(reserveManagement.getProjectReserveId());
                }else {
                    if (!cbbhList.contains(reserveManagement.getProjectReserveId())){
                        list.add(reserveManagement);
                        cbbhList.add(reserveManagement.getProjectReserveId());
                    }
                }

            }
        }
        return list;
    }

    /**
     * 获取立项筛选统计表表格数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<ProjectScreen> getProjectScreenUtil(ImportUtil importUtil,List<String> proIdList,List<String> proIdList2) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<ProjectScreen> list = new ArrayList<ProjectScreen>();
        //项目储备编号唯一性判断
        List<String> cbbhList = new ArrayList<>();
        //项目名称唯一性判断
        List<String> nameList = new ArrayList<>();
        //建设必要性及内容
        List<String> jsList = new ArrayList<>();
        ProjectScreen reserveManagement = null;
        for(int i=2; i<=lastRow;i++){
            reserveManagement = new ProjectScreen();
            Row row = importUtil.getRow(i);
            //储备人员流转信息
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 11);
            if(StringUtils.isNotBlank(projectReserveId)){

                reserveManagement.setProjectReserveId((String) importUtil.getCellValue(row,11));

                //和基本信息表比对，是否有对应的数据
                getBmList2(proIdList2,reserveManagement.getProjectReserveId());

                reserveManagement.setProjectPromotion((String) importUtil.getCellValue(row,44));
                reserveManagement.setCompleteProgress((String) importUtil.getCellValue(row,45));
                reserveManagement.setPreliminaryWorkPreparationRemarks((String) importUtil.getCellValue(row,48));
                reserveManagement.setRequirementUnitPriority((String) importUtil.getCellValue(row,49));
                reserveManagement.setImplementPlan((String) importUtil.getCellValue(row,50));
                reserveManagement.setImplementBatchScreen((String) importUtil.getCellValue(row,51));
                reserveManagement.setConstructionUnit((String) importUtil.getCellValue(row,52));
                reserveManagement.setProjectApprovalBatch((String) importUtil.getCellValue(row,53));
                reserveManagement.setRealityConstructionUnit((String) importUtil.getCellValue(row,54));
                reserveManagement.setApprovalDiagram((String) importUtil.getCellValue(row,55));
                reserveManagement.setApprovalDiagramTime((String) importUtil.getCellValue(row,56));
                reserveManagement.setPaperDrawing((String) importUtil.getCellValue(row,57));
                reserveManagement.setPaperDrawingTime((String) importUtil.getCellValue(row,58));
                reserveManagement.setScreenRemarks((String) importUtil.getCellValue(row,59));

                if (list.size() == 0){
                    list.add(reserveManagement);

                    cbbhList.add(reserveManagement.getProjectReserveId());
                }else {
                    if (!cbbhList.contains(reserveManagement.getProjectReserveId())){
                        list.add(reserveManagement);
                        cbbhList.add(reserveManagement.getProjectReserveId());
                    }
                }

            }
        }
        return list;
    }

    /**
     * 获取储备项目安全交底信息表格数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<ReserveSafety> getSafetyProjectUtil(ImportUtil importUtil,List<String> proIdList,List<String> proIdList2) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<ReserveSafety> list = new ArrayList<ReserveSafety>();

        //项目储备编号唯一性判断
        List<String> cbbhList = new ArrayList<>();

        //建设必要性及内容
        List<String> jsList = new ArrayList<>();
        ReserveSafety reserveManagement = null;
        for(int i=3; i<=lastRow;i++){
            reserveManagement = new ReserveSafety();
            Row row = importUtil.getRow(i);
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 11);
            if(StringUtils.isNotBlank(projectReserveId)){

                reserveManagement.setProjectReserveId((String) importUtil.getCellValue(row,11));

                //和基本信息表比对，是否有对应的数据
                getBmList2(proIdList2,reserveManagement.getProjectReserveId());

                reserveManagement.setTransmissionWork((String) importUtil.getCellValue(row,25));
                reserveManagement.setWorkDescribe((String) importUtil.getCellValue(row,26));
                reserveManagement.setTransmissionErection((String) importUtil.getCellValue(row,27));
                reserveManagement.setErecteDescribe((String) importUtil.getCellValue(row,28));
                reserveManagement.setTransmissionCommonTrench((String) importUtil.getCellValue(row,29));
                reserveManagement.setTrenchDescribe((String) importUtil.getCellValue(row,30));
                reserveManagement.setMediumVoltageWork((String) importUtil.getCellValue(row,31));
                reserveManagement.setVoltageWorkDescribe((String) importUtil.getCellValue(row,32));
                reserveManagement.setConfineSpaceWork((String) importUtil.getCellValue(row,33));
                reserveManagement.setSpaceDescribe((String) importUtil.getCellValue(row,34));
                reserveManagement.setSubStationCableBonding((String) importUtil.getCellValue(row,35));
                reserveManagement.setCableDescribe((String) importUtil.getCellValue(row,36));
                reserveManagement.setRoadRailwaysAndWaterwaysWork((String) importUtil.getCellValue(row,37));
                reserveManagement.setWaterDescribe((String) importUtil.getCellValue(row,38));
                reserveManagement.setHotWork((String) importUtil.getCellValue(row,39));
                reserveManagement.setHotWorkDescribe((String) importUtil.getCellValue(row,40));
                reserveManagement.setBlackoutLineFour((String) importUtil.getCellValue(row,41));
                reserveManagement.setLineFourDescribe((String) importUtil.getCellValue(row,42));
                reserveManagement.setLineLoadRedirectionThree((String) importUtil.getCellValue(row,43));
                reserveManagement.setThreeRedirectDescribe((String) importUtil.getCellValue(row,44));
                reserveManagement.setLargeScaleMultiTeamWork((String) importUtil.getCellValue(row,45));
                reserveManagement.setTeamWorkDescribe((String) importUtil.getCellValue(row,46));
                reserveManagement.setPrepareThreeMeasures((String) importUtil.getCellValue(row,47));
                reserveManagement.setMeasureDescribe((String) importUtil.getCellValue(row,48));
                reserveManagement.setJobRiskLevelPrediction((String) importUtil.getCellValue(row,49));




                if (list.size() == 0){
                    list.add(reserveManagement);
                    cbbhList.add(reserveManagement.getProjectReserveId());
                }else {
                    if (!cbbhList.contains(reserveManagement.getProjectReserveId())){
                        list.add(reserveManagement);
                        cbbhList.add(reserveManagement.getProjectReserveId());
                        jsList.add(reserveManagement.getConstructionNecessityAndContent());
                    }
                }

            }
        }
        return list;
    }

    /**
     * 获取储备项目预土建制化信息表格数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<ReservePreconstruction> getPreconstUtil(ImportUtil importUtil, List<String> proIdList,List<String> proIdList2) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<ReservePreconstruction> list = new ArrayList<ReservePreconstruction>();
        //项目储备编号唯一性判断
        List<String> cbbhList = new ArrayList<>();
        ReservePreconstruction reserveManagement = null;
        for(int i=3; i<=lastRow;i++){
            reserveManagement = new ReservePreconstruction();
            Row row = importUtil.getRow(i);
            //储备人员流转信息
            Row cbRow = importUtil.getRow(3);
            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 10);
            if(StringUtils.isNotBlank(projectReserveId)){

                reserveManagement.setProjectReserveId((String) importUtil.getCellValue(row,10));

                //和基本信息表比对，是否有对应的数据
                getBmList2(proIdList2,reserveManagement.getProjectReserveId());

                reserveManagement.setConfessCivilFoundation((String) importUtil.getCellValue(row,22));
                reserveManagement.setConfessPrefab((String) importUtil.getCellValue(row,23));
                reserveManagement.setConfessPrefabDescription((String) importUtil.getCellValue(row,24));
//                reserveManagement.setDesignCivilFoundation("");
//                reserveManagement.setCastInPlaceList("");
//                reserveManagement.setDesignList("");


                if (list.size() == 0){
                    list.add(reserveManagement);
                    cbbhList.add(reserveManagement.getProjectReserveId());
                }else {
                    if (!cbbhList.contains(reserveManagement.getProjectReserveId())){
                        list.add(reserveManagement);
                        cbbhList.add(reserveManagement.getProjectReserveId());
                    }
                }

            }
        }
        return list;
    }

    /**
     * 获取储备项目政策处理信息表格数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<ReservePolicyHand> getPolicyUtil(ImportUtil importUtil) throws ParseException {
        int lastRow = importUtil.getLastDataRowNum();
        List<ReservePolicyHand> list = new ArrayList<ReservePolicyHand>();
        //项目储备编号唯一性判断
//        List<String> cbbhList = new ArrayList<>();

        ReservePolicyHand reserveManagement = null;
        for(int i=2; i<=lastRow;i++){
            reserveManagement = new ReservePolicyHand();
            Row row = importUtil.getRow(i);

            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 10);
            if(StringUtils.isNotBlank(projectReserveId)){

                reserveManagement.setProjectReserveId((String) importUtil.getCellValue(row,10));

                reserveManagement.setPowerSupplyArea((String) importUtil.getCellValue(row,22));
                reserveManagement.setConstructionSpot((String) importUtil.getCellValue(row,23));
                reserveManagement.setIncludeCivilWork((String) importUtil.getCellValue(row,24));
                reserveManagement.setPoleWorkload((String) importUtil.getCellValue(row,25));
                reserveManagement.setProposedConstructionUnit((String) importUtil.getCellValue(row,27));
                reserveManagement.setOverToGovernment((String) importUtil.getCellValue(row,28));
                reserveManagement.setGovernmentOffice((String) importUtil.getCellValue(row,29));
                reserveManagement.setOfficeDescription((String) importUtil.getCellValue(row,30));
                reserveManagement.setAdministrativeDifficulty((String) importUtil.getCellValue(row,31));
                reserveManagement.setAdministrativeObjectNumber((String) importUtil.getCellValue(row,32));
                reserveManagement.setPropertyUnitOfficeDescription((String) importUtil.getCellValue(row,33));
                reserveManagement.setOfficeType((String) importUtil.getCellValue(row,34));

                reserveManagement.setStartOfficeTime((String) importUtil.getCellValue(row, 35));
                reserveManagement.setPlanApprovalRequire((String) importUtil.getCellValue(row,36));
                reserveManagement.setPlanApprovalCompletion((String) importUtil.getCellValue(row,37));
                reserveManagement.setSafetyReview((String) importUtil.getCellValue(row,38));
                reserveManagement.setSafetyReviewCompletion((String) importUtil.getCellValue(row,39));
                reserveManagement.setOfficeAmount((String) importUtil.getCellValue(row,40));
                reserveManagement.setPaymentCompleted((String) importUtil.getCellValue(row,41));
                reserveManagement.setOfficeProgress((String) importUtil.getCellValue(row,42));
                reserveManagement.setCivilEngineeringApproach((String) importUtil.getCellValue(row,43));
                reserveManagement.setElectricApproach((String) importUtil.getCellValue(row,44));
                reserveManagement.setCivilConstructionMaterialOpen((String) importUtil.getCellValue(row,45));
                reserveManagement.setElectricalPickListOpen((String) importUtil.getCellValue(row,46));
                reserveManagement.setAdministrativeOfficeRemark((String) importUtil.getCellValue(row,47));

                list.add(reserveManagement);
                /*if (list.size() == 0){
                    list.add(reserveManagement);
                    cbbhList.add(reserveManagement.getProjectReserveId());
                }else {
                    if (!cbbhList.contains(reserveManagement.getProjectReserveId())){
                        list.add(reserveManagement);
                        cbbhList.add(reserveManagement.getProjectReserveId());
                    }
                }*/

            }
        }
        return list;
    }

    /**
     * 获取储备项目交底汇总表格数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<ReserveSummary> getSummaryUtil(ImportUtil importUtil,List<String> proIdList,List<String> proIdList2) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<ReserveSummary> list = new ArrayList<ReserveSummary>();

        //项目储备编号唯一性判断
        List<String> cbbhList = new ArrayList<>();

        ReserveSummary reserveManagement = null;
        for(int i=2; i<=lastRow;i++){
            reserveManagement = new ReserveSummary();
            Row row = importUtil.getRow(i);

            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 11);

            if(StringUtils.isNotBlank(projectReserveId)){

                reserveManagement.setProjectReserveId((String) importUtil.getCellValue(row,11));
                //和基本信息表对比      是否无对应数据
                getBmList2(proIdList2,reserveManagement.getProjectReserveId());

                reserveManagement.setIncludeReserve((String) importUtil.getCellValue(row,23));
                reserveManagement.setReasonForCancel((String) importUtil.getCellValue(row,24));
                reserveManagement.setStartDesignOrNot((String) importUtil.getCellValue(row,25));
                reserveManagement.setCompleteDisclose((String) importUtil.getCellValue(row,26));
                reserveManagement.setCompleteDiscloseTime((String) importUtil.getCellValue(row,27));
                reserveManagement.setComprehensiveProject("");
                reserveManagement.setPowerFailureDifficulty((String) importUtil.getCellValue(row,31));
                reserveManagement.setPowerFailureDescribe((String) importUtil.getCellValue(row,32));
                reserveManagement.setOtherProblemDifficulty((String) importUtil.getCellValue(row,33));
                reserveManagement.setOtherProblemDescribe((String) importUtil.getCellValue(row,34));
                reserveManagement.setRunPlanRequire((String) importUtil.getCellValue(row,35));
                reserveManagement.setProgramChangeDescription((String) importUtil.getCellValue(row,36));
                reserveManagement.setDiscloseRemarks((String) importUtil.getCellValue(row,37));


                if (list.size() == 0){
                    list.add(reserveManagement);
                    cbbhList.add(reserveManagement.getProjectReserveId());
                }else {
                    if (!cbbhList.contains(reserveManagement.getProjectReserveId())){
                        list.add(reserveManagement);
                        cbbhList.add(reserveManagement.getProjectReserveId());
                    }
                }

            }
        }
        return list;
    }

    /**
     * 获取储备项目政策处理信息表格数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<Demolite> getDemoliteUtil(ImportUtil importUtil,String projectReserveId) throws ParseException {
        int lastRow = importUtil.getLastDataRowNum();
        List<Demolite> list = new ArrayList<Demolite>();

        Demolite reserveManagement = null;
        for(int i=1; i<=lastRow;i++){
            reserveManagement = new Demolite();
            Row row = importUtil.getRow(i);

            reserveManagement.setName((String) importUtil.getCellValue(row,1));
            reserveManagement.setSpecification((String) importUtil.getCellValue(row,2));
            reserveManagement.setUnit((String) importUtil.getCellValue(row,3));
            reserveManagement.setCount((String) importUtil.getCellValue(row,4));
            reserveManagement.setRemark((String) importUtil.getCellValue(row,5));
            reserveManagement.setProjectReserveId(projectReserveId);
            list.add(reserveManagement);
        }
        return list;
    }

    /**
     * 获取省公司评审表格数据
     * @param importUtil
     * @return List<ReserveManagementMapper> 导入表格数据
     */
    public static List<CompanyReview> getCompanyUtil(ImportUtil importUtil,List<String> proIdList,List<String> proIdList2) throws Exception {
        int lastRow = importUtil.getLastDataRowNum();
        List<CompanyReview> list = new ArrayList<CompanyReview>();

        CompanyReview companyReview = null;
        for(int i=3; i<=lastRow;i++){
            companyReview = new CompanyReview();
            Row row = importUtil.getRow(i);

            //获取项目储备编号
            String projectReserveId = (String) importUtil.getCellValue(row, 11);

            if(StringUtils.isNotBlank(projectReserveId)){

                companyReview.setProjectReserveId(projectReserveId);

                //去汇总表中查看是否有对应数据
                getBmList3(proIdList2,companyReview.getProjectReserveId());

                companyReview.setJoinProvincialCompanyReview((String) importUtil.getCellValue(row,20));
                companyReview.setBatchOfProvincialCompany((String) importUtil.getCellValue(row,21));
                companyReview.setPassProvincialCompanyReview((String) importUtil.getCellValue(row,22));
                companyReview.setReviewComments((String) importUtil.getCellValue(row,23));
                companyReview.setDesignChangeRequired((String) importUtil.getCellValue(row,24));
                companyReview.setCompanyRemarks((String) importUtil.getCellValue(row,25));
                list.add(companyReview);
            }
        }
        return list;
    }

    public static void getBmList(List<String> sjkList, String proId) throws Exception {
        if (sjkList.contains(proId)){
            throw new Exception( "项目编号为" + proId + "的项目在流程中或已完成，不对数据进行保存操作！");
        }
    }

    public static void getNaList(List<String> projectNameList, String name) throws Exception {
        if (projectNameList.contains(name)){
            throw new Exception( "项目名称为" + name + "的项目在流程中或已完成，不对数据进行保存操作！");
        }
    }
    public static void getCoList(List<String> contentList, String content) throws Exception {
        if (contentList.contains(content)){
            throw new Exception( "项目建设必要性及内容为" + content + "的项目在流程中或已完成，不对数据进行保存操作！");
        }
    }

    public static void getBmList2(List<String> sjkList, String proId) throws Exception {
        if (!sjkList.contains(proId)){
            throw new Exception( "项目储备编号为" + proId + "等项目在基础信息表中不存在相关数据！");
        }
    }

    public static void getBmList3(List<String> sjkList, String proId) throws Exception {
        if (!sjkList.contains(proId)){
            throw new Exception(proId + "项目不存在汇总信息，不允许导入相关省公司评审信息！");
        }
    }
}
