package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.web;

import com.google.common.collect.Maps;
import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.common.utils.DateUtils;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.modules.act.service.ActProcessService;
import com.jeeplus.modules.act.service.ActTaskService;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.CompanyReview;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ReserveProcessProject;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ReserveSummary;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ReserveSummaryProcess;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.service.*;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils.ReserveProcessProjectExportUtil;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils.ReserveProcessProjectProUtil;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.service.BudgetStatsService;
import com.jeeplus.modules.sg.managementcenter.materialproject.util.ImportUtil;
import com.jeeplus.modules.sg.managementcenter.reserveManagement.service.PersonnelTurnoverService;
import com.jeeplus.modules.sg.picking.activiti.entity.PickList;
import com.jeeplus.modules.sg.raiseCapital.service.RaiseCapitalService;
import com.jeeplus.modules.sg.raiseCapitalDesign.entity.CableSectionData;
import com.jeeplus.modules.sg.raiseCapitalDesign.entity.CableSectionInfo;
import com.jeeplus.modules.sg.raiseCapitalDesign.entity.VoltageInfo;
import com.jeeplus.modules.sg.raiseCapitalDesign.service.RaiseCapitalDesignService;
import com.jeeplus.modules.sys.utils.DictUtils;
import com.jeeplus.modules.sys.utils.UserUtils;
import org.activiti.engine.repository.ProcessDefinition;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.apache.shiro.authz.annotation.Logical;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 储备项目交底信息汇总统计 controller
 * @author: 王强
 * @create: 2022-07-27 11:03
 **/
@Controller
@RequestMapping(value = "${adminPath}/cg/reservemanagementcenter/summaryStatistics")
public class SummaryStatisticController extends BaseController {

    @Autowired
    private ReserveElectricityWorkService workService;

    @Autowired
    private CompanyReviewService reviewService;

    @Autowired
    private PersonnelTurnoverService service;

    @Autowired
    private SummaryStatisticService statisticService;

    @Autowired
    private ReserveProcessProjectService projectService;

    @Autowired
    private ActProcessService actProcessService;

    @Autowired
    private ActTaskService actTaskService;

    @Autowired
    private ReserveSummaryProcessService reserveProcessService;

    @Autowired
    private BudgetStatsService statsService;

    @Autowired
    private RaiseCapitalDesignService raiseCapitalDesignService;

    @Autowired
    private RaiseCapitalService raiseCapitalService;

    @Autowired
    private ProjectTypeVerificateService verificateService;

    @ModelAttribute
    public ReserveSummary get(@RequestParam(required = false) String id) {
        ReserveSummary entity = null;
        if (StringUtils.isNotBlank(id)) {
            entity = statisticService.get(id);
        }
        if (entity == null) {
            entity = new ReserveSummary();
        }
        return entity;
    }

    /**
     * 项目储备信息列表页面
     * @param reserveManagement
     * @param model
     * @return
     */
    @RequiresPermissions("cg:reservemanagementcenter:summaryStatistics:list")
    @RequestMapping(value = "skipList")
    public String skipList(ReserveSummary reserveManagement, Model model) {
        model.addAttribute("reserveManagement", reserveManagement);
        return "modules/cg/reservemanagementcenter/reserveManage/summaryStatistics/reserveManagementInformation";
    }

    /**
     * 项目储备信息数据列表
     * @param reserveManagement
     * @param request
     * @param response
     * @param model
     * @return
     */
    @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:summaryStatistics:list")
    @RequestMapping(value = "list")
    public Map<String, Object> basicData(ReserveSummary reserveManagement, HttpServletRequest request, HttpServletResponse response, Model model) {

        Page<ReserveSummary> page = statisticService.findPage(new Page<ReserveSummary>(request, response), reserveManagement);
        List<ReserveSummary> list = page.getList();
        List<ReserveSummary> summaryList = new ArrayList<>();

        List<String> nameList = new ArrayList<>();
        //获取所有小类的名称
        List<PickList> pickListList = raiseCapitalService.newAllList();
        if (null != pickListList) {
            pickListList.forEach(k->{
                if (k.getName().equals("三、设备")){
                    k.getMdTheClassList().forEach(v->{
                        v.getMdSmallClassList().forEach(na->{
                            nameList.add(na.getName());
                        });
                    });
                }
            });
        }

        for (ReserveSummary summary : list) {

            //设置  预算（含税）    预算（不含税）
//            if (StringUtils.isNotEmpty(summary.getAfterTrialEstimateAmount())){
//                summary.setBudgetIncludesTax(summary.getAfterTrialEstimateAmount());
//            }else if (StringUtils.isNotEmpty(summary.getPretrialEstimateAmount())){
//                summary.setBudgetIncludesTax(summary.getPretrialEstimateAmount());
//            }else {
//                summary.setBudgetIncludesTax("");
//            }
//
//            if (StringUtils.isNotEmpty(summary.getAfterTrialEstimateAmountExcludeTax())){
//                summary.setBudgetNotIncludesTax(summary.getAfterTrialEstimateAmountExcludeTax());
//            }else if (StringUtils.isNotEmpty(summary.getPretrialEstimateAmountExcludeTax())){
//                summary.setBudgetNotIncludesTax(summary.getPretrialEstimateAmountExcludeTax());
//            }else {
//                summary.setBudgetNotIncludesTax("");
//            }

            //根据projectReserveId查出流程表的proc_ins_id
            String procInsId = statisticService.getByProjectReserveId(summary.getProjectReserveId());
            //根据procInsId查出历史流程名称和时间
            List<History> histories = statisticService.getHistoryByExecuteId(procInsId);
            String historyName = workService.getHistoryName(procInsId);
            //当size>0时待办有历史流程，
            if (histories.size()>0){
                //根据proc_ins_id去运行时任务节点表（act_ru_task）中查出当前流程名称
                String name = statisticService.getByExecuteId(procInsId);
                //设置项目进度
                if (StringUtils.isNotEmpty(name)){
                    summary.setReserveProgress(name);
                }else {
                    if (StringUtils.isNotBlank(historyName) && historyName.equals("技经人员审预算")){
                        summary.setReserveProgress("储备完成");
                    } else {
                        summary.setReserveProgress(name);
                    }
                }
            }else {
                summary.setReserveProgress("");
            }

            //根据项目储备id去在线开甲供材表中查询物理信息
            List<String> materialNameList = verificateService.getMaterialName(summary.getProjectName());
            if (null != nameList & null != materialNameList){
                nameList.forEach(n->{
                    if (StringUtils.isBlank(summary.getProjectNature())){
                        if (materialNameList.contains(n)){
                            summary.setProjectNature("资本");
                        } else {
                            summary.setProjectNature("成本");
                        }
                    }
                });
            }
            if (StringUtils.isBlank(summary.getStateGridProjectCode())){
                summary.setStateGridProjectCode("");
            }
            if (StringUtils.isBlank(summary.getStateGridProjectName())){
                summary.setStateGridProjectName("");
            }
            summaryList.add(summary);
        }


        return getBootstrapData(page);
    }


    /**
     * 查看表单页面
     */
    @RequiresPermissions(value={"cg:reservemanagementcenter:summaryStatistics:view"},logical= Logical.OR)
    @RequestMapping(value = "view")
    public String view(ReserveSummary reserveManagement, Model model) {
        model.addAttribute("reserveManagement", reserveManagement);
        return "modules/cg/reservemanagementcenter/reserveManage/summaryStatistics/reserveManagementView";
    }


    /**
     * 专职人员保存表单
     * @param reserveManagement
     * @return
     */
    @ResponseBody
    @RequiresPermissions(value={"cg:reservemanagementcenter:summaryStatistics:add"},logical=Logical.OR)
    @RequestMapping(value = "save")
    public AjaxJson save(ReserveSummary reserveManagement){
        AjaxJson j = new AjaxJson();
        /**
         * 后台hibernate-validation插件校验
         */
        String errMsg = beanValidator(reserveManagement);
        if (StringUtils.isNotBlank(errMsg)){
            j.setSuccess(false);
            j.setMsg(errMsg);
            return j;
        }
        //新增或编辑表单保存
        statisticService.save(reserveManagement);//保存
        j.setSuccess(true);
        j.setMsg("保存储备项目基本信息成功");
        return j;
    }


    /**
     * 专职人员修改表单
     * @param reserveManagement
     * @return
     */
    @ResponseBody
    @RequiresPermissions(value={"cg:reservemanagementcenter:summaryStatistics:edit"},logical=Logical.OR)
    @RequestMapping(value = "update")
    public AjaxJson update(ReserveSummary reserveManagement){
        AjaxJson j = new AjaxJson();
        /**
         * 后台hibernate-validation插件校验
         */
        String errMsg = beanValidator(reserveManagement);
        if (StringUtils.isNotBlank(errMsg)){
            j.setSuccess(false);
            j.setMsg(errMsg);
            return j;
        }

        //根据项目储备id查数据
        ReserveSummary proId = statisticService.getByProId(reserveManagement.getProjectReserveId());
        if (null == proId){
            proId = new ReserveSummary();
//            BeanUtils.copyProperties(reserveManagement,proId);
            proId.setProjectReserveId(reserveManagement.getProjectReserveId());
            proId.setIncludeReserve(reserveManagement.getIncludeReserve());
            proId.setReasonForCancel(reserveManagement.getReasonForCancel());
            proId.setComprehensiveProject(reserveManagement.getComprehensiveProject());
            proId.setPowerFailureDifficulty(reserveManagement.getPowerFailureDifficulty());
            proId.setPowerFailureDescribe(reserveManagement.getPowerFailureDescribe());
            proId.setOtherProblemDifficulty(reserveManagement.getOtherProblemDifficulty());
            proId.setOtherProblemDescribe(reserveManagement.getOtherProblemDescribe());
            proId.setRunPlanRequire(reserveManagement.getRunPlanRequire());
            proId.setRunPlanRequire(reserveManagement.getRunPlanRequire());
            proId.setProgramChangeDescription(reserveManagement.getProgramChangeDescription());
            proId.setDiscloseRemarks(reserveManagement.getDiscloseRemarks());
            proId.setStartDesignOrNot(reserveManagement.getStartDesignOrNot());
            proId.setCompleteDisclose(reserveManagement.getCompleteDisclose());
            proId.setCompleteDiscloseTime(reserveManagement.getCompleteDiscloseTime());
            statisticService.save(proId);
        }else {
//            BeanUtils.copyProperties(reserveManagement,proId);
            proId.setIncludeReserve(reserveManagement.getIncludeReserve());
            proId.setReasonForCancel(reserveManagement.getReasonForCancel());
            proId.setComprehensiveProject(reserveManagement.getComprehensiveProject());
            proId.setPowerFailureDifficulty(reserveManagement.getPowerFailureDifficulty());
            proId.setPowerFailureDescribe(reserveManagement.getPowerFailureDescribe());
            proId.setOtherProblemDifficulty(reserveManagement.getOtherProblemDifficulty());
            proId.setOtherProblemDescribe(reserveManagement.getOtherProblemDescribe());
            proId.setRunPlanRequire(reserveManagement.getRunPlanRequire());
            proId.setRunPlanRequire(reserveManagement.getRunPlanRequire());
            proId.setProgramChangeDescription(reserveManagement.getProgramChangeDescription());
            proId.setDiscloseRemarks(reserveManagement.getDiscloseRemarks());
            proId.setStartDesignOrNot(reserveManagement.getStartDesignOrNot());
            proId.setCompleteDisclose(reserveManagement.getCompleteDisclose());
            proId.setCompleteDiscloseTime(reserveManagement.getCompleteDiscloseTime());
            //修改时需要从  省公司评审表中查看是否可以发起流程
            CompanyReview review = new CompanyReview();
            review.setProjectReserveId(reserveManagement.getProjectReserveId());
            CompanyReview companyReview = reviewService.queryByProjectReserveId(review);
            if (companyReview == null){
                //如果 流程状态是 进行中 还是 完成
                int status = projectService.getProcessStatus(reserveManagement.getProjectReserveId());
                if (status == 1 || status == 2){
                    j.setSuccess(false);
                    j.setMsg(reserveManagement.getProjectReserveId() + "项目流程正在进行中或已完成，无法修改！");
                    return j;
                }
                //去掉之前的流程，重新开始流程
                reserveProcessService.deleteAct(reserveManagement.getProjectReserveId());

//                if (reserveManagement.getIncludeReserve().equals("是")){
                if (reserveManagement.getStartDesignOrNot().equals("是")){
                    //发起流程
                    ReserveSummaryProcess reserveProcess = new ReserveSummaryProcess();
                    reserveProcess.preInsert();
                    reserveProcess.setProjectReserveId(reserveManagement.getProjectReserveId());
                    //更新
                    reserveProcessService.insert(reserveProcess);
                    //发送流程，更改项目状态
                    Map<String, Object> vars = Maps.newHashMap();

                    ReserveProcessProject processProject = projectService.queryByProjectId(reserveManagement.getProjectReserveId());
                    //审核代理人
                    vars.put("manager", UserUtils.getByUserName(processProject.getDesigner()).getLoginName());
//                String procDefId = projectService.findDefId("cblc");
                    String procDefId = projectService.findDefId("cblcNew");
                    ProcessDefinition p = actProcessService.getProcessDefinition(procDefId);
                    String title = reserveManagement.getCurrentUser().getName() + "在" + DateUtils.getDateTime() + "发起" + p.getName();
                    actTaskService.startProcess(p.getKey(), "cg_personnel_activiti", reserveProcess.getId(), title, vars);
                    //删除之前的甲供材数据
//                reserveProcessService.deleteMaterial(processProject.getProjectName());
                    //修改基本信息表的 流程状态
                    projectService.updateProcessStatus(reserveManagement.getProjectReserveId(),1);
                }
                //新增或编辑表单保存
                statisticService.update(proId);
//            }else if (companyReview.getPassProvincialCompanyReview().equals("取消") & reserveManagement.getIncludeReserve().equals("是")){
            }else if (companyReview.getPassProvincialCompanyReview().equals("取消") & reserveManagement.getStartDesignOrNot().equals("是")){
                j.setSuccess(false);
                j.setMsg(reserveManagement.getProjectReserveId() + "项目未通过省公司评审，无法发起流程！");
                return j;
            }else {
                //如果 流程状态是 进行中 还是 完成
                int status = projectService.getProcessStatus(reserveManagement.getProjectReserveId());
                if (status == 1 || status == 2){
                    j.setSuccess(false);
                    j.setMsg(reserveManagement.getProjectReserveId() + "项目流程正在进行中或已完成，无法修改！");
                    return j;
                }
                //去掉之前的流程，重新开始流程
                reserveProcessService.deleteAct(reserveManagement.getProjectReserveId());

//                if (reserveManagement.getIncludeReserve().equals("是")){
                if (reserveManagement.getStartDesignOrNot().equals("是")){
                    //发起流程
                    ReserveSummaryProcess reserveProcess = new ReserveSummaryProcess();
                    reserveProcess.preInsert();
                    reserveProcess.setProjectReserveId(reserveManagement.getProjectReserveId());
                    //更新
                    reserveProcessService.insert(reserveProcess);
                    //发送流程，更改项目状态
                    Map<String, Object> vars = Maps.newHashMap();

                    ReserveProcessProject processProject = projectService.queryByProjectId(reserveManagement.getProjectReserveId());
                    //审核代理人
                    vars.put("manager", UserUtils.getByUserName(processProject.getDesigner()).getLoginName());
//                String procDefId = projectService.findDefId("cblc");
                    String procDefId = projectService.findDefId("cblcNew");
                    ProcessDefinition p = actProcessService.getProcessDefinition(procDefId);
                    String title = reserveManagement.getCurrentUser().getName() + "在" + DateUtils.getDateTime() + "发起" + p.getName();
                    actTaskService.startProcess(p.getKey(), "cg_personnel_activiti", reserveProcess.getId(), title, vars);
                    //删除之前的甲供材数据
//                reserveProcessService.deleteMaterial(processProject.getProjectName());
                    //修改基本信息表的 流程状态
                    projectService.updateProcessStatus(reserveManagement.getProjectReserveId(),1);
                }
            }
            //新增或编辑表单保存
            statisticService.update(proId);
        }
        j.setSuccess(true);
        j.setMsg("修改储备项目基本信息成功");
        return j;
    }

    /**
     * 导入Excel数据
     */
   /* @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:summaryStatistics:import")
    @RequestMapping(value = "import")
    public AjaxJson importBasic(@RequestParam("file") MultipartFile file, HttpServletResponse response, HttpServletRequest request) {
        AjaxJson j = new AjaxJson();
        try {
            ImportUtil importUtil = new ImportUtil(file, 0, 0);
            //获取导入表格所有数据
            List<ReserveSummary> reserveManagementList = ReserveProcessProjectProUtil.getSummaryUtil(importUtil);
            //查询已有的参数数据 并分类返回已存在数据和未存在数据
            Map map = statisticService.getExistProjectList(reserveManagementList);
            //未存在数据
            List<ReserveSummary> withoutList = (List<ReserveSummary>) map.get("without");
            //已存在数据
            List<ReserveSummary> existList = (List<ReserveSummary>) map.get("exist");

            //对未存在的数据进行批量导入
            if(withoutList.size()>0){
                statisticService.insertList(withoutList);
            }

            //对已存在的数据进行修改
            if(existList.size()>0){
                for (ReserveSummary reserveManagement : existList) {
                    statisticService.update(reserveManagement);
                }
            }
            int i = withoutList.size() + existList.size();
            j.setMsg("已成功导入" + i + "条项目储备信息记录");

        } catch (Exception e) {
            j.setSuccess(false);
            j.setMsg("导入项目储备信息失败！失败信息：" + e.getMessage());
        }
        return j;
    }
*/

    /**
     * 导入Excel数据
     */
    @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:summaryStatistics:import")
    @RequestMapping(value = "import")
    public AjaxJson importBasic(@RequestParam("file") MultipartFile file, HttpServletResponse response, HttpServletRequest request) {
        AjaxJson j = new AjaxJson();
        try {
            ImportUtil importUtil = new ImportUtil(file, 0, 0);
            //从库中查出所有的  项目储备编号
            List<String> proIdList = statisticService.getAllProId();
            //从基本数据表中，查出所有的  项目储备编号
            List<String> proIdList2 = statisticService.getAllProId2();
            //获取导入表格所有数据
            List<ReserveSummary> reserveManagementList = ReserveProcessProjectProUtil.getSummaryUtil(importUtil,proIdList,proIdList2);
            //查询已有的参数数据 并分类返回已存在数据和未存在数据
            Map map = statisticService.getExistProjectList(reserveManagementList);
            //未存在数据
            List<ReserveSummary> withoutList = (List<ReserveSummary>) map.get("without");
            //已存在数据
            List<ReserveSummary> existList = (List<ReserveSummary>) map.get("exist");

            if (withoutList.size()>0){
                for (ReserveSummary s : withoutList){
                    /*s.setOpenProcessStatus("1");
                    System.out.println("ReserveSummary：" + s);*/
                    statisticService.insert(s);

//                    if (s.getIncludeReserve().equals("是")){
                    if (s.getStartDesignOrNot().equals("是")){

                        ReserveSummaryProcess reserveProcess = new ReserveSummaryProcess();
                        reserveProcess.preInsert();
                        reserveProcess.setProjectReserveId(s.getProjectReserveId());
                        //更新
                        reserveProcessService.insert(reserveProcess);
                        //发送流程，更改项目状态
                        Map<String, Object> vars = Maps.newHashMap();

                        ReserveProcessProject processProject = projectService.queryByProjectId(s.getProjectReserveId());
                        //审核代理人
                        vars.put("manager", UserUtils.getByUserName(processProject.getDesigner()).getLoginName());
//                        String procDefId = projectService.findDefId("cblc");
                        String procDefId = projectService.findDefId("cblcNew");
                        ProcessDefinition p = actProcessService.getProcessDefinition(procDefId);
                        String title = s.getCurrentUser().getName() + "在" + DateUtils.getDateTime() + "发起" + p.getName();
                        actTaskService.startProcess(p.getKey(), "cg_personnel_activiti", reserveProcess.getId(), title, vars);
                        //删除之前的甲供材数据
//                        reserveProcessService.deleteMaterial(processProject.getProjectName());

                        //将历史的问题清空
                        statisticService.save(s);
                    }
                }
            }

            //对已存在的数据进行修改
            if(existList.size()>0){
                for (ReserveSummary reserveManagement : existList) {
                    //去掉之前的流程，重新开始流程
                    reserveProcessService.deleteAct(reserveManagement.getProjectReserveId());
                    statisticService.update(reserveManagement);
//                    if (reserveManagement.getIncludeReserve().equals("是")){
                    if (reserveManagement.getStartDesignOrNot().equals("是")){
                        ReserveSummaryProcess reserveProcess = new ReserveSummaryProcess();
                        reserveProcess.preInsert();
                        reserveProcess.setProjectReserveId(reserveManagement.getProjectReserveId());
                        //更新
                        reserveProcessService.insert(reserveProcess);
                        //发送流程，更改项目状态
                        Map<String, Object> vars = Maps.newHashMap();

                        ReserveProcessProject processProject = projectService.queryByProjectId(reserveManagement.getProjectReserveId());
                        vars.put("manager", UserUtils.getByUserName(processProject.getDesigner()).getLoginName());
//                        String procDefId = projectService.findDefId("cblc");
                        String procDefId = projectService.findDefId("cblcNew");
                        ProcessDefinition p = actProcessService.getProcessDefinition(procDefId);
                        String title = reserveManagement.getCurrentUser().getName() + "在" + DateUtils.getDateTime() + "发起" + p.getName();
                        actTaskService.startProcessNew(p.getKey(), "cg_personnel_activiti", reserveProcess.getId(), title, vars);
                        //删除之前的甲供材数据
//                        reserveProcessService.deleteMaterial(processProject.getProjectName());
                    }
                }
            }

            int i = withoutList.size() + existList.size();
            j.setMsg("已成功导入" + i + "条项目储备信息记录");
        } catch (Exception e) {
            j.setSuccess(false);
            j.setMsg("导入项目规模信息失败！失败信息：" + e.getMessage());
        }
        return j;
    }


    //导出excel
    @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:summaryStatistics:export")
    @RequestMapping(value = "export")
    public void exportExcel(ReserveSummary reserveManagement, HttpServletRequest request, HttpServletResponse response) {
        List<ReserveSummary> list = statisticService.exportFindList(reserveManagement);

        List<ReserveSummary> summaryList = new ArrayList<>();

        List<String> nameList = new ArrayList<>();
        //获取所有小类的名称
        List<PickList> pickListList = raiseCapitalService.newAllList();
        if (null != pickListList) {
            pickListList.forEach(k->{
                if (k.getName().equals("三、设备")){
                    k.getMdTheClassList().forEach(v->{
                        v.getMdSmallClassList().forEach(na->{
                            nameList.add(na.getName());
                        });
                    });
                }
            });
        }

        for (ReserveSummary summary : list) {

            //根据projectReserveId查出流程表的proc_ins_id
            String procInsId = statisticService.getByProjectReserveId(summary.getProjectReserveId());
            //根据procInsId查出历史流程名称和时间
            List<History> histories = statisticService.getHistoryByExecuteId(procInsId);
            String historyName = workService.getHistoryName(procInsId);
            //当size>0时待办有历史流程，
            if (histories.size()>0){
                //根据proc_ins_id去运行时任务节点表（act_ru_task）中查出当前流程名称
                String name = statisticService.getByExecuteId(procInsId);
                //设置项目进度
                if (StringUtils.isNotEmpty(name)){
                    summary.setReserveProgress(name);
                }else {
                    if (StringUtils.isNotBlank(historyName) && historyName.equals("技经人员审预算")){
                        summary.setReserveProgress("储备完成");
                    } else {
                        summary.setReserveProgress(name);
                    }
                }
            }else {
                summary.setReserveProgress("");
            }

            //根据项目储备id去在线开甲供材表中查询物理信息
            List<String> materialNameList = verificateService.getMaterialName(summary.getProjectName());
            if (null != nameList & null != materialNameList){
                nameList.forEach(n->{
                    if (StringUtils.isBlank(summary.getProjectNature())){
                        if (materialNameList.contains(n)){
                            summary.setProjectNature("资本");
                        } else {
                            summary.setProjectNature("成本");
                        }
                    }
                });
            }

            summaryList.add(summary);
        }

        //生成序列号
        int i = 1;
        for (ReserveSummary s : summaryList) {
            s.setId(String.valueOf(i));
            i++;
        }

        ReserveProcessProjectExportUtil util = ReserveProcessProjectExportUtil.getOne();
        XSSFWorkbook workbook = util.getWorkbook("summaryStatistics");
        util.exportSummary(response,workbook,summaryList);
    }


    /**
     * 专职人员增加，编辑表单页面
     * @param reserveManagement
     * @param model
     * @return
     */
    @RequiresPermissions(value={"cg:reservemanagementcenter:summaryStatistics:add","cg:reservemanagementcenter:summaryStatistics:edit"},logical= Logical.OR)
    @RequestMapping(value = "form")
    public String form(ReserveSummary reserveManagement, Model model) {

        //根据projectReserveId查出流程表的proc_ins_id
        String procInsId = statisticService.getByProjectReserveId(reserveManagement.getProjectReserveId());
        //根据procInsId查出历史流程名称和时间
        List<History> histories = statisticService.getHistoryByExecuteId(procInsId);
        //当size>0时待办有历史流程，
        if (histories.size()>0){
            //根据proc_ins_id去运行时任务节点表（act_ru_task）中查出当前流程名称
            String name = statisticService.getByExecuteId(procInsId);
            //设置项目进度
            reserveManagement.setReserveProgress(name);
        }else {
            reserveManagement.setReserveProgress("");
        }
        model.addAttribute("reserveManagement", reserveManagement);
        //判断id是否为空 如果未空则为新增 否则为修改
        if(StringUtils.isBlank(reserveManagement.getId())){
            return "modules/cg/reservemanagementcenter/reserveManage/summaryStatistics/reserveManagementForm";
        }
        return "modules/cg/reservemanagementcenter/reserveManage/summaryStatistics/reserveManagementModifyByzz";
    }

    /**
     * 电缆分段
     * 查看，增加，编辑提资表单表单页面
     */
    @RequestMapping(value = "cableSectionForm")
    public String cableSectionForm(String uuid, Model model,String projectName,String projectReserveId) {
        List<CableSectionData> cableSectionData = raiseCapitalDesignService.getCableSectionData();
        List<CableSectionInfo> cableFourHundredList = raiseCapitalDesignService.getCableSection(projectReserveId + "cableFourHundred","cableFourHundred");
        List<CableSectionInfo> cableHundredAndTwentyList = raiseCapitalDesignService.getCableSection(projectReserveId + "cableHundredAndTwenty","cableHundredAndTwenty");
        List<CableSectionInfo> cableThreeHundredList = raiseCapitalDesignService.getCableSection(projectReserveId + "cableThreeHundred","cableThreeHundred");
        List<CableSectionInfo> cableTwoHundredFortyList = raiseCapitalDesignService.getCableSection(projectReserveId + "cableTwoHundredForty","cableTwoHundredForty");
        List<CableSectionInfo> cableSeventyList = raiseCapitalDesignService.getCableSection(projectReserveId + "cableSeventy","cableSeventy");
        //获取电缆分段的系数
        String cableFactor = DictUtils.getDictLabel("cableFactor", "designCalculateCoefficient", "");
        model.addAttribute("cableFactor", cableFactor);
        model.addAttribute("cableSectionData", cableSectionData);
        model.addAttribute("cableFourHundredList", cableFourHundredList);
        model.addAttribute("cableHundredAndTwentyList", cableHundredAndTwentyList);
        model.addAttribute("cableThreeHundredList", cableThreeHundredList);
        model.addAttribute("cableTwoHundredFortyList", cableTwoHundredFortyList);
        model.addAttribute("cableSeventyList", cableSeventyList);
        model.addAttribute("uuid", uuid);
        model.addAttribute("projectName", projectName);
        model.addAttribute("projectReserveId", projectReserveId);
        return "modules/cg/reservemanagementcenter/raiseCapital/cableSectionForm";
    }

    /**
     * 电缆分段
     * 查看，增加，编辑提资表单表单页面
     */
    @RequestMapping(value = "cableSectionForm2")
    public String cableSectionForm2(String uuid, Model model,String projectName,String projectReserveId) {
        List<CableSectionData> cableSectionData = raiseCapitalDesignService.getCableSectionData();
        List<CableSectionInfo> cableFourHundredList = raiseCapitalDesignService.getCableSection(projectReserveId + "pw" + "cableFourHundred","cableFourHundred");
        List<CableSectionInfo> cableHundredAndTwentyList = raiseCapitalDesignService.getCableSection(projectReserveId + "pw" + "cableHundredAndTwenty","cableHundredAndTwenty");
        List<CableSectionInfo> cableThreeHundredList = raiseCapitalDesignService.getCableSection(projectReserveId + "pw" + "cableThreeHundred","cableThreeHundred");
        List<CableSectionInfo> cableTwoHundredFortyList = raiseCapitalDesignService.getCableSection(projectReserveId + "pw" + "cableTwoHundredForty","cableTwoHundredForty");
        List<CableSectionInfo> cableSeventyList = raiseCapitalDesignService.getCableSection(projectReserveId + "pw" + "cableSeventy","cableSeventy");
        //获取电缆分段的系数
        String cableFactor = DictUtils.getDictLabel("cableFactor", "designCalculateCoefficient", "");
        model.addAttribute("cableFactor", cableFactor);
        model.addAttribute("cableSectionData", cableSectionData);
        model.addAttribute("cableFourHundredList", cableFourHundredList);
        model.addAttribute("cableHundredAndTwentyList", cableHundredAndTwentyList);
        model.addAttribute("cableThreeHundredList", cableThreeHundredList);
        model.addAttribute("cableTwoHundredFortyList", cableTwoHundredFortyList);
        model.addAttribute("cableSeventyList", cableSeventyList);
        model.addAttribute("uuid", uuid);
        model.addAttribute("projectName", projectName);
        model.addAttribute("projectReserveId", projectReserveId);
        return "modules/cg/reservemanagementcenter/raiseCapital/cableSectionForm2";
    }

    /**
     * 跳转架空导线处理页面
     */
    //@RequiresPermissions(value={"test:raiseCapitalDesign:view","test:raiseCapitalDesign:add","test:raiseCapitalDesign:edit"},logical=Logical.OR)
    @RequestMapping(value = "aerialConductorForm")
    public String aerialConductorForm(String uuid,String item, Model model,String projectName) {
        //将新增页数据保存到redis中（item）
        //raiseCapitalDesignService.disposeFormData(uuid,item);
        //查询10KV计算系数
        String highSingleVoltageCoefficient = DictUtils.getDictLabel("highSingleVoltageCoefficient", "designCalculateCoefficient", "");
        String highDoubleVoltageCoefficient = DictUtils.getDictLabel("highDoubleVoltageCoefficient", "designCalculateCoefficient", "");
        //查询0.4KV计算系数
        String lowSingleVoltageCoefficient = DictUtils.getDictLabel("lowSingleVoltageCoefficient", "designCalculateCoefficient", "");
        String lowDoubleVoltageCoefficient = DictUtils.getDictLabel("lowDoubleVoltageCoefficient", "designCalculateCoefficient", "");
        //查询10KV数据
        List<VoltageInfo> highVoltageList = raiseCapitalDesignService.getAerialConductor(uuid + "highVoltage","highVoltage");
        //查询0.4KV数据
        List<VoltageInfo> lowVoltageList = raiseCapitalDesignService.getAerialConductor(uuid + "lowVoltage","lowVoltage");
        model.addAttribute("highSingleVoltageCoefficient", highSingleVoltageCoefficient);
        model.addAttribute("highDoubleVoltageCoefficient", highDoubleVoltageCoefficient);
        model.addAttribute("lowSingleVoltageCoefficient", lowSingleVoltageCoefficient);
        model.addAttribute("lowDoubleVoltageCoefficient", lowDoubleVoltageCoefficient);
        model.addAttribute("highVoltageList", highVoltageList);
        model.addAttribute("lowVoltageList", lowVoltageList);
        model.addAttribute("projectName", projectName);
        model.addAttribute("uuid", uuid);
        return "modules/cg/reservemanagementcenter/raiseCapital/aerialConductorForm";
    }

    /**
     * 跳转架空导线处理页面
     */
    //@RequiresPermissions(value={"test:raiseCapitalDesign:view","test:raiseCapitalDesign:add","test:raiseCapitalDesign:edit"},logical=Logical.OR)
    @RequestMapping(value = "aerialConductorForm2")
    public String aerialConductorForm2(String uuid,String item, Model model,String projectName) {
        //将新增页数据保存到redis中（item）
        //raiseCapitalDesignService.disposeFormData(uuid,item);
        //查询10KV计算系数
        String highSingleVoltageCoefficient = DictUtils.getDictLabel("highSingleVoltageCoefficient", "designCalculateCoefficient", "");
        String highDoubleVoltageCoefficient = DictUtils.getDictLabel("highDoubleVoltageCoefficient", "designCalculateCoefficient", "");
        //查询0.4KV计算系数
        String lowSingleVoltageCoefficient = DictUtils.getDictLabel("lowSingleVoltageCoefficient", "designCalculateCoefficient", "");
        String lowDoubleVoltageCoefficient = DictUtils.getDictLabel("lowDoubleVoltageCoefficient", "designCalculateCoefficient", "");
        //查询10KV数据
        List<VoltageInfo> highVoltageList = raiseCapitalDesignService.getAerialConductor(uuid + "highVoltage","highVoltage");
        //查询0.4KV数据
        List<VoltageInfo> lowVoltageList = raiseCapitalDesignService.getAerialConductor(uuid + "lowVoltage","lowVoltage");
        model.addAttribute("highSingleVoltageCoefficient", highSingleVoltageCoefficient);
        model.addAttribute("highDoubleVoltageCoefficient", highDoubleVoltageCoefficient);
        model.addAttribute("lowSingleVoltageCoefficient", lowSingleVoltageCoefficient);
        model.addAttribute("lowDoubleVoltageCoefficient", lowDoubleVoltageCoefficient);
        model.addAttribute("highVoltageList", highVoltageList);
        model.addAttribute("lowVoltageList", lowVoltageList);
        model.addAttribute("projectName", projectName);
        model.addAttribute("uuid", uuid);
        return "modules/cg/reservemanagementcenter/raiseCapital/aerialConductorForm2";
    }
}
