package com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity;

import com.jeeplus.core.persistence.DataEntity;

/**
 * 储备项目出图进度统计表
 * @author 王强
 * @version 1.0
 * @date 2023-10-08 9:23
 */
public class PlotProgressStats extends DataEntity<PlotProgressStats> {

    //储备项目基本信息
    private String projectYear;             //项目年份
    private String projectNature;           //项目性质
    private String demandUnit;              //需求单位
    private String district;                //区域
    private String projectGroup;            //项目分组
    private String projectManager;          //业主储备项目经理
    private String reserveBatches;          //储备批次
    private String blockSupply;             //供电区域
    private String gridNumber;              //网格编号
    private String cellNumber;              //单元格编号
    private String projectName;             //项目名称
    private String stateGridProjectCode;    //国网项目编码
    private String stateGridProjectName;    //国网项目名称
    private String constructionNecessityAndContent;           //建设必要性及内容
    private String substationName;           //变电站名称
    private String circuitName;              //线路名称
    private String netRackProjectDivide;     //网架项目划分
    private String requirementType;          //需求类型
    private String costEstimate;             //费用估算
    private String basicRemarks;             //备注

    private String reserveProgress;          //储备进度
    private String implementPlan;            //是否纳入实施计划
    private String implementBatch;           //初定实施批次

    private String projectReserveId;                //项目储备编号
    private String needPaperDrawing;                //是否需出纸质图
    private String askPaperDrawingTime;             //要求移交纸质图纸时间
    private String paperDrawing;                    //是否移交纸质图
    private String paperDrawingTime;                //纸质图移交时间
    private String arrivePlanAndApprovalDrawing;    //是否需出规划报批图
    private String askPlanAndApprovalDrawingTime;   //要求移交规划报批图时间
    private String planAndApprovalDrawing;          //是否移交规划报批图
    private String planAndApprovalDrawingTime;      //规划报批图移交时间
    private String remarks;                         //备注

    public String getProjectYear() {
        return projectYear;
    }

    public void setProjectYear(String projectYear) {
        this.projectYear = projectYear;
    }

    public String getProjectNature() {
        return projectNature;
    }

    public void setProjectNature(String projectNature) {
        this.projectNature = projectNature;
    }

    public String getDemandUnit() {
        return demandUnit;
    }

    public void setDemandUnit(String demandUnit) {
        this.demandUnit = demandUnit;
    }

    public String getDistrict() {
        return district;
    }

    public void setDistrict(String district) {
        this.district = district;
    }

    public String getProjectGroup() {
        return projectGroup;
    }

    public void setProjectGroup(String projectGroup) {
        this.projectGroup = projectGroup;
    }

    public String getProjectManager() {
        return projectManager;
    }

    public void setProjectManager(String projectManager) {
        this.projectManager = projectManager;
    }

    public String getReserveBatches() {
        return reserveBatches;
    }

    public void setReserveBatches(String reserveBatches) {
        this.reserveBatches = reserveBatches;
    }

    public String getBlockSupply() {
        return blockSupply;
    }

    public void setBlockSupply(String blockSupply) {
        this.blockSupply = blockSupply;
    }

    public String getGridNumber() {
        return gridNumber;
    }

    public void setGridNumber(String gridNumber) {
        this.gridNumber = gridNumber;
    }

    public String getCellNumber() {
        return cellNumber;
    }

    public void setCellNumber(String cellNumber) {
        this.cellNumber = cellNumber;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getStateGridProjectCode() {
        return stateGridProjectCode;
    }

    public void setStateGridProjectCode(String stateGridProjectCode) {
        this.stateGridProjectCode = stateGridProjectCode;
    }

    public String getStateGridProjectName() {
        return stateGridProjectName;
    }

    public void setStateGridProjectName(String stateGridProjectName) {
        this.stateGridProjectName = stateGridProjectName;
    }

    public String getConstructionNecessityAndContent() {
        return constructionNecessityAndContent;
    }

    public void setConstructionNecessityAndContent(String constructionNecessityAndContent) {
        this.constructionNecessityAndContent = constructionNecessityAndContent;
    }

    public String getSubstationName() {
        return substationName;
    }

    public void setSubstationName(String substationName) {
        this.substationName = substationName;
    }

    public String getCircuitName() {
        return circuitName;
    }

    public void setCircuitName(String circuitName) {
        this.circuitName = circuitName;
    }

    public String getNetRackProjectDivide() {
        return netRackProjectDivide;
    }

    public void setNetRackProjectDivide(String netRackProjectDivide) {
        this.netRackProjectDivide = netRackProjectDivide;
    }

    public String getRequirementType() {
        return requirementType;
    }

    public void setRequirementType(String requirementType) {
        this.requirementType = requirementType;
    }

    public String getCostEstimate() {
        return costEstimate;
    }

    public void setCostEstimate(String costEstimate) {
        this.costEstimate = costEstimate;
    }

    public String getBasicRemarks() {
        return basicRemarks;
    }

    public void setBasicRemarks(String basicRemarks) {
        this.basicRemarks = basicRemarks;
    }

    public String getReserveProgress() {
        return reserveProgress;
    }

    public void setReserveProgress(String reserveProgress) {
        this.reserveProgress = reserveProgress;
    }

    public String getImplementPlan() {
        return implementPlan;
    }

    public void setImplementPlan(String implementPlan) {
        this.implementPlan = implementPlan;
    }

    public String getImplementBatch() {
        return implementBatch;
    }

    public void setImplementBatch(String implementBatch) {
        this.implementBatch = implementBatch;
    }

    public String getProjectReserveId() {
        return projectReserveId;
    }

    public void setProjectReserveId(String projectReserveId) {
        this.projectReserveId = projectReserveId;
    }

    public String getNeedPaperDrawing() {
        return needPaperDrawing;
    }

    public void setNeedPaperDrawing(String needPaperDrawing) {
        this.needPaperDrawing = needPaperDrawing;
    }

    public String getAskPaperDrawingTime() {
        return askPaperDrawingTime;
    }

    public void setAskPaperDrawingTime(String askPaperDrawingTime) {
        this.askPaperDrawingTime = askPaperDrawingTime;
    }

    public String getPaperDrawing() {
        return paperDrawing;
    }

    public void setPaperDrawing(String paperDrawing) {
        this.paperDrawing = paperDrawing;
    }

    public String getPaperDrawingTime() {
        return paperDrawingTime;
    }

    public void setPaperDrawingTime(String paperDrawingTime) {
        this.paperDrawingTime = paperDrawingTime;
    }

    public String getArrivePlanAndApprovalDrawing() {
        return arrivePlanAndApprovalDrawing;
    }

    public void setArrivePlanAndApprovalDrawing(String arrivePlanAndApprovalDrawing) {
        this.arrivePlanAndApprovalDrawing = arrivePlanAndApprovalDrawing;
    }

    public String getAskPlanAndApprovalDrawingTime() {
        return askPlanAndApprovalDrawingTime;
    }

    public void setAskPlanAndApprovalDrawingTime(String askPlanAndApprovalDrawingTime) {
        this.askPlanAndApprovalDrawingTime = askPlanAndApprovalDrawingTime;
    }

    public String getPlanAndApprovalDrawing() {
        return planAndApprovalDrawing;
    }

    public void setPlanAndApprovalDrawing(String planAndApprovalDrawing) {
        this.planAndApprovalDrawing = planAndApprovalDrawing;
    }

    public String getPlanAndApprovalDrawingTime() {
        return planAndApprovalDrawingTime;
    }

    public void setPlanAndApprovalDrawingTime(String planAndApprovalDrawingTime) {
        this.planAndApprovalDrawingTime = planAndApprovalDrawingTime;
    }

    @Override
    public String getRemarks() {
        return remarks;
    }

    @Override
    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }
}
