package com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity;

import com.jeeplus.core.persistence.DataEntity;

/**
 * 储备项目设计特殊物资参数统计表
 * @author: 王强
 * @create: 2022-08-16 09:57
 **/
public class SpecialParameterStats extends DataEntity<SpecialParameterStats> {

    //储备项目基本信息
    private String projectYear;             //项目年份
    private String projectNature;           //项目性质
    private String demandUnit;              //需求单位
    private String district;                //区域
    private String projectGroup;            //项目分组
    private String projectManager;          //项目经理
    private String reserveBatches;          //储备批次
    private String blockSupply;             //供电区域
    private String gridNumber;              //网格编号
    private String cellNumber;              //单元格编号
    private String projectReserveId;        //项目储备编号
    private String projectName;             //项目名称
    private String stateGridProjectCode;    //国网项目编码
    private String stateGridProjectName;    //国网项目名称
    private String constructionNecessityAndContent;           //建设必要性及内容
    private String substationName;           //变电站名称
    private String circuitName;              //线路名称
    private String netRackProjectDivide;     //网架项目划分
    private String requirementType;          //需求类型
    private String projectType;              //项目类型
    private String costEstimate;             //费用估算
    //其他
    private String reserveProgress;          //储备进度
    private String implementPlan;            //是否纳入实施计划
    private String implementBatch;           //初定实施批次

    private String materialName;             //物资名称
    private String specificationAndModel;    //规格型号
    private String materialDescription;      //物资描述
    private String number;                   //数量
    private String parameter;                //参数
    private String remarks;                  //备注

    private String speId;

    public String getSpeId() {
        return speId;
    }

    public void setSpeId(String speId) {
        this.speId = speId;
    }

    public String getProjectYear() {
        return projectYear;
    }

    public void setProjectYear(String projectYear) {
        this.projectYear = projectYear;
    }

    public String getProjectNature() {
        return projectNature;
    }

    public void setProjectNature(String projectNature) {
        this.projectNature = projectNature;
    }

    public String getDemandUnit() {
        return demandUnit;
    }

    public void setDemandUnit(String demandUnit) {
        this.demandUnit = demandUnit;
    }

    public String getDistrict() {
        return district;
    }

    public void setDistrict(String district) {
        this.district = district;
    }

    public String getProjectGroup() {
        return projectGroup;
    }

    public void setProjectGroup(String projectGroup) {
        this.projectGroup = projectGroup;
    }

    public String getProjectManager() {
        return projectManager;
    }

    public void setProjectManager(String projectManager) {
        this.projectManager = projectManager;
    }

    public String getReserveBatches() {
        return reserveBatches;
    }

    public void setReserveBatches(String reserveBatches) {
        this.reserveBatches = reserveBatches;
    }

    public String getBlockSupply() {
        return blockSupply;
    }

    public void setBlockSupply(String blockSupply) {
        this.blockSupply = blockSupply;
    }

    public String getGridNumber() {
        return gridNumber;
    }

    public void setGridNumber(String gridNumber) {
        this.gridNumber = gridNumber;
    }

    public String getCellNumber() {
        return cellNumber;
    }

    public void setCellNumber(String cellNumber) {
        this.cellNumber = cellNumber;
    }

    public String getProjectReserveId() {
        return projectReserveId;
    }

    public void setProjectReserveId(String projectReserveId) {
        this.projectReserveId = projectReserveId;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getStateGridProjectCode() {
        return stateGridProjectCode;
    }

    public void setStateGridProjectCode(String stateGridProjectCode) {
        this.stateGridProjectCode = stateGridProjectCode;
    }

    public String getStateGridProjectName() {
        return stateGridProjectName;
    }

    public void setStateGridProjectName(String stateGridProjectName) {
        this.stateGridProjectName = stateGridProjectName;
    }

    public String getConstructionNecessityAndContent() {
        return constructionNecessityAndContent;
    }

    public void setConstructionNecessityAndContent(String constructionNecessityAndContent) {
        this.constructionNecessityAndContent = constructionNecessityAndContent;
    }

    public String getSubstationName() {
        return substationName;
    }

    public void setSubstationName(String substationName) {
        this.substationName = substationName;
    }

    public String getCircuitName() {
        return circuitName;
    }

    public void setCircuitName(String circuitName) {
        this.circuitName = circuitName;
    }

    public String getNetRackProjectDivide() {
        return netRackProjectDivide;
    }

    public void setNetRackProjectDivide(String netRackProjectDivide) {
        this.netRackProjectDivide = netRackProjectDivide;
    }

    public String getRequirementType() {
        return requirementType;
    }

    public void setRequirementType(String requirementType) {
        this.requirementType = requirementType;
    }

    public String getProjectType() {
        return projectType;
    }

    public void setProjectType(String projectType) {
        this.projectType = projectType;
    }

    public String getCostEstimate() {
        return costEstimate;
    }

    public void setCostEstimate(String costEstimate) {
        this.costEstimate = costEstimate;
    }

    public String getReserveProgress() {
        return reserveProgress;
    }

    public void setReserveProgress(String reserveProgress) {
        this.reserveProgress = reserveProgress;
    }

    public String getImplementPlan() {
        return implementPlan;
    }

    public void setImplementPlan(String implementPlan) {
        this.implementPlan = implementPlan;
    }

    public String getImplementBatch() {
        return implementBatch;
    }

    public void setImplementBatch(String implementBatch) {
        this.implementBatch = implementBatch;
    }

    public String getMaterialName() {
        return materialName;
    }

    public void setMaterialName(String materialName) {
        this.materialName = materialName;
    }

    public String getSpecificationAndModel() {
        return specificationAndModel;
    }

    public void setSpecificationAndModel(String specificationAndModel) {
        this.specificationAndModel = specificationAndModel;
    }

    public String getMaterialDescription() {
        return materialDescription;
    }

    public void setMaterialDescription(String materialDescription) {
        this.materialDescription = materialDescription;
    }

    public String getNumber() {
        return number;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    public String getParameter() {
        return parameter;
    }

    public void setParameter(String parameter) {
        this.parameter = parameter;
    }

    @Override
    public String getRemarks() {
        return remarks;
    }

    @Override
    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }
}
