package com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.BudgetStats;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.PlotProgressStats;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-10-08 9:26
 */
@MyBatisMapper
public interface PlotProgressStatsMapper extends BaseMapper<PlotProgressStats> {

    /**
     * 根据项目储备id删除对应数据
     * @param proId
     */
    void deleteByProId(String proId);

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId();

    /**
     * 导出数据查询
     * @param budgetStats
     * @return
     */
    List<PlotProgressStats> exportFindList(PlotProgressStats budgetStats);

    /**
     * 批量添加储备项目出图进度统计表信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<PlotProgressStats> list);
}
