package com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.FeedBackBudget;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.ProgressStats;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 储备进度统计表
 * @author: 王强
 * @create: 2022-08-17 15:23
 **/
@MyBatisMapper
public interface ProgressStatsMapper extends BaseMapper<ProgressStats> {

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId();

    /**
     * 根据 ProInsId 和时间 去历史节点表查退回意见
     * @param proInsId
     * @return
     */
    String getCommentByProInsId(@Param("proInsId") String proInsId, @Param("time")String time);

    /**
     * 根据项目储备id删除对应数据
     * @param proId
     */
    void deleteByProId(String proId);

    /**
     * 批量添加储备项目概预算统计信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<ProgressStats> list);

    int selectCount(String projectReserveId);

    /**
     * 导出数据查询
     * @param progressStats
     * @return
     */
    List<ProgressStats> exportFindList(ProgressStats progressStats);

    /**
     * 根据projectReserveId查出proc_ins_id
     * @param projectReserveId
     * @return
     */
    String getByProjectReserveId(String projectReserveId);

    /**
     * 根据projectReserveId查出proc_ins_id
     * @param projectReserveId
     * @return
     */
    String getDistributionByProjectReserveId(String projectReserveId);

    /**
     * 根据proInsId 和节点名称去 历史表中 查设计单位节点信息
     * @param proInsId
     * @param name
     * @return
     */
    List<History> getHistoryByProInsId(@Param("proInsId") String proInsId, @Param("name") String name);

    /**
     * 根据项目储备id查反馈信息
     * @return
     */
    FeedBackBudget getByProId(String proId);

    History getHistoryByStartTime(String endTime);
}
