package com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.MaterialData;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.SpecialParameterStats;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-10-08 15:23
 */
@MyBatisMapper
public interface SpecialParameterStatsMapper extends BaseMapper<SpecialParameterStats> {

    /**
     * 根据项目储备id删除对应数据
     * @param proId
     */
    void deleteByProId(String proId);

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId();

    /**
     * 导出数据查询
     * @param budgetStats
     * @return
     */
    List<SpecialParameterStats> exportFindList(SpecialParameterStats budgetStats);

    /**
     * 批量添加储备项目出图进度统计表信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<SpecialParameterStats> list);

    /**
     * 获取所有的在线开甲供材物料数据
     * @return
     */
    List<MaterialData> getAllMaterialData();

    void deleteById(String id);
}
