package com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.service;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.BudgetStats;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.PlotProgressStats;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.mapper.PlotProgressStatsMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-10-08 9:28
 */
@Service
@Transactional(readOnly = true)
public class PlotProgressStatsService extends CrudService<PlotProgressStatsMapper, PlotProgressStats> {

    @Autowired
    private PlotProgressStatsMapper dao;


    /**
     * 根据项目储备编号删除方法
     * @param proId
     */
    @Transactional(readOnly = false)
    public void deleteByProId(String proId) {
        dao.deleteByProId(proId);
    }

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    public List<String> getAllProId(){
        return dao.getAllProId();
    }

    @Transactional(readOnly = false)
    public void insertList(@Param("list") List<PlotProgressStats> list){
        List<PlotProgressStats> statsList = dao.exportFindList(null);
        for(PlotProgressStats budgetStats : list){
            statsList.forEach(sta->{
                if (sta.getProjectReserveId().equals(budgetStats.getProjectReserveId())){
                    dao.deleteByProId(sta.getProjectReserveId());
                }
            });
            budgetStats.preInsert();
        }

        dao.insertList(list);
    }

    public List<PlotProgressStats> exportFindList(PlotProgressStats budgetStats) {
        List<PlotProgressStats> pageList = dao.exportFindList(budgetStats);
        return pageList;
    }

    public Page<PlotProgressStats> findPage(Page<PlotProgressStats> page, PlotProgressStats budgetStats) {
        Page<PlotProgressStats> pageList = super.findPage(page, budgetStats);
        return pageList;
    }
}
