package com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.service;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.MaterialData;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.SpecialParameterStats;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.mapper.SpecialParameterStatsMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.UUID;

/**
 * @author 王强
 * @version 1.0
 * @date 2023-10-08 15:24
 */
@Service
@Transactional(readOnly = true)
public class SpecialParameterStatsService extends CrudService<SpecialParameterStatsMapper, SpecialParameterStats> {

    @Autowired
    private SpecialParameterStatsMapper dao;

    public Page<SpecialParameterStats> findPage(Page<SpecialParameterStats> page, SpecialParameterStats budgetStats) {
        Page<SpecialParameterStats> pageList = super.findPage(page, budgetStats);
        return pageList;
    }

    /**
     * 根据项目储备编号删除方法
     * @param proId
     */
    @Transactional(readOnly = false)
    public void deleteByProId(String proId) {
        dao.deleteByProId(proId);
    }

    /**
     * 删除方法
     * @param id
     */
    @Transactional(readOnly = false)
    public void deleteById(String id) {
        dao.deleteById(id);
    }

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    public List<String> getAllProId(){
        return dao.getAllProId();
    }

    @Transactional(readOnly = false)
    public void insertList(@Param("list") List<SpecialParameterStats> list){
        List<SpecialParameterStats> statsList = dao.exportFindList(null);
        for(SpecialParameterStats budgetStats : list){
            statsList.forEach(sta->{
                if (sta.getProjectReserveId().equals(budgetStats.getProjectReserveId())){
                    dao.deleteByProId(sta.getProjectReserveId());
                }
            });
            // 生成id值
            budgetStats.preInsert();
            String id = UUID.randomUUID().toString().replace("-", "");
            budgetStats.setId(id);


        }

        dao.insertList(list);
    }

    public List<SpecialParameterStats> exportFindList(SpecialParameterStats budgetStats) {
        List<SpecialParameterStats> pageList = dao.exportFindList(budgetStats);
        return pageList;
    }

    public List<MaterialData> getAllMaterialData() {
        return dao.getAllMaterialData();
    }
}
