package com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.web;

import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.Cable;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.service.BudgetStatsService;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.service.CableService;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.util.ExcelExportUtil;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.util.ExcelImportUtil;
import com.jeeplus.modules.sg.managementcenter.materialproject.util.ImportUtil;
import com.jeeplus.modules.sg.raiseCapitalDesign.entity.CableSectionInfo;
import com.jeeplus.modules.sg.raiseCapitalDesign.service.RaiseCapitalDesignService;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.apache.shiro.authz.annotation.Logical;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 电缆段长统计表 controller
 * @author: 王强
 * @create: 2022-11-04 09:04
 **/
@Controller
@RequestMapping(value = "${adminPath}/cg/reservemanagementcenter/cable")
public class CableController extends BaseController {

    @Autowired
    private CableService cableService;

    @Autowired
    private BudgetStatsService statsService;

    @Autowired
    private RaiseCapitalDesignService raiseCapitalDesignService;

    @ModelAttribute
    public Cable get(@RequestParam(required = false) String id) {
        Cable entity = null;
        if (StringUtils.isNotBlank(id)) {
            entity = cableService.get(id);
        }
        if (entity == null) {
            entity = new Cable();
        }
        return entity;
    }

    /**
     * 电缆段长统计表页面
     * @param cable
     * @param model
     * @return
     */
    @RequiresPermissions("cg:reservemanagementcenter:cable:list")
    @RequestMapping(value = "cableList")
    public String budgetList(Cable cable, Model model) {
        model.addAttribute("cable", cable);
        return "modules/cg/statisticalTable/cable/cable";
    }

    /**
     * 储备项目概预算数据列表
     * @param cable
     * @param request
     * @param response
     * @param model
     * @return
     */
    @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:cable:list")
    @RequestMapping(value = "list")
    public Map<String, Object> basicData(Cable cable, HttpServletRequest request, HttpServletResponse response, Model model) throws ParseException {

        Page<Cable> page = cableService.findPage(new Page<Cable>(request, response), cable);

        List<Cable> list = page.getList();
        List<Cable> cableList = new ArrayList<>();
        Cable ca = null;
        for (int i=0;i<list.size();i++){
            ca = list.get(i);
            String uuid = cableService.getRedisIdByProjectReserveId(ca.getProjectReserveId());
            List<CableSectionInfo> cableFourHundredList = raiseCapitalDesignService.getCableSection(ca.getProjectReserveId() + "cableFourHundred","cableFourHundred");
            List<CableSectionInfo> cableHundredAndTwentyList = raiseCapitalDesignService.getCableSection(ca.getProjectReserveId() + "cableHundredAndTwenty","cableHundredAndTwenty");
            List<CableSectionInfo> cableThreeHundredList = raiseCapitalDesignService.getCableSection(ca.getProjectReserveId() + "cableThreeHundred","cableThreeHundred");
            List<CableSectionInfo> cableTwoHundredFortyList = raiseCapitalDesignService.getCableSection(ca.getProjectReserveId() + "cableTwoHundredForty","cableTwoHundredForty");
            List<CableSectionInfo> cableSeventyList = raiseCapitalDesignService.getCableSection(ca.getProjectReserveId() + "cableSeventy","cableSeventy");
            ca.setReserveProgress(statsService.getReserveProgress(ca.getProjectReserveId()));

            ca.setDestination("");
            ca.setPathLength("");
            ca.setUpperRod("");
            ca.setArrival("");
            ca.setIncomingEquipment("");
            ca.setCoefficient("");
            ca.setElectricalChief("");
            //进行赋值操作
            ca.setReserveProgress(statsService.getReserveProgress(ca.getProjectReserveId()));
            ca.setSpecifications("");
            //给起讫点-电气长赋值
            if ((null!=cableFourHundredList && cableFourHundredList.size()>0)
                    || (null !=cableHundredAndTwentyList && cableHundredAndTwentyList.size()>0)
                    || (null != cableThreeHundredList && cableThreeHundredList.size()>0)
                    || (null != cableTwoHundredFortyList && cableTwoHundredFortyList.size()>0)
                    || (null != cableSeventyList && cableSeventyList.size()>0)) {
                if (null != cableFourHundredList && cableFourHundredList.size()>0){
                    for (int j=0;j<cableFourHundredList.size();j++){
                        Cable te = new Cable();
                        BeanUtils.copyProperties(ca,te);
                        te.setDestination(cableFourHundredList.get(j).getDestination());
                        te.setPathLength(cableFourHundredList.get(j).getPathLength());
                        te.setUpperRod(cableFourHundredList.get(j).getUpperRod());
                        te.setArrival(cableFourHundredList.get(j).getArrival());
                        te.setIncomingEquipment(cableFourHundredList.get(j).getIncomingEquipment());
                        te.setCoefficient(cableFourHundredList.get(j).getCoefficient());
                        te.setElectricalChief(cableFourHundredList.get(j).getElectricalChief());
                        te.setSpecifications("YJV22-3×400mm²");
                        //进行赋值操作
                        te.setReserveProgress(ca.getReserveProgress());
                        cableList.add(te);
                    }
                }
                if (null != cableHundredAndTwentyList){
                    for (int j=0;j<cableHundredAndTwentyList.size();j++){
                        Cable te = new Cable();
                        BeanUtils.copyProperties(ca,te);
                        te.setDestination(cableHundredAndTwentyList.get(j).getDestination());
                        te.setPathLength(cableHundredAndTwentyList.get(j).getPathLength());
                        te.setUpperRod(cableHundredAndTwentyList.get(j).getUpperRod());
                        te.setArrival(cableHundredAndTwentyList.get(j).getArrival());
                        te.setIncomingEquipment(cableHundredAndTwentyList.get(j).getIncomingEquipment());
                        te.setCoefficient(cableHundredAndTwentyList.get(j).getCoefficient());
                        te.setElectricalChief(cableHundredAndTwentyList.get(j).getElectricalChief());
                        te.setSpecifications("YJV22-3×120mm²");
                        //进行赋值操作
                        te.setReserveProgress(statsService.getReserveProgress(ca.getProjectReserveId()));
                        cableList.add(te);
                    }
                }
                if (null != cableThreeHundredList){
                    for (int j=0;j<cableThreeHundredList.size();j++){
                        Cable te = new Cable();
                        BeanUtils.copyProperties(ca,te);
                        te.setDestination(cableThreeHundredList.get(j).getDestination());
                        te.setPathLength(cableThreeHundredList.get(j).getPathLength());
                        te.setUpperRod(cableThreeHundredList.get(j).getUpperRod());
                        te.setArrival(cableThreeHundredList.get(j).getArrival());
                        te.setIncomingEquipment(cableThreeHundredList.get(j).getIncomingEquipment());
                        te.setCoefficient(cableThreeHundredList.get(j).getCoefficient());
                        te.setElectricalChief(cableThreeHundredList.get(j).getElectricalChief());
                        te.setSpecifications("YJV22-3×300mm²");
                        //进行赋值操作
                        te.setReserveProgress(statsService.getReserveProgress(ca.getProjectReserveId()));
                        cableList.add(te);
                    }
                }
                if (null != cableTwoHundredFortyList){
                    for (int j=0;j<cableTwoHundredFortyList.size();j++){
                        Cable te = new Cable();
                        BeanUtils.copyProperties(ca,te);
                        te.setDestination(cableTwoHundredFortyList.get(j).getDestination());
                        te.setPathLength(cableTwoHundredFortyList.get(j).getPathLength());
                        te.setUpperRod(cableTwoHundredFortyList.get(j).getUpperRod());
                        te.setArrival(cableTwoHundredFortyList.get(j).getArrival());
                        te.setIncomingEquipment(cableTwoHundredFortyList.get(j).getIncomingEquipment());
                        te.setCoefficient(cableTwoHundredFortyList.get(j).getCoefficient());
                        te.setElectricalChief(cableTwoHundredFortyList.get(j).getElectricalChief());
                        te.setSpecifications("YJV22-3×240mm²");
                        //进行赋值操作
                        te.setReserveProgress(statsService.getReserveProgress(ca.getProjectReserveId()));
                        cableList.add(te);
                    }
                }
                if (null != cableSeventyList){
                    for (int j=0;j<cableSeventyList.size();j++){
                        Cable te = new Cable();
                        BeanUtils.copyProperties(ca,te);
                        te.setDestination(cableSeventyList.get(j).getDestination());
                        te.setPathLength(cableSeventyList.get(j).getPathLength());
                        te.setUpperRod(cableSeventyList.get(j).getUpperRod());
                        te.setArrival(cableSeventyList.get(j).getArrival());
                        te.setIncomingEquipment(cableSeventyList.get(j).getIncomingEquipment());
                        te.setCoefficient(cableSeventyList.get(j).getCoefficient());
                        te.setElectricalChief(cableSeventyList.get(j).getElectricalChief());
                        te.setSpecifications("YJV22-3×70mm²");
                        //进行赋值操作
                        te.setReserveProgress(statsService.getReserveProgress(ca.getProjectReserveId()));
                        cableList.add(te);
                    }
                }
            } else {
                cableList.add(ca);
            }


        }
        page.setList(cableList);
        return getBootstrapData(page);
    }

    /**
     * 删除表单
     */
    @ResponseBody
    @RequiresPermissions(value={"cg:reservemanagementcenter:cable:del"},logical= Logical.OR)
    @RequestMapping(value = "deleteAll")
    public AjaxJson delete(String ids){
        AjaxJson j = new AjaxJson();
        String idArray[] =ids.split(",");
        for(String id : idArray){
            cableService.deleteByProId(cableService.get(id).getProjectReserveId());
        }
        j.setMsg("删除电缆段长统计表信息成功");
        return j;
    }

    /**
     *  导入Excel数据
     */
    @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:cable:import")
    @RequestMapping(value = "import")
    public AjaxJson importBasic(@RequestParam("file") MultipartFile file, HttpServletResponse response, HttpServletRequest request) {
        AjaxJson j = new AjaxJson();
        try {
            ImportUtil importUtil = new ImportUtil(file, 0, 0);
            //从数据库中查出所有的 项目储备编号
            List<String> proIdList = cableService.getAllProId();
            //获取导入表格所有数据
            List<Cable> cables = ExcelImportUtil.getCableUtil(importUtil,proIdList);
            cableService.insertList(cables);
        } catch (Exception e) {
            j.setSuccess(false);
            j.setMsg("导入储备项目概预算信息失败！失败信息：" + e.getMessage());
        }
        return j;
    }

    //导出excel
    @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:cable:export")
    @RequestMapping(value = "export")
    public void exportExcel(Cable cable, HttpServletRequest request, HttpServletResponse response) throws ParseException {
        List<Cable> list = cableService.exportFindList(cable);

        List<Cable> cableList = new ArrayList<>();
        Cable ca = null;
        for (int i=0;i<list.size();i++){
            ca = list.get(i);
            String uuid = cableService.getRedisIdByProjectReserveId(ca.getProjectReserveId());
            List<CableSectionInfo> cableFourHundredList = raiseCapitalDesignService.getCableSection(ca.getProjectReserveId() + "cableFourHundred","cableFourHundred");
            List<CableSectionInfo> cableHundredAndTwentyList = raiseCapitalDesignService.getCableSection(ca.getProjectReserveId() + "cableHundredAndTwenty","cableHundredAndTwenty");
            List<CableSectionInfo> cableThreeHundredList = raiseCapitalDesignService.getCableSection(ca.getProjectReserveId() + "cableThreeHundred","cableThreeHundred");
            List<CableSectionInfo> cableTwoHundredFortyList = raiseCapitalDesignService.getCableSection(ca.getProjectReserveId() + "cableTwoHundredForty","cableTwoHundredForty");
            List<CableSectionInfo> cableSeventyList = raiseCapitalDesignService.getCableSection(ca.getProjectReserveId() + "cableSeventy","cableSeventy");

            ca.setDestination("");
            ca.setPathLength("");
            ca.setUpperRod("");
            ca.setArrival("");
            ca.setIncomingEquipment("");
            ca.setCoefficient("");
            ca.setElectricalChief("");
            //进行赋值操作
            ca.setReserveProgress(statsService.getReserveProgress(ca.getProjectReserveId()));
            ca.setSpecifications("");

            //给起讫点-电气长赋值
            if ((null!=cableFourHundredList && cableFourHundredList.size()>0)
                    || (null !=cableHundredAndTwentyList && cableHundredAndTwentyList.size()>0)
                    || (null != cableThreeHundredList && cableThreeHundredList.size()>0)
                    || (null != cableTwoHundredFortyList && cableTwoHundredFortyList.size()>0)
                    || (null != cableSeventyList && cableSeventyList.size()>0)) {
                if (null != cableFourHundredList && cableFourHundredList.size()>0){
                    for (int j=0;j<cableFourHundredList.size();j++){
                        Cable te = new Cable();
                        BeanUtils.copyProperties(ca,te);
                        te.setDestination(cableFourHundredList.get(j).getDestination());
                        te.setPathLength(cableFourHundredList.get(j).getPathLength());
                        te.setUpperRod(cableFourHundredList.get(j).getUpperRod());
                        te.setArrival(cableFourHundredList.get(j).getArrival());
                        te.setIncomingEquipment(cableFourHundredList.get(j).getIncomingEquipment());
                        te.setCoefficient(cableFourHundredList.get(j).getCoefficient());
                        te.setElectricalChief(cableFourHundredList.get(j).getElectricalChief());
                        te.setSpecifications("YJV22-3×400mm²");
                        //进行赋值操作
                        te.setReserveProgress(ca.getReserveProgress());
                        cableList.add(te);
                    }
                }
                if (null != cableHundredAndTwentyList){
                    for (int j=0;j<cableHundredAndTwentyList.size();j++){
                        Cable te = new Cable();
                        BeanUtils.copyProperties(ca,te);
                        te.setDestination(cableHundredAndTwentyList.get(j).getDestination());
                        te.setPathLength(cableHundredAndTwentyList.get(j).getPathLength());
                        te.setUpperRod(cableHundredAndTwentyList.get(j).getUpperRod());
                        te.setArrival(cableHundredAndTwentyList.get(j).getArrival());
                        te.setIncomingEquipment(cableHundredAndTwentyList.get(j).getIncomingEquipment());
                        te.setCoefficient(cableHundredAndTwentyList.get(j).getCoefficient());
                        te.setElectricalChief(cableHundredAndTwentyList.get(j).getElectricalChief());
                        te.setSpecifications("YJV22-3×120mm²");
                        //进行赋值操作
                        te.setReserveProgress(statsService.getReserveProgress(ca.getProjectReserveId()));
                        cableList.add(te);
                    }
                }
                if (null != cableThreeHundredList){
                    for (int j=0;j<cableThreeHundredList.size();j++){
                        Cable te = new Cable();
                        BeanUtils.copyProperties(ca,te);
                        te.setDestination(cableThreeHundredList.get(j).getDestination());
                        te.setPathLength(cableThreeHundredList.get(j).getPathLength());
                        te.setUpperRod(cableThreeHundredList.get(j).getUpperRod());
                        te.setArrival(cableThreeHundredList.get(j).getArrival());
                        te.setIncomingEquipment(cableThreeHundredList.get(j).getIncomingEquipment());
                        te.setCoefficient(cableThreeHundredList.get(j).getCoefficient());
                        te.setElectricalChief(cableThreeHundredList.get(j).getElectricalChief());
                        te.setSpecifications("YJV22-3×300mm²");
                        //进行赋值操作
                        te.setReserveProgress(statsService.getReserveProgress(ca.getProjectReserveId()));
                        cableList.add(te);
                    }
                }
                if (null != cableTwoHundredFortyList){
                    for (int j=0;j<cableTwoHundredFortyList.size();j++){
                        Cable te = new Cable();
                        BeanUtils.copyProperties(ca,te);
                        te.setDestination(cableTwoHundredFortyList.get(j).getDestination());
                        te.setPathLength(cableTwoHundredFortyList.get(j).getPathLength());
                        te.setUpperRod(cableTwoHundredFortyList.get(j).getUpperRod());
                        te.setArrival(cableTwoHundredFortyList.get(j).getArrival());
                        te.setIncomingEquipment(cableTwoHundredFortyList.get(j).getIncomingEquipment());
                        te.setCoefficient(cableTwoHundredFortyList.get(j).getCoefficient());
                        te.setElectricalChief(cableTwoHundredFortyList.get(j).getElectricalChief());
                        te.setSpecifications("YJV22-3×240mm²");
                        //进行赋值操作
                        te.setReserveProgress(statsService.getReserveProgress(ca.getProjectReserveId()));
                        cableList.add(te);
                    }
                }
                if (null != cableSeventyList){
                    for (int j=0;j<cableSeventyList.size();j++){
                        Cable te = new Cable();
                        BeanUtils.copyProperties(ca,te);
                        te.setDestination(cableSeventyList.get(j).getDestination());
                        te.setPathLength(cableSeventyList.get(j).getPathLength());
                        te.setUpperRod(cableSeventyList.get(j).getUpperRod());
                        te.setArrival(cableSeventyList.get(j).getArrival());
                        te.setIncomingEquipment(cableSeventyList.get(j).getIncomingEquipment());
                        te.setCoefficient(cableSeventyList.get(j).getCoefficient());
                        te.setElectricalChief(cableSeventyList.get(j).getElectricalChief());
                        te.setSpecifications("YJV22-3×70mm²");
                        //进行赋值操作
                        te.setReserveProgress(statsService.getReserveProgress(ca.getProjectReserveId()));
                        cableList.add(te);
                    }
                }
            } else {
                cableList.add(ca);
            }
        }

        ExcelExportUtil util = ExcelExportUtil.getOne();
        XSSFWorkbook workbook = util.getWorkbook("cable");
        util.exportCable(response,workbook,cableList);
    }
}
