<%@ page contentType="text/html;charset=UTF-8" %>
    <script >
    $(document).ready(function () {
        var id = document.getElementById("id").value
        $('#projectTable').bootstrapTable({
            //请求方法
            method: 'post',
            //类型json
            dataType: "json",
            contentType: "application/x-www-form-urlencoded",
            //显示检索按钮
            showSearch: true,
            //显示刷新按钮
            showRefresh: true,
            //显示切换手机试图按钮
            showToggle: true,
            //显示 内容列下拉框
            showColumns: true,
            //显示到处按钮
            showExport: true,
            //显示切换分页按钮
            showPaginationSwitch: true,
            //最低显示2行
            minimumCountColumns: 2,
            //是否显示行间隔色
            striped: true,
            //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
            cache: false,
            //是否显示分页（*）
            pagination: false,
            //排序方式
            sortOrder: "asc",
            //初始化加载第一页，默认第一页
            pageNumber: 1,
            //每页的记录行数（*）
            pageSize: 25,
            //可供选择的每页的行数（*）
            pageList: [5, 10, 25, 50, 100],
            //这个接口需要处理bootstrap table传递的固定参数,并返回特定格式的json数据
            url: "${ctx}/cg/infrastructure/infrastructureBasicInfo/reviewList?id=" + id,
            //默认值为 'limit',传给服务端的参数为：limit, offset, search, sort, order Else
            //queryParamsType:'',
            ////查询参数,每次调用是会带上这个参数，可自定义
            queryParams: function (params) {
                var searchParam = $("#searchForm").serializeJSON();
                searchParam.pageNo = params.limit === undefined ? "1" : params.offset / params.limit + 1;
                searchParam.pageSize = params.limit === undefined ? -1 : params.limit;
                searchParam.orderBy = params.sort === undefined ? "" : params.sort + " " + params.order;
                return searchParam;
            },
            //分页方式：client客户端分页，server服务端分页（*）
            sidePagination: "server",
            contextMenuTrigger: "right",//pc端 按右键弹出菜单
            contextMenuTriggerMobile: "press",//手机端 弹出菜单，click：单击， press：长按。
            contextMenu: '#context-menu',
            onContextMenuItem: function (row, $el) {
                if ($el.data("item") == "edit") {
                    edit(row.id);
                } else if ($el.data("item") == "view") {
                    view(row.id);
                } else if ($el.data("item") == "delete") {
                    jp.confirm('确认要删除该表单记录吗？', function () {
                        jp.loading();
                        jp.get("${ctx}/cg/infrastructure/infrastructureBasicInfo/delete?id=" + row.id, function (data) {
                            if (data.success) {
                                $('#projectTable').bootstrapTable('refresh');
                                jp.success(data.msg);
                            } else {
                                jp.error(data.msg);
                            }
                        })
                    });
                }
            },
            onLoadSuccess: function () {  //加载成功时执行
                var data = $("#projectTable").bootstrapTable('getData', true)
                //合并单元格
                mergeTable($('#projectTable'),"projectName");
                mergeTable($('#projectTable'),"projectCode");
                mergeTable($('#projectTable'),"isItInvolved");
                mergeTable($('#projectTable'),"phase");
                mergeTable($('#projectTable'),"preliminaryDesignInternalReview");
                mergeTable($('#projectTable'),"preliminaryDesignReviewPlan");
                mergeTable($('#projectTable'),"preliminaryExternalAuditReview");
                mergeTable($('#projectTable'),"preliminaryDesignReviewComments");
                mergeTable($('#projectTable'),"constructionDrawingReviewPlan");
                mergeTable($('#projectTable'),"constructionDrawingReview");
            },
            onClickRow: function (row, $el) {
            },
            onShowSearch: function () {
                $("#search-collapse").slideToggle();
            },
            columns:
                [
                    [
                        {"title":"评审计划安排信息(非新建变电站)","colspan":14,width: "2800px",align: "left"},
                    ],
                    [
                        {field:'projectName',title: '项目名称',valign:"middle",align: "center"},
                        {field:'projectCode',title: '项目编码',valign:"middle",align: "center"},
                        {field:'isItInvolved',title: '是否涉及新建变电站',valign:"middle",align: "center"
                        },
                        {field:'phase',title: '项目阶段',valign:"middle",align: "center"},
                        {field:'preliminaryDesignInternalReview',title: '（一）初步设计内审',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                                } else {
                                    return value;
                                }
                            }
                        },
                        {field:'preliminaryDesignReviewPlan',title: '（二）初步设计评审计划',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                                } else {
                                    return value;
                                }
                            }
                        },
                        {field:'preliminaryExternalAuditReview',title: '（三）初设外审评审',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                                } else {
                                    return value;
                                }
                            }
                        },
                        {field:'preliminaryDesignReviewComments',title: '（四）初设评审意见',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                // 判断value是否 有  -
                                var hasDash = value.includes('&');
                                var result = '';
                                if (hasDash) {
                                    // 如果包含 "-" 字符，则执行相应的操作
                                    // ...
                                    var splitValues = value.split('&');
                                    result = splitValues.length > 1 ? splitValues[1].trim() : '';
                                } else {
                                    // 如果不包含 "-" 字符，则执行相应的操作
                                    // ...
                                    result = value;
                                }
                                if (index === 0) {

                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + result + '" onchange="getValue(event, ' + index + ')">';
                                } else {
                                    return result;
                                }

                            }
                        },
                        {field:'constructionDrawingReviewPlan',title: '（五）施工图评审计划',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                // 判断value是否 有  -
                                var hasDash = value.includes('&');
                                var result = '';
                                if (hasDash) {
                                    // 如果包含 "-" 字符，则执行相应的操作
                                    // ...
                                    var dashCount = value.split('&').length - 1;
                                    if (dashCount === 1){
                                        var splitValues = value.split('&');
                                        result = splitValues.length > 1 ? splitValues[1].trim() : '';
                                    } else {
                                        // 获取第一个 - 的位置
                                        var firstDashIndex = value.indexOf('&');
                                        var secondDashIndex = value.indexOf('&', firstDashIndex + 1);
                                        if (secondDashIndex > -1) {
                                            result = value.substring(secondDashIndex + 1).trim();
                                        }
                                    }
                                } else {
                                    // 如果不包含 "-" 字符，则执行相应的操作
                                    // ...
                                    result = value;
                                }
                                if (index === 0) {

                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + result + '" onchange="getValue(event, ' + index + ')">';
                                } else {
                                    return result;
                                }

                            }
                        },
                        {field:'constructionDrawingReview',title: '（六）施工图评审',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                                } else {
                                    return value;
                                }
                            }
                        },
                        {field:'constructionDrawReview',title: '（七）施工图评审意见',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                // 添加 CSS 类名
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                                } else {
                                    var cssClass = '';
                                    if (index === 1) {
                                        cssClass = 'column-highlight';
                                    } else if (index === $('#projectTable').bootstrapTable('getData').length - 1) {
                                        cssClass = 'column-highlight';
                                    }
                                    return '<div class="' + cssClass + '">' + value + '</div>';
                                }

                            }
                        },
                        {field:'batchNumber',title: '施工计划批次',valign:"middle",align: "center"},
                        {field:'bidOpenTime',title: '施工定标日期',valign:"middle",align: "center"},
                        {field:'approvalTime',title: '核准时间+24月-施工定标时间<1月',valign:"middle",align: "center"},
                    ]
                ]
        });

        $('#projectTable2').bootstrapTable({
            //请求方法
            method: 'post',
            //类型json
            dataType: "json",
            contentType: "application/x-www-form-urlencoded",
            //显示检索按钮
            showSearch: false,
            //显示刷新按钮
            showRefresh: true,
            //显示切换手机试图按钮
            showToggle: false,
            //显示 内容列下拉框
            showColumns: false,
            //显示到处按钮
            showExport: false,
            //显示切换分页按钮
            showPaginationSwitch: false,
            //最低显示2行
            minimumCountColumns: 2,
            //是否显示行间隔色
            striped: true,
            //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
            cache: false,
            //是否显示分页（*）
            pagination: false,
            //排序方式
            sortOrder: "asc",
            //初始化加载第一页，默认第一页
            pageNumber:1,
            //每页的记录行数（*）
            pageSize: 10,
            //可供选择的每页的行数（*）
            pageList: [10, 25, 50, 100],
            //这个接口需要处理bootstrap table传递的固定参数,并返回特定格式的json数据
            url: "${ctx}/cg/infrastructure/infrastructureBasicInfo/reviewList2?id=" + id,
            //默认值为 'limit',传给服务端的参数为：limit, offset, search, sort, order Else
            ////查询参数,每次调用是会带上这个参数，可自定义
            queryParams : function(params) {
                var searchParam = $("#searchForm").serializeJSON();
                searchParam.pageNo = params.limit === undefined ? "1" : params.offset / params.limit + 1;
                searchParam.pageSize = params.limit === undefined ? -1 : params.limit;
                searchParam.orderBy = params.sort === undefined ? "" : params.sort + " " + params.order;
                return searchParam;
            },
            //分页方式：client客户端分页，server服务端分页（*）
            sidePagination: "server",
            contextMenuTrigger:"right",//pc端 按右键弹出菜单
            contextMenuTriggerMobile:"press",//手机端 弹出菜单，click：单击， press：长按。
            contextMenu: '#context-menu',
            onLoadSuccess: function () {  //加载成功时执行
                var data = $("#projectTable2").bootstrapTable('getData', true)
                //合并单元格
                mergeTable($('#projectTable2'),"projectName");
                mergeTable($('#projectTable2'),"projectCode");
                mergeTable($('#projectTable2'),"isItInvolved");
                mergeTable($('#projectTable2'),"phase");
                mergeTable($('#projectTable2'),"preliminaryDesignInternalReview");
                mergeTable($('#projectTable2'),"preliminaryDesignReviewPlan");
                mergeTable($('#projectTable2'),"preliminaryExternalAuditReview");
                mergeTable($('#projectTable2'),"preliminaryDesignReviewComments");
                mergeTable($('#projectTable2'),"constructionDrawingReviewPlan");
                mergeTable($('#projectTable2'),"constructionDrawingReview");
            },
            onClickRow: function (row, $el) {
            },
            onShowSearch: function () {
                $("#search-collapse").slideToggle();
            },
            columns:
                [
                    [
                        {"title":"评审计划安排信息(非新建变电站)","colspan":14,width: "2800px",align: "left"},
                    ],
                    [
                        {field:'projectName',title: '项目名称',valign:"middle",align: "center"},
                        {field:'projectCode',title: '项目编码',valign:"middle",align: "center"},
                        {field:'isItInvolved',title: '是否涉及新建变电站',valign:"middle",align: "center"
                        },
                        {field:'phase',title: '项目阶段',valign:"middle",align: "center"},
                        {field:'preliminaryDesignInternalReview',title: '（一）初步设计内审',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue2(event, ' + index + ')">';
                                } else {
                                    return value;
                                }
                            }
                        },
                        {field:'preliminaryDesignReviewPlan',title: '（二）初步设计评审计划',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue2(event, ' + index + ')">';
                                } else {
                                    return value;
                                }
                            }
                        },
                        {field:'preliminaryExternalAuditReview',title: '（三）初设外审评审',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue2(event, ' + index + ')">';
                                } else {
                                    return value;
                                }
                            }
                        },
                        {field:'preliminaryDesignReviewComments',title: '（四）初设评审意见',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                // 判断value是否 有  -
                                var hasDash = value.includes('&');
                                var result = '';
                                if (hasDash) {
                                    // 如果包含 "-" 字符，则执行相应的操作
                                    // ...
                                    var splitValues = value.split('&');
                                    result = splitValues.length > 1 ? splitValues[1].trim() : '';
                                } else {
                                    // 如果不包含 "-" 字符，则执行相应的操作
                                    // ...
                                    result = value;
                                }
                                if (index === 0) {

                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + result + '" onchange="getValue2(event, ' + index + ')">';
                                } else {
                                    return result;
                                }

                            }
                        },
                        {field:'constructionDrawingReviewPlan',title: '（五）施工图评审计划',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                // 判断value是否 有  -
                                var hasDash = value.includes('&');
                                var result = '';
                                if (hasDash) {
                                    // 如果包含 "-" 字符，则执行相应的操作
                                    // ...
                                    var dashCount = value.split('&').length - 1;
                                    if (dashCount === 1){
                                        var splitValues = value.split('&');
                                        result = splitValues.length > 1 ? splitValues[1].trim() : '';
                                    } else {
                                        // 获取第一个 - 的位置
                                        var firstDashIndex = value.indexOf('&');
                                        var secondDashIndex = value.indexOf('&', firstDashIndex + 1);
                                        if (secondDashIndex > -1) {
                                            result = value.substring(secondDashIndex + 1).trim();
                                        }
                                    }
                                } else {
                                    // 如果不包含 "-" 字符，则执行相应的操作
                                    // ...
                                    result = value;
                                }
                                if (index === 0) {

                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + result + '" onchange="getValue2(event, ' + index + ')">';
                                } else {
                                    return result;
                                }

                            }
                        },
                        {field:'constructionDrawingReview',title: '（六）施工图评审',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue2(event, ' + index + ')">';
                                } else {
                                    return value;
                                }
                            }
                        },
                        {field:'constructionDrawReview',title: '（七）施工图评审意见',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                // 添加 CSS 类名
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue2(event, ' + index + ')">';
                                } else {
                                    var cssClass = '';
                                    if (index === 1) {
                                        cssClass = 'column-highlight';
                                    } else if (index === $('#projectTable2').bootstrapTable('getData').length - 1) {
                                        cssClass = 'column-highlight';
                                    }
                                    return '<div class="' + cssClass + '">' + value + '</div>';
                                }

                            }
                        },
                        {field:'batchNumber',title: '施工计划批次',valign:"middle",align: "center"},
                        {field:'bidOpenTime',title: '施工定标日期',valign:"middle",align: "center"},
                        {field:'approvalTime',title: '核准时间+24月-施工定标时间<1月',valign:"middle",align: "center"},
                    ]
                ]
        });

        $('#projectTable3').bootstrapTable({
            //请求方法
            method: 'post',
            //类型json
            dataType: "json",
            contentType: "application/x-www-form-urlencoded",
            //显示检索按钮
            showSearch: false,
            //显示刷新按钮
            showRefresh: true,
            //显示切换手机试图按钮
            showToggle: false,
            //显示 内容列下拉框
            showColumns: false,
            //显示到处按钮
            showExport: false,
            //显示切换分页按钮
            showPaginationSwitch: false,
            //最低显示2行
            minimumCountColumns: 2,
            //是否显示行间隔色
            striped: true,
            //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
            cache: false,
            //是否显示分页（*）
            pagination: false,
            //排序方式
            sortOrder: "asc",
            //初始化加载第一页，默认第一页
            pageNumber:1,
            //每页的记录行数（*）
            pageSize: 10,
            //可供选择的每页的行数（*）
            pageList: [10, 25, 50, 100],
            //这个接口需要处理bootstrap table传递的固定参数,并返回特定格式的json数据
            url: "${ctx}/cg/infrastructure/infrastructureBasicInfo/reviewList3?id=" + id,
            //默认值为 'limit',传给服务端的参数为：limit, offset, search, sort, order Else
            ////查询参数,每次调用是会带上这个参数，可自定义
            queryParams : function(params) {
                var searchParam = $("#searchForm").serializeJSON();
                searchParam.pageNo = params.limit === undefined? "1" :params.offset/params.limit+1;
                searchParam.pageSize = params.limit === undefined? -1 : params.limit;
                searchParam.orderBy = params.sort === undefined? "" : params.sort+ " "+  params.order;
                return searchParam;
            },
            //分页方式：client客户端分页，server服务端分页（*）
            sidePagination: "server",
            contextMenuTrigger:"right",//pc端 按右键弹出菜单
            contextMenuTriggerMobile:"press",//手机端 弹出菜单，click：单击， press：长按。
            contextMenu: '#context-menu',
            onLoadSuccess: function () {  //加载成功时执行
                var data = $("#projectTable3").bootstrapTable('getData', true)
                //合并单元格
                mergeTable($('#projectTable3'),"projectName");
                mergeTable($('#projectTable3'),"projectCode");
                mergeTable($('#projectTable3'),"isItInvolved");
                mergeTable($('#projectTable3'),"phase");
                mergeTable($('#projectTable3'),"preliminaryDesignInternalReview");
                mergeTable($('#projectTable3'),"preliminaryDesignReviewPlan");
                mergeTable($('#projectTable3'),"preliminaryExternalAuditReview");
                mergeTable($('#projectTable3'),"preliminaryDesignReviewComments");
                mergeTable($('#projectTable3'),"constructionDrawingReviewPlan");
                mergeTable($('#projectTable3'),"constructionDrawingReview");
            },
            onClickRow: function (row, $el) {
            },
            onShowSearch: function () {
                $("#search-collapse").slideToggle();
            },
            columns:
                [
                    [
                        {"title":"评审计划安排信息(非新建变电站)","colspan":14,width: "2800px",align: "left"},
                    ],
                    [
                        {field:'projectName',title: '项目名称',valign:"middle",align: "center"},
                        {field:'projectCode',title: '项目编码',valign:"middle",align: "center"},
                        {field:'isItInvolved',title: '是否涉及新建变电站',valign:"middle",align: "center"
                        },
                        {field:'phase',title: '项目阶段',valign:"middle",align: "center"},
                        {field:'preliminaryDesignInternalReview',title: '（一）初步设计内审',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue4(event, ' + index + ')">';
                                } else {
                                    return value;
                                }
                            }
                        },
                        {field:'preliminaryDesignReviewPlan',title: '（二）初步设计评审计划',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue4(event, ' + index + ')">';
                                } else {
                                    return value;
                                }
                            }
                        },
                        {field:'preliminaryExternalAuditReview',title: '（三）初设外审评审',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue4(event, ' + index + ')">';
                                } else {
                                    return value;
                                }
                            }
                        },
                        {field:'preliminaryDesignReviewComments',title: '（四）初设评审意见',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                // 判断value是否 有  -
                                var hasDash = value.includes('&');
                                var result = '';
                                if (hasDash) {
                                    // 如果包含 "-" 字符，则执行相应的操作
                                    // ...
                                    var splitValues = value.split('&');
                                    result = splitValues.length > 1 ? splitValues[1].trim() : '';
                                } else {
                                    // 如果不包含 "-" 字符，则执行相应的操作
                                    // ...
                                    result = value;
                                }
                                if (index === 0) {

                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + result + '" onchange="getValue4(event, ' + index + ')">';
                                } else {
                                    return result;
                                }

                            }
                        },
                        {field:'constructionDrawingReviewPlan',title: '（五）施工图评审计划',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                // 判断value是否 有  -
                                var hasDash = value.includes('&');
                                var result = '';
                                if (hasDash) {
                                    // 如果包含 "-" 字符，则执行相应的操作
                                    // ...
                                    var dashCount = value.split('&').length - 1;
                                    if (dashCount === 1){
                                        var splitValues = value.split('&');
                                        result = splitValues.length > 1 ? splitValues[1].trim() : '';
                                    } else {
                                        // 获取第一个 - 的位置
                                        var firstDashIndex = value.indexOf('&');
                                        var secondDashIndex = value.indexOf('&', firstDashIndex + 1);
                                        if (secondDashIndex > -1) {
                                            result = value.substring(secondDashIndex + 1).trim();
                                        }
                                    }
                                } else {
                                    // 如果不包含 "-" 字符，则执行相应的操作
                                    // ...
                                    result = value;
                                }
                                if (index === 0) {

                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + result + '" onchange="getValue4(event, ' + index + ')">';
                                } else {
                                    return result;
                                }

                            }
                        },
                        {field:'constructionDrawingReview',title: '（六）施工图评审',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue4(event, ' + index + ')">';
                                } else {
                                    return value;
                                }
                            }
                        },
                        {field:'constructionDrawReview',title: '（七）施工图评审意见',valign:"middle",align: "center",
                            formatter: function(value, row, index) {
                                // 添加 CSS 类名
                                if (index === 0) {
                                    var inputId = 'datepicker-' + index;
                                    return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue4(event, ' + index + ')">';
                                } else {
                                    var cssClass = '';
                                    if (index === 1) {
                                        cssClass = 'column-highlight';
                                    } else if (index === $('#projectTable3').bootstrapTable('getData').length - 1) {
                                        cssClass = 'column-highlight';
                                    }
                                    return '<div class="' + cssClass + '">' + value + '</div>';
                                }

                            }
                        },
                        {field:'batchNumber',title: '施工计划批次',valign:"middle",align: "center"},
                        {field:'bidOpenTime',title: '施工定标日期',valign:"middle",align: "center"},
                        {field:'approvalTime',title: '核准时间+24月-施工定标时间<1月',valign:"middle",align: "center"},
                    ]
                ]
        });


        if (navigator.userAgent.match(/(iPhone|iPod|Android|ios)/i)) {//如果是移动端
            $('#projectTable').bootstrapTable("toggleView");
        }

        $('#projectTable').on('check.bs.table uncheck.bs.table load-success.bs.table ' +
            'check-all.bs.table uncheck-all.bs.table', function () {
            $('#remove').prop('disabled', !$('#projectTable').bootstrapTable('getSelections').length);
            $('#view,#edit,#jlEdit').prop('disabled', $('#projectTable').bootstrapTable('getSelections').length != 1);
        });

        $('#beginBeginDate').datetimepicker({
            format: "YYYY-MM-DD HH:mm:ss"
        });
        $('#endBeginDate').datetimepicker({
            format: "YYYY-MM-DD HH:mm:ss"
        });
        $('#endDate').datetimepicker({
            format: "YYYY-MM-DD HH:mm:ss"
        });

    });

function handleDateChange(event, index) {
    var inputId = event.target.id;
    var newValue = event.target.value;
    // 执行相关操作
    // ...
    console.log('inputId', inputId)
    console.log('newValue', newValue)
}
function getValue(element) {
    //获取修改后的值
    var value = event.target.value;
    //将 - 替换为 /
    var newValue = value.replace(/-/g, "/");
    var position = getElementPosition(event.target); // 获取元素所在的行和列索引
    var rowIndex = position.row;
    var arrangeIndex = position.column;

    //判断是否是需要保存的实际时间行
    if (rowIndex === 0){
        // 将获取到的新值发送到后台进行保存等操作
        // 获取表格数据
        var tableData = $('#projectTable').bootstrapTable('getData');
        // 修改第一行某 是否涉及新建变电站 的值为指定值
        if (arrangeIndex === 2){
            tableData[0].isItInvolved = newValue;
        }
        //修改（一）初步设计内审  - （七）施工图评审意见  的值
        if (arrangeIndex === 4){
            tableData[0].preliminaryDesignInternalReview = newValue;
        } else if (arrangeIndex === 5){
            tableData[0].preliminaryDesignReviewPlan = newValue;
        } else if (arrangeIndex === 6){
            tableData[0].preliminaryExternalAuditReview = newValue;
        } else if (arrangeIndex === 7){
            tableData[0].preliminaryDesignReviewComments = newValue;
        } else if (arrangeIndex === 8){
            tableData[0].constructionDrawingReviewPlan = newValue;
        } else if (arrangeIndex === 9){
            tableData[0].constructionDrawingReview = newValue;
        } else if (arrangeIndex === 10){
            tableData[0].constructionDrawReview = newValue;
        }else if (arrangeIndex === 13){
            tableData[0].approvalTime = newValue;
        }

        // 获取表格数据  第一行
        var tableData = $('#projectTable').bootstrapTable('getData')[0];
        // 将数据封装成 JSON 格式
        var jsonData = JSON.stringify(tableData);
        console.log('jsonData', jsonData)
        $.ajax({
            url: '${ctx}/cg/infrastructure/infrastructureBasicInfo/reviewSave',
            type: 'POST',
            data: JSON.stringify(tableData),
            contentType: 'application/json',
            success: function(data) {
                //处理返回结果
                jp.success(data.msg)
                refresh();
            },
            error: function (data) {
                jp.error(data.msg);
                refresh();
            }
        })

        console.log('newValue', newValue)
    }
}
function getValue2(event, index) {
    //获取修改后的值
    var value = event.target.value;
    //将 - 替换为 /
    var newValue = value.replace(/-/g, "/");
    var position = getElementPosition(event.target); // 获取元素所在的行和列索引
    var rowIndex = position.row;
    var arrangeIndex = position.column;

    console.log('newValue', newValue)
    //判断是否是需要保存的实际时间行
    if (rowIndex === 0){
        // 将获取到的新值发送到后台进行保存等操作
        // 获取表格数据
        var tableData = $('#projectTable2').bootstrapTable('getData');
        // 将数据封装成 JSON 格式
        var jsonData = JSON.stringify(tableData);
        // 修改第一行某 是否涉及新建变电站 的值为指定值
        if (arrangeIndex === 2){
            tableData[0].isItInvolved = newValue;
        }
        //修改（一）初步设计内审  - （七）施工图评审意见  的值
        if (arrangeIndex === 4){
            tableData[0].preliminaryDesignInternalReview = newValue;
        } else if (arrangeIndex === 5){
            tableData[0].preliminaryDesignReviewPlan = newValue;
        } else if (arrangeIndex === 6){
            tableData[0].preliminaryExternalAuditReview = newValue;
        } else if (arrangeIndex === 7){
            tableData[0].preliminaryDesignReviewComments = newValue;
        } else if (arrangeIndex === 8){
            tableData[0].constructionDrawingReviewPlan = newValue;
        } else if (arrangeIndex === 9){
            tableData[0].constructionDrawingReview = newValue;
        } else if (arrangeIndex === 10){
            tableData[0].constructionDrawReview = newValue;
        }else if (arrangeIndex === 13){
            tableData[0].approvalTime = newValue;
        }

        // 获取表格数据  第一行
        if (newValue !== '') {
            var tableData = $('#projectTable2').bootstrapTable('getData')[0];

            var id = document.getElementById("id").value;

            $.ajax({
                url: '${ctx}/cg/infrastructure/infrastructureBasicInfo/reviewList2?id=' + id,
                type: 'POST',
                data: {
                    "preliminaryDesignInternalReview": tableData.preliminaryDesignInternalReview.replaceAll("-","/"),
                    "preliminaryDesignReviewPlan": tableData.preliminaryDesignReviewPlan.replaceAll("-","/"),
                    "preliminaryExternalAuditReview": tableData.preliminaryExternalAuditReview.replaceAll("-","/"),
                    "preliminaryDesignReviewComments": tableData.preliminaryDesignReviewComments.replaceAll("-","/"),
                    "constructionDrawingReviewPlan": tableData.constructionDrawingReviewPlan.replaceAll("-","/"),
                    "constructionDrawingReview": tableData.constructionDrawingReview.replaceAll("-","/"),
                    "constructionDrawReview": tableData.constructionDrawReview.replaceAll("-","/")
                },
                dataType: "json",
                contentType: "application/x-www-form-urlencoded",
                success: function(data) {
                    //替换数据
                    $('#projectTable2').bootstrapTable('load', data);
                    //合并单元格
                    mergeTable($('#projectTable2'),"projectName");
                    mergeTable($('#projectTable2'),"projectCode");
                    mergeTable($('#projectTable2'),"isItInvolved");
                    mergeTable($('#projectTable2'),"phase");
                    mergeTable($('#projectTable2'),"preliminaryDesignInternalReview");
                    mergeTable($('#projectTable2'),"preliminaryDesignReviewPlan");
                    mergeTable($('#projectTable2'),"preliminaryExternalAuditReview");
                    mergeTable($('#projectTable2'),"preliminaryDesignReviewComments");
                    mergeTable($('#projectTable2'),"constructionDrawingReviewPlan");
                    mergeTable($('#projectTable2'),"constructionDrawingReview");

                    console.log('data', data)
                },
                error: function (data) {
                }
            })
        }

        console.log('newValue', newValue)
    }
}
function getValue4(event, index) {
    //获取修改后的值
    var value = event.target.value;
    //将 - 替换为 /
    var newValue = value.replace(/-/g, "/");
    var position = getElementPosition(event.target); // 获取元素所在的行和列索引
    var rowIndex = position.row;
    var arrangeIndex = position.column;

    console.log('newValue', newValue)
    //判断是否是需要保存的实际时间行
    if (rowIndex === 0){
        // 将获取到的新值发送到后台进行保存等操作
        // 获取表格数据
        var tableData = $('#projectTable3').bootstrapTable('getData');
        // 将数据封装成 JSON 格式
        var jsonData = JSON.stringify(tableData);
        // 修改第一行某 是否涉及新建变电站 的值为指定值
        if (arrangeIndex === 2){
            tableData[0].isItInvolved = newValue;
        }
        //修改（一）初步设计内审  - （七）施工图评审意见  的值
        if (arrangeIndex === 4){
            tableData[0].preliminaryDesignInternalReview = newValue;
        } else if (arrangeIndex === 5){
            tableData[0].preliminaryDesignReviewPlan = newValue;
        } else if (arrangeIndex === 6){
            tableData[0].preliminaryExternalAuditReview = newValue;
        } else if (arrangeIndex === 7){
            tableData[0].preliminaryDesignReviewComments = newValue;
        } else if (arrangeIndex === 8){
            tableData[0].constructionDrawingReviewPlan = newValue;
        } else if (arrangeIndex === 9){
            tableData[0].constructionDrawingReview = newValue;
        } else if (arrangeIndex === 10){
            tableData[0].constructionDrawReview = newValue;
        }else if (arrangeIndex === 13){
            tableData[0].approvalTime = newValue;
        }

        // 获取表格数据  第一行
        if (newValue !== '') {
            var tableData = $('#projectTable3').bootstrapTable('getData')[0];

            var id = document.getElementById("id").value;

            $.ajax({
                url: '${ctx}/cg/infrastructure/infrastructureBasicInfo/reviewList3?id=' + id,
                type: 'POST',
                data: {
                    "preliminaryDesignInternalReview": tableData.preliminaryDesignInternalReview.replaceAll("-","/"),
                    "preliminaryDesignReviewPlan": tableData.preliminaryDesignReviewPlan.replaceAll("-","/"),
                    "preliminaryExternalAuditReview": tableData.preliminaryExternalAuditReview.replaceAll("-","/"),
                    "preliminaryDesignReviewComments": tableData.preliminaryDesignReviewComments.replaceAll("-","/"),
                    "constructionDrawingReviewPlan": tableData.constructionDrawingReviewPlan.replaceAll("-","/"),
                    "constructionDrawingReview": tableData.constructionDrawingReview.replaceAll("-","/"),
                    "constructionDrawReview": tableData.constructionDrawReview.replaceAll("-","/")
                },
                dataType: "json",
                contentType: "application/x-www-form-urlencoded",
                success: function(data) {
                    //替换数据
                    $('#projectTable3').bootstrapTable('load', data);
                    //合并单元格
                    mergeTable($('#projectTable3'),"projectName");
                    mergeTable($('#projectTable3'),"projectCode");
                    mergeTable($('#projectTable3'),"isItInvolved");
                    mergeTable($('#projectTable3'),"phase");
                    mergeTable($('#projectTable3'),"preliminaryDesignInternalReview");
                    mergeTable($('#projectTable3'),"preliminaryDesignReviewPlan");
                    mergeTable($('#projectTable3'),"preliminaryExternalAuditReview");
                    mergeTable($('#projectTable3'),"preliminaryDesignReviewComments");
                    mergeTable($('#projectTable3'),"constructionDrawingReviewPlan");
                    mergeTable($('#projectTable3'),"constructionDrawingReview");

                    console.log('data', data)
                },
                error: function (data) {
                }
            })
        }

        console.log('newValue', newValue)
    }
}

function getElementPosition(element) {
    var $cell = $(element).closest('td'); // 获取元素的父元素（通常是 <td> 元素）
    var $row = $cell.closest('tr'); // 获取父元素所在的行 <tr> 元素

    var rowIndex = $row.index(); // 行索引（从 0 开始）
    var columnIndex = $cell.index(); // 列索引（从 0 开始）

    return {
        row: rowIndex,
        column: columnIndex
    };
}

// 监听“刷新”事件
$('#projectTable2').on('refresh.bs.table', function (e, args) {
    var tableData = $('#projectTable2').bootstrapTable('getData')[0];
    // 在这里执行自定义的操作，例如重新加载数据
    for (var key in tableData) {
        tableData[key] = null;
    }
    console.log('表格数据已经刷新');
});
// 监听“刷新”事件
$('#projectTable3').on('refresh.bs.table', function (e, args) {
    var tableData = $('#projectTable3').bootstrapTable('getData')[0];
    // 在这里执行自定义的操作，例如重新加载数据
    for (var key in tableData) {
        tableData[key] = null;
    }
    console.log('表格数据已经刷新');
});
//刷新列表
function refresh() {
    $('#projectTable').bootstrapTable('refresh');
}

function getIdSelections() {
    return $.map($("#projectTable").bootstrapTable('getSelections'), function (row) {
        return row.id
    });
}
//表格超出宽度鼠标悬停显示td内容
function paramsMatter(value,row,index,field) {
    var span = document.createElement('span');
    span.setAttribute('title',value);
    span.innerHTML = value;
    return span.outerHTML;
}

//转换日期格式(时间戳转换为datetime格式)
function changeDateFormat(cellval) {
    var dateVal = cellval + "";
    if (cellval != null) {
        var date = new Date(parseInt(dateVal.replace("/Date(", "").replace(")/", ""), 10));
        var month = date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1;
        var currentDate = date.getDate() < 10 ? "0" + date.getDate() : date.getDate();

        /*var hours = date.getHours() < 10 ? "0" + date.getHours() : date.getHours();
        var minutes = date.getMinutes() < 10 ? "0" + date.getMinutes() : date.getMinutes();
        var seconds = date.getSeconds() < 10 ? "0" + date.getSeconds() : date.getSeconds();*/

        return date.getFullYear() + "-" + month + "-" + currentDate /*+ " " + hours + ":" + minutes + ":" + seconds*/;
    }
}

/**
 * 合并单元格
 * @param bstable
 * @param fieldname
 */
function mergeTable(bstable, fieldname) {
    var rows = bstable.bootstrapTable('getData');
    var rowspan = 0;
    var index = 0;
    var first_yjzbmc = '';
    $.each(rows, function (i, row) {
        if (i == 0) {
            first_yjzbmc = row[fieldname];
            rowspan = 1;
            index = i;
        } else {
            if (first_yjzbmc === row[fieldname]) {
                rowspan++;
            }
            else {
                $(bstable).bootstrapTable('mergeCells', { index: index, field: fieldname, colspan: 1, rowspan: rowspan });
                first_yjzbmc = row[fieldname];
                rowspan = 1;
                index = i;
            }
            if (i == (rows.length - 1)) {
                $(bstable).bootstrapTable('mergeCells', { index: index, field: fieldname, colspan: 1, rowspan: rowspan });
            }
        }
    });
}

</script>

