<%@ page contentType="text/html;charset=UTF-8" %>
<script >
$(document).ready(function () {
    $('#projectTable').bootstrapTable({
        //请求方法
        method: 'post',
        //类型json
        dataType: "json",
        contentType: "application/x-www-form-urlencoded",
        //显示检索按钮
        showSearch: true,
        //显示刷新按钮
        showRefresh: true,
        //显示切换手机试图按钮
        showToggle: true,
        //显示 内容列下拉框
        showColumns: true,
        //显示到处按钮
        showExport: true,
        //显示切换分页按钮
        showPaginationSwitch: true,
        //最低显示2行
        minimumCountColumns: 2,
        //是否显示行间隔色
        striped: true,
        //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
        cache: false,
        //是否显示分页（*）
        pagination: true,
        //排序方式
        sortOrder: "asc",
        //初始化加载第一页，默认第一页
        pageNumber: 1,
        //每页的记录行数（*）
        pageSize: 25,
        //可供选择的每页的行数（*）
        pageList: [5, 10, 25, 50, 100],
        //这个接口需要处理bootstrap table传递的固定参数,并返回特定格式的json数据
        url: "${ctx}/cg/policeProcess/record/list",
        //默认值为 'limit',传给服务端的参数为：limit, offset, search, sort, order Else
        //queryParamsType:'',
        ////查询参数,每次调用是会带上这个参数，可自定义
        queryParams: function (params) {
            var searchParam = $("#searchForm").serializeJSON();
            searchParam.pageNo = params.limit === undefined ? "1" : params.offset / params.limit + 1;
            searchParam.pageSize = params.limit === undefined ? -1 : params.limit;
            searchParam.orderBy = params.sort === undefined ? "" : params.sort + " " + params.order;
            return searchParam;
        },
        //分页方式：client客户端分页，server服务端分页（*）
        sidePagination: "server",
        contextMenuTrigger: "right",//pc端 按右键弹出菜单
        contextMenuTriggerMobile: "press",//手机端 弹出菜单，click：单击， press：长按。
        contextMenu: '#context-menu',
        onContextMenuItem: function (row, $el) {
            if ($el.data("item") == "edit") {
                edit(row.id);
            } else if ($el.data("item") == "view") {
                view(row.id);
            } else if ($el.data("item") == "delete") {
                jp.confirm('确认要删除该表单记录吗？', function () {
                    jp.loading();
                    jp.get("${ctx}/cg/reservemanagementcenter/project/delete?id=" + row.id, function (data) {
                        if (data.success) {
                            $('#projectTable').bootstrapTable('refresh');
                            jp.success(data.msg);
                        } else {
                            jp.error(data.msg);
                        }
                    })
                });
            }
        },
        /*onLoadSuccess: function () {  //加载成功时执行
            var data = $("#projectTable").bootstrapTable('getData', true)
            //合并单元格
            mergeTable($('#projectTable'),"projectYear");
            mergeTable($('#projectTable'),"projectNature");
            mergeTable($('#projectTable'),"demandUnit");
            mergeTable($('#projectTable'),"district");
            mergeTable($('#projectTable'),"projectGroup");
            mergeTable($('#projectTable'),"reserveBatches");
            mergeTable($('#projectTable'),"blockSupply");
            mergeTable($('#projectTable'),"gridNumber");
            mergeTable($('#projectTable'),"cellNumber");
            mergeTable($('#projectTable'),"projectReserveId");
            mergeTable($('#projectTable'),"projectName");
            mergeTable($('#projectTable'),"stateGridProjectCode");
            mergeTable($('#projectTable'),"stateGridProjectName");
            mergeTable($('#projectTable'),"constructionNecessityAndContent");
            mergeTable($('#projectTable'),"substationName");
            mergeTable($('#projectTable'),"circuitName");
            mergeTable($('#projectTable'),"netRackProjectDivide");
            mergeTable($('#projectTable'),"requirementType");
            mergeTable($('#projectTable'),"projectType");
            mergeTable($('#projectTable'),"costEstimate");
            mergeTable($('#projectTable'),"remarks");
            mergeTable($('#projectTable'),"implementBatch");
            mergeTable($('#projectTable'),"constructionUnit");
            mergeTable($('#projectTable'),"projectReleaseBatch");
            mergeTable($('#projectTable'),"ownerManager");
            mergeTable($('#projectTable'),"constructionManagementUnit");
            mergeTable($('#projectTable'),"dqProjectManager");
            mergeTable($('#projectTable'),"tjProjectManager");
            mergeTable($('#projectTable'),"dqSubcontractingUnit");
            mergeTable($('#projectTable'),"dqContacts");
            mergeTable($('#projectTable'),"tjSubcontractingUnit");
            mergeTable($('#projectTable'),"tjContacts");
            mergeTable($('#projectTable'),"subpackageRemarks");
            mergeTable($('#projectTable'),"civilEngineer");
            mergeTable($('#projectTable'),"civilEngineerStatistic");
            mergeTable($('#projectTable'),"poleWorkload");
            mergeTable($('#projectTable'),"poleWorkloadStatistic");
            mergeTable($('#projectTable'),"statisticRemarks");
        },*/

        onClickRow: function (row, $el) {
        },
        onShowSearch: function () {
            $("#search-collapse").slideToggle();
        },
        columns:
            [
                [
                    {checkbox:true,width: 36},
                    {"title":"储备项目基本信息","colspan":21,"halign":"center","align": "center",width: "4200px"},
                    {"title":"项目参建（单位）人员信息","colspan":7,"halign":"center","align": "center",width: "1400px"},
                    {"title":"分包队伍","colspan":5,"halign":"center","align": "center",width: "1000px"},
                    {"title":"项目工程量统计","colspan":5,"halign":"center","align": "center",width: "1000px"},
                    {"title":"政处记录","colspan":21,"halign":"center","align": "center",width: "4200px"}
                ],
                [
                    {checkbox:true,width: 36},
                    { field: 'projectYear', title: "项目年份", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'projectNature', title: "项目性质", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'demandUnit', title: "需求单位", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'district', title: "区域", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'projectGroup', title: "项目分组", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'reserveBatches', title: "储备批次", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'blockSupply', title: "供电区域", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'gridNumber', title: "网格编号", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'cellNumber', title: "单元格编号", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'projectReserveId', title: "项目储备编号", valign:"middle", align:"center", colspan: 1, rowspan: 1,
                        formatter:function(value, row , index){

                            if(value == null || value ==""){
                                value = "-";
                            }
                        <c:choose>
                            <c:when test="${fns:hasPermission('cg:reservemanagementcenter:reserveManage:view')}">
                            return "<a href='javascript:view(\"" + row.id + "\", " + index + ")'>" + value + "</a>";

                        </c:when>
                            <c:otherwise>
                            return value;
                        </c:otherwise>
                            </c:choose>
                        }},
                    { field: 'projectName', title: "储备项目名称", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,formatter:paramsMatter},
                    { field: 'stateGridProjectCode', title: "国网项目编码", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'stateGridProjectName', title: "国网项目名称", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,formatter:paramsMatter},
                    { field: 'constructionNecessityAndContent', title: "建设必要性及内容", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,formatter:paramsMatter},
                    { field: 'substationName', title: "变电站名称", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'circuitName', title: "线路名称", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'netRackProjectDivide', title: "网架项目划分", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'requirementType', title: "需求类型", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'projectType', title: "项目类型", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'costEstimate', title: "费用估算", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'remarks', title: "备注", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,formatter:paramsMatter},
                    { field: 'implementBatch', title: "初定实施批次", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'constructionUnit', title: "初定施工单位", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'projectReleaseBatch', title: "项目下达批次", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'ownerManager', title: "业主项目经理", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'ConstructionManagementUnit', title: "现场施工管理单位", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'dqProjectManager', title: "施工项目经理(电气)", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'tjProjectManager', title: "施工项目经理(土建)", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'dqSubcontractingUnit', title: "电气分包单位", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'dqContacts', title: "电气联系人", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'tjSubcontractingUnit', title: "土建分包单位", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'tjContacts', title: "土建联系人", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'subpackageRemarks', title: "备注", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,formatter:paramsMatter},
                    { field: 'civilEngineer', title: "是否含土建", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'civilEngineerStatistic', title: "土建工作量统计", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'poleWorkload', title: "是否含立杆工作量", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'poleWorkloadStatistic', title: "立杆工作量统计", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'statisticRemarks', title: "备注", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,formatter:paramsMatter},
                    { field: 'serialNumber', title: "序号", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'startPoliticalWork', title: "是否启动政处工作", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'startTime', title: "政处启动日期", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'administrativeObject', title: "政处对象", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                // return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                                return '<select id="administrativeObject" name="administrativeObject" class="form-control" onchange="getValue(event, ' + index + ')">' +
                                    '<option value="">请选择</option>' +
                                    '<option value="规划报批" ' + (value === '规划报批' ? 'selected' : '') + '>规划报批</option>' +
                                    '<option value="安评" ' + (value === '安评' ? 'selected' : '') + '>安评</option>' +
                                    '<option value="航评" ' + (value === '航评' ? 'selected' : '') + '>航评</option>' +
                                    '</select>';

                            }
                        }
                    },
                    { field: 'needCompensation', title: "是否需赔付", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'compensationContent', title: "赔付内容", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,formatter:paramsMatter},
                    { field: 'compensationMoney', title: "赔付金额", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'documentCommitTime', title: "签字政处单据提交时间", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'financialPayment', title: "是否财政付款", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'needSignContract', title: "是否需签订合同", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'signContractTime', title: "政处合同完成签订时间", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'weatherLoan', title: "是否借款", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'loanTime', title: "借款支付时间", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'completeFinancialReimbursement', title: "是否完成财务报销", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'completeFinancialReimbursementTime', title: "财务报销完成时间", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'possibleToEnterSite', title: "是否可进场", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'possibleToEnterSiteTime', title: "可进场日期", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="date" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'completeProcess', title: "政处是否完成", valign:"middle", align:"center", colspan: 1, rowspan: 1 },
                    { field: 'negotiatingUnit', title: "政处洽谈单位", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'coordinateUnit', title: "政处配合单位", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                    { field: 'recordRemarks', title: "备注", valign:"middle", align:"center", colspan: 1, rowspan: 1 ,
                        formatter: function(value, row, index) {
                            var inputId = 'datepicker-' + index;
                            var tableData = $('#projectTable').bootstrapTable('getData');
                            if (tableData[index].serialNumber === null || tableData[index].serialNumber === '') {
                                return ''
                            } else {
                                return '<input type="text" id="' + inputId + '" class="form-control" value="' + value + '" onchange="getValue(event, ' + index + ')">';
                            }
                        }
                    },
                ]
            ]
    });


    if (navigator.userAgent.match(/(iPhone|iPod|Android|ios)/i)) {//如果是移动端
        $('#projectTable').bootstrapTable("toggleView");
    }

    $('#projectTable').on('check.bs.table uncheck.bs.table load-success.bs.table ' +
        'check-all.bs.table uncheck-all.bs.table', function () {
        $('#remove').prop('disabled', !$('#projectTable').bootstrapTable('getSelections').length);
        $('#view,#edit,#jlEdit').prop('disabled', $('#projectTable').bootstrapTable('getSelections').length != 1);
    });

    $("#btnImport").click(function () {
        jp.open({
            type: 2,
            area: [500, 200],
            auto: true,
            title: "导入数据",
            content: "${ctx}/tag/importExcel",
            btn: ['确定', '关闭'],
            btn1: function (index, layero) {
                var iframeWin = layero.find('iframe')[0]; //得到iframe页的窗口对象，执行iframe页的方法：iframeWin.method();
                iframeWin.contentWindow.importExcel('${ctx}/cg/policeProcess/record/import', function (data) {
                    if (data.success) {
                        jp.success(data.msg);
                        refresh();
                    } else {
                        jp.error(data.msg);
                    }
                    jp.close(index);
                });//调用保存事件
                return false;
            },
            btn2: function (index) {
                //  jp.close(index);
            }
        });
    });

    $("#btnExport").click(function () {
        var projectReserveId = $("#projectReserveId").val();
        var projectName = $("#projectName").val();
        var projectYear = $("#projectYear").val();
        jp.downloadFile('${ctx}/cg/policeProcess/record/export?projectReserveId=' + projectReserveId + '&projectName=' + projectName + '&projectYear=' + projectYear);
    });

    $("#search").click("click", function () {// 绑定查询按扭
        $('#projectTable').bootstrapTable('refresh');
    });

    $("#reset").click("click", function () {// 绑定查询按扭
        $("#searchForm  input").val("");
        $("#searchForm  select").val("");
        $("#searchForm  .select-item").html("");
        $('#projectTable').bootstrapTable('refresh');
    });

    $('#beginBeginDate').datetimepicker({
        format: "YYYY-MM-DD HH:mm:ss"
    });
    $('#endBeginDate').datetimepicker({
        format: "YYYY-MM-DD HH:mm:ss"
    });
    $('#endDate').datetimepicker({
        format: "YYYY-MM-DD HH:mm:ss"
    });
});

//表格超出宽度鼠标悬停显示td内容
function paramsMatter(value,row,index,field) {
    if (value === '' || value === null || value === undefined){
        return ''
    }
    var span = document.createElement('span');
    span.setAttribute('title',value);
    span.innerHTML = value;
    return span.outerHTML;
}

function getIdSelections() {
    return $.map($("#projectTable").bootstrapTable('getSelections'), function (row) {
        return row.id
    });
}


//刷新列表
function refresh() {
    $('#projectTable').bootstrapTable('refresh');
}

function add() {
    jp.openSaveDialog('新增储备项目基本信息', "${ctx}/cg/policeProcess/record/form", '800px', '500px');
}


function edit(id) {//没有权限时，不显示确定按钮
    if (id == undefined) {
        id = getIdSelections();
    }
    jp.openSaveDialog('编辑储备项目基本信息', "${ctx}/cg/policeProcess/record/form?id=" + id, '800px', '500px');
}

function view(id,index) {//没有权限时，不显示确定按钮
    if (id == undefined) {
        id = getIdSelections();
    }
    var tableData = $('#projectTable').bootstrapTable('getData');
    var serialNumber = tableData[index].serialNumber

    jp.openViewDialog('查看储备项目基本信息', "${ctx}/cg/policeProcess/record/view?id=" + id + '&serialNumber=' +serialNumber, '800px', '500px');
}

//转换日期格式(时间戳转换为datetime格式)
function changeDateFormat(cellval) {
    var dateVal = cellval + "";
    if (cellval != null) {
        var date = new Date(parseInt(dateVal.replace("/Date(", "").replace(")/", ""), 10));
        var month = date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1;
        var currentDate = date.getDate() < 10 ? "0" + date.getDate() : date.getDate();

        return date.getFullYear() + "-" + month + "-" + currentDate ;
    }
}

/**
 * 合并单元格
 * @param bstable
 * @param fieldname
 */
function mergeTable(bstable, fieldname) {
    var rows = bstable.bootstrapTable('getData');
    var rowspan = 0;
    var index = 0;
    var first_yjzbmc = '';
    $.each(rows, function (i, row) {
        if (i == 0) {
            first_yjzbmc = row[fieldname];
            rowspan = 1;
            index = i;
        } else {
            if (first_yjzbmc === row[fieldname]) {
                rowspan++;
            }
            else {
                $(bstable).bootstrapTable('mergeCells', { index: index, field: fieldname, colspan: 1, rowspan: rowspan });
                first_yjzbmc = row[fieldname];
                rowspan = 1;
                index = i;
            }
            if (i == (rows.length - 1)) {
                $(bstable).bootstrapTable('mergeCells', { index: index, field: fieldname, colspan: 1, rowspan: rowspan });
            }
        }
    });
}

function getValue(element,index) {
    //获取修改后的值
    var value = event.target.value;
    //将 - 替换为 /
    var position = getElementPosition(event.target); // 获取元素所在的行和列索引
    var rowIndex = position.row;
    var arrangeIndex = position.column;

    // 将获取到的新值发送到后台进行保存等操作
    // 获取表格数据
    var tableData = $('#projectTable').bootstrapTable('getData');
    // 修改第一行某 是否涉及新建变电站 的值为指定值
    console.log('arrangeIndex', arrangeIndex)
    if (arrangeIndex === 40){
        tableData[index].startPoliticalWork = value;
    }
    if (arrangeIndex === 41){
        tableData[index].startTime = value;
    }
    if (arrangeIndex === 42){
        tableData[index].administrativeObject = value;
    }
    if (arrangeIndex === 43){
        tableData[index].needCompensation = value;
    }
    if (arrangeIndex === 45){
        tableData[index].compensationMoney = value;
    }
    if (arrangeIndex === 46){
        tableData[index].documentCommitTime = value;
    }
    if (arrangeIndex === 47){
        tableData[index].financialPayment = value;
    }
    if (arrangeIndex === 48){
        tableData[index].needSignContract = value;
    }
    if (arrangeIndex === 49){
        tableData[index].signContractTime = value;
    }
    if (arrangeIndex === 50){
        tableData[index].weatherLoan = value;
    }
    if (arrangeIndex === 51){
        tableData[index].loanTime = value;
    }
    if (arrangeIndex === 52){
        tableData[index].completeFinancialReimbursement = value;
    }
    if (arrangeIndex === 53){
        tableData[index].completeFinancialReimbursementTime = value;
    }
    if (arrangeIndex === 54){
        tableData[index].possibleToEnterSite = value;
    }
    if (arrangeIndex === 55){
        tableData[index].possibleToEnterSiteTime = value;
    }
    if (arrangeIndex === 57){
        tableData[index].negotiatingUnit = value;
    }
    if (arrangeIndex === 58){
        tableData[index].coordinateUnit = value;
    }
    if (arrangeIndex === 59){
        tableData[index].recordRemarks = value;
    }

    // 获取表格数据  第一行
    var tableData = $('#projectTable').bootstrapTable('getData')[index];
    // 将数据封装成 JSON 格式
    var jsonData = JSON.stringify(tableData);
    $.ajax({
        url: '${ctx}/cg/policeProcess/record/reviewSave',
        type: 'POST',
        data: JSON.stringify(tableData),
        contentType: 'application/json',
        success: function(data) {
            //处理返回结果
            jp.success(data.msg)
            refresh();
        },
        error: function (data) {
            jp.error(data.msg);
            refresh();
        }
    })
}

function getElementPosition(element) {
    var $cell = $(element).closest('td'); // 获取元素的父元素（通常是 <td> 元素）
    var $row = $cell.closest('tr'); // 获取父元素所在的行 <tr> 元素

    var rowIndex = $row.index(); // 行索引（从 0 开始）
    var columnIndex = $cell.index(); // 列索引（从 0 开始）

    return {
        row: rowIndex,
        column: columnIndex
    };
}

</script>
