<%@ page contentType="text/html;charset=UTF-8" %>
<script >
$(document).ready(function () {
    $('#projectTable').bootstrapTable({
        //请求方法
        method: 'post',
        //类型json
        dataType: "json",
        contentType: "application/x-www-form-urlencoded",
        //显示检索按钮
        showSearch: true,
        //显示刷新按钮
        showRefresh: true,
        //显示切换手机试图按钮
        showToggle: true,
        //显示 内容列下拉框
        showColumns: true,
        //显示到处按钮
        showExport: true,
        //显示切换分页按钮
        showPaginationSwitch: true,
        //最低显示2行
        minimumCountColumns: 2,
        //是否显示行间隔色
        striped: true,
        //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
        cache: false,
        //是否显示分页（*）
        pagination: true,
        //排序方式
        sortOrder: "asc",
        //初始化加载第一页，默认第一页
        pageNumber: 1,
        //每页的记录行数（*）
        pageSize: 25,
        //可供选择的每页的行数（*）
        pageList: [5, 10, 25, 50, 100],
        //这个接口需要处理bootstrap table传递的固定参数,并返回特定格式的json数据
        url: "${ctx}/cg/reservemanagementcenter/reserveSafeDisclosure/list",
        //默认值为 'limit',传给服务端的参数为：limit, offset, search, sort, order Else
        //queryParamsType:'',
        ////查询参数,每次调用是会带上这个参数，可自定义
        queryParams: function (params) {
            var searchParam = $("#searchForm").serializeJSON();
            searchParam.pageNo = params.limit === undefined ? "1" : params.offset / params.limit + 1;
            searchParam.pageSize = params.limit === undefined ? -1 : params.limit;
            searchParam.orderBy = params.sort === undefined ? "" : params.sort + " " + params.order;
            return searchParam;
        },
        //分页方式：client客户端分页，server服务端分页（*）
        sidePagination: "server",
        contextMenuTrigger: "right",//pc端 按右键弹出菜单
        contextMenuTriggerMobile: "press",//手机端 弹出菜单，click：单击， press：长按。
        contextMenu: '#context-menu',
        onContextMenuItem: function (row, $el) {
            if ($el.data("item") == "edit") {
                edit(row.id);
            } else if ($el.data("item") == "view") {
                view(row.id);
            } else if ($el.data("item") == "delete") {
                jp.confirm('确认要删除该表单记录吗？', function () {
                    jp.loading();
                    jp.get("${ctx}/cg/reservemanagementcenter/project/delete?id=" + row.id, function (data) {
                        if (data.success) {
                            $('#projectTable').bootstrapTable('refresh');
                            jp.success(data.msg);
                        } else {
                            jp.error(data.msg);
                        }
                    })
                });
            }
        },

        onClickRow: function (row, $el) {
        },
        onShowSearch: function () {
            $("#search-collapse").slideToggle();
        },
        columns:
            [
                [
                    {checkbox:true,width: 36},
                    {"title":"储备项目基本信息","colspan":21,"halign":"center","align": "center",width: "4200px"},
                    {"title":"储备进度","colspan":3,"halign":"center","align": "center",width: "600px"},
                    {"title":"安全隐患排查","colspan":24,"halign":"center","align": "center",width: "4800px"}
                ],
                [
                    {checkbox:true,width: 36},
                    { field: 'projectYear', title: "项目年份", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'projectNature', title: "项目性质", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'demandUnit', title: "需求单位", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'district', title: "区域", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'projectGroup', title: "项目分组", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'projectManager', title: "项目经理", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'reserveBatches', title: "储备批次", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'blockSupply', title: "供电区域", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'gridNumber', title: "网格编号", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'cellNumber', title: "单元格编号", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'projectReserveId', title: "项目储备编号", valign:"middle", align:"center", colspan: 1, rowspan: 2,
                        formatter:function(value, row , index){

                                        if(value == null || value ==""){
                                            value = "-";
                                        }
                                    <c:choose>
                                        <c:when test="${fns:hasPermission('cg:reservemanagementcenter:reserveManage:view')}">
                                        return "<a href='javascript:view(\""+row.id+"\")'>"+value+"</a>";
                                    </c:when>
                                        <c:otherwise>
                                        return value;
                                    </c:otherwise>
                                        </c:choose>
                                    }},
                    { field: 'projectName', title: "储备项目名称", valign:"middle", align:"center", colspan: 1, rowspan: 2 ,formatter:paramsMatter},
                    { field: 'stateGridProjectCode', title: "国网项目编码", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'stateGridProjectName', title: "国网项目名称", valign:"middle", align:"center", colspan: 1, rowspan: 2 ,formatter:paramsMatter},
                    { field: 'constructionNecessityAndContent', title: "建设必要性及内容", valign:"middle", align:"center", colspan: 1, rowspan: 2 ,formatter:paramsMatter},
                    { field: 'substationName', title: "变电站名称", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'circuitName', title: "线路名称", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'netRackProjectDivide', title: "网架项目划分", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'requirementType', title: "需求类型", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'projectType', title: "项目类型", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'costEstimate', title: "费用估算", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'reserveProgress', title: "储备进度", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'implementPlan', title: "是否纳入实施计划", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { field: 'implementBatch', title: "初定实施批次", valign:"middle", align:"center", colspan: 1, rowspan: 2 },
                    { title: "是否临近（交叉）输电线路作业（含土建）", valign:"middle", align:"center", colspan: 2, rowspan: 1 },
                    { title: "是否与输电线路同杆架设", valign:"middle", align:"center", colspan: 2, rowspan: 1 },
                    { title: "是否与输电线路共沟", valign:"middle", align:"center", colspan: 2, rowspan: 1 },
                    { title: "是否临近带电中压线路作业", valign:"middle", align:"center", colspan: 2, rowspan: 1 },
                    { title: "是否有限空间作业", valign:"middle", align:"center", colspan: 2, rowspan: 1 },
                    { title: "是否存在变电站出线电缆搭接-是", valign:"middle", align:"center", colspan: 2, rowspan: 1 },
                    { title: "是否存在跨越公路、铁路、航道作业", valign:"middle", align:"center", colspan: 2, rowspan: 1 },
                    { title: "是否存在动火作业", valign:"middle", align:"center", colspan: 2, rowspan: 1 },
                    { title: "是否需停电四条以上线路", valign:"middle", align:"center", colspan: 2, rowspan: 1 },
                    { title: "是否三条以上线路负荷改接", valign:"middle", align:"center", colspan: 2, rowspan: 1 },
                    { title: "是否多专业、多班组大型作业", valign:"middle", align:"center", colspan: 2, rowspan: 1 },
                    { title: "是否需编制三措", valign:"middle", align:"center", colspan: 2, rowspan: 1 },
                    { field: 'jobRiskLevelPrediction', title: "作业风险等级预判", valign:"middle", align:"center", colspan: 1, rowspan: 2 }
                    ],

                [
                    {checkbox:true,width: 36},
                    { field: 'transmissionWork', title: '是/否', valign:"middle", align:"center" },
                    { field: 'workDescribe', title: '描述', valign:"middle", align:"center" ,formatter:paramsMatter},
                    { field: 'transmissionErection', title: '是/否', valign:"middle", align:"center" },
                    { field: 'erecteDescribe', title: '描述', valign:"middle", align:"center" ,formatter:paramsMatter},
                    { field: 'transmissionCommonTrench', title: '是/否', valign:"middle", align:"center" },
                    { field: 'trenchDescribe', title: '描述', valign:"middle", align:"center" ,formatter:paramsMatter},
                    { field: 'mediumVoltageWork', title: '是/否', valign:"middle", align:"center" },
                    { field: 'voltageWorkDescribe', title: '描述', valign:"middle", align:"center" ,formatter:paramsMatter},
                    { field: 'confineSpaceWork', title: '是/否', valign:"middle", align:"center" },
                    { field: 'spaceDescribe', title: '描述', valign:"middle", align:"center" ,formatter:paramsMatter},
                    { field: 'subStationCableBonding', title: '是/否', valign:"middle", align:"center" },
                    { field: 'cableDescribe', title: '描述', valign:"middle", align:"center" ,formatter:paramsMatter},
                    { field: 'roadRailwaysAndWaterwaysWork', title: '是/否', valign:"middle", align:"center" },
                    { field: 'waterDescribe', title: '描述', valign:"middle", align:"center" ,formatter:paramsMatter},
                    { field: 'hotWork', title: '是/否', valign:"middle", align:"center" },
                    { field: 'hotWorkDescribe', title: '描述', valign:"middle", align:"center" ,formatter:paramsMatter},
                    { field: 'blackoutLineFour', title: '是/否', valign:"middle", align:"center" },
                    { field: 'lineFourDescribe', title: '描述', valign:"middle", align:"center" ,formatter:paramsMatter},
                    { field: 'lineLoadRedirectionThree', title: '是/否', valign:"middle", align:"center" },
                    { field: 'threeRedirectDescribe', title: '描述', valign:"middle", align:"center" ,formatter:paramsMatter},
                    { field: 'largeScaleMultiTeamWork', title: '是/否', valign:"middle", align:"center" },
                    { field: 'teamWorkDescribe', title: '描述', valign:"middle", align:"center" ,formatter:paramsMatter},
                    { field: 'prepareThreeMeasures', title: '是/否', valign:"middle", align:"center" },
                    { field: 'measureDescribe', title: '描述', valign:"middle", align:"center" ,formatter:paramsMatter}

                    ]

        ]
    });


    if (navigator.userAgent.match(/(iPhone|iPod|Android|ios)/i)) {//如果是移动端
        $('#projectTable').bootstrapTable("toggleView");
    }

    $('#projectTable').on('check.bs.table uncheck.bs.table load-success.bs.table ' +
        'check-all.bs.table uncheck-all.bs.table', function () {
        $('#remove').prop('disabled', !$('#projectTable').bootstrapTable('getSelections').length);
        $('#view,#edit,#jlEdit').prop('disabled', $('#projectTable').bootstrapTable('getSelections').length != 1);
    });

    $("#btnImport").click(function () {
        jp.open({
            type: 2,
            area: [500, 200],
            auto: true,
            title: "导入数据",
            content: "${ctx}/tag/importExcel",
            btn: ['确定', '关闭'],
            btn1: function (index, layero) {
                var iframeWin = layero.find('iframe')[0]; //得到iframe页的窗口对象，执行iframe页的方法：iframeWin.method();
                iframeWin.contentWindow.importExcel('${ctx}/cg/reservemanagementcenter/reserveSafeDisclosure/import', function (data) {
                    if (data.success) {
                        jp.success(data.msg);
                        refresh();
                    } else {
                        jp.error(data.msg);
                    }
                    jp.close(index);
                });//调用保存事件
                return false;
            },
            btn2: function (index) {
                //  jp.close(index);
            }
        });
    });

    $("#jlImport").click(function () {
        jp.open({
            type: 2,
            area: [500, 200],
            auto: true,
            title: "导入数据",
            content: "${ctx}/tag/importExcel",
            btn: ['确定', '关闭'],
            btn1: function (index, layero) {
                var iframeWin = layero.find('iframe')[0]; //得到iframe页的窗口对象，执行iframe页的方法：iframeWin.method();
                iframeWin.contentWindow.importExcel('${ctx}/cg/reservemanagementcenter/reserveSafeDisclosure/jlImport', function (data) {
                    if (data.success) {
                        jp.success(data.msg);
                        refresh();
                    } else {
                        jp.error(data.msg);
                    }
                    jp.close(index);
                });//调用保存事件
                return false;
            },

            btn2: function (index) {
                //  jp.close(index);
            }
        });
    });

    $("#btnExport").click(function () {
        var projectReserveId = $("#projectReserveId").val();
        var projectName = $("#projectName").val();
        var projectYear = $("#projectYear").val();
        jp.downloadFile('${ctx}/cg/reservemanagementcenter/reserveSafeDisclosure/export?projectReserveId=' + projectReserveId + '&projectName=' + projectName + '&projectYear=' + projectYear);
    });

    $("#search").click("click", function () {// 绑定查询按扭
        $('#projectTable').bootstrapTable('refresh');
    });

    $("#reset").click("click", function () {// 绑定查询按扭
        $("#searchForm  input").val("");
        $("#searchForm  select").val("");
        $("#searchForm  .select-item").html("");
        $('#projectTable').bootstrapTable('refresh');
    });

    $('#beginBeginDate').datetimepicker({
        format: "YYYY-MM-DD HH:mm:ss"
    });
    $('#endBeginDate').datetimepicker({
        format: "YYYY-MM-DD HH:mm:ss"
    });
    $('#endDate').datetimepicker({
        format: "YYYY-MM-DD HH:mm:ss"
    });
});

//表格超出宽度鼠标悬停显示td内容
function paramsMatter(value,row,index,field) {
    var span = document.createElement('span');
    span.setAttribute('title',value);
    span.innerHTML = value;
    return span.outerHTML;
}

function getIdSelections() {
    return $.map($("#projectTable").bootstrapTable('getSelections'), function (row) {
        return row.id
    });
}


//刷新列表
function refresh() {
    $('#projectTable').bootstrapTable('refresh');
}

function add() {
    jp.openSaveDialog('新增储备项目基本信息', "${ctx}/cg/reservemanagementcenter/reserveSafeDisclosure/form", '800px', '500px');
}


function edit(id) {//没有权限时，不显示确定按钮
    if (id == undefined) {
        id = getIdSelections();
    }
    jp.openSaveDialog('编辑储备项目基本信息', "${ctx}/cg/reservemanagementcenter/reserveSafeDisclosure/form?id=" + id, '800px', '500px');
}

function jlEdit(id) {//没有权限时，不显示确定按钮
    if (id == undefined) {
        id = getIdSelections();
    }
    jp.openSaveDialog('编辑储备项目基本信息', "${ctx}/cg/reservemanagementcenter/reserveSafeDisclosure/jlEdit?id=" + id, '800px', '500px');
}

function view(id) {//没有权限时，不显示确定按钮
    if (id == undefined) {
        id = getIdSelections();
    }
    jp.openViewDialog('查看储备项目基本信息', "${ctx}/cg/reservemanagementcenter/reserveSafeDisclosure/view?id=" + id, '800px', '500px');
}

function deleteAll(){

    jp.confirm('确认要删除该储备项目基本信息吗？', function(){
        jp.loading();
        jp.get("${ctx}/cg/reservemanagementcenter/reserveSafeDisclosure/deleteAll?ids=" + getIdSelections(), function(data){
            if(data.success){
                $('#projectTable').bootstrapTable('refresh');
                jp.success(data.msg);
            }else{
                jp.error(data.msg);
            }
        })

    })
}
//转换日期格式(时间戳转换为datetime格式)
function changeDateFormat(cellval) {
    var dateVal = cellval + "";
    if (cellval != null) {
        var date = new Date(parseInt(dateVal.replace("/Date(", "").replace(")/", ""), 10));
        var month = date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1;
        var currentDate = date.getDate() < 10 ? "0" + date.getDate() : date.getDate();

        /*var hours = date.getHours() < 10 ? "0" + date.getHours() : date.getHours();
        var minutes = date.getMinutes() < 10 ? "0" + date.getMinutes() : date.getMinutes();
        var seconds = date.getSeconds() < 10 ? "0" + date.getSeconds() : date.getSeconds();*/

        return date.getFullYear() + "-" + month + "-" + currentDate /*+ " " + hours + ":" + minutes + ":" + seconds*/;
    }
}

</script>
