<%@ page contentType="text/html;charset=UTF-8" %>
<script >
$(document).ready(function () {
    $('#projectTable').bootstrapTable({
        //请求方法
        method: 'post',
        //类型json
        dataType: "json",
        contentType: "application/x-www-form-urlencoded",
        //显示检索按钮
        showSearch: true,
        //显示刷新按钮
        showRefresh: true,
        //显示切换手机试图按钮
        showToggle: true,
        //显示 内容列下拉框
        showColumns: true,
        //显示到处按钮
        showExport: true,
        //显示切换分页按钮
        showPaginationSwitch: true,
        //最低显示2行
        minimumCountColumns: 2,
        //是否显示行间隔色
        striped: true,
        //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
        cache: false,
        //是否显示分页（*）
        pagination: true,
        //排序方式
        sortOrder: "asc",
        //初始化加载第一页，默认第一页
        pageNumber: 1,
        //每页的记录行数（*）
        pageSize: 25,
        //可供选择的每页的行数（*）
        pageList: [5, 10, 25, 50, 100],
        //这个接口需要处理bootstrap table传递的固定参数,并返回特定格式的json数据
        url: "${ctx}/cg/reservemanagementcenter/summaryStatistics/list",
        //默认值为 'limit',传给服务端的参数为：limit, offset, search, sort, order Else
        //queryParamsType:'',
        ////查询参数,每次调用是会带上这个参数，可自定义
        queryParams: function (params) {
            var searchParam = $("#searchForm").serializeJSON();
            searchParam.pageNo = params.limit === undefined ? "1" : params.offset / params.limit + 1;
            searchParam.pageSize = params.limit === undefined ? -1 : params.limit;
            searchParam.orderBy = params.sort === undefined ? "" : params.sort + " " + params.order;
            return searchParam;
        },
        //分页方式：client客户端分页，server服务端分页（*）
        sidePagination: "server",
        contextMenuTrigger: "right",//pc端 按右键弹出菜单
        contextMenuTriggerMobile: "press",//手机端 弹出菜单，click：单击， press：长按。
        contextMenu: '#context-menu',
        onContextMenuItem: function (row, $el) {
            if ($el.data("item") == "edit") {
                edit(row.id);
            } else if ($el.data("item") == "view") {
                view(row.id);
            } else if ($el.data("item") == "delete") {
                jp.confirm('确认要删除该表单记录吗？', function () {
                    jp.loading();
                    jp.get("${ctx}/cg/reservemanagementcenter/project/delete?id=" + row.id, function (data) {
                        if (data.success) {
                            $('#projectTable').bootstrapTable('refresh');
                            jp.success(data.msg);
                        } else {
                            jp.error(data.msg);
                        }
                    })
                });
            }
        },

        onClickRow: function (row, $el) {
        },
        onShowSearch: function () {
            $("#search-collapse").slideToggle();
        },
        columns:
            [
                [
                    {checkbox:true,width: 36},
                    {"title":"储备项目基本信息","colspan":21,"halign":"center","align": "center",width: "4200px"},
                    {"title":"设计筛选","colspan":4,"halign":"center","align": "center",width: "800px"},
                    {"title":"储备项目交底信息统计","colspan":12,"halign":"center","align": "center",width: "2400px"},
                ],
                    [
                    {checkbox:true,width: 36},
                        { field: 'projectYear', title: "项目年份", valign:"middle", align:"center", colspan: 1 },
                        { field: 'projectNature', title: "项目性质", valign:"middle", align:"center", colspan: 1 },
                        { field: 'demandUnit', title: "需求单位", valign:"middle", align:"center", colspan: 1 },
                        { field: 'district', title: "区域", valign:"middle", align:"center", colspan: 1 },
                        { field: 'projectGroup', title: "项目分组", valign:"middle", align:"center", colspan: 1 },
                        { field: 'projectManager', title: "项目经理", valign:"middle", align:"center", colspan: 1 },
                        { field: 'reserveBatches', title: "储备批次", valign:"middle", align:"center", colspan: 1 },
                        { field: 'blockSupply', title: "供电区域", valign:"middle", align:"center", colspan: 1 },
                        { field: 'gridNumber', title: "网格编号", valign:"middle", align:"center", colspan: 1 },
                        { field: 'cellNumber', title: "单元格编号", valign:"middle", align:"center", colspan: 1 },
                        { field: 'projectReserveId', title: "项目储备编号", valign:"middle", align:"center", colspan: 1,
                            formatter:function(value, row , index){

                                if(value == null || value ==""){
                                    value = "-";
                                }
                            <c:choose>
                                <c:when test="${fns:hasPermission('cg:reservemanagementcenter:reserveManage:view')}">
                                return "<a href='javascript:view(\""+row.id+"\")'>"+value+"</a>";
                            </c:when>
                                <c:otherwise>
                                return value;
                            </c:otherwise>
                                </c:choose>
                            }},
                        { field: 'projectName', title: "储备项目名称", valign:"middle", align:"center", colspan: 1,formatter:paramsMatter},
                        { field: 'stateGridProjectCode', title: "国网项目编码", valign:"middle", align:"center", colspan: 1,formatter:paramsMatter},
                        { field: 'stateGridProjectName', title: "国网项目名称", valign:"middle", align:"center", colspan: 1,formatter:paramsMatter},
                        { field: 'constructionNecessityAndContent', title: "建设必要性及内容", valign:"middle", align:"center", colspan: 1,formatter:paramsMatter},
                        { field: 'substationName', title: "变电站名称", valign:"middle", align:"center", colspan: 1 },
                        { field: 'circuitName', title: "线路名称", valign:"middle", align:"center", colspan: 1 },
                        { field: 'netRackProjectDivide', title: "网架项目划分", valign:"middle", align:"center", colspan: 1 },
                        { field: 'requirementType', title: "需求类型", valign:"middle", align:"center", colspan: 1 },
                        { field: 'projectType', title: "项目类型", valign:"middle", align:"center", colspan: 1 },
                        { field: 'costEstimate', title: "费用估算", valign:"middle", align:"center", colspan: 1 },

                        { field: 'reserveProgress', title: "储备进度", valign:"middle", align:"center", colspan: 1 },
                        { field: 'includeReserve', title: "是否纳入储备", valign:"middle", align:"center", colspan: 1 },
                        { field: 'reasonForCancel', title: "取消原因说明", valign:"middle", align:"center", colspan: 1 ,formatter:paramsMatter},
                        { field: 'startDesignOrNot', title: "是否启动设计", valign:"middle", align:"center", colspan: 1 },

                        { field: 'completeDisclose', title: "是否完成交底", valign:"middle", align:"center", colspan: 1 },
                        { field: 'completeDiscloseTime', title: "交底完成时间", valign:"middle", align:"center", colspan: 1 },
                        { field: 'comprehensiveProject', title: "项目综合可实施性", valign:"middle", align:"center", colspan: 1 },
                        { field: 'officeDifficulty', title: "政处难度", valign:"middle", align:"center", colspan: 1 },
                        { field: 'officeProgress', title: "政处描述", valign:"middle", align:"center", colspan: 1 },
                        { field: 'powerFailureDifficulty', title: "停电难度", valign:"middle", align:"center", colspan: 1 },
                        { field: 'powerFailureDescribe', title: "停电描述", valign:"middle", align:"center", colspan: 1 ,formatter:paramsMatter},
                        { field: 'otherProblemDifficulty', title: "其他问题难度", valign:"middle", align:"center", colspan: 1 },
                        { field: 'otherProblemDescribe', title: "其他问题描述", valign:"middle", align:"center", colspan: 1 ,formatter:paramsMatter},
                        { field: 'runPlanRequire', title: "是否需重跑方案", valign:"middle", align:"center", colspan: 1 },
                        { field: 'programChangeDescription', title: "方案变更说明", valign:"middle", align:"center", colspan: 1 ,formatter:paramsMatter},
                        { field: 'discloseRemarks', title: "备注", valign:"middle", align:"center", colspan: 1 ,formatter:paramsMatter}

                    ],

        ]
    });


    if (navigator.userAgent.match(/(iPhone|iPod|Android|ios)/i)) {//如果是移动端
        $('#projectTable').bootstrapTable("toggleView");
    }

    $('#projectTable').on('check.bs.table uncheck.bs.table load-success.bs.table ' +
        'check-all.bs.table uncheck-all.bs.table', function () {
        $('#remove').prop('disabled', !$('#projectTable').bootstrapTable('getSelections').length);
        $('#view,#edit,#jlEdit').prop('disabled', $('#projectTable').bootstrapTable('getSelections').length != 1);
    });

    $("#btnImport").click(function () {
        jp.open({
            type: 2,
            area: [500, 200],
            auto: true,
            title: "导入数据",
            content: "${ctx}/tag/importExcel",
            btn: ['确定', '关闭'],
            btn1: function (index, layero) {
                var iframeWin = layero.find('iframe')[0]; //得到iframe页的窗口对象，执行iframe页的方法：iframeWin.method();
                iframeWin.contentWindow.importExcel('${ctx}/cg/reservemanagementcenter/summaryStatistics/import', function (data) {
                    if (data.success) {
                        jp.success(data.msg);
                        refresh();
                    } else {
                        jp.error(data.msg);
                    }
                    jp.close(index);
                });//调用保存事件
                return false;
            },
            btn2: function (index) {
                //  jp.close(index);
            }
        });
    });

    $("#jlImport").click(function () {
        jp.open({
            type: 2,
            area: [500, 200],
            auto: true,
            title: "导入数据",
            content: "${ctx}/tag/importExcel",
            btn: ['确定', '关闭'],
            btn1: function (index, layero) {
                var iframeWin = layero.find('iframe')[0]; //得到iframe页的窗口对象，执行iframe页的方法：iframeWin.method();
                iframeWin.contentWindow.importExcel('${ctx}/cg/reservemanagementcenter/summaryStatistics/jlImport', function (data) {
                    if (data.success) {
                        jp.success(data.msg);
                        refresh();
                    } else {
                        jp.error(data.msg);
                    }
                    jp.close(index);
                });//调用保存事件
                return false;
            },

            btn2: function (index) {
                //  jp.close(index);
            }
        });
    });

    $("#btnExport").click(function () {
        var projectReserveId = $("#projectReserveId").val();
        var projectName = $("#projectName").val();
        var projectYear = $("#projectYear").val();
        jp.downloadFile('${ctx}/cg/reservemanagementcenter/summaryStatistics/export?projectReserveId=' + projectReserveId + '&projectName=' + projectName + '&projectYear=' + projectYear);
    });

    $("#search").click("click", function () {// 绑定查询按扭
        $('#projectTable').bootstrapTable('refresh');
    });

    $("#reset").click("click", function () {// 绑定查询按扭
        $("#searchForm  input").val("");
        $("#searchForm  select").val("");
        $("#searchForm  .select-item").html("");
        $('#projectTable').bootstrapTable('refresh');
    });

    $('#beginBeginDate').datetimepicker({
        format: "YYYY-MM-DD HH:mm:ss"
    });
    $('#endBeginDate').datetimepicker({
        format: "YYYY-MM-DD HH:mm:ss"
    });
    $('#endDate').datetimepicker({
        format: "YYYY-MM-DD HH:mm:ss"
    });
});

//表格超出宽度鼠标悬停显示td内容
function paramsMatter(value,row,index,field) {
    var span = document.createElement('span');
    span.setAttribute('title',value);
    span.innerHTML = value;
    return span.outerHTML;
}

function getIdSelections() {
    return $.map($("#projectTable").bootstrapTable('getSelections'), function (row) {
        return row.id
    });
}


//刷新列表
function refresh() {
    $('#projectTable').bootstrapTable('refresh');
}

function add() {
    jp.openSaveDialog('新增储备项目基本信息', "${ctx}/cg/reservemanagementcenter/summaryStatistics/form", '800px', '500px');
}


function edit(id) {//没有权限时，不显示确定按钮
    if (id == undefined) {
        id = getIdSelections();
    }
    jp.openSaveDialog('编辑储备项目基本信息', "${ctx}/cg/reservemanagementcenter/summaryStatistics/form?id=" + id, '800px', '500px');
}

function jlEdit(id) {//没有权限时，不显示确定按钮
    if (id == undefined) {
        id = getIdSelections();
    }
    jp.openSaveDialog('编辑储备项目基本信息', "${ctx}/cg/reservemanagementcenter/summaryStatistics/jlEdit?id=" + id, '800px', '500px');
}

function view(id) {//没有权限时，不显示确定按钮
    if (id == undefined) {
        id = getIdSelections();
    }
    jp.openViewDialog('查看储备项目基本信息', "${ctx}/cg/reservemanagementcenter/summaryStatistics/view?id=" + id, '800px', '500px');
}

function deleteAll(){

    jp.confirm('确认要删除该储备项目基本信息吗？', function(){
        jp.loading();
        jp.get("${ctx}/cg/reservemanagementcenter/summaryStatistics/deleteAll?ids=" + getIdSelections(), function(data){
            if(data.success){
                $('#projectTable').bootstrapTable('refresh');
                jp.success(data.msg);
            }else{
                jp.error(data.msg);
            }
        })

    })
}
//转换日期格式(时间戳转换为datetime格式)
function changeDateFormat(cellval) {
    var dateVal = cellval + "";
    if (cellval != null) {
        var date = new Date(parseInt(dateVal.replace("/Date(", "").replace(")/", ""), 10));
        var month = date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1;
        var currentDate = date.getDate() < 10 ? "0" + date.getDate() : date.getDate();

        /*var hours = date.getHours() < 10 ? "0" + date.getHours() : date.getHours();
        var minutes = date.getMinutes() < 10 ? "0" + date.getMinutes() : date.getMinutes();
        var seconds = date.getSeconds() < 10 ? "0" + date.getSeconds() : date.getSeconds();*/

        return date.getFullYear() + "-" + month + "-" + currentDate /*+ " " + hours + ":" + minutes + ":" + seconds*/;
    }
}

</script>
